/*!
 * 
 * yorkie-js-sdk for building collaborative editing applications.
 *  - Version: v0.4.17
 *  - Date: 2024-04-19T05:45Z
 *  - Homepage: https://yorkie.dev
 *
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["yorkie"] = factory();
	else
		root["yorkie"] = factory();
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 646:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

//
// Copyright 2022 The Yorkie Authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.6.0 with parameter "target=js+dts,js_import_style=legacy_commonjs"
// @generated from file src/api/yorkie/v1/resources.proto (package yorkie.v1, syntax proto3)
/* eslint-disable */
// @ts-nocheck


Object.defineProperty(exports, "__esModule", ({ value: true }));

const { proto3, StringValue, Timestamp } = __webpack_require__(532);

/**
 * @generated from enum yorkie.v1.ValueType
 */
const ValueType = proto3.makeEnum(
  "yorkie.v1.ValueType",
  [
    {no: 0, name: "VALUE_TYPE_NULL", localName: "NULL"},
    {no: 1, name: "VALUE_TYPE_BOOLEAN", localName: "BOOLEAN"},
    {no: 2, name: "VALUE_TYPE_INTEGER", localName: "INTEGER"},
    {no: 3, name: "VALUE_TYPE_LONG", localName: "LONG"},
    {no: 4, name: "VALUE_TYPE_DOUBLE", localName: "DOUBLE"},
    {no: 5, name: "VALUE_TYPE_STRING", localName: "STRING"},
    {no: 6, name: "VALUE_TYPE_BYTES", localName: "BYTES"},
    {no: 7, name: "VALUE_TYPE_DATE", localName: "DATE"},
    {no: 8, name: "VALUE_TYPE_JSON_OBJECT", localName: "JSON_OBJECT"},
    {no: 9, name: "VALUE_TYPE_JSON_ARRAY", localName: "JSON_ARRAY"},
    {no: 10, name: "VALUE_TYPE_TEXT", localName: "TEXT"},
    {no: 11, name: "VALUE_TYPE_INTEGER_CNT", localName: "INTEGER_CNT"},
    {no: 12, name: "VALUE_TYPE_LONG_CNT", localName: "LONG_CNT"},
    {no: 13, name: "VALUE_TYPE_TREE", localName: "TREE"},
  ],
);

/**
 * @generated from enum yorkie.v1.DocEventType
 */
const DocEventType = proto3.makeEnum(
  "yorkie.v1.DocEventType",
  [
    {no: 0, name: "DOC_EVENT_TYPE_DOCUMENT_CHANGED", localName: "DOCUMENT_CHANGED"},
    {no: 1, name: "DOC_EVENT_TYPE_DOCUMENT_WATCHED", localName: "DOCUMENT_WATCHED"},
    {no: 2, name: "DOC_EVENT_TYPE_DOCUMENT_UNWATCHED", localName: "DOCUMENT_UNWATCHED"},
    {no: 3, name: "DOC_EVENT_TYPE_DOCUMENT_BROADCAST", localName: "DOCUMENT_BROADCAST"},
  ],
);

/**
 * ///////////////////////////////////////
 * Messages for Snapshot               //
 * ///////////////////////////////////////
 *
 * @generated from message yorkie.v1.Snapshot
 */
const Snapshot = proto3.makeMessageType(
  "yorkie.v1.Snapshot",
  () => [
    { no: 1, name: "root", kind: "message", T: JSONElement },
    { no: 2, name: "presences", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "message", T: Presence} },
  ],
);

/**
 * ChangePack is a message that contains all changes that occurred in a document.
 * It is used to synchronize changes between clients and servers.
 *
 * @generated from message yorkie.v1.ChangePack
 */
const ChangePack = proto3.makeMessageType(
  "yorkie.v1.ChangePack",
  () => [
    { no: 1, name: "document_key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "checkpoint", kind: "message", T: Checkpoint },
    { no: 3, name: "snapshot", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
    { no: 4, name: "changes", kind: "message", T: Change, repeated: true },
    { no: 5, name: "min_synced_ticket", kind: "message", T: TimeTicket },
    { no: 6, name: "is_removed", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
  ],
);

/**
 * @generated from message yorkie.v1.Change
 */
const Change = proto3.makeMessageType(
  "yorkie.v1.Change",
  () => [
    { no: 1, name: "id", kind: "message", T: ChangeID },
    { no: 2, name: "message", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "operations", kind: "message", T: Operation, repeated: true },
    { no: 4, name: "presence_change", kind: "message", T: PresenceChange },
  ],
);

/**
 * @generated from message yorkie.v1.ChangeID
 */
const ChangeID = proto3.makeMessageType(
  "yorkie.v1.ChangeID",
  () => [
    { no: 1, name: "client_seq", kind: "scalar", T: 13 /* ScalarType.UINT32 */ },
    { no: 2, name: "server_seq", kind: "scalar", T: 3 /* ScalarType.INT64 */, L: 1 /* LongType.STRING */ },
    { no: 3, name: "lamport", kind: "scalar", T: 3 /* ScalarType.INT64 */, L: 1 /* LongType.STRING */ },
    { no: 4, name: "actor_id", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
  ],
);

/**
 * @generated from message yorkie.v1.Operation
 */
const Operation = proto3.makeMessageType(
  "yorkie.v1.Operation",
  () => [
    { no: 1, name: "set", kind: "message", T: Operation_Set, oneof: "body" },
    { no: 2, name: "add", kind: "message", T: Operation_Add, oneof: "body" },
    { no: 3, name: "move", kind: "message", T: Operation_Move, oneof: "body" },
    { no: 4, name: "remove", kind: "message", T: Operation_Remove, oneof: "body" },
    { no: 5, name: "edit", kind: "message", T: Operation_Edit, oneof: "body" },
    { no: 6, name: "select", kind: "message", T: Operation_Select, oneof: "body" },
    { no: 7, name: "style", kind: "message", T: Operation_Style, oneof: "body" },
    { no: 8, name: "increase", kind: "message", T: Operation_Increase, oneof: "body" },
    { no: 9, name: "tree_edit", kind: "message", T: Operation_TreeEdit, oneof: "body" },
    { no: 10, name: "tree_style", kind: "message", T: Operation_TreeStyle, oneof: "body" },
  ],
);

/**
 * @generated from message yorkie.v1.Operation.Set
 */
const Operation_Set = proto3.makeMessageType(
  "yorkie.v1.Operation.Set",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "value", kind: "message", T: JSONElementSimple },
    { no: 4, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_Set"},
);

/**
 * @generated from message yorkie.v1.Operation.Add
 */
const Operation_Add = proto3.makeMessageType(
  "yorkie.v1.Operation.Add",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "prev_created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "value", kind: "message", T: JSONElementSimple },
    { no: 4, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_Add"},
);

/**
 * @generated from message yorkie.v1.Operation.Move
 */
const Operation_Move = proto3.makeMessageType(
  "yorkie.v1.Operation.Move",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "prev_created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "created_at", kind: "message", T: TimeTicket },
    { no: 4, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_Move"},
);

/**
 * @generated from message yorkie.v1.Operation.Remove
 */
const Operation_Remove = proto3.makeMessageType(
  "yorkie.v1.Operation.Remove",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_Remove"},
);

/**
 * @generated from message yorkie.v1.Operation.Edit
 */
const Operation_Edit = proto3.makeMessageType(
  "yorkie.v1.Operation.Edit",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "from", kind: "message", T: TextNodePos },
    { no: 3, name: "to", kind: "message", T: TextNodePos },
    { no: 4, name: "created_at_map_by_actor", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "message", T: TimeTicket} },
    { no: 5, name: "content", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 6, name: "executed_at", kind: "message", T: TimeTicket },
    { no: 7, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "scalar", T: 9 /* ScalarType.STRING */} },
  ],
  {localName: "Operation_Edit"},
);

/**
 * NOTE(hackerwins): Select Operation is not used in the current version.
 * In the previous version, it was used to represent selection of Text.
 * However, it has been replaced by Presence now. It is retained for backward
 * compatibility purposes.
 *
 * @generated from message yorkie.v1.Operation.Select
 */
const Operation_Select = proto3.makeMessageType(
  "yorkie.v1.Operation.Select",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "from", kind: "message", T: TextNodePos },
    { no: 3, name: "to", kind: "message", T: TextNodePos },
    { no: 4, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_Select"},
);

/**
 * @generated from message yorkie.v1.Operation.Style
 */
const Operation_Style = proto3.makeMessageType(
  "yorkie.v1.Operation.Style",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "from", kind: "message", T: TextNodePos },
    { no: 3, name: "to", kind: "message", T: TextNodePos },
    { no: 4, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "scalar", T: 9 /* ScalarType.STRING */} },
    { no: 5, name: "executed_at", kind: "message", T: TimeTicket },
    { no: 6, name: "created_at_map_by_actor", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "message", T: TimeTicket} },
  ],
  {localName: "Operation_Style"},
);

/**
 * @generated from message yorkie.v1.Operation.Increase
 */
const Operation_Increase = proto3.makeMessageType(
  "yorkie.v1.Operation.Increase",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "value", kind: "message", T: JSONElementSimple },
    { no: 3, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_Increase"},
);

/**
 * @generated from message yorkie.v1.Operation.TreeEdit
 */
const Operation_TreeEdit = proto3.makeMessageType(
  "yorkie.v1.Operation.TreeEdit",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "from", kind: "message", T: TreePos },
    { no: 3, name: "to", kind: "message", T: TreePos },
    { no: 4, name: "created_at_map_by_actor", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "message", T: TimeTicket} },
    { no: 5, name: "contents", kind: "message", T: TreeNodes, repeated: true },
    { no: 7, name: "split_level", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 6, name: "executed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "Operation_TreeEdit"},
);

/**
 * @generated from message yorkie.v1.Operation.TreeStyle
 */
const Operation_TreeStyle = proto3.makeMessageType(
  "yorkie.v1.Operation.TreeStyle",
  () => [
    { no: 1, name: "parent_created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "from", kind: "message", T: TreePos },
    { no: 3, name: "to", kind: "message", T: TreePos },
    { no: 4, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "scalar", T: 9 /* ScalarType.STRING */} },
    { no: 5, name: "executed_at", kind: "message", T: TimeTicket },
    { no: 6, name: "attributes_to_remove", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
  ],
  {localName: "Operation_TreeStyle"},
);

/**
 * @generated from message yorkie.v1.JSONElementSimple
 */
const JSONElementSimple = proto3.makeMessageType(
  "yorkie.v1.JSONElementSimple",
  () => [
    { no: 1, name: "created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 3, name: "removed_at", kind: "message", T: TimeTicket },
    { no: 4, name: "type", kind: "enum", T: proto3.getEnumType(ValueType) },
    { no: 5, name: "value", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
  ],
);

/**
 * @generated from message yorkie.v1.JSONElement
 */
const JSONElement = proto3.makeMessageType(
  "yorkie.v1.JSONElement",
  () => [
    { no: 1, name: "json_object", kind: "message", T: JSONElement_JSONObject, oneof: "body" },
    { no: 2, name: "json_array", kind: "message", T: JSONElement_JSONArray, oneof: "body" },
    { no: 3, name: "primitive", kind: "message", T: JSONElement_Primitive, oneof: "body" },
    { no: 5, name: "text", kind: "message", T: JSONElement_Text, oneof: "body" },
    { no: 6, name: "counter", kind: "message", T: JSONElement_Counter, oneof: "body" },
    { no: 7, name: "tree", kind: "message", T: JSONElement_Tree, oneof: "body" },
  ],
);

/**
 * @generated from message yorkie.v1.JSONElement.JSONObject
 */
const JSONElement_JSONObject = proto3.makeMessageType(
  "yorkie.v1.JSONElement.JSONObject",
  () => [
    { no: 1, name: "nodes", kind: "message", T: RHTNode, repeated: true },
    { no: 2, name: "created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 4, name: "removed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "JSONElement_JSONObject"},
);

/**
 * @generated from message yorkie.v1.JSONElement.JSONArray
 */
const JSONElement_JSONArray = proto3.makeMessageType(
  "yorkie.v1.JSONElement.JSONArray",
  () => [
    { no: 1, name: "nodes", kind: "message", T: RGANode, repeated: true },
    { no: 2, name: "created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 4, name: "removed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "JSONElement_JSONArray"},
);

/**
 * @generated from message yorkie.v1.JSONElement.Primitive
 */
const JSONElement_Primitive = proto3.makeMessageType(
  "yorkie.v1.JSONElement.Primitive",
  () => [
    { no: 1, name: "type", kind: "enum", T: proto3.getEnumType(ValueType) },
    { no: 2, name: "value", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
    { no: 3, name: "created_at", kind: "message", T: TimeTicket },
    { no: 4, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 5, name: "removed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "JSONElement_Primitive"},
);

/**
 * @generated from message yorkie.v1.JSONElement.Text
 */
const JSONElement_Text = proto3.makeMessageType(
  "yorkie.v1.JSONElement.Text",
  () => [
    { no: 1, name: "nodes", kind: "message", T: TextNode, repeated: true },
    { no: 2, name: "created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 4, name: "removed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "JSONElement_Text"},
);

/**
 * @generated from message yorkie.v1.JSONElement.Counter
 */
const JSONElement_Counter = proto3.makeMessageType(
  "yorkie.v1.JSONElement.Counter",
  () => [
    { no: 1, name: "type", kind: "enum", T: proto3.getEnumType(ValueType) },
    { no: 2, name: "value", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
    { no: 3, name: "created_at", kind: "message", T: TimeTicket },
    { no: 4, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 5, name: "removed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "JSONElement_Counter"},
);

/**
 * @generated from message yorkie.v1.JSONElement.Tree
 */
const JSONElement_Tree = proto3.makeMessageType(
  "yorkie.v1.JSONElement.Tree",
  () => [
    { no: 1, name: "nodes", kind: "message", T: TreeNode, repeated: true },
    { no: 2, name: "created_at", kind: "message", T: TimeTicket },
    { no: 3, name: "moved_at", kind: "message", T: TimeTicket },
    { no: 4, name: "removed_at", kind: "message", T: TimeTicket },
  ],
  {localName: "JSONElement_Tree"},
);

/**
 * @generated from message yorkie.v1.RHTNode
 */
const RHTNode = proto3.makeMessageType(
  "yorkie.v1.RHTNode",
  () => [
    { no: 1, name: "key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "element", kind: "message", T: JSONElement },
  ],
);

/**
 * @generated from message yorkie.v1.RGANode
 */
const RGANode = proto3.makeMessageType(
  "yorkie.v1.RGANode",
  () => [
    { no: 1, name: "next", kind: "message", T: RGANode },
    { no: 2, name: "element", kind: "message", T: JSONElement },
  ],
);

/**
 * @generated from message yorkie.v1.NodeAttr
 */
const NodeAttr = proto3.makeMessageType(
  "yorkie.v1.NodeAttr",
  () => [
    { no: 1, name: "value", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "updated_at", kind: "message", T: TimeTicket },
  ],
);

/**
 * @generated from message yorkie.v1.TextNode
 */
const TextNode = proto3.makeMessageType(
  "yorkie.v1.TextNode",
  () => [
    { no: 1, name: "id", kind: "message", T: TextNodeID },
    { no: 2, name: "value", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "removed_at", kind: "message", T: TimeTicket },
    { no: 4, name: "ins_prev_id", kind: "message", T: TextNodeID },
    { no: 5, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "message", T: NodeAttr} },
  ],
);

/**
 * @generated from message yorkie.v1.TextNodeID
 */
const TextNodeID = proto3.makeMessageType(
  "yorkie.v1.TextNodeID",
  () => [
    { no: 1, name: "created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "offset", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
  ],
);

/**
 * @generated from message yorkie.v1.TreeNode
 */
const TreeNode = proto3.makeMessageType(
  "yorkie.v1.TreeNode",
  () => [
    { no: 1, name: "id", kind: "message", T: TreeNodeID },
    { no: 2, name: "type", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "value", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 4, name: "removed_at", kind: "message", T: TimeTicket },
    { no: 5, name: "ins_prev_id", kind: "message", T: TreeNodeID },
    { no: 6, name: "ins_next_id", kind: "message", T: TreeNodeID },
    { no: 7, name: "depth", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 8, name: "attributes", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "message", T: NodeAttr} },
  ],
);

/**
 * @generated from message yorkie.v1.TreeNodes
 */
const TreeNodes = proto3.makeMessageType(
  "yorkie.v1.TreeNodes",
  () => [
    { no: 1, name: "content", kind: "message", T: TreeNode, repeated: true },
  ],
);

/**
 * @generated from message yorkie.v1.TreeNodeID
 */
const TreeNodeID = proto3.makeMessageType(
  "yorkie.v1.TreeNodeID",
  () => [
    { no: 1, name: "created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "offset", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
  ],
);

/**
 * @generated from message yorkie.v1.TreePos
 */
const TreePos = proto3.makeMessageType(
  "yorkie.v1.TreePos",
  () => [
    { no: 1, name: "parent_id", kind: "message", T: TreeNodeID },
    { no: 2, name: "left_sibling_id", kind: "message", T: TreeNodeID },
  ],
);

/**
 * @generated from message yorkie.v1.User
 */
const User = proto3.makeMessageType(
  "yorkie.v1.User",
  () => [
    { no: 1, name: "id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "username", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "created_at", kind: "message", T: Timestamp },
  ],
);

/**
 * @generated from message yorkie.v1.Project
 */
const Project = proto3.makeMessageType(
  "yorkie.v1.Project",
  () => [
    { no: 1, name: "id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "public_key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 4, name: "secret_key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 5, name: "auth_webhook_url", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 6, name: "auth_webhook_methods", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 7, name: "client_deactivate_threshold", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 8, name: "created_at", kind: "message", T: Timestamp },
    { no: 9, name: "updated_at", kind: "message", T: Timestamp },
  ],
);

/**
 * @generated from message yorkie.v1.UpdatableProjectFields
 */
const UpdatableProjectFields = proto3.makeMessageType(
  "yorkie.v1.UpdatableProjectFields",
  () => [
    { no: 1, name: "name", kind: "message", T: StringValue },
    { no: 2, name: "auth_webhook_url", kind: "message", T: StringValue },
    { no: 3, name: "auth_webhook_methods", kind: "message", T: UpdatableProjectFields_AuthWebhookMethods },
    { no: 4, name: "client_deactivate_threshold", kind: "message", T: StringValue },
  ],
);

/**
 * @generated from message yorkie.v1.UpdatableProjectFields.AuthWebhookMethods
 */
const UpdatableProjectFields_AuthWebhookMethods = proto3.makeMessageType(
  "yorkie.v1.UpdatableProjectFields.AuthWebhookMethods",
  () => [
    { no: 1, name: "methods", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
  ],
  {localName: "UpdatableProjectFields_AuthWebhookMethods"},
);

/**
 * @generated from message yorkie.v1.DocumentSummary
 */
const DocumentSummary = proto3.makeMessageType(
  "yorkie.v1.DocumentSummary",
  () => [
    { no: 1, name: "id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "snapshot", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 4, name: "created_at", kind: "message", T: Timestamp },
    { no: 5, name: "accessed_at", kind: "message", T: Timestamp },
    { no: 6, name: "updated_at", kind: "message", T: Timestamp },
  ],
);

/**
 * @generated from message yorkie.v1.PresenceChange
 */
const PresenceChange = proto3.makeMessageType(
  "yorkie.v1.PresenceChange",
  () => [
    { no: 1, name: "type", kind: "enum", T: proto3.getEnumType(PresenceChange_ChangeType) },
    { no: 2, name: "presence", kind: "message", T: Presence },
  ],
);

/**
 * @generated from enum yorkie.v1.PresenceChange.ChangeType
 */
const PresenceChange_ChangeType = proto3.makeEnum(
  "yorkie.v1.PresenceChange.ChangeType",
  [
    {no: 0, name: "CHANGE_TYPE_UNSPECIFIED", localName: "UNSPECIFIED"},
    {no: 1, name: "CHANGE_TYPE_PUT", localName: "PUT"},
    {no: 2, name: "CHANGE_TYPE_DELETE", localName: "DELETE"},
    {no: 3, name: "CHANGE_TYPE_CLEAR", localName: "CLEAR"},
  ],
);

/**
 * @generated from message yorkie.v1.Presence
 */
const Presence = proto3.makeMessageType(
  "yorkie.v1.Presence",
  () => [
    { no: 1, name: "data", kind: "map", K: 9 /* ScalarType.STRING */, V: {kind: "scalar", T: 9 /* ScalarType.STRING */} },
  ],
);

/**
 * @generated from message yorkie.v1.Checkpoint
 */
const Checkpoint = proto3.makeMessageType(
  "yorkie.v1.Checkpoint",
  () => [
    { no: 1, name: "server_seq", kind: "scalar", T: 3 /* ScalarType.INT64 */, L: 1 /* LongType.STRING */ },
    { no: 2, name: "client_seq", kind: "scalar", T: 13 /* ScalarType.UINT32 */ },
  ],
);

/**
 * @generated from message yorkie.v1.TextNodePos
 */
const TextNodePos = proto3.makeMessageType(
  "yorkie.v1.TextNodePos",
  () => [
    { no: 1, name: "created_at", kind: "message", T: TimeTicket },
    { no: 2, name: "offset", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 3, name: "relative_offset", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
  ],
);

/**
 * @generated from message yorkie.v1.TimeTicket
 */
const TimeTicket = proto3.makeMessageType(
  "yorkie.v1.TimeTicket",
  () => [
    { no: 1, name: "lamport", kind: "scalar", T: 3 /* ScalarType.INT64 */, L: 1 /* LongType.STRING */ },
    { no: 2, name: "delimiter", kind: "scalar", T: 13 /* ScalarType.UINT32 */ },
    { no: 3, name: "actor_id", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
  ],
);

/**
 * @generated from message yorkie.v1.DocEventBody
 */
const DocEventBody = proto3.makeMessageType(
  "yorkie.v1.DocEventBody",
  () => [
    { no: 1, name: "topic", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "payload", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
  ],
);

/**
 * @generated from message yorkie.v1.DocEvent
 */
const DocEvent = proto3.makeMessageType(
  "yorkie.v1.DocEvent",
  () => [
    { no: 1, name: "type", kind: "enum", T: proto3.getEnumType(DocEventType) },
    { no: 2, name: "publisher", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "body", kind: "message", T: DocEventBody },
  ],
);


exports.ValueType = ValueType;
exports.DocEventType = DocEventType;
exports.Snapshot = Snapshot;
exports.ChangePack = ChangePack;
exports.Change = Change;
exports.ChangeID = ChangeID;
exports.Operation = Operation;
exports.Operation_Set = Operation_Set;
exports.Operation_Add = Operation_Add;
exports.Operation_Move = Operation_Move;
exports.Operation_Remove = Operation_Remove;
exports.Operation_Edit = Operation_Edit;
exports.Operation_Select = Operation_Select;
exports.Operation_Style = Operation_Style;
exports.Operation_Increase = Operation_Increase;
exports.Operation_TreeEdit = Operation_TreeEdit;
exports.Operation_TreeStyle = Operation_TreeStyle;
exports.JSONElementSimple = JSONElementSimple;
exports.JSONElement = JSONElement;
exports.JSONElement_JSONObject = JSONElement_JSONObject;
exports.JSONElement_JSONArray = JSONElement_JSONArray;
exports.JSONElement_Primitive = JSONElement_Primitive;
exports.JSONElement_Text = JSONElement_Text;
exports.JSONElement_Counter = JSONElement_Counter;
exports.JSONElement_Tree = JSONElement_Tree;
exports.RHTNode = RHTNode;
exports.RGANode = RGANode;
exports.NodeAttr = NodeAttr;
exports.TextNode = TextNode;
exports.TextNodeID = TextNodeID;
exports.TreeNode = TreeNode;
exports.TreeNodes = TreeNodes;
exports.TreeNodeID = TreeNodeID;
exports.TreePos = TreePos;
exports.User = User;
exports.Project = Project;
exports.UpdatableProjectFields = UpdatableProjectFields;
exports.UpdatableProjectFields_AuthWebhookMethods = UpdatableProjectFields_AuthWebhookMethods;
exports.DocumentSummary = DocumentSummary;
exports.PresenceChange = PresenceChange;
exports.PresenceChange_ChangeType = PresenceChange_ChangeType;
exports.Presence = Presence;
exports.Checkpoint = Checkpoint;
exports.TextNodePos = TextNodePos;
exports.TimeTicket = TimeTicket;
exports.DocEventBody = DocEventBody;
exports.DocEvent = DocEvent;


/***/ }),

/***/ 295:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var __webpack_unused_export__;
//
// Copyright 2020 The Yorkie Authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-connect-es v1.2.0 with parameter "target=js+dts,js_import_style=legacy_commonjs"
// @generated from file src/api/yorkie/v1/yorkie.proto (package yorkie.v1, syntax proto3)
/* eslint-disable */
// @ts-nocheck


__webpack_unused_export__ = ({ value: true });

const { ActivateClientRequest, ActivateClientResponse, AttachDocumentRequest, AttachDocumentResponse, BroadcastRequest, BroadcastResponse, DeactivateClientRequest, DeactivateClientResponse, DetachDocumentRequest, DetachDocumentResponse, PushPullChangesRequest, PushPullChangesResponse, RemoveDocumentRequest, RemoveDocumentResponse, WatchDocumentRequest, WatchDocumentResponse } = __webpack_require__(176);
const { MethodKind } = __webpack_require__(532);

/**
 * Yorkie is a service that provides a API for SDKs.
 *
 * @generated from service yorkie.v1.YorkieService
 */
const YorkieService = {
  typeName: "yorkie.v1.YorkieService",
  methods: {
    /**
     * @generated from rpc yorkie.v1.YorkieService.ActivateClient
     */
    activateClient: {
      name: "ActivateClient",
      I: ActivateClientRequest,
      O: ActivateClientResponse,
      kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.DeactivateClient
     */
    deactivateClient: {
      name: "DeactivateClient",
      I: DeactivateClientRequest,
      O: DeactivateClientResponse,
      kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.AttachDocument
     */
    attachDocument: {
      name: "AttachDocument",
      I: AttachDocumentRequest,
      O: AttachDocumentResponse,
      kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.DetachDocument
     */
    detachDocument: {
      name: "DetachDocument",
      I: DetachDocumentRequest,
      O: DetachDocumentResponse,
      kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.RemoveDocument
     */
    removeDocument: {
      name: "RemoveDocument",
      I: RemoveDocumentRequest,
      O: RemoveDocumentResponse,
      kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.PushPullChanges
     */
    pushPullChanges: {
      name: "PushPullChanges",
      I: PushPullChangesRequest,
      O: PushPullChangesResponse,
      kind: MethodKind.Unary,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.WatchDocument
     */
    watchDocument: {
      name: "WatchDocument",
      I: WatchDocumentRequest,
      O: WatchDocumentResponse,
      kind: MethodKind.ServerStreaming,
    },
    /**
     * @generated from rpc yorkie.v1.YorkieService.Broadcast
     */
    broadcast: {
      name: "Broadcast",
      I: BroadcastRequest,
      O: BroadcastResponse,
      kind: MethodKind.Unary,
    },
  }
};


exports.V = YorkieService;


/***/ }),

/***/ 176:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

//
// Copyright 2020 The Yorkie Authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// @generated by protoc-gen-es v1.6.0 with parameter "target=js+dts,js_import_style=legacy_commonjs"
// @generated from file src/api/yorkie/v1/yorkie.proto (package yorkie.v1, syntax proto3)
/* eslint-disable */
// @ts-nocheck


Object.defineProperty(exports, "__esModule", ({ value: true }));

const { proto3 } = __webpack_require__(532);
const { ChangePack, DocEvent } = __webpack_require__(646);

/**
 * @generated from message yorkie.v1.ActivateClientRequest
 */
const ActivateClientRequest = proto3.makeMessageType(
  "yorkie.v1.ActivateClientRequest",
  () => [
    { no: 1, name: "client_key", kind: "scalar", T: 9 /* ScalarType.STRING */ },
  ],
);

/**
 * @generated from message yorkie.v1.ActivateClientResponse
 */
const ActivateClientResponse = proto3.makeMessageType(
  "yorkie.v1.ActivateClientResponse",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
  ],
);

/**
 * @generated from message yorkie.v1.DeactivateClientRequest
 */
const DeactivateClientRequest = proto3.makeMessageType(
  "yorkie.v1.DeactivateClientRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
  ],
);

/**
 * @generated from message yorkie.v1.DeactivateClientResponse
 */
const DeactivateClientResponse = proto3.makeMessageType(
  "yorkie.v1.DeactivateClientResponse",
  [],
);

/**
 * @generated from message yorkie.v1.AttachDocumentRequest
 */
const AttachDocumentRequest = proto3.makeMessageType(
  "yorkie.v1.AttachDocumentRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "change_pack", kind: "message", T: ChangePack },
  ],
);

/**
 * @generated from message yorkie.v1.AttachDocumentResponse
 */
const AttachDocumentResponse = proto3.makeMessageType(
  "yorkie.v1.AttachDocumentResponse",
  () => [
    { no: 1, name: "document_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "change_pack", kind: "message", T: ChangePack },
  ],
);

/**
 * @generated from message yorkie.v1.DetachDocumentRequest
 */
const DetachDocumentRequest = proto3.makeMessageType(
  "yorkie.v1.DetachDocumentRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "document_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "change_pack", kind: "message", T: ChangePack },
    { no: 4, name: "remove_if_not_attached", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
  ],
);

/**
 * @generated from message yorkie.v1.DetachDocumentResponse
 */
const DetachDocumentResponse = proto3.makeMessageType(
  "yorkie.v1.DetachDocumentResponse",
  () => [
    { no: 2, name: "change_pack", kind: "message", T: ChangePack },
  ],
);

/**
 * @generated from message yorkie.v1.WatchDocumentRequest
 */
const WatchDocumentRequest = proto3.makeMessageType(
  "yorkie.v1.WatchDocumentRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "document_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
  ],
);

/**
 * @generated from message yorkie.v1.WatchDocumentResponse
 */
const WatchDocumentResponse = proto3.makeMessageType(
  "yorkie.v1.WatchDocumentResponse",
  () => [
    { no: 1, name: "initialization", kind: "message", T: WatchDocumentResponse_Initialization, oneof: "body" },
    { no: 2, name: "event", kind: "message", T: DocEvent, oneof: "body" },
  ],
);

/**
 * @generated from message yorkie.v1.WatchDocumentResponse.Initialization
 */
const WatchDocumentResponse_Initialization = proto3.makeMessageType(
  "yorkie.v1.WatchDocumentResponse.Initialization",
  () => [
    { no: 1, name: "client_ids", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
  ],
  {localName: "WatchDocumentResponse_Initialization"},
);

/**
 * @generated from message yorkie.v1.RemoveDocumentRequest
 */
const RemoveDocumentRequest = proto3.makeMessageType(
  "yorkie.v1.RemoveDocumentRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "document_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "change_pack", kind: "message", T: ChangePack },
  ],
);

/**
 * @generated from message yorkie.v1.RemoveDocumentResponse
 */
const RemoveDocumentResponse = proto3.makeMessageType(
  "yorkie.v1.RemoveDocumentResponse",
  () => [
    { no: 1, name: "change_pack", kind: "message", T: ChangePack },
  ],
);

/**
 * @generated from message yorkie.v1.PushPullChangesRequest
 */
const PushPullChangesRequest = proto3.makeMessageType(
  "yorkie.v1.PushPullChangesRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "document_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "change_pack", kind: "message", T: ChangePack },
    { no: 4, name: "push_only", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
  ],
);

/**
 * @generated from message yorkie.v1.PushPullChangesResponse
 */
const PushPullChangesResponse = proto3.makeMessageType(
  "yorkie.v1.PushPullChangesResponse",
  () => [
    { no: 1, name: "change_pack", kind: "message", T: ChangePack },
  ],
);

/**
 * @generated from message yorkie.v1.BroadcastRequest
 */
const BroadcastRequest = proto3.makeMessageType(
  "yorkie.v1.BroadcastRequest",
  () => [
    { no: 1, name: "client_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "document_id", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "topic", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 4, name: "payload", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
  ],
);

/**
 * @generated from message yorkie.v1.BroadcastResponse
 */
const BroadcastResponse = proto3.makeMessageType(
  "yorkie.v1.BroadcastResponse",
  [],
);


exports.ActivateClientRequest = ActivateClientRequest;
exports.ActivateClientResponse = ActivateClientResponse;
exports.DeactivateClientRequest = DeactivateClientRequest;
exports.DeactivateClientResponse = DeactivateClientResponse;
exports.AttachDocumentRequest = AttachDocumentRequest;
exports.AttachDocumentResponse = AttachDocumentResponse;
exports.DetachDocumentRequest = DetachDocumentRequest;
exports.DetachDocumentResponse = DetachDocumentResponse;
exports.WatchDocumentRequest = WatchDocumentRequest;
exports.WatchDocumentResponse = WatchDocumentResponse;
exports.WatchDocumentResponse_Initialization = WatchDocumentResponse_Initialization;
exports.RemoveDocumentRequest = RemoveDocumentRequest;
exports.RemoveDocumentResponse = RemoveDocumentResponse;
exports.PushPullChangesRequest = PushPullChangesRequest;
exports.PushPullChangesResponse = PushPullChangesResponse;
exports.BroadcastRequest = BroadcastRequest;
exports.BroadcastResponse = BroadcastResponse;


/***/ }),

/***/ 79:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Lt: () => (/* binding */ BinaryWriter),
/* harmony export */   TD: () => (/* binding */ WireType),
/* harmony export */   oP: () => (/* binding */ BinaryReader)
/* harmony export */ });
/* harmony import */ var _google_varint_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(818);
/* harmony import */ var _private_assert_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(120);
/* harmony import */ var _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(210);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/* eslint-disable prefer-const,no-case-declarations,@typescript-eslint/restrict-plus-operands */
/**
 * Protobuf binary format wire types.
 *
 * A wire type provides just enough information to find the length of the
 * following value.
 *
 * See https://developers.google.com/protocol-buffers/docs/encoding#structure
 */
var WireType;
(function (WireType) {
    /**
     * Used for int32, int64, uint32, uint64, sint32, sint64, bool, enum
     */
    WireType[WireType["Varint"] = 0] = "Varint";
    /**
     * Used for fixed64, sfixed64, double.
     * Always 8 bytes with little-endian byte order.
     */
    WireType[WireType["Bit64"] = 1] = "Bit64";
    /**
     * Used for string, bytes, embedded messages, packed repeated fields
     *
     * Only repeated numeric types (types which use the varint, 32-bit,
     * or 64-bit wire types) can be packed. In proto3, such fields are
     * packed by default.
     */
    WireType[WireType["LengthDelimited"] = 2] = "LengthDelimited";
    /**
     * Start of a tag-delimited aggregate, such as a proto2 group, or a message
     * in editions with message_encoding = DELIMITED.
     */
    WireType[WireType["StartGroup"] = 3] = "StartGroup";
    /**
     * End of a tag-delimited aggregate.
     */
    WireType[WireType["EndGroup"] = 4] = "EndGroup";
    /**
     * Used for fixed32, sfixed32, float.
     * Always 4 bytes with little-endian byte order.
     */
    WireType[WireType["Bit32"] = 5] = "Bit32";
})(WireType || (WireType = {}));
class BinaryWriter {
    constructor(textEncoder) {
        /**
         * Previous fork states.
         */
        this.stack = [];
        this.textEncoder = textEncoder !== null && textEncoder !== void 0 ? textEncoder : new TextEncoder();
        this.chunks = [];
        this.buf = [];
    }
    /**
     * Return all bytes written and reset this writer.
     */
    finish() {
        this.chunks.push(new Uint8Array(this.buf)); // flush the buffer
        let len = 0;
        for (let i = 0; i < this.chunks.length; i++)
            len += this.chunks[i].length;
        let bytes = new Uint8Array(len);
        let offset = 0;
        for (let i = 0; i < this.chunks.length; i++) {
            bytes.set(this.chunks[i], offset);
            offset += this.chunks[i].length;
        }
        this.chunks = [];
        return bytes;
    }
    /**
     * Start a new fork for length-delimited data like a message
     * or a packed repeated field.
     *
     * Must be joined later with `join()`.
     */
    fork() {
        this.stack.push({ chunks: this.chunks, buf: this.buf });
        this.chunks = [];
        this.buf = [];
        return this;
    }
    /**
     * Join the last fork. Write its length and bytes, then
     * return to the previous state.
     */
    join() {
        // get chunk of fork
        let chunk = this.finish();
        // restore previous state
        let prev = this.stack.pop();
        if (!prev)
            throw new Error("invalid state, fork stack empty");
        this.chunks = prev.chunks;
        this.buf = prev.buf;
        // write length of chunk as varint
        this.uint32(chunk.byteLength);
        return this.raw(chunk);
    }
    /**
     * Writes a tag (field number and wire type).
     *
     * Equivalent to `uint32( (fieldNo << 3 | type) >>> 0 )`.
     *
     * Generated code should compute the tag ahead of time and call `uint32()`.
     */
    tag(fieldNo, type) {
        return this.uint32(((fieldNo << 3) | type) >>> 0);
    }
    /**
     * Write a chunk of raw bytes.
     */
    raw(chunk) {
        if (this.buf.length) {
            this.chunks.push(new Uint8Array(this.buf));
            this.buf = [];
        }
        this.chunks.push(chunk);
        return this;
    }
    /**
     * Write a `uint32` value, an unsigned 32 bit varint.
     */
    uint32(value) {
        (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assertUInt32 */ .fp)(value);
        // write value as varint 32, inlined for speed
        while (value > 0x7f) {
            this.buf.push((value & 0x7f) | 0x80);
            value = value >>> 7;
        }
        this.buf.push(value);
        return this;
    }
    /**
     * Write a `int32` value, a signed 32 bit varint.
     */
    int32(value) {
        (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assertInt32 */ .ug)(value);
        (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint32write */ .fC)(value, this.buf);
        return this;
    }
    /**
     * Write a `bool` value, a variant.
     */
    bool(value) {
        this.buf.push(value ? 1 : 0);
        return this;
    }
    /**
     * Write a `bytes` value, length-delimited arbitrary data.
     */
    bytes(value) {
        this.uint32(value.byteLength); // write length of chunk as varint
        return this.raw(value);
    }
    /**
     * Write a `string` value, length-delimited data converted to UTF-8 text.
     */
    string(value) {
        let chunk = this.textEncoder.encode(value);
        this.uint32(chunk.byteLength); // write length of chunk as varint
        return this.raw(chunk);
    }
    /**
     * Write a `float` value, 32-bit floating point number.
     */
    float(value) {
        (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assertFloat32 */ .E_)(value);
        let chunk = new Uint8Array(4);
        new DataView(chunk.buffer).setFloat32(0, value, true);
        return this.raw(chunk);
    }
    /**
     * Write a `double` value, a 64-bit floating point number.
     */
    double(value) {
        let chunk = new Uint8Array(8);
        new DataView(chunk.buffer).setFloat64(0, value, true);
        return this.raw(chunk);
    }
    /**
     * Write a `fixed32` value, an unsigned, fixed-length 32-bit integer.
     */
    fixed32(value) {
        (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assertUInt32 */ .fp)(value);
        let chunk = new Uint8Array(4);
        new DataView(chunk.buffer).setUint32(0, value, true);
        return this.raw(chunk);
    }
    /**
     * Write a `sfixed32` value, a signed, fixed-length 32-bit integer.
     */
    sfixed32(value) {
        (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assertInt32 */ .ug)(value);
        let chunk = new Uint8Array(4);
        new DataView(chunk.buffer).setInt32(0, value, true);
        return this.raw(chunk);
    }
    /**
     * Write a `sint32` value, a signed, zigzag-encoded 32-bit varint.
     */
    sint32(value) {
        (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assertInt32 */ .ug)(value);
        // zigzag encode
        value = ((value << 1) ^ (value >> 31)) >>> 0;
        (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint32write */ .fC)(value, this.buf);
        return this;
    }
    /**
     * Write a `fixed64` value, a signed, fixed-length 64-bit integer.
     */
    sfixed64(value) {
        let chunk = new Uint8Array(8), view = new DataView(chunk.buffer), tc = _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.enc(value);
        view.setInt32(0, tc.lo, true);
        view.setInt32(4, tc.hi, true);
        return this.raw(chunk);
    }
    /**
     * Write a `fixed64` value, an unsigned, fixed-length 64 bit integer.
     */
    fixed64(value) {
        let chunk = new Uint8Array(8), view = new DataView(chunk.buffer), tc = _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.uEnc(value);
        view.setInt32(0, tc.lo, true);
        view.setInt32(4, tc.hi, true);
        return this.raw(chunk);
    }
    /**
     * Write a `int64` value, a signed 64-bit varint.
     */
    int64(value) {
        let tc = _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.enc(value);
        (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint64write */ ._y)(tc.lo, tc.hi, this.buf);
        return this;
    }
    /**
     * Write a `sint64` value, a signed, zig-zag-encoded 64-bit varint.
     */
    sint64(value) {
        let tc = _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.enc(value), 
        // zigzag encode
        sign = tc.hi >> 31, lo = (tc.lo << 1) ^ sign, hi = ((tc.hi << 1) | (tc.lo >>> 31)) ^ sign;
        (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint64write */ ._y)(lo, hi, this.buf);
        return this;
    }
    /**
     * Write a `uint64` value, an unsigned 64-bit varint.
     */
    uint64(value) {
        let tc = _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.uEnc(value);
        (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint64write */ ._y)(tc.lo, tc.hi, this.buf);
        return this;
    }
}
class BinaryReader {
    constructor(buf, textDecoder) {
        this.varint64 = _google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint64read */ .sg; // dirty cast for `this`
        /**
         * Read a `uint32` field, an unsigned 32 bit varint.
         */
        this.uint32 = _google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .varint32read */ .jI; // dirty cast for `this` and access to protected `buf`
        this.buf = buf;
        this.len = buf.length;
        this.pos = 0;
        this.view = new DataView(buf.buffer, buf.byteOffset, buf.byteLength);
        this.textDecoder = textDecoder !== null && textDecoder !== void 0 ? textDecoder : new TextDecoder();
    }
    /**
     * Reads a tag - field number and wire type.
     */
    tag() {
        let tag = this.uint32(), fieldNo = tag >>> 3, wireType = tag & 7;
        if (fieldNo <= 0 || wireType < 0 || wireType > 5)
            throw new Error("illegal tag: field no " + fieldNo + " wire type " + wireType);
        return [fieldNo, wireType];
    }
    /**
     * Skip one element on the wire and return the skipped data.
     * Supports WireType.StartGroup since v2.0.0-alpha.23.
     */
    skip(wireType) {
        let start = this.pos;
        switch (wireType) {
            case WireType.Varint:
                while (this.buf[this.pos++] & 0x80) {
                    // ignore
                }
                break;
            // eslint-disable-next-line
            // @ts-ignore TS7029: Fallthrough case in switch
            case WireType.Bit64:
                this.pos += 4;
            // eslint-disable-next-line
            // @ts-ignore TS7029: Fallthrough case in switch
            case WireType.Bit32:
                this.pos += 4;
                break;
            case WireType.LengthDelimited:
                let len = this.uint32();
                this.pos += len;
                break;
            case WireType.StartGroup:
                // From descriptor.proto: Group type is deprecated, not supported in proto3.
                // But we must still be able to parse and treat as unknown.
                let t;
                while ((t = this.tag()[1]) !== WireType.EndGroup) {
                    this.skip(t);
                }
                break;
            default:
                throw new Error("cant skip wire type " + wireType);
        }
        this.assertBounds();
        return this.buf.subarray(start, this.pos);
    }
    /**
     * Throws error if position in byte array is out of range.
     */
    assertBounds() {
        if (this.pos > this.len)
            throw new RangeError("premature EOF");
    }
    /**
     * Read a `int32` field, a signed 32 bit varint.
     */
    int32() {
        return this.uint32() | 0;
    }
    /**
     * Read a `sint32` field, a signed, zigzag-encoded 32-bit varint.
     */
    sint32() {
        let zze = this.uint32();
        // decode zigzag
        return (zze >>> 1) ^ -(zze & 1);
    }
    /**
     * Read a `int64` field, a signed 64-bit varint.
     */
    int64() {
        return _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.dec(...this.varint64());
    }
    /**
     * Read a `uint64` field, an unsigned 64-bit varint.
     */
    uint64() {
        return _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.uDec(...this.varint64());
    }
    /**
     * Read a `sint64` field, a signed, zig-zag-encoded 64-bit varint.
     */
    sint64() {
        let [lo, hi] = this.varint64();
        // decode zig zag
        let s = -(lo & 1);
        lo = ((lo >>> 1) | ((hi & 1) << 31)) ^ s;
        hi = (hi >>> 1) ^ s;
        return _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.dec(lo, hi);
    }
    /**
     * Read a `bool` field, a variant.
     */
    bool() {
        let [lo, hi] = this.varint64();
        return lo !== 0 || hi !== 0;
    }
    /**
     * Read a `fixed32` field, an unsigned, fixed-length 32-bit integer.
     */
    fixed32() {
        return this.view.getUint32((this.pos += 4) - 4, true);
    }
    /**
     * Read a `sfixed32` field, a signed, fixed-length 32-bit integer.
     */
    sfixed32() {
        return this.view.getInt32((this.pos += 4) - 4, true);
    }
    /**
     * Read a `fixed64` field, an unsigned, fixed-length 64 bit integer.
     */
    fixed64() {
        return _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.uDec(this.sfixed32(), this.sfixed32());
    }
    /**
     * Read a `fixed64` field, a signed, fixed-length 64-bit integer.
     */
    sfixed64() {
        return _proto_int64_js__WEBPACK_IMPORTED_MODULE_2__/* .protoInt64 */ .q.dec(this.sfixed32(), this.sfixed32());
    }
    /**
     * Read a `float` field, 32-bit floating point number.
     */
    float() {
        return this.view.getFloat32((this.pos += 4) - 4, true);
    }
    /**
     * Read a `double` field, a 64-bit floating point number.
     */
    double() {
        return this.view.getFloat64((this.pos += 8) - 8, true);
    }
    /**
     * Read a `bytes` field, length-delimited arbitrary data.
     */
    bytes() {
        let len = this.uint32(), start = this.pos;
        this.pos += len;
        this.assertBounds();
        return this.buf.subarray(start, start + len);
    }
    /**
     * Read a `string` field, length-delimited data converted to UTF-8 text.
     */
    string() {
        return this.textDecoder.decode(this.bytes());
    }
}


/***/ }),

/***/ 465:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   p: () => (/* binding */ LongType),
/* harmony export */   w: () => (/* binding */ ScalarType)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Scalar value types. This is a subset of field types declared by protobuf
 * enum google.protobuf.FieldDescriptorProto.Type The types GROUP and MESSAGE
 * are omitted, but the numerical values are identical.
 */
var ScalarType;
(function (ScalarType) {
    // 0 is reserved for errors.
    // Order is weird for historical reasons.
    ScalarType[ScalarType["DOUBLE"] = 1] = "DOUBLE";
    ScalarType[ScalarType["FLOAT"] = 2] = "FLOAT";
    // Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT64 if
    // negative values are likely.
    ScalarType[ScalarType["INT64"] = 3] = "INT64";
    ScalarType[ScalarType["UINT64"] = 4] = "UINT64";
    // Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT32 if
    // negative values are likely.
    ScalarType[ScalarType["INT32"] = 5] = "INT32";
    ScalarType[ScalarType["FIXED64"] = 6] = "FIXED64";
    ScalarType[ScalarType["FIXED32"] = 7] = "FIXED32";
    ScalarType[ScalarType["BOOL"] = 8] = "BOOL";
    ScalarType[ScalarType["STRING"] = 9] = "STRING";
    // Tag-delimited aggregate.
    // Group type is deprecated and not supported in proto3. However, Proto3
    // implementations should still be able to parse the group wire format and
    // treat group fields as unknown fields.
    // TYPE_GROUP = 10,
    // TYPE_MESSAGE = 11,  // Length-delimited aggregate.
    // New in version 2.
    ScalarType[ScalarType["BYTES"] = 12] = "BYTES";
    ScalarType[ScalarType["UINT32"] = 13] = "UINT32";
    // TYPE_ENUM = 14,
    ScalarType[ScalarType["SFIXED32"] = 15] = "SFIXED32";
    ScalarType[ScalarType["SFIXED64"] = 16] = "SFIXED64";
    ScalarType[ScalarType["SINT32"] = 17] = "SINT32";
    ScalarType[ScalarType["SINT64"] = 18] = "SINT64";
})(ScalarType || (ScalarType = {}));
/**
 * JavaScript representation of fields with 64 bit integral types (int64, uint64,
 * sint64, fixed64, sfixed64).
 *
 * This is a subset of google.protobuf.FieldOptions.JSType, which defines JS_NORMAL,
 * JS_STRING, and JS_NUMBER. Protobuf-ES uses BigInt by default, but will use
 * String if `[jstype = JS_STRING]` is specified.
 *
 * ```protobuf
 * uint64 field_a = 1; // BigInt
 * uint64 field_b = 2 [jstype = JS_NORMAL]; // BigInt
 * uint64 field_b = 2 [jstype = JS_NUMBER]; // BigInt
 * uint64 field_b = 2 [jstype = JS_STRING]; // String
 * ```
 */
var LongType;
(function (LongType) {
    /**
     * Use JavaScript BigInt.
     */
    LongType[LongType["BIGINT"] = 0] = "BIGINT";
    /**
     * Use JavaScript String.
     *
     * Field option `[jstype = JS_STRING]`.
     */
    LongType[LongType["STRING"] = 1] = "STRING";
})(LongType || (LongType = {}));


/***/ }),

/***/ 733:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   I: () => (/* binding */ Any)
/* harmony export */ });
/* harmony import */ var _message_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(561);
/* harmony import */ var _proto3_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(850);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * `Any` contains an arbitrary serialized protocol buffer message along with a
 * URL that describes the type of the serialized message.
 *
 * Protobuf library provides support to pack/unpack Any values in the form
 * of utility functions or additional generated methods of the Any type.
 *
 * Example 1: Pack and unpack a message in C++.
 *
 *     Foo foo = ...;
 *     Any any;
 *     any.PackFrom(foo);
 *     ...
 *     if (any.UnpackTo(&foo)) {
 *       ...
 *     }
 *
 * Example 2: Pack and unpack a message in Java.
 *
 *     Foo foo = ...;
 *     Any any = Any.pack(foo);
 *     ...
 *     if (any.is(Foo.class)) {
 *       foo = any.unpack(Foo.class);
 *     }
 *     // or ...
 *     if (any.isSameTypeAs(Foo.getDefaultInstance())) {
 *       foo = any.unpack(Foo.getDefaultInstance());
 *     }
 *
 *  Example 3: Pack and unpack a message in Python.
 *
 *     foo = Foo(...)
 *     any = Any()
 *     any.Pack(foo)
 *     ...
 *     if any.Is(Foo.DESCRIPTOR):
 *       any.Unpack(foo)
 *       ...
 *
 *  Example 4: Pack and unpack a message in Go
 *
 *      foo := &pb.Foo{...}
 *      any, err := anypb.New(foo)
 *      if err != nil {
 *        ...
 *      }
 *      ...
 *      foo := &pb.Foo{}
 *      if err := any.UnmarshalTo(foo); err != nil {
 *        ...
 *      }
 *
 * The pack methods provided by protobuf library will by default use
 * 'type.googleapis.com/full.type.name' as the type URL and the unpack
 * methods only use the fully qualified type name after the last '/'
 * in the type URL, for example "foo.bar.com/x/y.z" will yield type
 * name "y.z".
 *
 * JSON
 * ====
 * The JSON representation of an `Any` value uses the regular
 * representation of the deserialized, embedded message, with an
 * additional field `@type` which contains the type URL. Example:
 *
 *     package google.profile;
 *     message Person {
 *       string first_name = 1;
 *       string last_name = 2;
 *     }
 *
 *     {
 *       "@type": "type.googleapis.com/google.profile.Person",
 *       "firstName": <string>,
 *       "lastName": <string>
 *     }
 *
 * If the embedded message type is well-known and has a custom JSON
 * representation, that representation will be embedded adding a field
 * `value` which holds the custom JSON in addition to the `@type`
 * field. Example (for message [google.protobuf.Duration][]):
 *
 *     {
 *       "@type": "type.googleapis.com/google.protobuf.Duration",
 *       "value": "1.212s"
 *     }
 *
 *
 * @generated from message google.protobuf.Any
 */
class Any extends _message_js__WEBPACK_IMPORTED_MODULE_0__/* .Message */ .v {
    constructor(data) {
        super();
        /**
         * A URL/resource name that uniquely identifies the type of the serialized
         * protocol buffer message. This string must contain at least
         * one "/" character. The last segment of the URL's path must represent
         * the fully qualified name of the type (as in
         * `path/google.protobuf.Duration`). The name should be in a canonical form
         * (e.g., leading "." is not accepted).
         *
         * In practice, teams usually precompile into the binary all types that they
         * expect it to use in the context of Any. However, for URLs which use the
         * scheme `http`, `https`, or no scheme, one can optionally set up a type
         * server that maps type URLs to message definitions as follows:
         *
         * * If no scheme is provided, `https` is assumed.
         * * An HTTP GET on the URL must yield a [google.protobuf.Type][]
         *   value in binary format, or produce an error.
         * * Applications are allowed to cache lookup results based on the
         *   URL, or have them precompiled into a binary to avoid any
         *   lookup. Therefore, binary compatibility needs to be preserved
         *   on changes to types. (Use versioned type names to manage
         *   breaking changes.)
         *
         * Note: this functionality is not currently available in the official
         * protobuf release, and it is not used for type URLs beginning with
         * type.googleapis.com. As of May 2023, there are no widely used type server
         * implementations and no plans to implement one.
         *
         * Schemes other than `http`, `https` (or the empty scheme) might be
         * used with implementation specific semantics.
         *
         *
         * @generated from field: string type_url = 1;
         */
        this.typeUrl = "";
        /**
         * Must be a valid serialized protocol buffer of the above specified type.
         *
         * @generated from field: bytes value = 2;
         */
        this.value = new Uint8Array(0);
        _proto3_js__WEBPACK_IMPORTED_MODULE_1__/* .proto3 */ .w.util.initPartial(data, this);
    }
    toJson(options) {
        var _a;
        if (this.typeUrl === "") {
            return {};
        }
        const typeName = this.typeUrlToName(this.typeUrl);
        const messageType = (_a = options === null || options === void 0 ? void 0 : options.typeRegistry) === null || _a === void 0 ? void 0 : _a.findMessage(typeName);
        if (!messageType) {
            throw new Error(`cannot encode message google.protobuf.Any to JSON: "${this.typeUrl}" is not in the type registry`);
        }
        const message = messageType.fromBinary(this.value);
        let json = message.toJson(options);
        if (typeName.startsWith("google.protobuf.") || (json === null || Array.isArray(json) || typeof json !== "object")) {
            json = { value: json };
        }
        json["@type"] = this.typeUrl;
        return json;
    }
    fromJson(json, options) {
        var _a;
        if (json === null || Array.isArray(json) || typeof json != "object") {
            throw new Error(`cannot decode message google.protobuf.Any from JSON: expected object but got ${json === null ? "null" : Array.isArray(json) ? "array" : typeof json}`);
        }
        if (Object.keys(json).length == 0) {
            return this;
        }
        const typeUrl = json["@type"];
        if (typeof typeUrl != "string" || typeUrl == "") {
            throw new Error(`cannot decode message google.protobuf.Any from JSON: "@type" is empty`);
        }
        const typeName = this.typeUrlToName(typeUrl), messageType = (_a = options === null || options === void 0 ? void 0 : options.typeRegistry) === null || _a === void 0 ? void 0 : _a.findMessage(typeName);
        if (!messageType) {
            throw new Error(`cannot decode message google.protobuf.Any from JSON: ${typeUrl} is not in the type registry`);
        }
        let message;
        if (typeName.startsWith("google.protobuf.") && Object.prototype.hasOwnProperty.call(json, "value")) {
            message = messageType.fromJson(json["value"], options);
        }
        else {
            const copy = Object.assign({}, json);
            delete copy["@type"];
            message = messageType.fromJson(copy, options);
        }
        this.packFrom(message);
        return this;
    }
    packFrom(message) {
        this.value = message.toBinary();
        this.typeUrl = this.typeNameToUrl(message.getType().typeName);
    }
    unpackTo(target) {
        if (!this.is(target.getType())) {
            return false;
        }
        target.fromBinary(this.value);
        return true;
    }
    unpack(registry) {
        if (this.typeUrl === "") {
            return undefined;
        }
        const messageType = registry.findMessage(this.typeUrlToName(this.typeUrl));
        if (!messageType) {
            return undefined;
        }
        return messageType.fromBinary(this.value);
    }
    is(type) {
        if (this.typeUrl === '') {
            return false;
        }
        const name = this.typeUrlToName(this.typeUrl);
        let typeName = '';
        if (typeof type === 'string') {
            typeName = type;
        }
        else {
            typeName = type.typeName;
        }
        return name === typeName;
    }
    typeNameToUrl(name) {
        return `type.googleapis.com/${name}`;
    }
    typeUrlToName(url) {
        if (!url.length) {
            throw new Error(`invalid type url: ${url}`);
        }
        const slash = url.lastIndexOf("/");
        const name = slash >= 0 ? url.substring(slash + 1) : url;
        if (!name.length) {
            throw new Error(`invalid type url: ${url}`);
        }
        return name;
    }
    static pack(message) {
        const any = new Any();
        any.packFrom(message);
        return any;
    }
    static fromBinary(bytes, options) {
        return new Any().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Any().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Any().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return _proto3_js__WEBPACK_IMPORTED_MODULE_1__/* .proto3 */ .w.util.equals(Any, a, b);
    }
}
Any.runtime = _proto3_js__WEBPACK_IMPORTED_MODULE_1__/* .proto3 */ .w;
Any.typeName = "google.protobuf.Any";
Any.fields = _proto3_js__WEBPACK_IMPORTED_MODULE_1__/* .proto3 */ .w.util.newFieldList(() => [
    { no: 1, name: "type_url", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "value", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
]);


/***/ }),

/***/ 818:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Ak: () => (/* binding */ int64ToString),
/* harmony export */   CZ: () => (/* binding */ int64FromString),
/* harmony export */   Fd: () => (/* binding */ uInt64ToString),
/* harmony export */   _y: () => (/* binding */ varint64write),
/* harmony export */   fC: () => (/* binding */ varint32write),
/* harmony export */   jI: () => (/* binding */ varint32read),
/* harmony export */   sg: () => (/* binding */ varint64read)
/* harmony export */ });
// Copyright 2008 Google Inc.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// * Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
// * Redistributions in binary form must reproduce the above
// copyright notice, this list of conditions and the following disclaimer
// in the documentation and/or other materials provided with the
// distribution.
// * Neither the name of Google Inc. nor the names of its
// contributors may be used to endorse or promote products derived from
// this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Code generated by the Protocol Buffer compiler is owned by the owner
// of the input file used when generating it.  This code is not
// standalone and requires a support library to be linked with it.  This
// support library is itself covered by the above license.
/* eslint-disable prefer-const,@typescript-eslint/restrict-plus-operands */
/**
 * Read a 64 bit varint as two JS numbers.
 *
 * Returns tuple:
 * [0]: low bits
 * [1]: high bits
 *
 * Copyright 2008 Google Inc.  All rights reserved.
 *
 * See https://github.com/protocolbuffers/protobuf/blob/8a71927d74a4ce34efe2d8769fda198f52d20d12/js/experimental/runtime/kernel/buffer_decoder.js#L175
 */
function varint64read() {
    let lowBits = 0;
    let highBits = 0;
    for (let shift = 0; shift < 28; shift += 7) {
        let b = this.buf[this.pos++];
        lowBits |= (b & 0x7f) << shift;
        if ((b & 0x80) == 0) {
            this.assertBounds();
            return [lowBits, highBits];
        }
    }
    let middleByte = this.buf[this.pos++];
    // last four bits of the first 32 bit number
    lowBits |= (middleByte & 0x0f) << 28;
    // 3 upper bits are part of the next 32 bit number
    highBits = (middleByte & 0x70) >> 4;
    if ((middleByte & 0x80) == 0) {
        this.assertBounds();
        return [lowBits, highBits];
    }
    for (let shift = 3; shift <= 31; shift += 7) {
        let b = this.buf[this.pos++];
        highBits |= (b & 0x7f) << shift;
        if ((b & 0x80) == 0) {
            this.assertBounds();
            return [lowBits, highBits];
        }
    }
    throw new Error("invalid varint");
}
/**
 * Write a 64 bit varint, given as two JS numbers, to the given bytes array.
 *
 * Copyright 2008 Google Inc.  All rights reserved.
 *
 * See https://github.com/protocolbuffers/protobuf/blob/8a71927d74a4ce34efe2d8769fda198f52d20d12/js/experimental/runtime/kernel/writer.js#L344
 */
function varint64write(lo, hi, bytes) {
    for (let i = 0; i < 28; i = i + 7) {
        const shift = lo >>> i;
        const hasNext = !(shift >>> 7 == 0 && hi == 0);
        const byte = (hasNext ? shift | 0x80 : shift) & 0xff;
        bytes.push(byte);
        if (!hasNext) {
            return;
        }
    }
    const splitBits = ((lo >>> 28) & 0x0f) | ((hi & 0x07) << 4);
    const hasMoreBits = !(hi >> 3 == 0);
    bytes.push((hasMoreBits ? splitBits | 0x80 : splitBits) & 0xff);
    if (!hasMoreBits) {
        return;
    }
    for (let i = 3; i < 31; i = i + 7) {
        const shift = hi >>> i;
        const hasNext = !(shift >>> 7 == 0);
        const byte = (hasNext ? shift | 0x80 : shift) & 0xff;
        bytes.push(byte);
        if (!hasNext) {
            return;
        }
    }
    bytes.push((hi >>> 31) & 0x01);
}
// constants for binary math
const TWO_PWR_32_DBL = 0x100000000;
/**
 * Parse decimal string of 64 bit integer value as two JS numbers.
 *
 * Copyright 2008 Google Inc.  All rights reserved.
 *
 * See https://github.com/protocolbuffers/protobuf-javascript/blob/a428c58273abad07c66071d9753bc4d1289de426/experimental/runtime/int64.js#L10
 */
function int64FromString(dec) {
    // Check for minus sign.
    const minus = dec[0] === "-";
    if (minus) {
        dec = dec.slice(1);
    }
    // Work 6 decimal digits at a time, acting like we're converting base 1e6
    // digits to binary. This is safe to do with floating point math because
    // Number.isSafeInteger(ALL_32_BITS * 1e6) == true.
    const base = 1e6;
    let lowBits = 0;
    let highBits = 0;
    function add1e6digit(begin, end) {
        // Note: Number('') is 0.
        const digit1e6 = Number(dec.slice(begin, end));
        highBits *= base;
        lowBits = lowBits * base + digit1e6;
        // Carry bits from lowBits to
        if (lowBits >= TWO_PWR_32_DBL) {
            highBits = highBits + ((lowBits / TWO_PWR_32_DBL) | 0);
            lowBits = lowBits % TWO_PWR_32_DBL;
        }
    }
    add1e6digit(-24, -18);
    add1e6digit(-18, -12);
    add1e6digit(-12, -6);
    add1e6digit(-6);
    return minus ? negate(lowBits, highBits) : newBits(lowBits, highBits);
}
/**
 * Losslessly converts a 64-bit signed integer in 32:32 split representation
 * into a decimal string.
 *
 * Copyright 2008 Google Inc.  All rights reserved.
 *
 * See https://github.com/protocolbuffers/protobuf-javascript/blob/a428c58273abad07c66071d9753bc4d1289de426/experimental/runtime/int64.js#L10
 */
function int64ToString(lo, hi) {
    let bits = newBits(lo, hi);
    // If we're treating the input as a signed value and the high bit is set, do
    // a manual two's complement conversion before the decimal conversion.
    const negative = (bits.hi & 0x80000000);
    if (negative) {
        bits = negate(bits.lo, bits.hi);
    }
    const result = uInt64ToString(bits.lo, bits.hi);
    return negative ? "-" + result : result;
}
/**
 * Losslessly converts a 64-bit unsigned integer in 32:32 split representation
 * into a decimal string.
 *
 * Copyright 2008 Google Inc.  All rights reserved.
 *
 * See https://github.com/protocolbuffers/protobuf-javascript/blob/a428c58273abad07c66071d9753bc4d1289de426/experimental/runtime/int64.js#L10
 */
function uInt64ToString(lo, hi) {
    ({ lo, hi } = toUnsigned(lo, hi));
    // Skip the expensive conversion if the number is small enough to use the
    // built-in conversions.
    // Number.MAX_SAFE_INTEGER = 0x001FFFFF FFFFFFFF, thus any number with
    // highBits <= 0x1FFFFF can be safely expressed with a double and retain
    // integer precision.
    // Proven by: Number.isSafeInteger(0x1FFFFF * 2**32 + 0xFFFFFFFF) == true.
    if (hi <= 0x1FFFFF) {
        return String(TWO_PWR_32_DBL * hi + lo);
    }
    // What this code is doing is essentially converting the input number from
    // base-2 to base-1e7, which allows us to represent the 64-bit range with
    // only 3 (very large) digits. Those digits are then trivial to convert to
    // a base-10 string.
    // The magic numbers used here are -
    // 2^24 = 16777216 = (1,6777216) in base-1e7.
    // 2^48 = 281474976710656 = (2,8147497,6710656) in base-1e7.
    // Split 32:32 representation into 16:24:24 representation so our
    // intermediate digits don't overflow.
    const low = lo & 0xFFFFFF;
    const mid = ((lo >>> 24) | (hi << 8)) & 0xFFFFFF;
    const high = (hi >> 16) & 0xFFFF;
    // Assemble our three base-1e7 digits, ignoring carries. The maximum
    // value in a digit at this step is representable as a 48-bit integer, which
    // can be stored in a 64-bit floating point number.
    let digitA = low + (mid * 6777216) + (high * 6710656);
    let digitB = mid + (high * 8147497);
    let digitC = (high * 2);
    // Apply carries from A to B and from B to C.
    const base = 10000000;
    if (digitA >= base) {
        digitB += Math.floor(digitA / base);
        digitA %= base;
    }
    if (digitB >= base) {
        digitC += Math.floor(digitB / base);
        digitB %= base;
    }
    // If digitC is 0, then we should have returned in the trivial code path
    // at the top for non-safe integers. Given this, we can assume both digitB
    // and digitA need leading zeros.
    return digitC.toString() + decimalFrom1e7WithLeadingZeros(digitB) +
        decimalFrom1e7WithLeadingZeros(digitA);
}
function toUnsigned(lo, hi) {
    return { lo: lo >>> 0, hi: hi >>> 0 };
}
function newBits(lo, hi) {
    return { lo: lo | 0, hi: hi | 0 };
}
/**
 * Returns two's compliment negation of input.
 * @see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Bitwise_Operators#Signed_32-bit_integers
 */
function negate(lowBits, highBits) {
    highBits = ~highBits;
    if (lowBits) {
        lowBits = ~lowBits + 1;
    }
    else {
        // If lowBits is 0, then bitwise-not is 0xFFFFFFFF,
        // adding 1 to that, results in 0x100000000, which leaves
        // the low bits 0x0 and simply adds one to the high bits.
        highBits += 1;
    }
    return newBits(lowBits, highBits);
}
/**
 * Returns decimal representation of digit1e7 with leading zeros.
 */
const decimalFrom1e7WithLeadingZeros = (digit1e7) => {
    const partial = String(digit1e7);
    return "0000000".slice(partial.length) + partial;
};
/**
 * Write a 32 bit varint, signed or unsigned. Same as `varint64write(0, value, bytes)`
 *
 * Copyright 2008 Google Inc.  All rights reserved.
 *
 * See https://github.com/protocolbuffers/protobuf/blob/1b18833f4f2a2f681f4e4a25cdf3b0a43115ec26/js/binary/encoder.js#L144
 */
function varint32write(value, bytes) {
    if (value >= 0) {
        // write value as varint 32
        while (value > 0x7f) {
            bytes.push((value & 0x7f) | 0x80);
            value = value >>> 7;
        }
        bytes.push(value);
    }
    else {
        for (let i = 0; i < 9; i++) {
            bytes.push((value & 127) | 128);
            value = value >> 7;
        }
        bytes.push(1);
    }
}
/**
 * Read an unsigned 32 bit varint.
 *
 * See https://github.com/protocolbuffers/protobuf/blob/8a71927d74a4ce34efe2d8769fda198f52d20d12/js/experimental/runtime/kernel/buffer_decoder.js#L220
 */
function varint32read() {
    let b = this.buf[this.pos++];
    let result = b & 0x7f;
    if ((b & 0x80) == 0) {
        this.assertBounds();
        return result;
    }
    b = this.buf[this.pos++];
    result |= (b & 0x7f) << 7;
    if ((b & 0x80) == 0) {
        this.assertBounds();
        return result;
    }
    b = this.buf[this.pos++];
    result |= (b & 0x7f) << 14;
    if ((b & 0x80) == 0) {
        this.assertBounds();
        return result;
    }
    b = this.buf[this.pos++];
    result |= (b & 0x7f) << 21;
    if ((b & 0x80) == 0) {
        this.assertBounds();
        return result;
    }
    // Extract only last 4 bits
    b = this.buf[this.pos++];
    result |= (b & 0x0f) << 28;
    for (let readBytes = 5; (b & 0x80) !== 0 && readBytes < 10; readBytes++)
        b = this.buf[this.pos++];
    if ((b & 0x80) != 0)
        throw new Error("invalid varint");
    this.assertBounds();
    // Result can have 32 bits, convert it to unsigned
    return result >>> 0;
}


/***/ }),

/***/ 532:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Any: () => (/* reexport */ any_pb/* Any */.I),
  Api: () => (/* reexport */ Api),
  BinaryReader: () => (/* reexport */ binary_encoding/* BinaryReader */.oP),
  BinaryWriter: () => (/* reexport */ binary_encoding/* BinaryWriter */.Lt),
  BoolValue: () => (/* reexport */ BoolValue),
  BytesValue: () => (/* reexport */ BytesValue),
  CodeGeneratorRequest: () => (/* reexport */ CodeGeneratorRequest),
  CodeGeneratorResponse: () => (/* reexport */ CodeGeneratorResponse),
  CodeGeneratorResponse_Feature: () => (/* reexport */ CodeGeneratorResponse_Feature),
  CodeGeneratorResponse_File: () => (/* reexport */ CodeGeneratorResponse_File),
  DescriptorProto: () => (/* reexport */ DescriptorProto),
  DescriptorProto_ExtensionRange: () => (/* reexport */ DescriptorProto_ExtensionRange),
  DescriptorProto_ReservedRange: () => (/* reexport */ DescriptorProto_ReservedRange),
  DoubleValue: () => (/* reexport */ DoubleValue),
  Duration: () => (/* reexport */ Duration),
  Edition: () => (/* reexport */ Edition),
  Empty: () => (/* reexport */ Empty),
  Enum: () => (/* reexport */ Enum),
  EnumDescriptorProto: () => (/* reexport */ EnumDescriptorProto),
  EnumDescriptorProto_EnumReservedRange: () => (/* reexport */ EnumDescriptorProto_EnumReservedRange),
  EnumOptions: () => (/* reexport */ EnumOptions),
  EnumValue: () => (/* reexport */ EnumValue),
  EnumValueDescriptorProto: () => (/* reexport */ EnumValueDescriptorProto),
  EnumValueOptions: () => (/* reexport */ EnumValueOptions),
  ExtensionRangeOptions: () => (/* reexport */ ExtensionRangeOptions),
  ExtensionRangeOptions_Declaration: () => (/* reexport */ ExtensionRangeOptions_Declaration),
  ExtensionRangeOptions_VerificationState: () => (/* reexport */ ExtensionRangeOptions_VerificationState),
  FeatureSet: () => (/* reexport */ FeatureSet),
  FeatureSetDefaults: () => (/* reexport */ FeatureSetDefaults),
  FeatureSetDefaults_FeatureSetEditionDefault: () => (/* reexport */ FeatureSetDefaults_FeatureSetEditionDefault),
  FeatureSet_EnumType: () => (/* reexport */ FeatureSet_EnumType),
  FeatureSet_FieldPresence: () => (/* reexport */ FeatureSet_FieldPresence),
  FeatureSet_JsonFormat: () => (/* reexport */ FeatureSet_JsonFormat),
  FeatureSet_MessageEncoding: () => (/* reexport */ FeatureSet_MessageEncoding),
  FeatureSet_RepeatedFieldEncoding: () => (/* reexport */ FeatureSet_RepeatedFieldEncoding),
  FeatureSet_Utf8Validation: () => (/* reexport */ FeatureSet_Utf8Validation),
  Field: () => (/* reexport */ Field),
  FieldDescriptorProto: () => (/* reexport */ FieldDescriptorProto),
  FieldDescriptorProto_Label: () => (/* reexport */ FieldDescriptorProto_Label),
  FieldDescriptorProto_Type: () => (/* reexport */ FieldDescriptorProto_Type),
  FieldMask: () => (/* reexport */ FieldMask),
  FieldOptions: () => (/* reexport */ FieldOptions),
  FieldOptions_CType: () => (/* reexport */ FieldOptions_CType),
  FieldOptions_EditionDefault: () => (/* reexport */ FieldOptions_EditionDefault),
  FieldOptions_JSType: () => (/* reexport */ FieldOptions_JSType),
  FieldOptions_OptionRetention: () => (/* reexport */ FieldOptions_OptionRetention),
  FieldOptions_OptionTargetType: () => (/* reexport */ FieldOptions_OptionTargetType),
  Field_Cardinality: () => (/* reexport */ Field_Cardinality),
  Field_Kind: () => (/* reexport */ Field_Kind),
  FileDescriptorProto: () => (/* reexport */ FileDescriptorProto),
  FileDescriptorSet: () => (/* reexport */ FileDescriptorSet),
  FileOptions: () => (/* reexport */ FileOptions),
  FileOptions_OptimizeMode: () => (/* reexport */ FileOptions_OptimizeMode),
  FloatValue: () => (/* reexport */ FloatValue),
  GeneratedCodeInfo: () => (/* reexport */ GeneratedCodeInfo),
  GeneratedCodeInfo_Annotation: () => (/* reexport */ GeneratedCodeInfo_Annotation),
  GeneratedCodeInfo_Annotation_Semantic: () => (/* reexport */ GeneratedCodeInfo_Annotation_Semantic),
  Int32Value: () => (/* reexport */ Int32Value),
  Int64Value: () => (/* reexport */ Int64Value),
  ListValue: () => (/* reexport */ ListValue),
  LongType: () => (/* reexport */ esm_field/* LongType */.p),
  Message: () => (/* reexport */ esm_message/* Message */.v),
  MessageOptions: () => (/* reexport */ MessageOptions),
  Method: () => (/* reexport */ Method),
  MethodDescriptorProto: () => (/* reexport */ MethodDescriptorProto),
  MethodIdempotency: () => (/* reexport */ service_type/* MethodIdempotency */.w),
  MethodKind: () => (/* reexport */ service_type/* MethodKind */.t),
  MethodOptions: () => (/* reexport */ MethodOptions),
  MethodOptions_IdempotencyLevel: () => (/* reexport */ MethodOptions_IdempotencyLevel),
  Mixin: () => (/* reexport */ Mixin),
  NullValue: () => (/* reexport */ NullValue),
  OneofDescriptorProto: () => (/* reexport */ OneofDescriptorProto),
  OneofOptions: () => (/* reexport */ OneofOptions),
  Option: () => (/* reexport */ Option),
  ScalarType: () => (/* reexport */ esm_field/* ScalarType */.w),
  ServiceDescriptorProto: () => (/* reexport */ ServiceDescriptorProto),
  ServiceOptions: () => (/* reexport */ ServiceOptions),
  SourceCodeInfo: () => (/* reexport */ SourceCodeInfo),
  SourceCodeInfo_Location: () => (/* reexport */ SourceCodeInfo_Location),
  SourceContext: () => (/* reexport */ SourceContext),
  StringValue: () => (/* reexport */ StringValue),
  Struct: () => (/* reexport */ Struct),
  Syntax: () => (/* reexport */ Syntax),
  Timestamp: () => (/* reexport */ Timestamp),
  Type: () => (/* reexport */ Type),
  UInt32Value: () => (/* reexport */ UInt32Value),
  UInt64Value: () => (/* reexport */ UInt64Value),
  UninterpretedOption: () => (/* reexport */ UninterpretedOption),
  UninterpretedOption_NamePart: () => (/* reexport */ UninterpretedOption_NamePart),
  Value: () => (/* reexport */ Value),
  Version: () => (/* reexport */ Version),
  WireType: () => (/* reexport */ binary_encoding/* WireType */.TD),
  codegenInfo: () => (/* reexport */ codegenInfo),
  createDescriptorSet: () => (/* reexport */ createDescriptorSet),
  createRegistry: () => (/* reexport */ createRegistry),
  createRegistryFromDescriptors: () => (/* reexport */ createRegistryFromDescriptors),
  proto2: () => (/* reexport */ proto2),
  proto3: () => (/* reexport */ proto3/* proto3 */.w),
  protoBase64: () => (/* reexport */ proto_base64/* protoBase64 */.W),
  protoDelimited: () => (/* reexport */ protoDelimited),
  protoDouble: () => (/* reexport */ protoDouble),
  protoInt64: () => (/* reexport */ proto_int64/* protoInt64 */.q),
  toPlainMessage: () => (/* reexport */ toPlainMessage)
});

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto3.js + 2 modules
var proto3 = __webpack_require__(850);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/proto-runtime.js + 1 modules
var proto_runtime = __webpack_require__(493);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/field.js
var esm_field = __webpack_require__(465);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/binary-format-common.js
var binary_format_common = __webpack_require__(744);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/binary-format-proto2.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/* eslint-disable @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-argument, @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unnecessary-condition, @typescript-eslint/strict-boolean-expressions, no-case-declarations, prefer-const */
function makeBinaryFormatProto2() {
    return Object.assign(Object.assign({}, (0,binary_format_common/* makeBinaryFormatCommon */.gY)()), { writeMessage(message, writer, options) {
            const type = message.getType();
            let field;
            try {
                for (field of type.fields.byNumber()) {
                    let value, // this will be our field value, whether it is member of a oneof or not
                    repeated = field.repeated, localName = field.localName;
                    if (field.oneof) {
                        const oneof = message[field.oneof.localName];
                        if (oneof.case !== localName) {
                            continue; // field is not selected, skip
                        }
                        value = oneof.value;
                    }
                    else {
                        value = message[localName];
                        // In contrast to proto3, we raise an error if a non-optional (proto2 required)
                        // field is missing a value.
                        if (value === undefined && !field.oneof && !field.opt) {
                            throw new Error(`cannot encode field ${type.typeName}.${field.name} to binary: required field not set`);
                        }
                    }
                    switch (field.kind) {
                        case "scalar":
                        case "enum":
                            let scalarType = field.kind == "enum" ? esm_field/* ScalarType */.w.INT32 : field.T;
                            if (repeated) {
                                if (field.packed) {
                                    (0,binary_format_common/* writePacked */.Jj)(writer, scalarType, field.no, value);
                                }
                                else {
                                    for (const item of value) {
                                        (0,binary_format_common/* writeScalar */.NN)(writer, scalarType, field.no, item, true);
                                    }
                                }
                            }
                            else {
                                if (value !== undefined) {
                                    // In contrast to proto3, we do not skip intrinsic default values.
                                    // Explicit default values are not special cased either.
                                    (0,binary_format_common/* writeScalar */.NN)(writer, scalarType, field.no, value, true);
                                }
                            }
                            break;
                        case "message":
                            if (repeated) {
                                for (const item of value) {
                                    (0,binary_format_common/* writeMessageField */.oQ)(writer, options, field, item);
                                }
                            }
                            else {
                                (0,binary_format_common/* writeMessageField */.oQ)(writer, options, field, value);
                            }
                            break;
                        case "map":
                            for (const [key, val] of Object.entries(value)) {
                                (0,binary_format_common/* writeMapEntry */.gQ)(writer, options, field, key, val);
                            }
                            break;
                    }
                }
            }
            catch (e) {
                let m = field
                    ? `cannot encode field ${type.typeName}.${field === null || field === void 0 ? void 0 : field.name} to binary`
                    : `cannot encode message ${type.typeName} to binary`;
                let r = e instanceof Error ? e.message : String(e);
                throw new Error(m + (r.length > 0 ? `: ${r}` : ""));
            }
            if (options.writeUnknownFields) {
                this.writeUnknownFields(message, writer);
            }
            return writer;
        } });
}

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/util-common.js
var util_common = __webpack_require__(433);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/field-list.js
var field_list = __webpack_require__(501);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/field.js
var private_field = __webpack_require__(215);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/names.js
var names = __webpack_require__(504);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/field-wrapper.js
var field_wrapper = __webpack_require__(432);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/assert.js
var assert = __webpack_require__(120);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/json-format-common.js
var json_format_common = __webpack_require__(814);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/json-format-proto2.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/* eslint-disable no-case-declarations, @typescript-eslint/restrict-plus-operands,@typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-argument */
function makeJsonFormatProto2() {
    return (0,json_format_common/* makeJsonFormatCommon */.b)((writeEnum, writeScalar) => {
        return function writeField(field, value, options) {
            if (field.kind == "map") {
                const jsonObj = {};
                switch (field.V.kind) {
                    case "scalar":
                        for (const [entryKey, entryValue] of Object.entries(value)) {
                            const val = writeScalar(field.V.T, entryValue, true);
                            (0,assert/* assert */.hu)(val !== undefined);
                            jsonObj[entryKey.toString()] = val; // JSON standard allows only (double quoted) string as property key
                        }
                        break;
                    case "message":
                        for (const [entryKey, entryValue] of Object.entries(value)) {
                            // JSON standard allows only (double quoted) string as property key
                            jsonObj[entryKey.toString()] = entryValue.toJson(options);
                        }
                        break;
                    case "enum":
                        const enumType = field.V.T;
                        for (const [entryKey, entryValue] of Object.entries(value)) {
                            (0,assert/* assert */.hu)(entryValue === undefined || typeof entryValue == "number");
                            const val = writeEnum(enumType, entryValue, true, options.enumAsInteger);
                            (0,assert/* assert */.hu)(val !== undefined);
                            jsonObj[entryKey.toString()] = val; // JSON standard allows only (double quoted) string as property key
                        }
                        break;
                }
                return options.emitDefaultValues || Object.keys(jsonObj).length > 0
                    ? jsonObj
                    : undefined;
            }
            else if (field.repeated) {
                const jsonArr = [];
                switch (field.kind) {
                    case "scalar":
                        for (let i = 0; i < value.length; i++) {
                            jsonArr.push(writeScalar(field.T, value[i], true));
                        }
                        break;
                    case "enum":
                        for (let i = 0; i < value.length; i++) {
                            jsonArr.push(writeEnum(field.T, value[i], true, options.enumAsInteger));
                        }
                        break;
                    case "message":
                        for (let i = 0; i < value.length; i++) {
                            jsonArr.push(value[i].toJson(options));
                        }
                        break;
                }
                return options.emitDefaultValues || jsonArr.length > 0
                    ? jsonArr
                    : undefined;
            }
            else {
                // In contrast to proto3, we raise an error if a non-optional (proto2 required)
                // field is missing a value.
                if (value === undefined) {
                    if (!field.oneof && !field.opt) {
                        throw `required field not set`;
                    }
                    return undefined;
                }
                switch (field.kind) {
                    case "scalar":
                        // In contrast to proto3, we do not skip intrinsic default values.
                        // Explicit default values are not special cased either.
                        return writeScalar(field.T, value, true);
                    case "enum":
                        // In contrast to proto3, we do not skip intrinsic default values.
                        // Explicit default values are not special cased either.
                        return writeEnum(field.T, value, true, options.enumAsInteger);
                    case "message":
                        return (0,field_wrapper/* wrapField */.E)(field.T, value).toJson(options);
                }
            }
        };
    });
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto2.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.








/**
 * Provides functionality for messages defined with the proto2 syntax.
 */
const proto2 = (0,proto_runtime/* makeProtoRuntime */.F)("proto2", makeJsonFormatProto2(), makeBinaryFormatProto2(), Object.assign(Object.assign({}, (0,util_common/* makeUtilCommon */.f)()), { newFieldList(fields) {
        return new field_list/* InternalFieldList */.i(fields, normalizeFieldInfosProto2);
    },
    initFields(target) {
        for (const member of target.getType().fields.byMember()) {
            const name = member.localName, t = target;
            if (member.repeated) {
                t[name] = [];
                continue;
            }
            switch (member.kind) {
                case "oneof":
                    t[name] = { case: undefined };
                    break;
                case "map":
                    t[name] = {};
                    break;
                case "scalar":
                case "enum":
                case "message":
                    // In contrast to proto3, enum and scalar fields have no intrinsic default value,
                    // only an optional explicit default value.
                    // Unlike proto3 intrinsic default values, proto2 explicit default values are not
                    // set on construction, because they are not omitted on the wire. If we did set
                    // default values on construction, a deserialize-serialize round-trip would add
                    // fields to a message.
                    break;
            }
        }
    } }));
/* eslint-disable @typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-argument */
function normalizeFieldInfosProto2(fieldInfos) {
    var _a, _b, _c, _d, _e;
    const r = [];
    let o;
    for (const field of typeof fieldInfos == "function"
        ? fieldInfos()
        : fieldInfos) {
        const f = field;
        f.localName = (0,names/* localFieldName */.Rz)(field.name, field.oneof !== undefined);
        f.jsonName = (_a = field.jsonName) !== null && _a !== void 0 ? _a : (0,names/* fieldJsonName */.x1)(field.name);
        f.repeated = (_b = field.repeated) !== null && _b !== void 0 ? _b : false;
        if (field.kind == "scalar") {
            f.L = (_c = field.L) !== null && _c !== void 0 ? _c : esm_field/* LongType */.p.BIGINT;
        }
        // We do not surface options at this time
        // f.options = field.options ?? emptyReadonlyObject;
        if (field.oneof !== undefined) {
            const ooname = typeof field.oneof == "string" ? field.oneof : field.oneof.name;
            if (!o || o.name != ooname) {
                o = new private_field/* InternalOneofInfo */.o(ooname);
            }
            f.oneof = o;
            o.addField(f);
        }
        // proto2 specific:
        if (field.kind == "message") {
            f.delimited = (_d = field.delimited) !== null && _d !== void 0 ? _d : false;
        }
        // In contrast to proto3, repeated fields are unpacked except when explicitly specified.
        f.packed = (_e = field.packed) !== null && _e !== void 0 ? _e : false;
        r.push(f);
    }
    return r;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto-double.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Export global Number constants. This is done so that we can safely use
// these global constants when generating code and be assured we're using
// the correct values. We cannot rely on globalThis since we support ES2017
// and globalThis was introduced in ES2020. We also don't want to explicitly
// generate code using, for example, Number.NaN, since this could clash with
// a message name of Number. Instead we can export them here since this will
// be in a different scope as the generated code and we are guaranteed to use
// the intended global values.
const protoDouble = {
    NaN: Number.NaN,
    POSITIVE_INFINITY: Number.POSITIVE_INFINITY,
    NEGATIVE_INFINITY: Number.NEGATIVE_INFINITY,
};

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto-int64.js
var proto_int64 = __webpack_require__(210);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto-base64.js
var proto_base64 = __webpack_require__(236);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/binary-encoding.js
var binary_encoding = __webpack_require__(79);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto-delimited.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __asyncValues = (undefined && undefined.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (undefined && undefined.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (undefined && undefined.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
    function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
    function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};


/**
 * protoDelimited provides functions to serialize and parse size-delimited
 * messages.
 *
 * A size-delimited message is a varint size in bytes, followed by exactly
 * that many bytes of a message serialized with the binary format.
 *
 * This size-delimited format is compatible with other implementations.
 * For details, see https://github.com/protocolbuffers/protobuf/issues/10229
 */
const protoDelimited = {
    /**
     * Serialize a message, prefixing it with its size.
     */
    enc(message, options) {
        const opt = (0,binary_format_common/* makeBinaryFormatCommon */.gY)().makeWriteOptions(options);
        return opt.writerFactory().bytes(message.toBinary(opt)).finish();
    },
    /**
     * Parse a size-delimited message, ignoring extra bytes.
     */
    dec(type, bytes, options) {
        const opt = (0,binary_format_common/* makeBinaryFormatCommon */.gY)().makeReadOptions(options);
        return type.fromBinary(opt.readerFactory(bytes).bytes(), opt);
    },
    /**
     * Parse a stream of size-delimited messages.
     */
    decStream(type, iterable) {
        return __asyncGenerator(this, arguments, function* decStream_1() {
            var _a, e_1, _b, _c;
            // append chunk to buffer, returning updated buffer
            function append(buffer, chunk) {
                const n = new Uint8Array(buffer.byteLength + chunk.byteLength);
                n.set(buffer);
                n.set(chunk, buffer.length);
                return n;
            }
            let buffer = new Uint8Array(0);
            try {
                for (var _d = true, iterable_1 = __asyncValues(iterable), iterable_1_1; iterable_1_1 = yield __await(iterable_1.next()), _a = iterable_1_1.done, !_a; _d = true) {
                    _c = iterable_1_1.value;
                    _d = false;
                    const chunk = _c;
                    buffer = append(buffer, chunk);
                    for (;;) {
                        const size = protoDelimited.peekSize(buffer);
                        if (size.eof) {
                            // size is incomplete, buffer more data
                            break;
                        }
                        if (size.offset + size.size > buffer.byteLength) {
                            // message is incomplete, buffer more data
                            break;
                        }
                        yield yield __await(protoDelimited.dec(type, buffer));
                        buffer = buffer.subarray(size.offset + size.size);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_1.return)) yield __await(_b.call(iterable_1));
                }
                finally { if (e_1) throw e_1.error; }
            }
            if (buffer.byteLength > 0) {
                throw new Error("incomplete data");
            }
        });
    },
    /**
     * Decodes the size from the given size-delimited message, which may be
     * incomplete.
     *
     * Returns an object with the following properties:
     * - size: The size of the delimited message in bytes
     * - offset: The offset in the given byte array where the message starts
     * - eof: true
     *
     * If the size-delimited data does not include all bytes of the varint size,
     * the following object is returned:
     * - size: null
     * - offset: null
     * - eof: false
     *
     * This function can be used to implement parsing of size-delimited messages
     * from a stream.
     */
    peekSize(data) {
        const sizeEof = { eof: true, size: null, offset: null };
        for (let i = 0; i < 10; i++) {
            if (i > data.byteLength) {
                return sizeEof;
            }
            if ((data[i] & 0x80) == 0) {
                const reader = new binary_encoding/* BinaryReader */.oP(data);
                let size;
                try {
                    size = reader.uint32();
                }
                catch (e) {
                    if (e instanceof RangeError) {
                        return sizeEof;
                    }
                    throw e;
                }
                return {
                    eof: false,
                    size,
                    offset: reader.pos,
                };
            }
        }
        throw new Error("invalid varint");
    },
};

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/scalars.js
var scalars = __webpack_require__(781);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/reify-wkt.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @deprecated please use reifyWkt from @bufbuild/protoplugin/ecmascript instead
 *
 * Reifies a given DescMessage into a more concrete object representing its
 * respective well-known type.  The returned object will contain properties
 * representing the WKT's defined fields.
 *
 * Useful during code generation when immediate access to a particular field
 * is needed without having to search the object's typename and DescField list.
 *
 * Returns undefined if the WKT cannot be completely constructed via the
 * DescMessage.
 */
function reifyWkt(message) {
    switch (message.typeName) {
        case "google.protobuf.Any": {
            const typeUrl = message.fields.find((f) => f.number == 1 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.STRING);
            const value = message.fields.find((f) => f.number == 2 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.BYTES);
            if (typeUrl && value) {
                return {
                    typeName: message.typeName,
                    typeUrl,
                    value,
                };
            }
            break;
        }
        case "google.protobuf.Timestamp": {
            const seconds = message.fields.find((f) => f.number == 1 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.INT64);
            const nanos = message.fields.find((f) => f.number == 2 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.INT32);
            if (seconds && nanos) {
                return {
                    typeName: message.typeName,
                    seconds,
                    nanos,
                };
            }
            break;
        }
        case "google.protobuf.Duration": {
            const seconds = message.fields.find((f) => f.number == 1 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.INT64);
            const nanos = message.fields.find((f) => f.number == 2 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.INT32);
            if (seconds && nanos) {
                return {
                    typeName: message.typeName,
                    seconds,
                    nanos,
                };
            }
            break;
        }
        case "google.protobuf.Struct": {
            const fields = message.fields.find((f) => f.number == 1 && !f.repeated);
            if ((fields === null || fields === void 0 ? void 0 : fields.fieldKind) !== "map" ||
                fields.mapValue.kind !== "message" ||
                fields.mapValue.message.typeName !== "google.protobuf.Value") {
                break;
            }
            return { typeName: message.typeName, fields };
        }
        case "google.protobuf.Value": {
            const kind = message.oneofs.find((o) => o.name === "kind");
            const nullValue = message.fields.find((f) => f.number == 1 && f.oneof === kind);
            if ((nullValue === null || nullValue === void 0 ? void 0 : nullValue.fieldKind) !== "enum" ||
                nullValue.enum.typeName !== "google.protobuf.NullValue") {
                return undefined;
            }
            const numberValue = message.fields.find((f) => f.number == 2 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.DOUBLE &&
                f.oneof === kind);
            const stringValue = message.fields.find((f) => f.number == 3 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.STRING &&
                f.oneof === kind);
            const boolValue = message.fields.find((f) => f.number == 4 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.BOOL &&
                f.oneof === kind);
            const structValue = message.fields.find((f) => f.number == 5 && f.oneof === kind);
            if ((structValue === null || structValue === void 0 ? void 0 : structValue.fieldKind) !== "message" ||
                structValue.message.typeName !== "google.protobuf.Struct") {
                return undefined;
            }
            const listValue = message.fields.find((f) => f.number == 6 && f.oneof === kind);
            if ((listValue === null || listValue === void 0 ? void 0 : listValue.fieldKind) !== "message" ||
                listValue.message.typeName !== "google.protobuf.ListValue") {
                return undefined;
            }
            if (kind && numberValue && stringValue && boolValue) {
                return {
                    typeName: message.typeName,
                    kind,
                    nullValue,
                    numberValue,
                    stringValue,
                    boolValue,
                    structValue,
                    listValue,
                };
            }
            break;
        }
        case "google.protobuf.ListValue": {
            const values = message.fields.find((f) => f.number == 1 && f.repeated);
            if ((values === null || values === void 0 ? void 0 : values.fieldKind) != "message" ||
                values.message.typeName !== "google.protobuf.Value") {
                break;
            }
            return { typeName: message.typeName, values };
        }
        case "google.protobuf.FieldMask": {
            const paths = message.fields.find((f) => f.number == 1 &&
                f.fieldKind == "scalar" &&
                f.scalar === esm_field/* ScalarType */.w.STRING &&
                f.repeated);
            if (paths) {
                return { typeName: message.typeName, paths };
            }
            break;
        }
        case "google.protobuf.DoubleValue":
        case "google.protobuf.FloatValue":
        case "google.protobuf.Int64Value":
        case "google.protobuf.UInt64Value":
        case "google.protobuf.Int32Value":
        case "google.protobuf.UInt32Value":
        case "google.protobuf.BoolValue":
        case "google.protobuf.StringValue":
        case "google.protobuf.BytesValue": {
            const value = message.fields.find((f) => f.number == 1 && f.name == "value");
            if (!value) {
                break;
            }
            if (value.fieldKind !== "scalar") {
                break;
            }
            return { typeName: message.typeName, value };
        }
    }
    return undefined;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/codegen-info.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





const packageName = "@bufbuild/protobuf";
const codegenInfo = {
    packageName: "@bufbuild/protobuf",
    localName: names/* localName */.r1,
    reifyWkt: reifyWkt,
    getUnwrappedFieldType: field_wrapper/* getUnwrappedFieldType */.w,
    scalarDefaultValue: scalars/* scalarDefaultValue */.kY,
    safeIdentifier: names/* safeIdentifier */.GD,
    safeObjectProperty: names/* safeObjectProperty */.ll,
    // prettier-ignore
    symbols: {
        proto2: { typeOnly: false, privateImportPath: "./proto2.js", publicImportPath: packageName },
        proto3: { typeOnly: false, privateImportPath: "./proto3.js", publicImportPath: packageName },
        Message: { typeOnly: false, privateImportPath: "./message.js", publicImportPath: packageName },
        PartialMessage: { typeOnly: true, privateImportPath: "./message.js", publicImportPath: packageName },
        PlainMessage: { typeOnly: true, privateImportPath: "./message.js", publicImportPath: packageName },
        FieldList: { typeOnly: true, privateImportPath: "./field-list.js", publicImportPath: packageName },
        MessageType: { typeOnly: true, privateImportPath: "./message-type.js", publicImportPath: packageName },
        BinaryReadOptions: { typeOnly: true, privateImportPath: "./binary-format.js", publicImportPath: packageName },
        BinaryWriteOptions: { typeOnly: true, privateImportPath: "./binary-format.js", publicImportPath: packageName },
        JsonReadOptions: { typeOnly: true, privateImportPath: "./json-format.js", publicImportPath: packageName },
        JsonWriteOptions: { typeOnly: true, privateImportPath: "./json-format.js", publicImportPath: packageName },
        JsonValue: { typeOnly: true, privateImportPath: "./json-format.js", publicImportPath: packageName },
        JsonObject: { typeOnly: true, privateImportPath: "./json-format.js", publicImportPath: packageName },
        protoDouble: { typeOnly: false, privateImportPath: "./proto-double.js", publicImportPath: packageName },
        protoInt64: { typeOnly: false, privateImportPath: "./proto-int64.js", publicImportPath: packageName },
        ScalarType: { typeOnly: false, privateImportPath: "./field.js", publicImportPath: packageName },
        LongType: { typeOnly: false, privateImportPath: "./field.js", publicImportPath: packageName },
        MethodKind: { typeOnly: false, privateImportPath: "./service-type.js", publicImportPath: packageName },
        MethodIdempotency: { typeOnly: false, privateImportPath: "./service-type.js", publicImportPath: packageName },
        IMessageTypeRegistry: { typeOnly: true, privateImportPath: "./type-registry.js", publicImportPath: packageName },
    },
    wktSourceFiles: [
        "google/protobuf/compiler/plugin.proto",
        "google/protobuf/any.proto",
        "google/protobuf/api.proto",
        "google/protobuf/descriptor.proto",
        "google/protobuf/duration.proto",
        "google/protobuf/empty.proto",
        "google/protobuf/field_mask.proto",
        "google/protobuf/source_context.proto",
        "google/protobuf/struct.proto",
        "google/protobuf/timestamp.proto",
        "google/protobuf/type.proto",
        "google/protobuf/wrappers.proto",
    ],
};

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/message.js
var esm_message = __webpack_require__(561);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/service-type.js
var service_type = __webpack_require__(328);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/descriptor_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// Author: kenton@google.com (Kenton Varda)
//  Based on original Protocol Buffers design by
//  Sanjay Ghemawat, Jeff Dean, and others.
//
// The messages in this file describe the definitions found in .proto files.
// A valid .proto file can be translated directly to a FileDescriptorProto
// without any other information (e.g. without reading its imports).
// @generated by protoc-gen-es v1.6.0 with parameter "bootstrap_wkt=true,ts_nocheck=false,target=ts"
// @generated from file google/protobuf/descriptor.proto (package google.protobuf, syntax proto2)
/* eslint-disable */


/**
 * The full set of known editions.
 *
 * @generated from enum google.protobuf.Edition
 */
var Edition;
(function (Edition) {
    /**
     * A placeholder for an unknown edition value.
     *
     * @generated from enum value: EDITION_UNKNOWN = 0;
     */
    Edition[Edition["EDITION_UNKNOWN"] = 0] = "EDITION_UNKNOWN";
    /**
     * Legacy syntax "editions".  These pre-date editions, but behave much like
     * distinct editions.  These can't be used to specify the edition of proto
     * files, but feature definitions must supply proto2/proto3 defaults for
     * backwards compatibility.
     *
     * @generated from enum value: EDITION_PROTO2 = 998;
     */
    Edition[Edition["EDITION_PROTO2"] = 998] = "EDITION_PROTO2";
    /**
     * @generated from enum value: EDITION_PROTO3 = 999;
     */
    Edition[Edition["EDITION_PROTO3"] = 999] = "EDITION_PROTO3";
    /**
     * Editions that have been released.  The specific values are arbitrary and
     * should not be depended on, but they will always be time-ordered for easy
     * comparison.
     *
     * @generated from enum value: EDITION_2023 = 1000;
     */
    Edition[Edition["EDITION_2023"] = 1000] = "EDITION_2023";
    /**
     * Placeholder editions for testing feature resolution.  These should not be
     * used or relyed on outside of tests.
     *
     * @generated from enum value: EDITION_1_TEST_ONLY = 1;
     */
    Edition[Edition["EDITION_1_TEST_ONLY"] = 1] = "EDITION_1_TEST_ONLY";
    /**
     * @generated from enum value: EDITION_2_TEST_ONLY = 2;
     */
    Edition[Edition["EDITION_2_TEST_ONLY"] = 2] = "EDITION_2_TEST_ONLY";
    /**
     * @generated from enum value: EDITION_99997_TEST_ONLY = 99997;
     */
    Edition[Edition["EDITION_99997_TEST_ONLY"] = 99997] = "EDITION_99997_TEST_ONLY";
    /**
     * @generated from enum value: EDITION_99998_TEST_ONLY = 99998;
     */
    Edition[Edition["EDITION_99998_TEST_ONLY"] = 99998] = "EDITION_99998_TEST_ONLY";
    /**
     * @generated from enum value: EDITION_99999_TEST_ONLY = 99999;
     */
    Edition[Edition["EDITION_99999_TEST_ONLY"] = 99999] = "EDITION_99999_TEST_ONLY";
})(Edition || (Edition = {}));
// Retrieve enum metadata with: proto2.getEnumType(Edition)
proto2.util.setEnumType(Edition, "google.protobuf.Edition", [
    { no: 0, name: "EDITION_UNKNOWN" },
    { no: 998, name: "EDITION_PROTO2" },
    { no: 999, name: "EDITION_PROTO3" },
    { no: 1000, name: "EDITION_2023" },
    { no: 1, name: "EDITION_1_TEST_ONLY" },
    { no: 2, name: "EDITION_2_TEST_ONLY" },
    { no: 99997, name: "EDITION_99997_TEST_ONLY" },
    { no: 99998, name: "EDITION_99998_TEST_ONLY" },
    { no: 99999, name: "EDITION_99999_TEST_ONLY" },
]);
/**
 * The protocol compiler can output a FileDescriptorSet containing the .proto
 * files it parses.
 *
 * @generated from message google.protobuf.FileDescriptorSet
 */
class FileDescriptorSet extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.FileDescriptorProto file = 1;
         */
        this.file = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FileDescriptorSet().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FileDescriptorSet().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FileDescriptorSet().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FileDescriptorSet, a, b);
    }
}
FileDescriptorSet.runtime = proto2;
FileDescriptorSet.typeName = "google.protobuf.FileDescriptorSet";
FileDescriptorSet.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "file", kind: "message", T: FileDescriptorProto, repeated: true },
]);
/**
 * Describes a complete .proto file.
 *
 * @generated from message google.protobuf.FileDescriptorProto
 */
class FileDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Names of files imported by this file.
         *
         * @generated from field: repeated string dependency = 3;
         */
        this.dependency = [];
        /**
         * Indexes of the public imported files in the dependency list above.
         *
         * @generated from field: repeated int32 public_dependency = 10;
         */
        this.publicDependency = [];
        /**
         * Indexes of the weak imported files in the dependency list.
         * For Google-internal migration only. Do not use.
         *
         * @generated from field: repeated int32 weak_dependency = 11;
         */
        this.weakDependency = [];
        /**
         * All top-level definitions in this file.
         *
         * @generated from field: repeated google.protobuf.DescriptorProto message_type = 4;
         */
        this.messageType = [];
        /**
         * @generated from field: repeated google.protobuf.EnumDescriptorProto enum_type = 5;
         */
        this.enumType = [];
        /**
         * @generated from field: repeated google.protobuf.ServiceDescriptorProto service = 6;
         */
        this.service = [];
        /**
         * @generated from field: repeated google.protobuf.FieldDescriptorProto extension = 7;
         */
        this.extension = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FileDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FileDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FileDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FileDescriptorProto, a, b);
    }
}
FileDescriptorProto.runtime = proto2;
FileDescriptorProto.typeName = "google.protobuf.FileDescriptorProto";
FileDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "package", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "dependency", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 10, name: "public_dependency", kind: "scalar", T: 5 /* ScalarType.INT32 */, repeated: true },
    { no: 11, name: "weak_dependency", kind: "scalar", T: 5 /* ScalarType.INT32 */, repeated: true },
    { no: 4, name: "message_type", kind: "message", T: DescriptorProto, repeated: true },
    { no: 5, name: "enum_type", kind: "message", T: EnumDescriptorProto, repeated: true },
    { no: 6, name: "service", kind: "message", T: ServiceDescriptorProto, repeated: true },
    { no: 7, name: "extension", kind: "message", T: FieldDescriptorProto, repeated: true },
    { no: 8, name: "options", kind: "message", T: FileOptions, opt: true },
    { no: 9, name: "source_code_info", kind: "message", T: SourceCodeInfo, opt: true },
    { no: 12, name: "syntax", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 14, name: "edition", kind: "enum", T: proto2.getEnumType(Edition), opt: true },
]);
/**
 * Describes a message type.
 *
 * @generated from message google.protobuf.DescriptorProto
 */
class DescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.FieldDescriptorProto field = 2;
         */
        this.field = [];
        /**
         * @generated from field: repeated google.protobuf.FieldDescriptorProto extension = 6;
         */
        this.extension = [];
        /**
         * @generated from field: repeated google.protobuf.DescriptorProto nested_type = 3;
         */
        this.nestedType = [];
        /**
         * @generated from field: repeated google.protobuf.EnumDescriptorProto enum_type = 4;
         */
        this.enumType = [];
        /**
         * @generated from field: repeated google.protobuf.DescriptorProto.ExtensionRange extension_range = 5;
         */
        this.extensionRange = [];
        /**
         * @generated from field: repeated google.protobuf.OneofDescriptorProto oneof_decl = 8;
         */
        this.oneofDecl = [];
        /**
         * @generated from field: repeated google.protobuf.DescriptorProto.ReservedRange reserved_range = 9;
         */
        this.reservedRange = [];
        /**
         * Reserved field names, which may not be used by fields in the same message.
         * A given name may only be reserved once.
         *
         * @generated from field: repeated string reserved_name = 10;
         */
        this.reservedName = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new DescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new DescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new DescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(DescriptorProto, a, b);
    }
}
DescriptorProto.runtime = proto2;
DescriptorProto.typeName = "google.protobuf.DescriptorProto";
DescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "field", kind: "message", T: FieldDescriptorProto, repeated: true },
    { no: 6, name: "extension", kind: "message", T: FieldDescriptorProto, repeated: true },
    { no: 3, name: "nested_type", kind: "message", T: DescriptorProto, repeated: true },
    { no: 4, name: "enum_type", kind: "message", T: EnumDescriptorProto, repeated: true },
    { no: 5, name: "extension_range", kind: "message", T: DescriptorProto_ExtensionRange, repeated: true },
    { no: 8, name: "oneof_decl", kind: "message", T: OneofDescriptorProto, repeated: true },
    { no: 7, name: "options", kind: "message", T: MessageOptions, opt: true },
    { no: 9, name: "reserved_range", kind: "message", T: DescriptorProto_ReservedRange, repeated: true },
    { no: 10, name: "reserved_name", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
]);
/**
 * @generated from message google.protobuf.DescriptorProto.ExtensionRange
 */
class DescriptorProto_ExtensionRange extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new DescriptorProto_ExtensionRange().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new DescriptorProto_ExtensionRange().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new DescriptorProto_ExtensionRange().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(DescriptorProto_ExtensionRange, a, b);
    }
}
DescriptorProto_ExtensionRange.runtime = proto2;
DescriptorProto_ExtensionRange.typeName = "google.protobuf.DescriptorProto.ExtensionRange";
DescriptorProto_ExtensionRange.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "start", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 2, name: "end", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 3, name: "options", kind: "message", T: ExtensionRangeOptions, opt: true },
]);
/**
 * Range of reserved tag numbers. Reserved tag numbers may not be used by
 * fields or extension ranges in the same message. Reserved ranges may
 * not overlap.
 *
 * @generated from message google.protobuf.DescriptorProto.ReservedRange
 */
class DescriptorProto_ReservedRange extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new DescriptorProto_ReservedRange().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new DescriptorProto_ReservedRange().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new DescriptorProto_ReservedRange().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(DescriptorProto_ReservedRange, a, b);
    }
}
DescriptorProto_ReservedRange.runtime = proto2;
DescriptorProto_ReservedRange.typeName = "google.protobuf.DescriptorProto.ReservedRange";
DescriptorProto_ReservedRange.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "start", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 2, name: "end", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
]);
/**
 * @generated from message google.protobuf.ExtensionRangeOptions
 */
class ExtensionRangeOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        /**
         * For external users: DO NOT USE. We are in the process of open sourcing
         * extension declaration and executing internal cleanups before it can be
         * used externally.
         *
         * @generated from field: repeated google.protobuf.ExtensionRangeOptions.Declaration declaration = 2;
         */
        this.declaration = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new ExtensionRangeOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new ExtensionRangeOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new ExtensionRangeOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(ExtensionRangeOptions, a, b);
    }
}
ExtensionRangeOptions.runtime = proto2;
ExtensionRangeOptions.typeName = "google.protobuf.ExtensionRangeOptions";
ExtensionRangeOptions.fields = proto2.util.newFieldList(() => [
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
    { no: 2, name: "declaration", kind: "message", T: ExtensionRangeOptions_Declaration, repeated: true },
    { no: 50, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 3, name: "verification", kind: "enum", T: proto2.getEnumType(ExtensionRangeOptions_VerificationState), opt: true, default: ExtensionRangeOptions_VerificationState.UNVERIFIED },
]);
/**
 * The verification state of the extension range.
 *
 * @generated from enum google.protobuf.ExtensionRangeOptions.VerificationState
 */
var ExtensionRangeOptions_VerificationState;
(function (ExtensionRangeOptions_VerificationState) {
    /**
     * All the extensions of the range must be declared.
     *
     * @generated from enum value: DECLARATION = 0;
     */
    ExtensionRangeOptions_VerificationState[ExtensionRangeOptions_VerificationState["DECLARATION"] = 0] = "DECLARATION";
    /**
     * @generated from enum value: UNVERIFIED = 1;
     */
    ExtensionRangeOptions_VerificationState[ExtensionRangeOptions_VerificationState["UNVERIFIED"] = 1] = "UNVERIFIED";
})(ExtensionRangeOptions_VerificationState || (ExtensionRangeOptions_VerificationState = {}));
// Retrieve enum metadata with: proto2.getEnumType(ExtensionRangeOptions_VerificationState)
proto2.util.setEnumType(ExtensionRangeOptions_VerificationState, "google.protobuf.ExtensionRangeOptions.VerificationState", [
    { no: 0, name: "DECLARATION" },
    { no: 1, name: "UNVERIFIED" },
]);
/**
 * @generated from message google.protobuf.ExtensionRangeOptions.Declaration
 */
class ExtensionRangeOptions_Declaration extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new ExtensionRangeOptions_Declaration().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new ExtensionRangeOptions_Declaration().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new ExtensionRangeOptions_Declaration().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(ExtensionRangeOptions_Declaration, a, b);
    }
}
ExtensionRangeOptions_Declaration.runtime = proto2;
ExtensionRangeOptions_Declaration.typeName = "google.protobuf.ExtensionRangeOptions.Declaration";
ExtensionRangeOptions_Declaration.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "number", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 2, name: "full_name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "type", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 5, name: "reserved", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 6, name: "repeated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
]);
/**
 * Describes a field within a message.
 *
 * @generated from message google.protobuf.FieldDescriptorProto
 */
class FieldDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FieldDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FieldDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FieldDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FieldDescriptorProto, a, b);
    }
}
FieldDescriptorProto.runtime = proto2;
FieldDescriptorProto.typeName = "google.protobuf.FieldDescriptorProto";
FieldDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "number", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 4, name: "label", kind: "enum", T: proto2.getEnumType(FieldDescriptorProto_Label), opt: true },
    { no: 5, name: "type", kind: "enum", T: proto2.getEnumType(FieldDescriptorProto_Type), opt: true },
    { no: 6, name: "type_name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "extendee", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 7, name: "default_value", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 9, name: "oneof_index", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 10, name: "json_name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 8, name: "options", kind: "message", T: FieldOptions, opt: true },
    { no: 17, name: "proto3_optional", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
]);
/**
 * @generated from enum google.protobuf.FieldDescriptorProto.Type
 */
var FieldDescriptorProto_Type;
(function (FieldDescriptorProto_Type) {
    /**
     * 0 is reserved for errors.
     * Order is weird for historical reasons.
     *
     * @generated from enum value: TYPE_DOUBLE = 1;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["DOUBLE"] = 1] = "DOUBLE";
    /**
     * @generated from enum value: TYPE_FLOAT = 2;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["FLOAT"] = 2] = "FLOAT";
    /**
     * Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT64 if
     * negative values are likely.
     *
     * @generated from enum value: TYPE_INT64 = 3;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["INT64"] = 3] = "INT64";
    /**
     * @generated from enum value: TYPE_UINT64 = 4;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["UINT64"] = 4] = "UINT64";
    /**
     * Not ZigZag encoded.  Negative numbers take 10 bytes.  Use TYPE_SINT32 if
     * negative values are likely.
     *
     * @generated from enum value: TYPE_INT32 = 5;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["INT32"] = 5] = "INT32";
    /**
     * @generated from enum value: TYPE_FIXED64 = 6;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["FIXED64"] = 6] = "FIXED64";
    /**
     * @generated from enum value: TYPE_FIXED32 = 7;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["FIXED32"] = 7] = "FIXED32";
    /**
     * @generated from enum value: TYPE_BOOL = 8;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["BOOL"] = 8] = "BOOL";
    /**
     * @generated from enum value: TYPE_STRING = 9;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["STRING"] = 9] = "STRING";
    /**
     * Tag-delimited aggregate.
     * Group type is deprecated and not supported after google.protobuf. However, Proto3
     * implementations should still be able to parse the group wire format and
     * treat group fields as unknown fields.  In Editions, the group wire format
     * can be enabled via the `message_encoding` feature.
     *
     * @generated from enum value: TYPE_GROUP = 10;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["GROUP"] = 10] = "GROUP";
    /**
     * Length-delimited aggregate.
     *
     * @generated from enum value: TYPE_MESSAGE = 11;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["MESSAGE"] = 11] = "MESSAGE";
    /**
     * New in version 2.
     *
     * @generated from enum value: TYPE_BYTES = 12;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["BYTES"] = 12] = "BYTES";
    /**
     * @generated from enum value: TYPE_UINT32 = 13;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["UINT32"] = 13] = "UINT32";
    /**
     * @generated from enum value: TYPE_ENUM = 14;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["ENUM"] = 14] = "ENUM";
    /**
     * @generated from enum value: TYPE_SFIXED32 = 15;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["SFIXED32"] = 15] = "SFIXED32";
    /**
     * @generated from enum value: TYPE_SFIXED64 = 16;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["SFIXED64"] = 16] = "SFIXED64";
    /**
     * Uses ZigZag encoding.
     *
     * @generated from enum value: TYPE_SINT32 = 17;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["SINT32"] = 17] = "SINT32";
    /**
     * Uses ZigZag encoding.
     *
     * @generated from enum value: TYPE_SINT64 = 18;
     */
    FieldDescriptorProto_Type[FieldDescriptorProto_Type["SINT64"] = 18] = "SINT64";
})(FieldDescriptorProto_Type || (FieldDescriptorProto_Type = {}));
// Retrieve enum metadata with: proto2.getEnumType(FieldDescriptorProto_Type)
proto2.util.setEnumType(FieldDescriptorProto_Type, "google.protobuf.FieldDescriptorProto.Type", [
    { no: 1, name: "TYPE_DOUBLE" },
    { no: 2, name: "TYPE_FLOAT" },
    { no: 3, name: "TYPE_INT64" },
    { no: 4, name: "TYPE_UINT64" },
    { no: 5, name: "TYPE_INT32" },
    { no: 6, name: "TYPE_FIXED64" },
    { no: 7, name: "TYPE_FIXED32" },
    { no: 8, name: "TYPE_BOOL" },
    { no: 9, name: "TYPE_STRING" },
    { no: 10, name: "TYPE_GROUP" },
    { no: 11, name: "TYPE_MESSAGE" },
    { no: 12, name: "TYPE_BYTES" },
    { no: 13, name: "TYPE_UINT32" },
    { no: 14, name: "TYPE_ENUM" },
    { no: 15, name: "TYPE_SFIXED32" },
    { no: 16, name: "TYPE_SFIXED64" },
    { no: 17, name: "TYPE_SINT32" },
    { no: 18, name: "TYPE_SINT64" },
]);
/**
 * @generated from enum google.protobuf.FieldDescriptorProto.Label
 */
var FieldDescriptorProto_Label;
(function (FieldDescriptorProto_Label) {
    /**
     * 0 is reserved for errors
     *
     * @generated from enum value: LABEL_OPTIONAL = 1;
     */
    FieldDescriptorProto_Label[FieldDescriptorProto_Label["OPTIONAL"] = 1] = "OPTIONAL";
    /**
     * @generated from enum value: LABEL_REPEATED = 3;
     */
    FieldDescriptorProto_Label[FieldDescriptorProto_Label["REPEATED"] = 3] = "REPEATED";
    /**
     * The required label is only allowed in google.protobuf.  In proto3 and Editions
     * it's explicitly prohibited.  In Editions, the `field_presence` feature
     * can be used to get this behavior.
     *
     * @generated from enum value: LABEL_REQUIRED = 2;
     */
    FieldDescriptorProto_Label[FieldDescriptorProto_Label["REQUIRED"] = 2] = "REQUIRED";
})(FieldDescriptorProto_Label || (FieldDescriptorProto_Label = {}));
// Retrieve enum metadata with: proto2.getEnumType(FieldDescriptorProto_Label)
proto2.util.setEnumType(FieldDescriptorProto_Label, "google.protobuf.FieldDescriptorProto.Label", [
    { no: 1, name: "LABEL_OPTIONAL" },
    { no: 3, name: "LABEL_REPEATED" },
    { no: 2, name: "LABEL_REQUIRED" },
]);
/**
 * Describes a oneof.
 *
 * @generated from message google.protobuf.OneofDescriptorProto
 */
class OneofDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new OneofDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new OneofDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new OneofDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(OneofDescriptorProto, a, b);
    }
}
OneofDescriptorProto.runtime = proto2;
OneofDescriptorProto.typeName = "google.protobuf.OneofDescriptorProto";
OneofDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "options", kind: "message", T: OneofOptions, opt: true },
]);
/**
 * Describes an enum type.
 *
 * @generated from message google.protobuf.EnumDescriptorProto
 */
class EnumDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.EnumValueDescriptorProto value = 2;
         */
        this.value = [];
        /**
         * Range of reserved numeric values. Reserved numeric values may not be used
         * by enum values in the same enum declaration. Reserved ranges may not
         * overlap.
         *
         * @generated from field: repeated google.protobuf.EnumDescriptorProto.EnumReservedRange reserved_range = 4;
         */
        this.reservedRange = [];
        /**
         * Reserved enum value names, which may not be reused. A given name may only
         * be reserved once.
         *
         * @generated from field: repeated string reserved_name = 5;
         */
        this.reservedName = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new EnumDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new EnumDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new EnumDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(EnumDescriptorProto, a, b);
    }
}
EnumDescriptorProto.runtime = proto2;
EnumDescriptorProto.typeName = "google.protobuf.EnumDescriptorProto";
EnumDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "value", kind: "message", T: EnumValueDescriptorProto, repeated: true },
    { no: 3, name: "options", kind: "message", T: EnumOptions, opt: true },
    { no: 4, name: "reserved_range", kind: "message", T: EnumDescriptorProto_EnumReservedRange, repeated: true },
    { no: 5, name: "reserved_name", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
]);
/**
 * Range of reserved numeric values. Reserved values may not be used by
 * entries in the same enum. Reserved ranges may not overlap.
 *
 * Note that this is distinct from DescriptorProto.ReservedRange in that it
 * is inclusive such that it can appropriately represent the entire int32
 * domain.
 *
 * @generated from message google.protobuf.EnumDescriptorProto.EnumReservedRange
 */
class EnumDescriptorProto_EnumReservedRange extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new EnumDescriptorProto_EnumReservedRange().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new EnumDescriptorProto_EnumReservedRange().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new EnumDescriptorProto_EnumReservedRange().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(EnumDescriptorProto_EnumReservedRange, a, b);
    }
}
EnumDescriptorProto_EnumReservedRange.runtime = proto2;
EnumDescriptorProto_EnumReservedRange.typeName = "google.protobuf.EnumDescriptorProto.EnumReservedRange";
EnumDescriptorProto_EnumReservedRange.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "start", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 2, name: "end", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
]);
/**
 * Describes a value within an enum.
 *
 * @generated from message google.protobuf.EnumValueDescriptorProto
 */
class EnumValueDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new EnumValueDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new EnumValueDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new EnumValueDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(EnumValueDescriptorProto, a, b);
    }
}
EnumValueDescriptorProto.runtime = proto2;
EnumValueDescriptorProto.typeName = "google.protobuf.EnumValueDescriptorProto";
EnumValueDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "number", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 3, name: "options", kind: "message", T: EnumValueOptions, opt: true },
]);
/**
 * Describes a service.
 *
 * @generated from message google.protobuf.ServiceDescriptorProto
 */
class ServiceDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.MethodDescriptorProto method = 2;
         */
        this.method = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new ServiceDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new ServiceDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new ServiceDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(ServiceDescriptorProto, a, b);
    }
}
ServiceDescriptorProto.runtime = proto2;
ServiceDescriptorProto.typeName = "google.protobuf.ServiceDescriptorProto";
ServiceDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "method", kind: "message", T: MethodDescriptorProto, repeated: true },
    { no: 3, name: "options", kind: "message", T: ServiceOptions, opt: true },
]);
/**
 * Describes a method of a service.
 *
 * @generated from message google.protobuf.MethodDescriptorProto
 */
class MethodDescriptorProto extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new MethodDescriptorProto().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new MethodDescriptorProto().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new MethodDescriptorProto().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(MethodDescriptorProto, a, b);
    }
}
MethodDescriptorProto.runtime = proto2;
MethodDescriptorProto.typeName = "google.protobuf.MethodDescriptorProto";
MethodDescriptorProto.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "input_type", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "output_type", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 4, name: "options", kind: "message", T: MethodOptions, opt: true },
    { no: 5, name: "client_streaming", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 6, name: "server_streaming", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
]);
/**
 * @generated from message google.protobuf.FileOptions
 */
class FileOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here.
         * See the documentation for the "Options" section above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FileOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FileOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FileOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FileOptions, a, b);
    }
}
FileOptions.runtime = proto2;
FileOptions.typeName = "google.protobuf.FileOptions";
FileOptions.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "java_package", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 8, name: "java_outer_classname", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 10, name: "java_multiple_files", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 20, name: "java_generate_equals_and_hash", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 27, name: "java_string_check_utf8", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 9, name: "optimize_for", kind: "enum", T: proto2.getEnumType(FileOptions_OptimizeMode), opt: true, default: FileOptions_OptimizeMode.SPEED },
    { no: 11, name: "go_package", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 16, name: "cc_generic_services", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 17, name: "java_generic_services", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 18, name: "py_generic_services", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 42, name: "php_generic_services", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 23, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 31, name: "cc_enable_arenas", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: true },
    { no: 36, name: "objc_class_prefix", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 37, name: "csharp_namespace", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 39, name: "swift_prefix", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 40, name: "php_class_prefix", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 41, name: "php_namespace", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 44, name: "php_metadata_namespace", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 45, name: "ruby_package", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 50, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * Generated classes can be optimized for speed or code size.
 *
 * @generated from enum google.protobuf.FileOptions.OptimizeMode
 */
var FileOptions_OptimizeMode;
(function (FileOptions_OptimizeMode) {
    /**
     * Generate complete code for parsing, serialization,
     *
     * @generated from enum value: SPEED = 1;
     */
    FileOptions_OptimizeMode[FileOptions_OptimizeMode["SPEED"] = 1] = "SPEED";
    /**
     * etc.
     *
     * Use ReflectionOps to implement these methods.
     *
     * @generated from enum value: CODE_SIZE = 2;
     */
    FileOptions_OptimizeMode[FileOptions_OptimizeMode["CODE_SIZE"] = 2] = "CODE_SIZE";
    /**
     * Generate code using MessageLite and the lite runtime.
     *
     * @generated from enum value: LITE_RUNTIME = 3;
     */
    FileOptions_OptimizeMode[FileOptions_OptimizeMode["LITE_RUNTIME"] = 3] = "LITE_RUNTIME";
})(FileOptions_OptimizeMode || (FileOptions_OptimizeMode = {}));
// Retrieve enum metadata with: proto2.getEnumType(FileOptions_OptimizeMode)
proto2.util.setEnumType(FileOptions_OptimizeMode, "google.protobuf.FileOptions.OptimizeMode", [
    { no: 1, name: "SPEED" },
    { no: 2, name: "CODE_SIZE" },
    { no: 3, name: "LITE_RUNTIME" },
]);
/**
 * @generated from message google.protobuf.MessageOptions
 */
class MessageOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new MessageOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new MessageOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new MessageOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(MessageOptions, a, b);
    }
}
MessageOptions.runtime = proto2;
MessageOptions.typeName = "google.protobuf.MessageOptions";
MessageOptions.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "message_set_wire_format", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 2, name: "no_standard_descriptor_accessor", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 3, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 7, name: "map_entry", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 11, name: "deprecated_legacy_json_field_conflicts", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 12, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * @generated from message google.protobuf.FieldOptions
 */
class FieldOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.FieldOptions.OptionTargetType targets = 19;
         */
        this.targets = [];
        /**
         * @generated from field: repeated google.protobuf.FieldOptions.EditionDefault edition_defaults = 20;
         */
        this.editionDefaults = [];
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FieldOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FieldOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FieldOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FieldOptions, a, b);
    }
}
FieldOptions.runtime = proto2;
FieldOptions.typeName = "google.protobuf.FieldOptions";
FieldOptions.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "ctype", kind: "enum", T: proto2.getEnumType(FieldOptions_CType), opt: true, default: FieldOptions_CType.STRING },
    { no: 2, name: "packed", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 6, name: "jstype", kind: "enum", T: proto2.getEnumType(FieldOptions_JSType), opt: true, default: FieldOptions_JSType.JS_NORMAL },
    { no: 5, name: "lazy", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 15, name: "unverified_lazy", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 3, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 10, name: "weak", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 16, name: "debug_redact", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 17, name: "retention", kind: "enum", T: proto2.getEnumType(FieldOptions_OptionRetention), opt: true },
    { no: 19, name: "targets", kind: "enum", T: proto2.getEnumType(FieldOptions_OptionTargetType), repeated: true },
    { no: 20, name: "edition_defaults", kind: "message", T: FieldOptions_EditionDefault, repeated: true },
    { no: 21, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * @generated from enum google.protobuf.FieldOptions.CType
 */
var FieldOptions_CType;
(function (FieldOptions_CType) {
    /**
     * Default mode.
     *
     * @generated from enum value: STRING = 0;
     */
    FieldOptions_CType[FieldOptions_CType["STRING"] = 0] = "STRING";
    /**
     * The option [ctype=CORD] may be applied to a non-repeated field of type
     * "bytes". It indicates that in C++, the data should be stored in a Cord
     * instead of a string.  For very large strings, this may reduce memory
     * fragmentation. It may also allow better performance when parsing from a
     * Cord, or when parsing with aliasing enabled, as the parsed Cord may then
     * alias the original buffer.
     *
     * @generated from enum value: CORD = 1;
     */
    FieldOptions_CType[FieldOptions_CType["CORD"] = 1] = "CORD";
    /**
     * @generated from enum value: STRING_PIECE = 2;
     */
    FieldOptions_CType[FieldOptions_CType["STRING_PIECE"] = 2] = "STRING_PIECE";
})(FieldOptions_CType || (FieldOptions_CType = {}));
// Retrieve enum metadata with: proto2.getEnumType(FieldOptions_CType)
proto2.util.setEnumType(FieldOptions_CType, "google.protobuf.FieldOptions.CType", [
    { no: 0, name: "STRING" },
    { no: 1, name: "CORD" },
    { no: 2, name: "STRING_PIECE" },
]);
/**
 * @generated from enum google.protobuf.FieldOptions.JSType
 */
var FieldOptions_JSType;
(function (FieldOptions_JSType) {
    /**
     * Use the default type.
     *
     * @generated from enum value: JS_NORMAL = 0;
     */
    FieldOptions_JSType[FieldOptions_JSType["JS_NORMAL"] = 0] = "JS_NORMAL";
    /**
     * Use JavaScript strings.
     *
     * @generated from enum value: JS_STRING = 1;
     */
    FieldOptions_JSType[FieldOptions_JSType["JS_STRING"] = 1] = "JS_STRING";
    /**
     * Use JavaScript numbers.
     *
     * @generated from enum value: JS_NUMBER = 2;
     */
    FieldOptions_JSType[FieldOptions_JSType["JS_NUMBER"] = 2] = "JS_NUMBER";
})(FieldOptions_JSType || (FieldOptions_JSType = {}));
// Retrieve enum metadata with: proto2.getEnumType(FieldOptions_JSType)
proto2.util.setEnumType(FieldOptions_JSType, "google.protobuf.FieldOptions.JSType", [
    { no: 0, name: "JS_NORMAL" },
    { no: 1, name: "JS_STRING" },
    { no: 2, name: "JS_NUMBER" },
]);
/**
 * If set to RETENTION_SOURCE, the option will be omitted from the binary.
 * Note: as of January 2023, support for this is in progress and does not yet
 * have an effect (b/264593489).
 *
 * @generated from enum google.protobuf.FieldOptions.OptionRetention
 */
var FieldOptions_OptionRetention;
(function (FieldOptions_OptionRetention) {
    /**
     * @generated from enum value: RETENTION_UNKNOWN = 0;
     */
    FieldOptions_OptionRetention[FieldOptions_OptionRetention["RETENTION_UNKNOWN"] = 0] = "RETENTION_UNKNOWN";
    /**
     * @generated from enum value: RETENTION_RUNTIME = 1;
     */
    FieldOptions_OptionRetention[FieldOptions_OptionRetention["RETENTION_RUNTIME"] = 1] = "RETENTION_RUNTIME";
    /**
     * @generated from enum value: RETENTION_SOURCE = 2;
     */
    FieldOptions_OptionRetention[FieldOptions_OptionRetention["RETENTION_SOURCE"] = 2] = "RETENTION_SOURCE";
})(FieldOptions_OptionRetention || (FieldOptions_OptionRetention = {}));
// Retrieve enum metadata with: proto2.getEnumType(FieldOptions_OptionRetention)
proto2.util.setEnumType(FieldOptions_OptionRetention, "google.protobuf.FieldOptions.OptionRetention", [
    { no: 0, name: "RETENTION_UNKNOWN" },
    { no: 1, name: "RETENTION_RUNTIME" },
    { no: 2, name: "RETENTION_SOURCE" },
]);
/**
 * This indicates the types of entities that the field may apply to when used
 * as an option. If it is unset, then the field may be freely used as an
 * option on any kind of entity. Note: as of January 2023, support for this is
 * in progress and does not yet have an effect (b/264593489).
 *
 * @generated from enum google.protobuf.FieldOptions.OptionTargetType
 */
var FieldOptions_OptionTargetType;
(function (FieldOptions_OptionTargetType) {
    /**
     * @generated from enum value: TARGET_TYPE_UNKNOWN = 0;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_UNKNOWN"] = 0] = "TARGET_TYPE_UNKNOWN";
    /**
     * @generated from enum value: TARGET_TYPE_FILE = 1;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_FILE"] = 1] = "TARGET_TYPE_FILE";
    /**
     * @generated from enum value: TARGET_TYPE_EXTENSION_RANGE = 2;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_EXTENSION_RANGE"] = 2] = "TARGET_TYPE_EXTENSION_RANGE";
    /**
     * @generated from enum value: TARGET_TYPE_MESSAGE = 3;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_MESSAGE"] = 3] = "TARGET_TYPE_MESSAGE";
    /**
     * @generated from enum value: TARGET_TYPE_FIELD = 4;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_FIELD"] = 4] = "TARGET_TYPE_FIELD";
    /**
     * @generated from enum value: TARGET_TYPE_ONEOF = 5;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_ONEOF"] = 5] = "TARGET_TYPE_ONEOF";
    /**
     * @generated from enum value: TARGET_TYPE_ENUM = 6;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_ENUM"] = 6] = "TARGET_TYPE_ENUM";
    /**
     * @generated from enum value: TARGET_TYPE_ENUM_ENTRY = 7;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_ENUM_ENTRY"] = 7] = "TARGET_TYPE_ENUM_ENTRY";
    /**
     * @generated from enum value: TARGET_TYPE_SERVICE = 8;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_SERVICE"] = 8] = "TARGET_TYPE_SERVICE";
    /**
     * @generated from enum value: TARGET_TYPE_METHOD = 9;
     */
    FieldOptions_OptionTargetType[FieldOptions_OptionTargetType["TARGET_TYPE_METHOD"] = 9] = "TARGET_TYPE_METHOD";
})(FieldOptions_OptionTargetType || (FieldOptions_OptionTargetType = {}));
// Retrieve enum metadata with: proto2.getEnumType(FieldOptions_OptionTargetType)
proto2.util.setEnumType(FieldOptions_OptionTargetType, "google.protobuf.FieldOptions.OptionTargetType", [
    { no: 0, name: "TARGET_TYPE_UNKNOWN" },
    { no: 1, name: "TARGET_TYPE_FILE" },
    { no: 2, name: "TARGET_TYPE_EXTENSION_RANGE" },
    { no: 3, name: "TARGET_TYPE_MESSAGE" },
    { no: 4, name: "TARGET_TYPE_FIELD" },
    { no: 5, name: "TARGET_TYPE_ONEOF" },
    { no: 6, name: "TARGET_TYPE_ENUM" },
    { no: 7, name: "TARGET_TYPE_ENUM_ENTRY" },
    { no: 8, name: "TARGET_TYPE_SERVICE" },
    { no: 9, name: "TARGET_TYPE_METHOD" },
]);
/**
 * @generated from message google.protobuf.FieldOptions.EditionDefault
 */
class FieldOptions_EditionDefault extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FieldOptions_EditionDefault().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FieldOptions_EditionDefault().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FieldOptions_EditionDefault().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FieldOptions_EditionDefault, a, b);
    }
}
FieldOptions_EditionDefault.runtime = proto2;
FieldOptions_EditionDefault.typeName = "google.protobuf.FieldOptions.EditionDefault";
FieldOptions_EditionDefault.fields = proto2.util.newFieldList(() => [
    { no: 3, name: "edition", kind: "enum", T: proto2.getEnumType(Edition), opt: true },
    { no: 2, name: "value", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
]);
/**
 * @generated from message google.protobuf.OneofOptions
 */
class OneofOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new OneofOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new OneofOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new OneofOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(OneofOptions, a, b);
    }
}
OneofOptions.runtime = proto2;
OneofOptions.typeName = "google.protobuf.OneofOptions";
OneofOptions.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * @generated from message google.protobuf.EnumOptions
 */
class EnumOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new EnumOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new EnumOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new EnumOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(EnumOptions, a, b);
    }
}
EnumOptions.runtime = proto2;
EnumOptions.typeName = "google.protobuf.EnumOptions";
EnumOptions.fields = proto2.util.newFieldList(() => [
    { no: 2, name: "allow_alias", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 3, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 6, name: "deprecated_legacy_json_field_conflicts", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true },
    { no: 7, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * @generated from message google.protobuf.EnumValueOptions
 */
class EnumValueOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new EnumValueOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new EnumValueOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new EnumValueOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(EnumValueOptions, a, b);
    }
}
EnumValueOptions.runtime = proto2;
EnumValueOptions.typeName = "google.protobuf.EnumValueOptions";
EnumValueOptions.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 2, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 3, name: "debug_redact", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * @generated from message google.protobuf.ServiceOptions
 */
class ServiceOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new ServiceOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new ServiceOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new ServiceOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(ServiceOptions, a, b);
    }
}
ServiceOptions.runtime = proto2;
ServiceOptions.typeName = "google.protobuf.ServiceOptions";
ServiceOptions.fields = proto2.util.newFieldList(() => [
    { no: 34, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 33, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * @generated from message google.protobuf.MethodOptions
 */
class MethodOptions extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The parser stores options it doesn't recognize here. See above.
         *
         * @generated from field: repeated google.protobuf.UninterpretedOption uninterpreted_option = 999;
         */
        this.uninterpretedOption = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new MethodOptions().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new MethodOptions().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new MethodOptions().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(MethodOptions, a, b);
    }
}
MethodOptions.runtime = proto2;
MethodOptions.typeName = "google.protobuf.MethodOptions";
MethodOptions.fields = proto2.util.newFieldList(() => [
    { no: 33, name: "deprecated", kind: "scalar", T: 8 /* ScalarType.BOOL */, opt: true, default: false },
    { no: 34, name: "idempotency_level", kind: "enum", T: proto2.getEnumType(MethodOptions_IdempotencyLevel), opt: true, default: MethodOptions_IdempotencyLevel.IDEMPOTENCY_UNKNOWN },
    { no: 35, name: "features", kind: "message", T: FeatureSet, opt: true },
    { no: 999, name: "uninterpreted_option", kind: "message", T: UninterpretedOption, repeated: true },
]);
/**
 * Is this method side-effect-free (or safe in HTTP parlance), or idempotent,
 * or neither? HTTP based RPC implementation may choose GET verb for safe
 * methods, and PUT verb for idempotent methods instead of the default POST.
 *
 * @generated from enum google.protobuf.MethodOptions.IdempotencyLevel
 */
var MethodOptions_IdempotencyLevel;
(function (MethodOptions_IdempotencyLevel) {
    /**
     * @generated from enum value: IDEMPOTENCY_UNKNOWN = 0;
     */
    MethodOptions_IdempotencyLevel[MethodOptions_IdempotencyLevel["IDEMPOTENCY_UNKNOWN"] = 0] = "IDEMPOTENCY_UNKNOWN";
    /**
     * implies idempotent
     *
     * @generated from enum value: NO_SIDE_EFFECTS = 1;
     */
    MethodOptions_IdempotencyLevel[MethodOptions_IdempotencyLevel["NO_SIDE_EFFECTS"] = 1] = "NO_SIDE_EFFECTS";
    /**
     * idempotent, but may have side effects
     *
     * @generated from enum value: IDEMPOTENT = 2;
     */
    MethodOptions_IdempotencyLevel[MethodOptions_IdempotencyLevel["IDEMPOTENT"] = 2] = "IDEMPOTENT";
})(MethodOptions_IdempotencyLevel || (MethodOptions_IdempotencyLevel = {}));
// Retrieve enum metadata with: proto2.getEnumType(MethodOptions_IdempotencyLevel)
proto2.util.setEnumType(MethodOptions_IdempotencyLevel, "google.protobuf.MethodOptions.IdempotencyLevel", [
    { no: 0, name: "IDEMPOTENCY_UNKNOWN" },
    { no: 1, name: "NO_SIDE_EFFECTS" },
    { no: 2, name: "IDEMPOTENT" },
]);
/**
 * A message representing a option the parser does not recognize. This only
 * appears in options protos created by the compiler::Parser class.
 * DescriptorPool resolves these when building Descriptor objects. Therefore,
 * options protos in descriptor objects (e.g. returned by Descriptor::options(),
 * or produced by Descriptor::CopyTo()) will never have UninterpretedOptions
 * in them.
 *
 * @generated from message google.protobuf.UninterpretedOption
 */
class UninterpretedOption extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.UninterpretedOption.NamePart name = 2;
         */
        this.name = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new UninterpretedOption().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new UninterpretedOption().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new UninterpretedOption().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(UninterpretedOption, a, b);
    }
}
UninterpretedOption.runtime = proto2;
UninterpretedOption.typeName = "google.protobuf.UninterpretedOption";
UninterpretedOption.fields = proto2.util.newFieldList(() => [
    { no: 2, name: "name", kind: "message", T: UninterpretedOption_NamePart, repeated: true },
    { no: 3, name: "identifier_value", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 4, name: "positive_int_value", kind: "scalar", T: 4 /* ScalarType.UINT64 */, opt: true },
    { no: 5, name: "negative_int_value", kind: "scalar", T: 3 /* ScalarType.INT64 */, opt: true },
    { no: 6, name: "double_value", kind: "scalar", T: 1 /* ScalarType.DOUBLE */, opt: true },
    { no: 7, name: "string_value", kind: "scalar", T: 12 /* ScalarType.BYTES */, opt: true },
    { no: 8, name: "aggregate_value", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
]);
/**
 * The name of the uninterpreted option.  Each string represents a segment in
 * a dot-separated name.  is_extension is true iff a segment represents an
 * extension (denoted with parentheses in options specs in .proto files).
 * E.g.,{ ["foo", false], ["bar.baz", true], ["moo", false] } represents
 * "foo.(bar.baz).moo".
 *
 * @generated from message google.protobuf.UninterpretedOption.NamePart
 */
class UninterpretedOption_NamePart extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new UninterpretedOption_NamePart().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new UninterpretedOption_NamePart().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new UninterpretedOption_NamePart().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(UninterpretedOption_NamePart, a, b);
    }
}
UninterpretedOption_NamePart.runtime = proto2;
UninterpretedOption_NamePart.typeName = "google.protobuf.UninterpretedOption.NamePart";
UninterpretedOption_NamePart.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name_part", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "is_extension", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
]);
/**
 * TODO Enums in C++ gencode (and potentially other languages) are
 * not well scoped.  This means that each of the feature enums below can clash
 * with each other.  The short names we've chosen maximize call-site
 * readability, but leave us very open to this scenario.  A future feature will
 * be designed and implemented to handle this, hopefully before we ever hit a
 * conflict here.
 *
 * @generated from message google.protobuf.FeatureSet
 */
class FeatureSet extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FeatureSet().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FeatureSet().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FeatureSet().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FeatureSet, a, b);
    }
}
FeatureSet.runtime = proto2;
FeatureSet.typeName = "google.protobuf.FeatureSet";
FeatureSet.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "field_presence", kind: "enum", T: proto2.getEnumType(FeatureSet_FieldPresence), opt: true },
    { no: 2, name: "enum_type", kind: "enum", T: proto2.getEnumType(FeatureSet_EnumType), opt: true },
    { no: 3, name: "repeated_field_encoding", kind: "enum", T: proto2.getEnumType(FeatureSet_RepeatedFieldEncoding), opt: true },
    { no: 4, name: "utf8_validation", kind: "enum", T: proto2.getEnumType(FeatureSet_Utf8Validation), opt: true },
    { no: 5, name: "message_encoding", kind: "enum", T: proto2.getEnumType(FeatureSet_MessageEncoding), opt: true },
    { no: 6, name: "json_format", kind: "enum", T: proto2.getEnumType(FeatureSet_JsonFormat), opt: true },
]);
/**
 * @generated from enum google.protobuf.FeatureSet.FieldPresence
 */
var FeatureSet_FieldPresence;
(function (FeatureSet_FieldPresence) {
    /**
     * @generated from enum value: FIELD_PRESENCE_UNKNOWN = 0;
     */
    FeatureSet_FieldPresence[FeatureSet_FieldPresence["FIELD_PRESENCE_UNKNOWN"] = 0] = "FIELD_PRESENCE_UNKNOWN";
    /**
     * @generated from enum value: EXPLICIT = 1;
     */
    FeatureSet_FieldPresence[FeatureSet_FieldPresence["EXPLICIT"] = 1] = "EXPLICIT";
    /**
     * @generated from enum value: IMPLICIT = 2;
     */
    FeatureSet_FieldPresence[FeatureSet_FieldPresence["IMPLICIT"] = 2] = "IMPLICIT";
    /**
     * @generated from enum value: LEGACY_REQUIRED = 3;
     */
    FeatureSet_FieldPresence[FeatureSet_FieldPresence["LEGACY_REQUIRED"] = 3] = "LEGACY_REQUIRED";
})(FeatureSet_FieldPresence || (FeatureSet_FieldPresence = {}));
// Retrieve enum metadata with: proto2.getEnumType(FeatureSet_FieldPresence)
proto2.util.setEnumType(FeatureSet_FieldPresence, "google.protobuf.FeatureSet.FieldPresence", [
    { no: 0, name: "FIELD_PRESENCE_UNKNOWN" },
    { no: 1, name: "EXPLICIT" },
    { no: 2, name: "IMPLICIT" },
    { no: 3, name: "LEGACY_REQUIRED" },
]);
/**
 * @generated from enum google.protobuf.FeatureSet.EnumType
 */
var FeatureSet_EnumType;
(function (FeatureSet_EnumType) {
    /**
     * @generated from enum value: ENUM_TYPE_UNKNOWN = 0;
     */
    FeatureSet_EnumType[FeatureSet_EnumType["ENUM_TYPE_UNKNOWN"] = 0] = "ENUM_TYPE_UNKNOWN";
    /**
     * @generated from enum value: OPEN = 1;
     */
    FeatureSet_EnumType[FeatureSet_EnumType["OPEN"] = 1] = "OPEN";
    /**
     * @generated from enum value: CLOSED = 2;
     */
    FeatureSet_EnumType[FeatureSet_EnumType["CLOSED"] = 2] = "CLOSED";
})(FeatureSet_EnumType || (FeatureSet_EnumType = {}));
// Retrieve enum metadata with: proto2.getEnumType(FeatureSet_EnumType)
proto2.util.setEnumType(FeatureSet_EnumType, "google.protobuf.FeatureSet.EnumType", [
    { no: 0, name: "ENUM_TYPE_UNKNOWN" },
    { no: 1, name: "OPEN" },
    { no: 2, name: "CLOSED" },
]);
/**
 * @generated from enum google.protobuf.FeatureSet.RepeatedFieldEncoding
 */
var FeatureSet_RepeatedFieldEncoding;
(function (FeatureSet_RepeatedFieldEncoding) {
    /**
     * @generated from enum value: REPEATED_FIELD_ENCODING_UNKNOWN = 0;
     */
    FeatureSet_RepeatedFieldEncoding[FeatureSet_RepeatedFieldEncoding["REPEATED_FIELD_ENCODING_UNKNOWN"] = 0] = "REPEATED_FIELD_ENCODING_UNKNOWN";
    /**
     * @generated from enum value: PACKED = 1;
     */
    FeatureSet_RepeatedFieldEncoding[FeatureSet_RepeatedFieldEncoding["PACKED"] = 1] = "PACKED";
    /**
     * @generated from enum value: EXPANDED = 2;
     */
    FeatureSet_RepeatedFieldEncoding[FeatureSet_RepeatedFieldEncoding["EXPANDED"] = 2] = "EXPANDED";
})(FeatureSet_RepeatedFieldEncoding || (FeatureSet_RepeatedFieldEncoding = {}));
// Retrieve enum metadata with: proto2.getEnumType(FeatureSet_RepeatedFieldEncoding)
proto2.util.setEnumType(FeatureSet_RepeatedFieldEncoding, "google.protobuf.FeatureSet.RepeatedFieldEncoding", [
    { no: 0, name: "REPEATED_FIELD_ENCODING_UNKNOWN" },
    { no: 1, name: "PACKED" },
    { no: 2, name: "EXPANDED" },
]);
/**
 * @generated from enum google.protobuf.FeatureSet.Utf8Validation
 */
var FeatureSet_Utf8Validation;
(function (FeatureSet_Utf8Validation) {
    /**
     * @generated from enum value: UTF8_VALIDATION_UNKNOWN = 0;
     */
    FeatureSet_Utf8Validation[FeatureSet_Utf8Validation["UTF8_VALIDATION_UNKNOWN"] = 0] = "UTF8_VALIDATION_UNKNOWN";
    /**
     * @generated from enum value: NONE = 1;
     */
    FeatureSet_Utf8Validation[FeatureSet_Utf8Validation["NONE"] = 1] = "NONE";
    /**
     * @generated from enum value: VERIFY = 2;
     */
    FeatureSet_Utf8Validation[FeatureSet_Utf8Validation["VERIFY"] = 2] = "VERIFY";
})(FeatureSet_Utf8Validation || (FeatureSet_Utf8Validation = {}));
// Retrieve enum metadata with: proto2.getEnumType(FeatureSet_Utf8Validation)
proto2.util.setEnumType(FeatureSet_Utf8Validation, "google.protobuf.FeatureSet.Utf8Validation", [
    { no: 0, name: "UTF8_VALIDATION_UNKNOWN" },
    { no: 1, name: "NONE" },
    { no: 2, name: "VERIFY" },
]);
/**
 * @generated from enum google.protobuf.FeatureSet.MessageEncoding
 */
var FeatureSet_MessageEncoding;
(function (FeatureSet_MessageEncoding) {
    /**
     * @generated from enum value: MESSAGE_ENCODING_UNKNOWN = 0;
     */
    FeatureSet_MessageEncoding[FeatureSet_MessageEncoding["MESSAGE_ENCODING_UNKNOWN"] = 0] = "MESSAGE_ENCODING_UNKNOWN";
    /**
     * @generated from enum value: LENGTH_PREFIXED = 1;
     */
    FeatureSet_MessageEncoding[FeatureSet_MessageEncoding["LENGTH_PREFIXED"] = 1] = "LENGTH_PREFIXED";
    /**
     * @generated from enum value: DELIMITED = 2;
     */
    FeatureSet_MessageEncoding[FeatureSet_MessageEncoding["DELIMITED"] = 2] = "DELIMITED";
})(FeatureSet_MessageEncoding || (FeatureSet_MessageEncoding = {}));
// Retrieve enum metadata with: proto2.getEnumType(FeatureSet_MessageEncoding)
proto2.util.setEnumType(FeatureSet_MessageEncoding, "google.protobuf.FeatureSet.MessageEncoding", [
    { no: 0, name: "MESSAGE_ENCODING_UNKNOWN" },
    { no: 1, name: "LENGTH_PREFIXED" },
    { no: 2, name: "DELIMITED" },
]);
/**
 * @generated from enum google.protobuf.FeatureSet.JsonFormat
 */
var FeatureSet_JsonFormat;
(function (FeatureSet_JsonFormat) {
    /**
     * @generated from enum value: JSON_FORMAT_UNKNOWN = 0;
     */
    FeatureSet_JsonFormat[FeatureSet_JsonFormat["JSON_FORMAT_UNKNOWN"] = 0] = "JSON_FORMAT_UNKNOWN";
    /**
     * @generated from enum value: ALLOW = 1;
     */
    FeatureSet_JsonFormat[FeatureSet_JsonFormat["ALLOW"] = 1] = "ALLOW";
    /**
     * @generated from enum value: LEGACY_BEST_EFFORT = 2;
     */
    FeatureSet_JsonFormat[FeatureSet_JsonFormat["LEGACY_BEST_EFFORT"] = 2] = "LEGACY_BEST_EFFORT";
})(FeatureSet_JsonFormat || (FeatureSet_JsonFormat = {}));
// Retrieve enum metadata with: proto2.getEnumType(FeatureSet_JsonFormat)
proto2.util.setEnumType(FeatureSet_JsonFormat, "google.protobuf.FeatureSet.JsonFormat", [
    { no: 0, name: "JSON_FORMAT_UNKNOWN" },
    { no: 1, name: "ALLOW" },
    { no: 2, name: "LEGACY_BEST_EFFORT" },
]);
/**
 * A compiled specification for the defaults of a set of features.  These
 * messages are generated from FeatureSet extensions and can be used to seed
 * feature resolution. The resolution with this object becomes a simple search
 * for the closest matching edition, followed by proto merges.
 *
 * @generated from message google.protobuf.FeatureSetDefaults
 */
class FeatureSetDefaults extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.FeatureSetDefaults.FeatureSetEditionDefault defaults = 1;
         */
        this.defaults = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FeatureSetDefaults().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FeatureSetDefaults().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FeatureSetDefaults().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FeatureSetDefaults, a, b);
    }
}
FeatureSetDefaults.runtime = proto2;
FeatureSetDefaults.typeName = "google.protobuf.FeatureSetDefaults";
FeatureSetDefaults.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "defaults", kind: "message", T: FeatureSetDefaults_FeatureSetEditionDefault, repeated: true },
    { no: 4, name: "minimum_edition", kind: "enum", T: proto2.getEnumType(Edition), opt: true },
    { no: 5, name: "maximum_edition", kind: "enum", T: proto2.getEnumType(Edition), opt: true },
]);
/**
 * A map from every known edition with a unique set of defaults to its
 * defaults. Not all editions may be contained here.  For a given edition,
 * the defaults at the closest matching edition ordered at or before it should
 * be used.  This field must be in strict ascending order by edition.
 *
 * @generated from message google.protobuf.FeatureSetDefaults.FeatureSetEditionDefault
 */
class FeatureSetDefaults_FeatureSetEditionDefault extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new FeatureSetDefaults_FeatureSetEditionDefault().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FeatureSetDefaults_FeatureSetEditionDefault().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FeatureSetDefaults_FeatureSetEditionDefault().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(FeatureSetDefaults_FeatureSetEditionDefault, a, b);
    }
}
FeatureSetDefaults_FeatureSetEditionDefault.runtime = proto2;
FeatureSetDefaults_FeatureSetEditionDefault.typeName = "google.protobuf.FeatureSetDefaults.FeatureSetEditionDefault";
FeatureSetDefaults_FeatureSetEditionDefault.fields = proto2.util.newFieldList(() => [
    { no: 3, name: "edition", kind: "enum", T: proto2.getEnumType(Edition), opt: true },
    { no: 2, name: "features", kind: "message", T: FeatureSet, opt: true },
]);
/**
 * Encapsulates information about the original source file from which a
 * FileDescriptorProto was generated.
 *
 * @generated from message google.protobuf.SourceCodeInfo
 */
class SourceCodeInfo extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * A Location identifies a piece of source code in a .proto file which
         * corresponds to a particular definition.  This information is intended
         * to be useful to IDEs, code indexers, documentation generators, and similar
         * tools.
         *
         * For example, say we have a file like:
         *   message Foo {
         *     optional string foo = 1;
         *   }
         * Let's look at just the field definition:
         *   optional string foo = 1;
         *   ^       ^^     ^^  ^  ^^^
         *   a       bc     de  f  ghi
         * We have the following locations:
         *   span   path               represents
         *   [a,i)  [ 4, 0, 2, 0 ]     The whole field definition.
         *   [a,b)  [ 4, 0, 2, 0, 4 ]  The label (optional).
         *   [c,d)  [ 4, 0, 2, 0, 5 ]  The type (string).
         *   [e,f)  [ 4, 0, 2, 0, 1 ]  The name (foo).
         *   [g,h)  [ 4, 0, 2, 0, 3 ]  The number (1).
         *
         * Notes:
         * - A location may refer to a repeated field itself (i.e. not to any
         *   particular index within it).  This is used whenever a set of elements are
         *   logically enclosed in a single code segment.  For example, an entire
         *   extend block (possibly containing multiple extension definitions) will
         *   have an outer location whose path refers to the "extensions" repeated
         *   field without an index.
         * - Multiple locations may have the same path.  This happens when a single
         *   logical declaration is spread out across multiple places.  The most
         *   obvious example is the "extend" block again -- there may be multiple
         *   extend blocks in the same scope, each of which will have the same path.
         * - A location's span is not always a subset of its parent's span.  For
         *   example, the "extendee" of an extension declaration appears at the
         *   beginning of the "extend" block and is shared by all extensions within
         *   the block.
         * - Just because a location's span is a subset of some other location's span
         *   does not mean that it is a descendant.  For example, a "group" defines
         *   both a type and a field in a single declaration.  Thus, the locations
         *   corresponding to the type and field and their components will overlap.
         * - Code which tries to interpret locations should probably be designed to
         *   ignore those that it doesn't understand, as more types of locations could
         *   be recorded in the future.
         *
         * @generated from field: repeated google.protobuf.SourceCodeInfo.Location location = 1;
         */
        this.location = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new SourceCodeInfo().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new SourceCodeInfo().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new SourceCodeInfo().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(SourceCodeInfo, a, b);
    }
}
SourceCodeInfo.runtime = proto2;
SourceCodeInfo.typeName = "google.protobuf.SourceCodeInfo";
SourceCodeInfo.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "location", kind: "message", T: SourceCodeInfo_Location, repeated: true },
]);
/**
 * @generated from message google.protobuf.SourceCodeInfo.Location
 */
class SourceCodeInfo_Location extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Identifies which part of the FileDescriptorProto was defined at this
         * location.
         *
         * Each element is a field number or an index.  They form a path from
         * the root FileDescriptorProto to the place where the definition occurs.
         * For example, this path:
         *   [ 4, 3, 2, 7, 1 ]
         * refers to:
         *   file.message_type(3)  // 4, 3
         *       .field(7)         // 2, 7
         *       .name()           // 1
         * This is because FileDescriptorProto.message_type has field number 4:
         *   repeated DescriptorProto message_type = 4;
         * and DescriptorProto.field has field number 2:
         *   repeated FieldDescriptorProto field = 2;
         * and FieldDescriptorProto.name has field number 1:
         *   optional string name = 1;
         *
         * Thus, the above path gives the location of a field name.  If we removed
         * the last element:
         *   [ 4, 3, 2, 7 ]
         * this path refers to the whole field declaration (from the beginning
         * of the label to the terminating semicolon).
         *
         * @generated from field: repeated int32 path = 1 [packed = true];
         */
        this.path = [];
        /**
         * Always has exactly three or four elements: start line, start column,
         * end line (optional, otherwise assumed same as start line), end column.
         * These are packed into a single field for efficiency.  Note that line
         * and column numbers are zero-based -- typically you will want to add
         * 1 to each before displaying to a user.
         *
         * @generated from field: repeated int32 span = 2 [packed = true];
         */
        this.span = [];
        /**
         * @generated from field: repeated string leading_detached_comments = 6;
         */
        this.leadingDetachedComments = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new SourceCodeInfo_Location().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new SourceCodeInfo_Location().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new SourceCodeInfo_Location().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(SourceCodeInfo_Location, a, b);
    }
}
SourceCodeInfo_Location.runtime = proto2;
SourceCodeInfo_Location.typeName = "google.protobuf.SourceCodeInfo.Location";
SourceCodeInfo_Location.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "path", kind: "scalar", T: 5 /* ScalarType.INT32 */, repeated: true, packed: true },
    { no: 2, name: "span", kind: "scalar", T: 5 /* ScalarType.INT32 */, repeated: true, packed: true },
    { no: 3, name: "leading_comments", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 4, name: "trailing_comments", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 6, name: "leading_detached_comments", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
]);
/**
 * Describes the relationship between generated code and its original source
 * file. A GeneratedCodeInfo message is associated with only one generated
 * source file, but may contain references to different source .proto files.
 *
 * @generated from message google.protobuf.GeneratedCodeInfo
 */
class GeneratedCodeInfo extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * An Annotation connects some span of text in generated code to an element
         * of its generating .proto file.
         *
         * @generated from field: repeated google.protobuf.GeneratedCodeInfo.Annotation annotation = 1;
         */
        this.annotation = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new GeneratedCodeInfo().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new GeneratedCodeInfo().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new GeneratedCodeInfo().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(GeneratedCodeInfo, a, b);
    }
}
GeneratedCodeInfo.runtime = proto2;
GeneratedCodeInfo.typeName = "google.protobuf.GeneratedCodeInfo";
GeneratedCodeInfo.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "annotation", kind: "message", T: GeneratedCodeInfo_Annotation, repeated: true },
]);
/**
 * @generated from message google.protobuf.GeneratedCodeInfo.Annotation
 */
class GeneratedCodeInfo_Annotation extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Identifies the element in the original source .proto file. This field
         * is formatted the same as SourceCodeInfo.Location.path.
         *
         * @generated from field: repeated int32 path = 1 [packed = true];
         */
        this.path = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new GeneratedCodeInfo_Annotation().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new GeneratedCodeInfo_Annotation().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new GeneratedCodeInfo_Annotation().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(GeneratedCodeInfo_Annotation, a, b);
    }
}
GeneratedCodeInfo_Annotation.runtime = proto2;
GeneratedCodeInfo_Annotation.typeName = "google.protobuf.GeneratedCodeInfo.Annotation";
GeneratedCodeInfo_Annotation.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "path", kind: "scalar", T: 5 /* ScalarType.INT32 */, repeated: true, packed: true },
    { no: 2, name: "source_file", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "begin", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 4, name: "end", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 5, name: "semantic", kind: "enum", T: proto2.getEnumType(GeneratedCodeInfo_Annotation_Semantic), opt: true },
]);
/**
 * Represents the identified object's effect on the element in the original
 * .proto file.
 *
 * @generated from enum google.protobuf.GeneratedCodeInfo.Annotation.Semantic
 */
var GeneratedCodeInfo_Annotation_Semantic;
(function (GeneratedCodeInfo_Annotation_Semantic) {
    /**
     * There is no effect or the effect is indescribable.
     *
     * @generated from enum value: NONE = 0;
     */
    GeneratedCodeInfo_Annotation_Semantic[GeneratedCodeInfo_Annotation_Semantic["NONE"] = 0] = "NONE";
    /**
     * The element is set or otherwise mutated.
     *
     * @generated from enum value: SET = 1;
     */
    GeneratedCodeInfo_Annotation_Semantic[GeneratedCodeInfo_Annotation_Semantic["SET"] = 1] = "SET";
    /**
     * An alias to the element is returned.
     *
     * @generated from enum value: ALIAS = 2;
     */
    GeneratedCodeInfo_Annotation_Semantic[GeneratedCodeInfo_Annotation_Semantic["ALIAS"] = 2] = "ALIAS";
})(GeneratedCodeInfo_Annotation_Semantic || (GeneratedCodeInfo_Annotation_Semantic = {}));
// Retrieve enum metadata with: proto2.getEnumType(GeneratedCodeInfo_Annotation_Semantic)
proto2.util.setEnumType(GeneratedCodeInfo_Annotation_Semantic, "google.protobuf.GeneratedCodeInfo.Annotation.Semantic", [
    { no: 0, name: "NONE" },
    { no: 1, name: "SET" },
    { no: 2, name: "ALIAS" },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/text-format.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



function parseTextFormatEnumValue(descEnum, value) {
    const enumValue = descEnum.values.find((v) => v.name === value);
    (0,assert/* assert */.hu)(enumValue, `cannot parse ${descEnum.name} default value: ${value}`);
    return enumValue.number;
}
function parseTextFormatScalarValue(type, value) {
    switch (type) {
        case esm_field/* ScalarType */.w.STRING:
            return value;
        case esm_field/* ScalarType */.w.BYTES: {
            const u = unescapeBytesDefaultValue(value);
            if (u === false) {
                throw new Error(`cannot parse ${esm_field/* ScalarType */.w[type]} default value: ${value}`);
            }
            return u;
        }
        case esm_field/* ScalarType */.w.INT64:
        case esm_field/* ScalarType */.w.SFIXED64:
        case esm_field/* ScalarType */.w.SINT64:
            return proto_int64/* protoInt64 */.q.parse(value);
        case esm_field/* ScalarType */.w.UINT64:
        case esm_field/* ScalarType */.w.FIXED64:
            return proto_int64/* protoInt64 */.q.uParse(value);
        case esm_field/* ScalarType */.w.DOUBLE:
        case esm_field/* ScalarType */.w.FLOAT:
            switch (value) {
                case "inf":
                    return Number.POSITIVE_INFINITY;
                case "-inf":
                    return Number.NEGATIVE_INFINITY;
                case "nan":
                    return Number.NaN;
                default:
                    return parseFloat(value);
            }
        case esm_field/* ScalarType */.w.BOOL:
            return value === "true";
        case esm_field/* ScalarType */.w.INT32:
        case esm_field/* ScalarType */.w.UINT32:
        case esm_field/* ScalarType */.w.SINT32:
        case esm_field/* ScalarType */.w.FIXED32:
        case esm_field/* ScalarType */.w.SFIXED32:
            return parseInt(value, 10);
    }
}
/**
 * Parses a text-encoded default value (proto2) of a BYTES field.
 */
function unescapeBytesDefaultValue(str) {
    const b = [];
    const input = {
        tail: str,
        c: "",
        next() {
            if (this.tail.length == 0) {
                return false;
            }
            this.c = this.tail[0];
            this.tail = this.tail.substring(1);
            return true;
        },
        take(n) {
            if (this.tail.length >= n) {
                const r = this.tail.substring(0, n);
                this.tail = this.tail.substring(n);
                return r;
            }
            return false;
        },
    };
    while (input.next()) {
        switch (input.c) {
            case "\\":
                if (input.next()) {
                    switch (input.c) {
                        case "\\":
                            b.push(input.c.charCodeAt(0));
                            break;
                        case "b":
                            b.push(0x08);
                            break;
                        case "f":
                            b.push(0x0c);
                            break;
                        case "n":
                            b.push(0x0a);
                            break;
                        case "r":
                            b.push(0x0d);
                            break;
                        case "t":
                            b.push(0x09);
                            break;
                        case "v":
                            b.push(0x0b);
                            break;
                        case "0":
                        case "1":
                        case "2":
                        case "3":
                        case "4":
                        case "5":
                        case "6":
                        case "7": {
                            const s = input.c;
                            const t = input.take(2);
                            if (t === false) {
                                return false;
                            }
                            const n = parseInt(s + t, 8);
                            if (isNaN(n)) {
                                return false;
                            }
                            b.push(n);
                            break;
                        }
                        case "x": {
                            const s = input.c;
                            const t = input.take(2);
                            if (t === false) {
                                return false;
                            }
                            const n = parseInt(s + t, 16);
                            if (isNaN(n)) {
                                return false;
                            }
                            b.push(n);
                            break;
                        }
                        case "u": {
                            const s = input.c;
                            const t = input.take(4);
                            if (t === false) {
                                return false;
                            }
                            const n = parseInt(s + t, 16);
                            if (isNaN(n)) {
                                return false;
                            }
                            const chunk = new Uint8Array(4);
                            const view = new DataView(chunk.buffer);
                            view.setInt32(0, n, true);
                            b.push(chunk[0], chunk[1], chunk[2], chunk[3]);
                            break;
                        }
                        case "U": {
                            const s = input.c;
                            const t = input.take(8);
                            if (t === false) {
                                return false;
                            }
                            const tc = proto_int64/* protoInt64 */.q.uEnc(s + t);
                            const chunk = new Uint8Array(8);
                            const view = new DataView(chunk.buffer);
                            view.setInt32(0, tc.lo, true);
                            view.setInt32(4, tc.hi, true);
                            b.push(chunk[0], chunk[1], chunk[2], chunk[3], chunk[4], chunk[5], chunk[6], chunk[7]);
                            break;
                        }
                    }
                }
                break;
            default:
                b.push(input.c.charCodeAt(0));
        }
    }
    return new Uint8Array(b);
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/feature-set.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Static edition feature defaults supported by @bufbuild/protobuf.
 */
const featureSetDefaults = FeatureSetDefaults.fromBinary(proto_base64/* protoBase64 */.W.dec(
/*upstream-inject-feature-defaults-start*/ "ChESDAgBEAIYAiABKAEwAhjmBwoREgwIAhABGAEgAigBMAEY5wcKERIMCAEQARgBIAIoATABGOgHIOYHKOgH" /*upstream-inject-feature-defaults-end*/));
/**
 * Create an edition feature resolver with the given feature set defaults.
 */
function createFeatureResolver(compiledFeatureSetDefaults) {
    const min = compiledFeatureSetDefaults.minimumEdition;
    const max = compiledFeatureSetDefaults.maximumEdition;
    if (min === undefined ||
        max === undefined ||
        compiledFeatureSetDefaults.defaults.some((d) => d.edition === undefined)) {
        throw new Error("Invalid FeatureSetDefaults");
    }
    const defaultsBinByEdition = new Map();
    return (edition, ...rest) => {
        var _a, _b;
        let defaultsBin = defaultsBinByEdition.get(edition);
        if (defaultsBin === undefined) {
            if (edition < min) {
                throw new Error(`Edition ${Edition[edition]} is earlier than the minimum supported edition ${Edition[min]}`);
            }
            if (max < edition) {
                throw new Error(`Edition ${Edition[edition]} is later than the maximum supported edition ${Edition[max]}`);
            }
            let highestMatch = undefined;
            for (const c of compiledFeatureSetDefaults.defaults) {
                const e = (_a = c.edition) !== null && _a !== void 0 ? _a : 0;
                if (e > edition) {
                    continue;
                }
                if (highestMatch !== undefined && highestMatch.e > e) {
                    continue;
                }
                highestMatch = {
                    e,
                    f: (_b = c.features) !== null && _b !== void 0 ? _b : new FeatureSet(),
                };
            }
            if (highestMatch === undefined) {
                throw new Error(`No valid default found for edition ${Edition[edition]}`);
            }
            defaultsBin = highestMatch.f.toBinary();
            defaultsBinByEdition.set(edition, defaultsBin);
        }
        const f = FeatureSet.fromBinary(defaultsBin);
        for (const c of rest) {
            if (c !== undefined) {
                f.fromBinary(c.toBinary());
            }
        }
        if (!validateMergedFeatures(f)) {
            throw new Error(`Invalid FeatureSet for edition ${Edition[edition]}`);
        }
        return f;
    };
}
// When protoc generates google.protobuf.FeatureSetDefaults, it ensures that
// fields are not repeated or required, do not use oneof, and have a default
// value.
//
// When features for an element are resolved, features of the element and its
// parents are merged into the default FeatureSet for the edition. Because unset
// fields in the FeatureSet of an element do not unset the default FeatureSet
// values, a resolved FeatureSet is guaranteed to have all fields set. This is
// also the case for extensions to FeatureSet that a user might provide, and for
// features from the future.
//
// We cannot exhaustively validate correctness of FeatureSetDefaults at runtime
// without knowing the schema: If no value for a feature is provided, we do not
// know that it exists at all.
//
// As a sanity check, we validate that all fields known to our version of
// FeatureSet are set.
function validateMergedFeatures(featureSet) {
    for (const fi of FeatureSet.fields.list()) {
        const v = featureSet[fi.localName];
        if (v === undefined) {
            return false;
        }
        if (fi.kind == "enum" && v === 0) {
            return false;
        }
    }
    return true;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/create-descriptor-set.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.







/**
 * Create a DescriptorSet, a convenient interface for working with a set of
 * google.protobuf.FileDescriptorProto.
 *
 * Note that files must be given in topological order, so each file appears
 * before any file that imports it. Protocol buffer compilers always produce
 * files in topological order.
 */
function createDescriptorSet(input, options) {
    var _a;
    const cart = {
        enums: new Map(),
        messages: new Map(),
        services: new Map(),
        extensions: new Map(),
        mapEntries: new Map(),
        resolveFeatures: createFeatureResolver((_a = options === null || options === void 0 ? void 0 : options.featureSetDefaults) !== null && _a !== void 0 ? _a : featureSetDefaults),
    };
    const fileDescriptors = input instanceof FileDescriptorSet
        ? input.file
        : input instanceof Uint8Array
            ? FileDescriptorSet.fromBinary(input).file
            : input;
    const files = fileDescriptors.map((proto) => newFile(proto, cart));
    return Object.assign({ files }, cart);
}
/**
 * Create a descriptor for a file.
 */
function newFile(proto, cart) {
    var _a, _b;
    (0,assert/* assert */.hu)(proto.name, `invalid FileDescriptorProto: missing name`);
    const file = Object.assign(Object.assign({ kind: "file", proto, deprecated: (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) !== null && _b !== void 0 ? _b : false }, parseFileSyntax(proto.syntax, proto.edition)), { name: proto.name.replace(/\.proto/, ""), enums: [], messages: [], extensions: [], services: [], toString() {
            // eslint-disable-next-line @typescript-eslint/restrict-template-expressions -- we asserted above
            return `file ${this.proto.name}`;
        },
        getSyntaxComments() {
            return findComments(this.proto.sourceCodeInfo, [
                FieldNumber.FileDescriptorProto_Syntax,
            ]);
        },
        getPackageComments() {
            return findComments(this.proto.sourceCodeInfo, [
                FieldNumber.FileDescriptorProto_Package,
            ]);
        },
        getFeatures() {
            var _a;
            return cart.resolveFeatures(this.edition, (_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.features);
        } });
    cart.mapEntries.clear(); // map entries are local to the file, we can safely discard
    for (const enumProto of proto.enumType) {
        addEnum(enumProto, file, undefined, cart);
    }
    for (const messageProto of proto.messageType) {
        addMessage(messageProto, file, undefined, cart);
    }
    for (const serviceProto of proto.service) {
        addService(serviceProto, file, cart);
    }
    addExtensions(file, cart);
    for (const mapEntry of cart.mapEntries.values()) {
        addFields(mapEntry, cart);
    }
    for (const message of file.messages) {
        addFields(message, cart);
        addExtensions(message, cart);
    }
    cart.mapEntries.clear(); // map entries are local to the file, we can safely discard
    return file;
}
/**
 * Create descriptors for extensions, and add them to the message / file,
 * and to our cart.
 * Recurses into nested types.
 */
function addExtensions(desc, cart) {
    switch (desc.kind) {
        case "file":
            for (const proto of desc.proto.extension) {
                const ext = newExtension(proto, desc, undefined, cart);
                desc.extensions.push(ext);
                cart.extensions.set(ext.typeName, ext);
            }
            break;
        case "message":
            for (const proto of desc.proto.extension) {
                const ext = newExtension(proto, desc.file, desc, cart);
                desc.nestedExtensions.push(ext);
                cart.extensions.set(ext.typeName, ext);
            }
            for (const message of desc.nestedMessages) {
                addExtensions(message, cart);
            }
            break;
    }
}
/**
 * Create descriptors for fields and oneof groups, and add them to the message.
 * Recurses into nested types.
 */
function addFields(message, cart) {
    const allOneofs = message.proto.oneofDecl.map((proto) => newOneof(proto, message, cart));
    const oneofsSeen = new Set();
    for (const proto of message.proto.field) {
        const oneof = findOneof(proto, allOneofs);
        const field = newField(proto, message.file, message, oneof, cart);
        message.fields.push(field);
        if (oneof === undefined) {
            message.members.push(field);
        }
        else {
            oneof.fields.push(field);
            if (!oneofsSeen.has(oneof)) {
                oneofsSeen.add(oneof);
                message.members.push(oneof);
            }
        }
    }
    for (const oneof of allOneofs.filter((o) => oneofsSeen.has(o))) {
        message.oneofs.push(oneof);
    }
    for (const child of message.nestedMessages) {
        addFields(child, cart);
    }
}
/**
 * Create a descriptor for an enumeration, and add it our cart and to the
 * parent type, if any.
 */
function addEnum(proto, file, parent, cart) {
    var _a, _b, _c;
    (0,assert/* assert */.hu)(proto.name, `invalid EnumDescriptorProto: missing name`);
    const desc = {
        kind: "enum",
        proto,
        deprecated: (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) !== null && _b !== void 0 ? _b : false,
        file,
        parent,
        name: proto.name,
        typeName: makeTypeName(proto, parent, file),
        values: [],
        sharedPrefix: (0,names/* findEnumSharedPrefix */.Sm)(proto.name, proto.value.map((v) => { var _a; return (_a = v.name) !== null && _a !== void 0 ? _a : ""; })),
        toString() {
            return `enum ${this.typeName}`;
        },
        getComments() {
            const path = this.parent
                ? [
                    ...this.parent.getComments().sourcePath,
                    FieldNumber.DescriptorProto_EnumType,
                    this.parent.proto.enumType.indexOf(this.proto),
                ]
                : [
                    FieldNumber.FileDescriptorProto_EnumType,
                    this.file.proto.enumType.indexOf(this.proto),
                ];
            return findComments(file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a, _b, _c;
            const parentFeatures = (_b = (_a = this.parent) === null || _a === void 0 ? void 0 : _a.getFeatures()) !== null && _b !== void 0 ? _b : this.file.getFeatures();
            return cart.resolveFeatures(this.file.edition, parentFeatures, (_c = this.proto.options) === null || _c === void 0 ? void 0 : _c.features);
        },
    };
    cart.enums.set(desc.typeName, desc);
    proto.value.forEach((proto) => {
        var _a, _b;
        (0,assert/* assert */.hu)(proto.name, `invalid EnumValueDescriptorProto: missing name`);
        (0,assert/* assert */.hu)(proto.number !== undefined, `invalid EnumValueDescriptorProto: missing number`);
        desc.values.push({
            kind: "enum_value",
            proto,
            deprecated: (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) !== null && _b !== void 0 ? _b : false,
            parent: desc,
            name: proto.name,
            number: proto.number,
            toString() {
                return `enum value ${desc.typeName}.${this.name}`;
            },
            declarationString() {
                var _a;
                let str = `${this.name} = ${this.number}`;
                if (((_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) === true) {
                    str += " [deprecated = true]";
                }
                return str;
            },
            getComments() {
                const path = [
                    ...this.parent.getComments().sourcePath,
                    FieldNumber.EnumDescriptorProto_Value,
                    this.parent.proto.value.indexOf(this.proto),
                ];
                return findComments(file.proto.sourceCodeInfo, path);
            },
            getFeatures() {
                var _a;
                return cart.resolveFeatures(this.parent.file.edition, this.parent.getFeatures(), (_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.features);
            },
        });
    });
    ((_c = parent === null || parent === void 0 ? void 0 : parent.nestedEnums) !== null && _c !== void 0 ? _c : file.enums).push(desc);
}
/**
 * Create a descriptor for a message, including nested types, and add it to our
 * cart. Note that this does not create descriptors fields.
 */
function addMessage(proto, file, parent, cart) {
    var _a, _b, _c, _d;
    (0,assert/* assert */.hu)(proto.name, `invalid DescriptorProto: missing name`);
    const desc = {
        kind: "message",
        proto,
        deprecated: (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) !== null && _b !== void 0 ? _b : false,
        file,
        parent,
        name: proto.name,
        typeName: makeTypeName(proto, parent, file),
        fields: [],
        oneofs: [],
        members: [],
        nestedEnums: [],
        nestedMessages: [],
        nestedExtensions: [],
        toString() {
            return `message ${this.typeName}`;
        },
        getComments() {
            const path = this.parent
                ? [
                    ...this.parent.getComments().sourcePath,
                    FieldNumber.DescriptorProto_NestedType,
                    this.parent.proto.nestedType.indexOf(this.proto),
                ]
                : [
                    FieldNumber.FileDescriptorProto_MessageType,
                    this.file.proto.messageType.indexOf(this.proto),
                ];
            return findComments(file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a, _b, _c;
            const parentFeatures = (_b = (_a = this.parent) === null || _a === void 0 ? void 0 : _a.getFeatures()) !== null && _b !== void 0 ? _b : this.file.getFeatures();
            return cart.resolveFeatures(this.file.edition, parentFeatures, (_c = this.proto.options) === null || _c === void 0 ? void 0 : _c.features);
        },
    };
    if (((_c = proto.options) === null || _c === void 0 ? void 0 : _c.mapEntry) === true) {
        cart.mapEntries.set(desc.typeName, desc);
    }
    else {
        ((_d = parent === null || parent === void 0 ? void 0 : parent.nestedMessages) !== null && _d !== void 0 ? _d : file.messages).push(desc);
        cart.messages.set(desc.typeName, desc);
    }
    for (const enumProto of proto.enumType) {
        addEnum(enumProto, file, desc, cart);
    }
    for (const messageProto of proto.nestedType) {
        addMessage(messageProto, file, desc, cart);
    }
}
/**
 * Create a descriptor for a service, including methods, and add it to our
 * cart.
 */
function addService(proto, file, cart) {
    var _a, _b;
    (0,assert/* assert */.hu)(proto.name, `invalid ServiceDescriptorProto: missing name`);
    const desc = {
        kind: "service",
        proto,
        deprecated: (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) !== null && _b !== void 0 ? _b : false,
        file,
        name: proto.name,
        typeName: makeTypeName(proto, undefined, file),
        methods: [],
        toString() {
            return `service ${this.typeName}`;
        },
        getComments() {
            const path = [
                FieldNumber.FileDescriptorProto_Service,
                this.file.proto.service.indexOf(this.proto),
            ];
            return findComments(file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a;
            return cart.resolveFeatures(this.file.edition, this.file.getFeatures(), (_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.features);
        },
    };
    file.services.push(desc);
    cart.services.set(desc.typeName, desc);
    for (const methodProto of proto.method) {
        desc.methods.push(newMethod(methodProto, desc, cart));
    }
}
/**
 * Create a descriptor for a method.
 */
function newMethod(proto, parent, cart) {
    var _a, _b, _c;
    (0,assert/* assert */.hu)(proto.name, `invalid MethodDescriptorProto: missing name`);
    (0,assert/* assert */.hu)(proto.inputType, `invalid MethodDescriptorProto: missing input_type`);
    (0,assert/* assert */.hu)(proto.outputType, `invalid MethodDescriptorProto: missing output_type`);
    let methodKind;
    if (proto.clientStreaming === true && proto.serverStreaming === true) {
        methodKind = service_type/* MethodKind */.t.BiDiStreaming;
    }
    else if (proto.clientStreaming === true) {
        methodKind = service_type/* MethodKind */.t.ClientStreaming;
    }
    else if (proto.serverStreaming === true) {
        methodKind = service_type/* MethodKind */.t.ServerStreaming;
    }
    else {
        methodKind = service_type/* MethodKind */.t.Unary;
    }
    let idempotency;
    switch ((_a = proto.options) === null || _a === void 0 ? void 0 : _a.idempotencyLevel) {
        case MethodOptions_IdempotencyLevel.IDEMPOTENT:
            idempotency = service_type/* MethodIdempotency */.w.Idempotent;
            break;
        case MethodOptions_IdempotencyLevel.NO_SIDE_EFFECTS:
            idempotency = service_type/* MethodIdempotency */.w.NoSideEffects;
            break;
        case MethodOptions_IdempotencyLevel.IDEMPOTENCY_UNKNOWN:
        case undefined:
            idempotency = undefined;
            break;
    }
    const input = cart.messages.get(trimLeadingDot(proto.inputType));
    const output = cart.messages.get(trimLeadingDot(proto.outputType));
    (0,assert/* assert */.hu)(input, `invalid MethodDescriptorProto: input_type ${proto.inputType} not found`);
    (0,assert/* assert */.hu)(output, `invalid MethodDescriptorProto: output_type ${proto.inputType} not found`);
    const name = proto.name;
    return {
        kind: "rpc",
        proto,
        deprecated: (_c = (_b = proto.options) === null || _b === void 0 ? void 0 : _b.deprecated) !== null && _c !== void 0 ? _c : false,
        parent,
        name,
        methodKind,
        input,
        output,
        idempotency,
        toString() {
            return `rpc ${parent.typeName}.${name}`;
        },
        getComments() {
            const path = [
                ...this.parent.getComments().sourcePath,
                FieldNumber.ServiceDescriptorProto_Method,
                this.parent.proto.method.indexOf(this.proto),
            ];
            return findComments(parent.file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a;
            return cart.resolveFeatures(this.parent.file.edition, this.parent.getFeatures(), (_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.features);
        },
    };
}
/**
 * Create a descriptor for a oneof group.
 */
function newOneof(proto, parent, cart) {
    (0,assert/* assert */.hu)(proto.name, `invalid OneofDescriptorProto: missing name`);
    return {
        kind: "oneof",
        proto,
        deprecated: false,
        parent,
        fields: [],
        name: proto.name,
        toString() {
            return `oneof ${parent.typeName}.${this.name}`;
        },
        getComments() {
            const path = [
                ...this.parent.getComments().sourcePath,
                FieldNumber.DescriptorProto_OneofDecl,
                this.parent.proto.oneofDecl.indexOf(this.proto),
            ];
            return findComments(parent.file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a;
            return cart.resolveFeatures(this.parent.file.edition, this.parent.getFeatures(), (_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.features);
        },
    };
}
/**
 * Create a descriptor for a field.
 */
function newField(proto, file, parent, oneof, cart) {
    var _a, _b, _c;
    (0,assert/* assert */.hu)(proto.name, `invalid FieldDescriptorProto: missing name`);
    (0,assert/* assert */.hu)(proto.number, `invalid FieldDescriptorProto: missing number`);
    (0,assert/* assert */.hu)(proto.type, `invalid FieldDescriptorProto: missing type`);
    const common = {
        proto,
        deprecated: (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.deprecated) !== null && _b !== void 0 ? _b : false,
        name: proto.name,
        number: proto.number,
        parent,
        oneof,
        optional: isOptionalField(proto, file.syntax),
        packedByDefault: isPackedFieldByDefault(file, proto, cart.resolveFeatures),
        packed: isPackedField(file, parent, proto, cart.resolveFeatures),
        jsonName: proto.jsonName === (0,names/* fieldJsonName */.x1)(proto.name) ? undefined : proto.jsonName,
        scalar: undefined,
        longType: undefined,
        message: undefined,
        enum: undefined,
        mapKey: undefined,
        mapValue: undefined,
        declarationString,
        // toString, getComments, getFeatures are overridden in newExtension
        toString() {
            return `field ${this.parent.typeName}.${this.name}`;
        },
        getComments() {
            const path = [
                ...this.parent.getComments().sourcePath,
                FieldNumber.DescriptorProto_Field,
                this.parent.proto.field.indexOf(this.proto),
            ];
            return findComments(file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a;
            return cart.resolveFeatures(file.edition, this.parent.getFeatures(), (_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.features);
        },
    };
    const repeated = proto.label === FieldDescriptorProto_Label.REPEATED;
    switch (proto.type) {
        case FieldDescriptorProto_Type.MESSAGE:
        case FieldDescriptorProto_Type.GROUP: {
            (0,assert/* assert */.hu)(proto.typeName, `invalid FieldDescriptorProto: missing type_name`);
            const mapEntry = cart.mapEntries.get(trimLeadingDot(proto.typeName));
            if (mapEntry !== undefined) {
                (0,assert/* assert */.hu)(repeated, `invalid FieldDescriptorProto: expected map entry to be repeated`);
                return Object.assign(Object.assign(Object.assign({}, common), { kind: "field", fieldKind: "map", repeated: false }), getMapFieldTypes(mapEntry));
            }
            const message = cart.messages.get(trimLeadingDot(proto.typeName));
            (0,assert/* assert */.hu)(message !== undefined, `invalid FieldDescriptorProto: type_name ${proto.typeName} not found`);
            return Object.assign(Object.assign({}, common), { kind: "field", fieldKind: "message", repeated,
                message });
        }
        case FieldDescriptorProto_Type.ENUM: {
            (0,assert/* assert */.hu)(proto.typeName, `invalid FieldDescriptorProto: missing type_name`);
            const e = cart.enums.get(trimLeadingDot(proto.typeName));
            (0,assert/* assert */.hu)(e !== undefined, `invalid FieldDescriptorProto: type_name ${proto.typeName} not found`);
            return Object.assign(Object.assign({}, common), { kind: "field", fieldKind: "enum", getDefaultValue,
                repeated, enum: e });
        }
        default: {
            const scalar = fieldTypeToScalarType[proto.type];
            (0,assert/* assert */.hu)(scalar, `invalid FieldDescriptorProto: unknown type ${proto.type}`);
            return Object.assign(Object.assign({}, common), { kind: "field", fieldKind: "scalar", getDefaultValue,
                repeated,
                scalar, longType: ((_c = proto.options) === null || _c === void 0 ? void 0 : _c.jstype) == FieldOptions_JSType.JS_STRING
                    ? esm_field/* LongType */.p.STRING
                    : esm_field/* LongType */.p.BIGINT });
        }
    }
}
/**
 * Create a descriptor for an extension field.
 */
function newExtension(proto, file, parent, cart) {
    (0,assert/* assert */.hu)(proto.extendee, `invalid FieldDescriptorProto: missing extendee`);
    const field = newField(proto, file, null, // to safe us many lines of duplicated code, we trick the type system
    undefined, cart);
    const extendee = cart.messages.get(trimLeadingDot(proto.extendee));
    (0,assert/* assert */.hu)(extendee, `invalid FieldDescriptorProto: extendee ${proto.extendee} not found`);
    return Object.assign(Object.assign({}, field), { kind: "extension", typeName: makeTypeName(proto, parent, file), parent,
        file,
        extendee,
        // Must override toString, getComments, getFeatures from newField, because we
        // call newField with parent undefined.
        toString() {
            return `extension ${this.typeName}`;
        },
        getComments() {
            const path = this.parent
                ? [
                    ...this.parent.getComments().sourcePath,
                    FieldNumber.DescriptorProto_Extension,
                    this.parent.proto.extension.indexOf(proto),
                ]
                : [
                    FieldNumber.FileDescriptorProto_Extension,
                    this.file.proto.extension.indexOf(proto),
                ];
            return findComments(file.proto.sourceCodeInfo, path);
        },
        getFeatures() {
            var _a, _b;
            return cart.resolveFeatures(this.file.edition, ((_a = this.parent) !== null && _a !== void 0 ? _a : this.file).getFeatures(), (_b = this.proto.options) === null || _b === void 0 ? void 0 : _b.features);
        } });
}
/**
 * Parse the "syntax" and "edition" fields, stripping test editions.
 */
function parseFileSyntax(syntax, edition) {
    let e;
    let s;
    switch (syntax) {
        case undefined:
        case "proto2":
            s = "proto2";
            e = Edition.EDITION_PROTO2;
            break;
        case "proto3":
            s = "proto3";
            e = Edition.EDITION_PROTO3;
            break;
        case "editions":
            s = "editions";
            switch (edition) {
                case undefined:
                case Edition.EDITION_1_TEST_ONLY:
                case Edition.EDITION_2_TEST_ONLY:
                case Edition.EDITION_99997_TEST_ONLY:
                case Edition.EDITION_99998_TEST_ONLY:
                case Edition.EDITION_99999_TEST_ONLY:
                case Edition.EDITION_UNKNOWN:
                    e = Edition.EDITION_UNKNOWN;
                    break;
                default:
                    e = edition;
                    break;
            }
            break;
        default:
            throw new Error(`invalid FileDescriptorProto: unsupported syntax: ${syntax}`);
    }
    if (syntax === "editions" && edition === Edition.EDITION_UNKNOWN) {
        throw new Error(`invalid FileDescriptorProto: syntax ${syntax} cannot have edition ${String(edition)}`);
    }
    return {
        syntax: s,
        edition: e,
    };
}
/**
 * Create a fully qualified name for a protobuf type or extension field.
 *
 * The fully qualified name for messages, enumerations, and services is
 * constructed by concatenating the package name (if present), parent
 * message names (for nested types), and the type name. We omit the leading
 * dot added by protobuf compilers. Examples:
 * - mypackage.MyMessage
 * - mypackage.MyMessage.NestedMessage
 *
 * The fully qualified name for extension fields is constructed by
 * concatenating the package name (if present), parent message names (for
 * extensions declared within a message), and the field name. Examples:
 * - mypackage.extfield
 * - mypackage.MyMessage.extfield
 */
function makeTypeName(proto, parent, file) {
    (0,assert/* assert */.hu)(proto.name, `invalid ${proto.getType().typeName}: missing name`);
    let typeName;
    if (parent) {
        typeName = `${parent.typeName}.${proto.name}`;
    }
    else if (file.proto.package !== undefined) {
        typeName = `${file.proto.package}.${proto.name}`;
    }
    else {
        typeName = `${proto.name}`;
    }
    return typeName;
}
/**
 * Remove the leading dot from a fully qualified type name.
 */
function trimLeadingDot(typeName) {
    return typeName.startsWith(".") ? typeName.substring(1) : typeName;
}
function getMapFieldTypes(mapEntry) {
    var _a, _b;
    (0,assert/* assert */.hu)((_a = mapEntry.proto.options) === null || _a === void 0 ? void 0 : _a.mapEntry, `invalid DescriptorProto: expected ${mapEntry.toString()} to be a map entry`);
    (0,assert/* assert */.hu)(mapEntry.fields.length === 2, `invalid DescriptorProto: map entry ${mapEntry.toString()} has ${mapEntry.fields.length} fields`);
    const keyField = mapEntry.fields.find((f) => f.proto.number === 1);
    (0,assert/* assert */.hu)(keyField, `invalid DescriptorProto: map entry ${mapEntry.toString()} is missing key field`);
    const mapKey = keyField.scalar;
    (0,assert/* assert */.hu)(mapKey !== undefined &&
        mapKey !== esm_field/* ScalarType */.w.BYTES &&
        mapKey !== esm_field/* ScalarType */.w.FLOAT &&
        mapKey !== esm_field/* ScalarType */.w.DOUBLE, `invalid DescriptorProto: map entry ${mapEntry.toString()} has unexpected key type ${(_b = keyField.proto.type) !== null && _b !== void 0 ? _b : -1}`);
    const valueField = mapEntry.fields.find((f) => f.proto.number === 2);
    (0,assert/* assert */.hu)(valueField, `invalid DescriptorProto: map entry ${mapEntry.toString()} is missing value field`);
    switch (valueField.fieldKind) {
        case "scalar":
            return {
                mapKey,
                mapValue: Object.assign(Object.assign({}, valueField), { kind: "scalar" }),
            };
        case "message":
            return {
                mapKey,
                mapValue: Object.assign(Object.assign({}, valueField), { kind: "message" }),
            };
        case "enum":
            return {
                mapKey,
                mapValue: Object.assign(Object.assign({}, valueField), { kind: "enum" }),
            };
        default:
            throw new Error("invalid DescriptorProto: unsupported map entry value field");
    }
}
/**
 * Did the user put the field in a oneof group?
 * This handles proto3 optionals.
 */
function findOneof(proto, allOneofs) {
    var _a;
    const oneofIndex = proto.oneofIndex;
    if (oneofIndex === undefined) {
        return undefined;
    }
    let oneof;
    if (proto.proto3Optional !== true) {
        oneof = allOneofs[oneofIndex];
        (0,assert/* assert */.hu)(oneof, `invalid FieldDescriptorProto: oneof #${oneofIndex} for field #${(_a = proto.number) !== null && _a !== void 0 ? _a : -1} not found`);
    }
    return oneof;
}
/**
 * Did the user use the `optional` keyword?
 * This handles proto3 optionals.
 */
function isOptionalField(proto, syntax) {
    switch (syntax) {
        case "proto2":
            return (proto.oneofIndex === undefined &&
                proto.label === FieldDescriptorProto_Label.OPTIONAL);
        case "proto3":
            return proto.proto3Optional === true;
        case "editions":
            return false;
    }
}
/**
 * Is this field packed by default? Only valid for repeated enum fields, and
 * for repeated scalar fields except BYTES and STRING.
 *
 * In proto3 syntax, fields are packed by default. In proto2 syntax, fields
 * are unpacked by default. With editions, the default is whatever the edition
 * specifies as a default. In edition 2023, fields are packed by default.
 */
function isPackedFieldByDefault(file, proto, resolveFeatures) {
    const { repeatedFieldEncoding } = resolveFeatures(file.edition);
    if (repeatedFieldEncoding != FeatureSet_RepeatedFieldEncoding.PACKED) {
        return false;
    }
    // From the proto3 language guide:
    // > In proto3, repeated fields of scalar numeric types are packed by default.
    // This information is incomplete - according to the conformance tests, BOOL
    // and ENUM are packed by default as well. This means only STRING and BYTES
    // are not packed by default, which makes sense because they are length-delimited.
    switch (proto.type) {
        case FieldDescriptorProto_Type.STRING:
        case FieldDescriptorProto_Type.BYTES:
        case FieldDescriptorProto_Type.GROUP:
        case FieldDescriptorProto_Type.MESSAGE:
            return false;
        default:
            return true;
    }
}
/**
 * Pack this repeated field?
 *
 * Respects field type, proto2/proto3 defaults and the `packed` option, or
 * edition defaults and the edition features.repeated_field_encoding options.
 */
function isPackedField(file, parent, proto, resolveFeatures) {
    var _a, _b, _c, _d, _e, _f;
    switch (proto.type) {
        case FieldDescriptorProto_Type.STRING:
        case FieldDescriptorProto_Type.BYTES:
        case FieldDescriptorProto_Type.GROUP:
        case FieldDescriptorProto_Type.MESSAGE:
            // length-delimited types cannot be packed
            return false;
        default:
            switch (file.edition) {
                case Edition.EDITION_PROTO2:
                    return (_b = (_a = proto.options) === null || _a === void 0 ? void 0 : _a.packed) !== null && _b !== void 0 ? _b : false;
                case Edition.EDITION_PROTO3:
                    return (_d = (_c = proto.options) === null || _c === void 0 ? void 0 : _c.packed) !== null && _d !== void 0 ? _d : true;
                default: {
                    const { repeatedFieldEncoding } = resolveFeatures(file.edition, (_e = parent === null || parent === void 0 ? void 0 : parent.getFeatures()) !== null && _e !== void 0 ? _e : file.getFeatures(), (_f = proto.options) === null || _f === void 0 ? void 0 : _f.features);
                    return (repeatedFieldEncoding == FeatureSet_RepeatedFieldEncoding.PACKED);
                }
            }
    }
}
/**
 * Map from a compiler-generated field type to our ScalarType, which is a
 * subset of field types declared by protobuf enum google.protobuf.FieldDescriptorProto.
 */
const fieldTypeToScalarType = {
    [FieldDescriptorProto_Type.DOUBLE]: esm_field/* ScalarType */.w.DOUBLE,
    [FieldDescriptorProto_Type.FLOAT]: esm_field/* ScalarType */.w.FLOAT,
    [FieldDescriptorProto_Type.INT64]: esm_field/* ScalarType */.w.INT64,
    [FieldDescriptorProto_Type.UINT64]: esm_field/* ScalarType */.w.UINT64,
    [FieldDescriptorProto_Type.INT32]: esm_field/* ScalarType */.w.INT32,
    [FieldDescriptorProto_Type.FIXED64]: esm_field/* ScalarType */.w.FIXED64,
    [FieldDescriptorProto_Type.FIXED32]: esm_field/* ScalarType */.w.FIXED32,
    [FieldDescriptorProto_Type.BOOL]: esm_field/* ScalarType */.w.BOOL,
    [FieldDescriptorProto_Type.STRING]: esm_field/* ScalarType */.w.STRING,
    [FieldDescriptorProto_Type.GROUP]: undefined,
    [FieldDescriptorProto_Type.MESSAGE]: undefined,
    [FieldDescriptorProto_Type.BYTES]: esm_field/* ScalarType */.w.BYTES,
    [FieldDescriptorProto_Type.UINT32]: esm_field/* ScalarType */.w.UINT32,
    [FieldDescriptorProto_Type.ENUM]: undefined,
    [FieldDescriptorProto_Type.SFIXED32]: esm_field/* ScalarType */.w.SFIXED32,
    [FieldDescriptorProto_Type.SFIXED64]: esm_field/* ScalarType */.w.SFIXED64,
    [FieldDescriptorProto_Type.SINT32]: esm_field/* ScalarType */.w.SINT32,
    [FieldDescriptorProto_Type.SINT64]: esm_field/* ScalarType */.w.SINT64,
};
/**
 * Find comments.
 */
function findComments(sourceCodeInfo, sourcePath) {
    if (!sourceCodeInfo) {
        return {
            leadingDetached: [],
            sourcePath,
        };
    }
    for (const location of sourceCodeInfo.location) {
        if (location.path.length !== sourcePath.length) {
            continue;
        }
        if (location.path.some((value, index) => sourcePath[index] !== value)) {
            continue;
        }
        return {
            leadingDetached: location.leadingDetachedComments,
            leading: location.leadingComments,
            trailing: location.trailingComments,
            sourcePath,
        };
    }
    return {
        leadingDetached: [],
        sourcePath,
    };
}
/**
 * The following field numbers are used to find comments in
 * google.protobuf.SourceCodeInfo.
 */
var FieldNumber;
(function (FieldNumber) {
    FieldNumber[FieldNumber["FileDescriptorProto_Package"] = 2] = "FileDescriptorProto_Package";
    FieldNumber[FieldNumber["FileDescriptorProto_MessageType"] = 4] = "FileDescriptorProto_MessageType";
    FieldNumber[FieldNumber["FileDescriptorProto_EnumType"] = 5] = "FileDescriptorProto_EnumType";
    FieldNumber[FieldNumber["FileDescriptorProto_Service"] = 6] = "FileDescriptorProto_Service";
    FieldNumber[FieldNumber["FileDescriptorProto_Extension"] = 7] = "FileDescriptorProto_Extension";
    FieldNumber[FieldNumber["FileDescriptorProto_Syntax"] = 12] = "FileDescriptorProto_Syntax";
    FieldNumber[FieldNumber["DescriptorProto_Field"] = 2] = "DescriptorProto_Field";
    FieldNumber[FieldNumber["DescriptorProto_NestedType"] = 3] = "DescriptorProto_NestedType";
    FieldNumber[FieldNumber["DescriptorProto_EnumType"] = 4] = "DescriptorProto_EnumType";
    FieldNumber[FieldNumber["DescriptorProto_Extension"] = 6] = "DescriptorProto_Extension";
    FieldNumber[FieldNumber["DescriptorProto_OneofDecl"] = 8] = "DescriptorProto_OneofDecl";
    FieldNumber[FieldNumber["EnumDescriptorProto_Value"] = 2] = "EnumDescriptorProto_Value";
    FieldNumber[FieldNumber["ServiceDescriptorProto_Method"] = 2] = "ServiceDescriptorProto_Method";
})(FieldNumber || (FieldNumber = {}));
/**
 * Return a string that matches the definition of a field in the protobuf
 * source. Does not take custom options into account.
 */
function declarationString() {
    var _a, _b, _c;
    const parts = [];
    if (this.repeated) {
        parts.push("repeated");
    }
    if (this.optional) {
        parts.push("optional");
    }
    const file = this.kind === "extension" ? this.file : this.parent.file;
    if (file.syntax == "proto2" &&
        this.proto.label === FieldDescriptorProto_Label.REQUIRED) {
        parts.push("required");
    }
    let type;
    switch (this.fieldKind) {
        case "scalar":
            type = esm_field/* ScalarType */.w[this.scalar].toLowerCase();
            break;
        case "enum":
            type = this.enum.typeName;
            break;
        case "message":
            type = this.message.typeName;
            break;
        case "map": {
            const k = esm_field/* ScalarType */.w[this.mapKey].toLowerCase();
            let v;
            switch (this.mapValue.kind) {
                case "scalar":
                    v = esm_field/* ScalarType */.w[this.mapValue.scalar].toLowerCase();
                    break;
                case "enum":
                    v = this.mapValue.enum.typeName;
                    break;
                case "message":
                    v = this.mapValue.message.typeName;
                    break;
            }
            type = `map<${k}, ${v}>`;
            break;
        }
    }
    parts.push(`${type} ${this.name} = ${this.number}`);
    const options = [];
    if (((_a = this.proto.options) === null || _a === void 0 ? void 0 : _a.packed) !== undefined) {
        options.push(`packed = ${this.proto.options.packed.toString()}`);
    }
    let defaultValue = this.proto.defaultValue;
    if (defaultValue !== undefined) {
        if (this.proto.type == FieldDescriptorProto_Type.BYTES ||
            this.proto.type == FieldDescriptorProto_Type.STRING) {
            defaultValue = '"' + defaultValue.replace('"', '\\"') + '"';
        }
        options.push(`default = ${defaultValue}`);
    }
    if (this.jsonName !== undefined) {
        options.push(`json_name = "${this.jsonName}"`);
    }
    if (((_b = this.proto.options) === null || _b === void 0 ? void 0 : _b.jstype) !== undefined) {
        options.push(`jstype = ${FieldOptions_JSType[this.proto.options.jstype]}`);
    }
    if (((_c = this.proto.options) === null || _c === void 0 ? void 0 : _c.deprecated) === true) {
        options.push(`deprecated = true`);
    }
    if (options.length > 0) {
        parts.push("[" + options.join(", ") + "]");
    }
    return parts.join(" ");
}
/**
 * Parses a text-encoded default value (proto2) of a scalar or enum field.
 */
function getDefaultValue() {
    const d = this.proto.defaultValue;
    if (d === undefined) {
        return undefined;
    }
    switch (this.fieldKind) {
        case "enum":
            return parseTextFormatEnumValue(this.enum, d);
        case "scalar":
            return parseTextFormatScalarValue(this.scalar, d);
        default:
            return undefined;
    }
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/create-registry.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Create a new registry from the given types.
 */
function createRegistry(...types) {
    const messages = {};
    const enums = {};
    const services = {};
    const registry = {
        /**
         * Add a type to the registry. For messages, the types used in message
         * fields are added recursively. For services, the message types used
         * for requests and responses are added recursively.
         */
        add(type) {
            if ("fields" in type) {
                if (!this.findMessage(type.typeName)) {
                    messages[type.typeName] = type;
                    for (const field of type.fields.list()) {
                        if (field.kind == "message") {
                            this.add(field.T);
                        }
                        else if (field.kind == "map" && field.V.kind == "message") {
                            this.add(field.V.T);
                        }
                        else if (field.kind == "enum") {
                            this.add(field.T);
                        }
                    }
                }
            }
            else if ("methods" in type) {
                if (!this.findService(type.typeName)) {
                    services[type.typeName] = type;
                    for (const method of Object.values(type.methods)) {
                        this.add(method.I);
                        this.add(method.O);
                    }
                }
            }
            else {
                enums[type.typeName] = type;
            }
        },
        findMessage(typeName) {
            return messages[typeName];
        },
        findEnum(typeName) {
            return enums[typeName];
        },
        findService(typeName) {
            return services[typeName];
        },
    };
    for (const type of types) {
        registry.add(type);
    }
    return registry;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/timestamp_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * A Timestamp represents a point in time independent of any time zone or local
 * calendar, encoded as a count of seconds and fractions of seconds at
 * nanosecond resolution. The count is relative to an epoch at UTC midnight on
 * January 1, 1970, in the proleptic Gregorian calendar which extends the
 * Gregorian calendar backwards to year one.
 *
 * All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap
 * second table is needed for interpretation, using a [24-hour linear
 * smear](https://developers.google.com/time/smear).
 *
 * The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By
 * restricting to that range, we ensure that we can convert to and from [RFC
 * 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings.
 *
 * # Examples
 *
 * Example 1: Compute Timestamp from POSIX `time()`.
 *
 *     Timestamp timestamp;
 *     timestamp.set_seconds(time(NULL));
 *     timestamp.set_nanos(0);
 *
 * Example 2: Compute Timestamp from POSIX `gettimeofday()`.
 *
 *     struct timeval tv;
 *     gettimeofday(&tv, NULL);
 *
 *     Timestamp timestamp;
 *     timestamp.set_seconds(tv.tv_sec);
 *     timestamp.set_nanos(tv.tv_usec * 1000);
 *
 * Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`.
 *
 *     FILETIME ft;
 *     GetSystemTimeAsFileTime(&ft);
 *     UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;
 *
 *     // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
 *     // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
 *     Timestamp timestamp;
 *     timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
 *     timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));
 *
 * Example 4: Compute Timestamp from Java `System.currentTimeMillis()`.
 *
 *     long millis = System.currentTimeMillis();
 *
 *     Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
 *         .setNanos((int) ((millis % 1000) * 1000000)).build();
 *
 * Example 5: Compute Timestamp from Java `Instant.now()`.
 *
 *     Instant now = Instant.now();
 *
 *     Timestamp timestamp =
 *         Timestamp.newBuilder().setSeconds(now.getEpochSecond())
 *             .setNanos(now.getNano()).build();
 *
 * Example 6: Compute Timestamp from current time in Python.
 *
 *     timestamp = Timestamp()
 *     timestamp.GetCurrentTime()
 *
 * # JSON Mapping
 *
 * In JSON format, the Timestamp type is encoded as a string in the
 * [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the
 * format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z"
 * where {year} is always expressed using four digits while {month}, {day},
 * {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional
 * seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution),
 * are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone
 * is required. A proto3 JSON serializer should always use UTC (as indicated by
 * "Z") when printing the Timestamp type and a proto3 JSON parser should be
 * able to accept both UTC and other timezones (as indicated by an offset).
 *
 * For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past
 * 01:30 UTC on January 15, 2017.
 *
 * In JavaScript, one can convert a Date object to this format using the
 * standard
 * [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString)
 * method. In Python, a standard `datetime.datetime` object can be converted
 * to this format using
 * [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with
 * the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use
 * the Joda Time's [`ISODateTimeFormat.dateTime()`](
 * http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime()
 * ) to obtain a formatter capable of generating timestamps in this format.
 *
 *
 * @generated from message google.protobuf.Timestamp
 */
class Timestamp extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Represents seconds of UTC time since Unix epoch
         * 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to
         * 9999-12-31T23:59:59Z inclusive.
         *
         * @generated from field: int64 seconds = 1;
         */
        this.seconds = proto_int64/* protoInt64 */.q.zero;
        /**
         * Non-negative fractions of a second at nanosecond resolution. Negative
         * second values with fractions must still have non-negative nanos values
         * that count forward in time. Must be from 0 to 999,999,999
         * inclusive.
         *
         * @generated from field: int32 nanos = 2;
         */
        this.nanos = 0;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    fromJson(json, options) {
        if (typeof json !== "string") {
            throw new Error(`cannot decode google.protobuf.Timestamp from JSON: ${proto3/* proto3 */.w.json.debug(json)}`);
        }
        const matches = json.match(/^([0-9]{4})-([0-9]{2})-([0-9]{2})T([0-9]{2}):([0-9]{2}):([0-9]{2})(?:Z|\.([0-9]{3,9})Z|([+-][0-9][0-9]:[0-9][0-9]))$/);
        if (!matches) {
            throw new Error(`cannot decode google.protobuf.Timestamp from JSON: invalid RFC 3339 string`);
        }
        const ms = Date.parse(matches[1] + "-" + matches[2] + "-" + matches[3] + "T" + matches[4] + ":" + matches[5] + ":" + matches[6] + (matches[8] ? matches[8] : "Z"));
        if (Number.isNaN(ms)) {
            throw new Error(`cannot decode google.protobuf.Timestamp from JSON: invalid RFC 3339 string`);
        }
        if (ms < Date.parse("0001-01-01T00:00:00Z") || ms > Date.parse("9999-12-31T23:59:59Z")) {
            throw new Error(`cannot decode message google.protobuf.Timestamp from JSON: must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive`);
        }
        this.seconds = proto_int64/* protoInt64 */.q.parse(ms / 1000);
        this.nanos = 0;
        if (matches[7]) {
            this.nanos = (parseInt("1" + matches[7] + "0".repeat(9 - matches[7].length)) - 1000000000);
        }
        return this;
    }
    toJson(options) {
        const ms = Number(this.seconds) * 1000;
        if (ms < Date.parse("0001-01-01T00:00:00Z") || ms > Date.parse("9999-12-31T23:59:59Z")) {
            throw new Error(`cannot encode google.protobuf.Timestamp to JSON: must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive`);
        }
        if (this.nanos < 0) {
            throw new Error(`cannot encode google.protobuf.Timestamp to JSON: nanos must not be negative`);
        }
        let z = "Z";
        if (this.nanos > 0) {
            const nanosStr = (this.nanos + 1000000000).toString().substring(1);
            if (nanosStr.substring(3) === "000000") {
                z = "." + nanosStr.substring(0, 3) + "Z";
            }
            else if (nanosStr.substring(6) === "000") {
                z = "." + nanosStr.substring(0, 6) + "Z";
            }
            else {
                z = "." + nanosStr + "Z";
            }
        }
        return new Date(ms).toISOString().replace(".000Z", z);
    }
    toDate() {
        return new Date(Number(this.seconds) * 1000 + Math.ceil(this.nanos / 1000000));
    }
    static now() {
        return Timestamp.fromDate(new Date());
    }
    static fromDate(date) {
        const ms = date.getTime();
        return new Timestamp({
            seconds: proto_int64/* protoInt64 */.q.parse(Math.floor(ms / 1000)),
            nanos: (ms % 1000) * 1000000,
        });
    }
    static fromBinary(bytes, options) {
        return new Timestamp().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Timestamp().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Timestamp().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Timestamp, a, b);
    }
}
Timestamp.runtime = proto3/* proto3 */.w;
Timestamp.typeName = "google.protobuf.Timestamp";
Timestamp.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "seconds", kind: "scalar", T: 3 /* ScalarType.INT64 */ },
    { no: 2, name: "nanos", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/duration_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * A Duration represents a signed, fixed-length span of time represented
 * as a count of seconds and fractions of seconds at nanosecond
 * resolution. It is independent of any calendar and concepts like "day"
 * or "month". It is related to Timestamp in that the difference between
 * two Timestamp values is a Duration and it can be added or subtracted
 * from a Timestamp. Range is approximately +-10,000 years.
 *
 * # Examples
 *
 * Example 1: Compute Duration from two Timestamps in pseudo code.
 *
 *     Timestamp start = ...;
 *     Timestamp end = ...;
 *     Duration duration = ...;
 *
 *     duration.seconds = end.seconds - start.seconds;
 *     duration.nanos = end.nanos - start.nanos;
 *
 *     if (duration.seconds < 0 && duration.nanos > 0) {
 *       duration.seconds += 1;
 *       duration.nanos -= 1000000000;
 *     } else if (duration.seconds > 0 && duration.nanos < 0) {
 *       duration.seconds -= 1;
 *       duration.nanos += 1000000000;
 *     }
 *
 * Example 2: Compute Timestamp from Timestamp + Duration in pseudo code.
 *
 *     Timestamp start = ...;
 *     Duration duration = ...;
 *     Timestamp end = ...;
 *
 *     end.seconds = start.seconds + duration.seconds;
 *     end.nanos = start.nanos + duration.nanos;
 *
 *     if (end.nanos < 0) {
 *       end.seconds -= 1;
 *       end.nanos += 1000000000;
 *     } else if (end.nanos >= 1000000000) {
 *       end.seconds += 1;
 *       end.nanos -= 1000000000;
 *     }
 *
 * Example 3: Compute Duration from datetime.timedelta in Python.
 *
 *     td = datetime.timedelta(days=3, minutes=10)
 *     duration = Duration()
 *     duration.FromTimedelta(td)
 *
 * # JSON Mapping
 *
 * In JSON format, the Duration type is encoded as a string rather than an
 * object, where the string ends in the suffix "s" (indicating seconds) and
 * is preceded by the number of seconds, with nanoseconds expressed as
 * fractional seconds. For example, 3 seconds with 0 nanoseconds should be
 * encoded in JSON format as "3s", while 3 seconds and 1 nanosecond should
 * be expressed in JSON format as "3.000000001s", and 3 seconds and 1
 * microsecond should be expressed in JSON format as "3.000001s".
 *
 *
 * @generated from message google.protobuf.Duration
 */
class Duration extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Signed seconds of the span of time. Must be from -315,576,000,000
         * to +315,576,000,000 inclusive. Note: these bounds are computed from:
         * 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years
         *
         * @generated from field: int64 seconds = 1;
         */
        this.seconds = proto_int64/* protoInt64 */.q.zero;
        /**
         * Signed fractions of a second at nanosecond resolution of the span
         * of time. Durations less than one second are represented with a 0
         * `seconds` field and a positive or negative `nanos` field. For durations
         * of one second or more, a non-zero value for the `nanos` field must be
         * of the same sign as the `seconds` field. Must be from -999,999,999
         * to +999,999,999 inclusive.
         *
         * @generated from field: int32 nanos = 2;
         */
        this.nanos = 0;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    fromJson(json, options) {
        if (typeof json !== "string") {
            throw new Error(`cannot decode google.protobuf.Duration from JSON: ${proto3/* proto3 */.w.json.debug(json)}`);
        }
        const match = json.match(/^(-?[0-9]+)(?:\.([0-9]+))?s/);
        if (match === null) {
            throw new Error(`cannot decode google.protobuf.Duration from JSON: ${proto3/* proto3 */.w.json.debug(json)}`);
        }
        const longSeconds = Number(match[1]);
        if (longSeconds > 315576000000 || longSeconds < -315576000000) {
            throw new Error(`cannot decode google.protobuf.Duration from JSON: ${proto3/* proto3 */.w.json.debug(json)}`);
        }
        this.seconds = proto_int64/* protoInt64 */.q.parse(longSeconds);
        if (typeof match[2] == "string") {
            const nanosStr = match[2] + "0".repeat(9 - match[2].length);
            this.nanos = parseInt(nanosStr);
            if (longSeconds < 0 || Object.is(longSeconds, -0)) {
                this.nanos = -this.nanos;
            }
        }
        return this;
    }
    toJson(options) {
        if (Number(this.seconds) > 315576000000 || Number(this.seconds) < -315576000000) {
            throw new Error(`cannot encode google.protobuf.Duration to JSON: value out of range`);
        }
        let text = this.seconds.toString();
        if (this.nanos !== 0) {
            let nanosStr = Math.abs(this.nanos).toString();
            nanosStr = "0".repeat(9 - nanosStr.length) + nanosStr;
            if (nanosStr.substring(3) === "000000") {
                nanosStr = nanosStr.substring(0, 3);
            }
            else if (nanosStr.substring(6) === "000") {
                nanosStr = nanosStr.substring(0, 6);
            }
            text += "." + nanosStr;
            if (this.nanos < 0 && Number(this.seconds) == 0) {
                text = "-" + text;
            }
        }
        return text + "s";
    }
    static fromBinary(bytes, options) {
        return new Duration().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Duration().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Duration().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Duration, a, b);
    }
}
Duration.runtime = proto3/* proto3 */.w;
Duration.typeName = "google.protobuf.Duration";
Duration.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "seconds", kind: "scalar", T: 3 /* ScalarType.INT64 */ },
    { no: 2, name: "nanos", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
]);

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/any_pb.js
var any_pb = __webpack_require__(733);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/empty_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * A generic empty message that you can re-use to avoid defining duplicated
 * empty messages in your APIs. A typical example is to use it as the request
 * or the response type of an API method. For instance:
 *
 *     service Foo {
 *       rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty);
 *     }
 *
 *
 * @generated from message google.protobuf.Empty
 */
class Empty extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Empty().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Empty().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Empty().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Empty, a, b);
    }
}
Empty.runtime = proto3/* proto3 */.w;
Empty.typeName = "google.protobuf.Empty";
Empty.fields = proto3/* proto3 */.w.util.newFieldList(() => []);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/field_mask_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * `FieldMask` represents a set of symbolic field paths, for example:
 *
 *     paths: "f.a"
 *     paths: "f.b.d"
 *
 * Here `f` represents a field in some root message, `a` and `b`
 * fields in the message found in `f`, and `d` a field found in the
 * message in `f.b`.
 *
 * Field masks are used to specify a subset of fields that should be
 * returned by a get operation or modified by an update operation.
 * Field masks also have a custom JSON encoding (see below).
 *
 * # Field Masks in Projections
 *
 * When used in the context of a projection, a response message or
 * sub-message is filtered by the API to only contain those fields as
 * specified in the mask. For example, if the mask in the previous
 * example is applied to a response message as follows:
 *
 *     f {
 *       a : 22
 *       b {
 *         d : 1
 *         x : 2
 *       }
 *       y : 13
 *     }
 *     z: 8
 *
 * The result will not contain specific values for fields x,y and z
 * (their value will be set to the default, and omitted in proto text
 * output):
 *
 *
 *     f {
 *       a : 22
 *       b {
 *         d : 1
 *       }
 *     }
 *
 * A repeated field is not allowed except at the last position of a
 * paths string.
 *
 * If a FieldMask object is not present in a get operation, the
 * operation applies to all fields (as if a FieldMask of all fields
 * had been specified).
 *
 * Note that a field mask does not necessarily apply to the
 * top-level response message. In case of a REST get operation, the
 * field mask applies directly to the response, but in case of a REST
 * list operation, the mask instead applies to each individual message
 * in the returned resource list. In case of a REST custom method,
 * other definitions may be used. Where the mask applies will be
 * clearly documented together with its declaration in the API.  In
 * any case, the effect on the returned resource/resources is required
 * behavior for APIs.
 *
 * # Field Masks in Update Operations
 *
 * A field mask in update operations specifies which fields of the
 * targeted resource are going to be updated. The API is required
 * to only change the values of the fields as specified in the mask
 * and leave the others untouched. If a resource is passed in to
 * describe the updated values, the API ignores the values of all
 * fields not covered by the mask.
 *
 * If a repeated field is specified for an update operation, new values will
 * be appended to the existing repeated field in the target resource. Note that
 * a repeated field is only allowed in the last position of a `paths` string.
 *
 * If a sub-message is specified in the last position of the field mask for an
 * update operation, then new value will be merged into the existing sub-message
 * in the target resource.
 *
 * For example, given the target message:
 *
 *     f {
 *       b {
 *         d: 1
 *         x: 2
 *       }
 *       c: [1]
 *     }
 *
 * And an update message:
 *
 *     f {
 *       b {
 *         d: 10
 *       }
 *       c: [2]
 *     }
 *
 * then if the field mask is:
 *
 *  paths: ["f.b", "f.c"]
 *
 * then the result will be:
 *
 *     f {
 *       b {
 *         d: 10
 *         x: 2
 *       }
 *       c: [1, 2]
 *     }
 *
 * An implementation may provide options to override this default behavior for
 * repeated and message fields.
 *
 * In order to reset a field's value to the default, the field must
 * be in the mask and set to the default value in the provided resource.
 * Hence, in order to reset all fields of a resource, provide a default
 * instance of the resource and set all fields in the mask, or do
 * not provide a mask as described below.
 *
 * If a field mask is not present on update, the operation applies to
 * all fields (as if a field mask of all fields has been specified).
 * Note that in the presence of schema evolution, this may mean that
 * fields the client does not know and has therefore not filled into
 * the request will be reset to their default. If this is unwanted
 * behavior, a specific service may require a client to always specify
 * a field mask, producing an error if not.
 *
 * As with get operations, the location of the resource which
 * describes the updated values in the request message depends on the
 * operation kind. In any case, the effect of the field mask is
 * required to be honored by the API.
 *
 * ## Considerations for HTTP REST
 *
 * The HTTP kind of an update operation which uses a field mask must
 * be set to PATCH instead of PUT in order to satisfy HTTP semantics
 * (PUT must only be used for full updates).
 *
 * # JSON Encoding of Field Masks
 *
 * In JSON, a field mask is encoded as a single string where paths are
 * separated by a comma. Fields name in each path are converted
 * to/from lower-camel naming conventions.
 *
 * As an example, consider the following message declarations:
 *
 *     message Profile {
 *       User user = 1;
 *       Photo photo = 2;
 *     }
 *     message User {
 *       string display_name = 1;
 *       string address = 2;
 *     }
 *
 * In proto a field mask for `Profile` may look as such:
 *
 *     mask {
 *       paths: "user.display_name"
 *       paths: "photo"
 *     }
 *
 * In JSON, the same mask is represented as below:
 *
 *     {
 *       mask: "user.displayName,photo"
 *     }
 *
 * # Field Masks and Oneof Fields
 *
 * Field masks treat fields in oneofs just as regular fields. Consider the
 * following message:
 *
 *     message SampleMessage {
 *       oneof test_oneof {
 *         string name = 4;
 *         SubMessage sub_message = 9;
 *       }
 *     }
 *
 * The field mask can be:
 *
 *     mask {
 *       paths: "name"
 *     }
 *
 * Or:
 *
 *     mask {
 *       paths: "sub_message"
 *     }
 *
 * Note that oneof type names ("test_oneof" in this case) cannot be used in
 * paths.
 *
 * ## Field Mask Verification
 *
 * The implementation of any API method which has a FieldMask type field in the
 * request should verify the included field paths, and return an
 * `INVALID_ARGUMENT` error if any path is unmappable.
 *
 * @generated from message google.protobuf.FieldMask
 */
class FieldMask extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The set of field mask paths.
         *
         * @generated from field: repeated string paths = 1;
         */
        this.paths = [];
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        // Converts snake_case to protoCamelCase according to the convention
        // used by protoc to convert a field name to a JSON name.
        function protoCamelCase(snakeCase) {
            let capNext = false;
            const b = [];
            for (let i = 0; i < snakeCase.length; i++) {
                let c = snakeCase.charAt(i);
                switch (c) {
                    case '_':
                        capNext = true;
                        break;
                    case '0':
                    case '1':
                    case '2':
                    case '3':
                    case '4':
                    case '5':
                    case '6':
                    case '7':
                    case '8':
                    case '9':
                        b.push(c);
                        capNext = false;
                        break;
                    default:
                        if (capNext) {
                            capNext = false;
                            c = c.toUpperCase();
                        }
                        b.push(c);
                        break;
                }
            }
            return b.join('');
        }
        return this.paths.map(p => {
            if (p.match(/_[0-9]?_/g) || p.match(/[A-Z]/g)) {
                throw new Error("cannot encode google.protobuf.FieldMask to JSON: lowerCamelCase of path name \"" + p + "\" is irreversible");
            }
            return protoCamelCase(p);
        }).join(",");
    }
    fromJson(json, options) {
        if (typeof json !== "string") {
            throw new Error("cannot decode google.protobuf.FieldMask from JSON: " + proto3/* proto3 */.w.json.debug(json));
        }
        if (json === "") {
            return this;
        }
        function camelToSnake(str) {
            if (str.includes("_")) {
                throw new Error("cannot decode google.protobuf.FieldMask from JSON: path names must be lowerCamelCase");
            }
            const sc = str.replace(/[A-Z]/g, letter => "_" + letter.toLowerCase());
            return (sc[0] === "_") ? sc.substring(1) : sc;
        }
        this.paths = json.split(",").map(camelToSnake);
        return this;
    }
    static fromBinary(bytes, options) {
        return new FieldMask().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FieldMask().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FieldMask().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(FieldMask, a, b);
    }
}
FieldMask.runtime = proto3/* proto3 */.w;
FieldMask.typeName = "google.protobuf.FieldMask";
FieldMask.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "paths", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/struct_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// @generated by protoc-gen-es v1.6.0 with parameter "bootstrap_wkt=true,ts_nocheck=false,target=ts"
// @generated from file google/protobuf/struct.proto (package google.protobuf, syntax proto3)
/* eslint-disable */


/**
 * `NullValue` is a singleton enumeration to represent the null value for the
 * `Value` type union.
 *
 * The JSON representation for `NullValue` is JSON `null`.
 *
 * @generated from enum google.protobuf.NullValue
 */
var NullValue;
(function (NullValue) {
    /**
     * Null value.
     *
     * @generated from enum value: NULL_VALUE = 0;
     */
    NullValue[NullValue["NULL_VALUE"] = 0] = "NULL_VALUE";
})(NullValue || (NullValue = {}));
// Retrieve enum metadata with: proto3.getEnumType(NullValue)
proto3/* proto3 */.w.util.setEnumType(NullValue, "google.protobuf.NullValue", [
    { no: 0, name: "NULL_VALUE" },
]);
/**
 * `Struct` represents a structured data value, consisting of fields
 * which map to dynamically typed values. In some languages, `Struct`
 * might be supported by a native representation. For example, in
 * scripting languages like JS a struct is represented as an
 * object. The details of that representation are described together
 * with the proto support for the language.
 *
 * The JSON representation for `Struct` is JSON object.
 *
 * @generated from message google.protobuf.Struct
 */
class Struct extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Unordered map of dynamically typed values.
         *
         * @generated from field: map<string, google.protobuf.Value> fields = 1;
         */
        this.fields = {};
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        const json = {};
        for (const [k, v] of Object.entries(this.fields)) {
            json[k] = v.toJson(options);
        }
        return json;
    }
    fromJson(json, options) {
        if (typeof json != "object" || json == null || Array.isArray(json)) {
            throw new Error("cannot decode google.protobuf.Struct from JSON " + proto3/* proto3 */.w.json.debug(json));
        }
        for (const [k, v] of Object.entries(json)) {
            this.fields[k] = Value.fromJson(v);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new Struct().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Struct().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Struct().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Struct, a, b);
    }
}
Struct.runtime = proto3/* proto3 */.w;
Struct.typeName = "google.protobuf.Struct";
Struct.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "fields", kind: "map", K: 9 /* ScalarType.STRING */, V: { kind: "message", T: Value } },
]);
/**
 * `Value` represents a dynamically typed value which can be either
 * null, a number, a string, a boolean, a recursive struct value, or a
 * list of values. A producer of value is expected to set one of these
 * variants. Absence of any variant indicates an error.
 *
 * The JSON representation for `Value` is JSON value.
 *
 * @generated from message google.protobuf.Value
 */
class Value extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The kind of value.
         *
         * @generated from oneof google.protobuf.Value.kind
         */
        this.kind = { case: undefined };
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        switch (this.kind.case) {
            case "nullValue":
                return null;
            case "numberValue":
                if (!Number.isFinite(this.kind.value)) {
                    throw new Error("google.protobuf.Value cannot be NaN or Infinity");
                }
                return this.kind.value;
            case "boolValue":
                return this.kind.value;
            case "stringValue":
                return this.kind.value;
            case "structValue":
            case "listValue":
                return this.kind.value.toJson(Object.assign(Object.assign({}, options), { emitDefaultValues: true }));
        }
        throw new Error("google.protobuf.Value must have a value");
    }
    fromJson(json, options) {
        switch (typeof json) {
            case "number":
                this.kind = { case: "numberValue", value: json };
                break;
            case "string":
                this.kind = { case: "stringValue", value: json };
                break;
            case "boolean":
                this.kind = { case: "boolValue", value: json };
                break;
            case "object":
                if (json === null) {
                    this.kind = { case: "nullValue", value: NullValue.NULL_VALUE };
                }
                else if (Array.isArray(json)) {
                    this.kind = { case: "listValue", value: ListValue.fromJson(json) };
                }
                else {
                    this.kind = { case: "structValue", value: Struct.fromJson(json) };
                }
                break;
            default:
                throw new Error("cannot decode google.protobuf.Value from JSON " + proto3/* proto3 */.w.json.debug(json));
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new Value().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Value().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Value().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Value, a, b);
    }
}
Value.runtime = proto3/* proto3 */.w;
Value.typeName = "google.protobuf.Value";
Value.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "null_value", kind: "enum", T: proto3/* proto3 */.w.getEnumType(NullValue), oneof: "kind" },
    { no: 2, name: "number_value", kind: "scalar", T: 1 /* ScalarType.DOUBLE */, oneof: "kind" },
    { no: 3, name: "string_value", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "kind" },
    { no: 4, name: "bool_value", kind: "scalar", T: 8 /* ScalarType.BOOL */, oneof: "kind" },
    { no: 5, name: "struct_value", kind: "message", T: Struct, oneof: "kind" },
    { no: 6, name: "list_value", kind: "message", T: ListValue, oneof: "kind" },
]);
/**
 * `ListValue` is a wrapper around a repeated field of values.
 *
 * The JSON representation for `ListValue` is JSON array.
 *
 * @generated from message google.protobuf.ListValue
 */
class ListValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Repeated field of dynamically typed values.
         *
         * @generated from field: repeated google.protobuf.Value values = 1;
         */
        this.values = [];
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return this.values.map(v => v.toJson());
    }
    fromJson(json, options) {
        if (!Array.isArray(json)) {
            throw new Error("cannot decode google.protobuf.ListValue from JSON " + proto3/* proto3 */.w.json.debug(json));
        }
        for (let e of json) {
            this.values.push(Value.fromJson(e));
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new ListValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new ListValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new ListValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(ListValue, a, b);
    }
}
ListValue.runtime = proto3/* proto3 */.w;
ListValue.typeName = "google.protobuf.ListValue";
ListValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "values", kind: "message", T: Value, repeated: true },
]);

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/enum.js
var private_enum = __webpack_require__(609);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/wrappers_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.




/**
 * Wrapper message for `double`.
 *
 * The JSON representation for `DoubleValue` is JSON number.
 *
 * @generated from message google.protobuf.DoubleValue
 */
class DoubleValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The double value.
         *
         * @generated from field: double value = 1;
         */
        this.value = 0;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.DOUBLE, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.DOUBLE, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.DoubleValue from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new DoubleValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new DoubleValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new DoubleValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(DoubleValue, a, b);
    }
}
DoubleValue.runtime = proto3/* proto3 */.w;
DoubleValue.typeName = "google.protobuf.DoubleValue";
DoubleValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 1 /* ScalarType.DOUBLE */ },
]);
DoubleValue.fieldWrapper = {
    wrapField(value) {
        return new DoubleValue({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `float`.
 *
 * The JSON representation for `FloatValue` is JSON number.
 *
 * @generated from message google.protobuf.FloatValue
 */
class FloatValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The float value.
         *
         * @generated from field: float value = 1;
         */
        this.value = 0;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.FLOAT, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.FLOAT, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.FloatValue from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new FloatValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new FloatValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new FloatValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(FloatValue, a, b);
    }
}
FloatValue.runtime = proto3/* proto3 */.w;
FloatValue.typeName = "google.protobuf.FloatValue";
FloatValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 2 /* ScalarType.FLOAT */ },
]);
FloatValue.fieldWrapper = {
    wrapField(value) {
        return new FloatValue({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `int64`.
 *
 * The JSON representation for `Int64Value` is JSON string.
 *
 * @generated from message google.protobuf.Int64Value
 */
class Int64Value extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The int64 value.
         *
         * @generated from field: int64 value = 1;
         */
        this.value = proto_int64/* protoInt64 */.q.zero;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.INT64, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.INT64, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.Int64Value from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new Int64Value().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Int64Value().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Int64Value().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Int64Value, a, b);
    }
}
Int64Value.runtime = proto3/* proto3 */.w;
Int64Value.typeName = "google.protobuf.Int64Value";
Int64Value.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 3 /* ScalarType.INT64 */ },
]);
Int64Value.fieldWrapper = {
    wrapField(value) {
        return new Int64Value({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `uint64`.
 *
 * The JSON representation for `UInt64Value` is JSON string.
 *
 * @generated from message google.protobuf.UInt64Value
 */
class UInt64Value extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The uint64 value.
         *
         * @generated from field: uint64 value = 1;
         */
        this.value = proto_int64/* protoInt64 */.q.zero;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.UINT64, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.UINT64, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.UInt64Value from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new UInt64Value().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new UInt64Value().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new UInt64Value().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(UInt64Value, a, b);
    }
}
UInt64Value.runtime = proto3/* proto3 */.w;
UInt64Value.typeName = "google.protobuf.UInt64Value";
UInt64Value.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 4 /* ScalarType.UINT64 */ },
]);
UInt64Value.fieldWrapper = {
    wrapField(value) {
        return new UInt64Value({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `int32`.
 *
 * The JSON representation for `Int32Value` is JSON number.
 *
 * @generated from message google.protobuf.Int32Value
 */
class Int32Value extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The int32 value.
         *
         * @generated from field: int32 value = 1;
         */
        this.value = 0;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.INT32, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.INT32, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.Int32Value from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new Int32Value().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Int32Value().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Int32Value().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Int32Value, a, b);
    }
}
Int32Value.runtime = proto3/* proto3 */.w;
Int32Value.typeName = "google.protobuf.Int32Value";
Int32Value.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
]);
Int32Value.fieldWrapper = {
    wrapField(value) {
        return new Int32Value({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `uint32`.
 *
 * The JSON representation for `UInt32Value` is JSON number.
 *
 * @generated from message google.protobuf.UInt32Value
 */
class UInt32Value extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The uint32 value.
         *
         * @generated from field: uint32 value = 1;
         */
        this.value = 0;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.UINT32, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.UINT32, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.UInt32Value from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new UInt32Value().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new UInt32Value().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new UInt32Value().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(UInt32Value, a, b);
    }
}
UInt32Value.runtime = proto3/* proto3 */.w;
UInt32Value.typeName = "google.protobuf.UInt32Value";
UInt32Value.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 13 /* ScalarType.UINT32 */ },
]);
UInt32Value.fieldWrapper = {
    wrapField(value) {
        return new UInt32Value({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `bool`.
 *
 * The JSON representation for `BoolValue` is JSON `true` and `false`.
 *
 * @generated from message google.protobuf.BoolValue
 */
class BoolValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The bool value.
         *
         * @generated from field: bool value = 1;
         */
        this.value = false;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.BOOL, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.BOOL, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.BoolValue from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new BoolValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new BoolValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new BoolValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(BoolValue, a, b);
    }
}
BoolValue.runtime = proto3/* proto3 */.w;
BoolValue.typeName = "google.protobuf.BoolValue";
BoolValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
]);
BoolValue.fieldWrapper = {
    wrapField(value) {
        return new BoolValue({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `string`.
 *
 * The JSON representation for `StringValue` is JSON string.
 *
 * @generated from message google.protobuf.StringValue
 */
class StringValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The string value.
         *
         * @generated from field: string value = 1;
         */
        this.value = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.STRING, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.STRING, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.StringValue from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new StringValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new StringValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new StringValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(StringValue, a, b);
    }
}
StringValue.runtime = proto3/* proto3 */.w;
StringValue.typeName = "google.protobuf.StringValue";
StringValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 9 /* ScalarType.STRING */ },
]);
StringValue.fieldWrapper = {
    wrapField(value) {
        return new StringValue({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};
/**
 * Wrapper message for `bytes`.
 *
 * The JSON representation for `BytesValue` is JSON string.
 *
 * @generated from message google.protobuf.BytesValue
 */
class BytesValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The bytes value.
         *
         * @generated from field: bytes value = 1;
         */
        this.value = new Uint8Array(0);
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    toJson(options) {
        return proto3/* proto3 */.w.json.writeScalar(esm_field/* ScalarType */.w.BYTES, this.value, true);
    }
    fromJson(json, options) {
        try {
            this.value = proto3/* proto3 */.w.json.readScalar(esm_field/* ScalarType */.w.BYTES, json);
        }
        catch (e) {
            let m = `cannot decode message google.protobuf.BytesValue from JSON"`;
            if (e instanceof Error && e.message.length > 0) {
                m += `: ${e.message}`;
            }
            throw new Error(m);
        }
        return this;
    }
    static fromBinary(bytes, options) {
        return new BytesValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new BytesValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new BytesValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(BytesValue, a, b);
    }
}
BytesValue.runtime = proto3/* proto3 */.w;
BytesValue.typeName = "google.protobuf.BytesValue";
BytesValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "value", kind: "scalar", T: 12 /* ScalarType.BYTES */ },
]);
BytesValue.fieldWrapper = {
    wrapField(value) {
        return new BytesValue({ value });
    },
    unwrapField(value) {
        return value.value;
    }
};

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/create-registry-from-desc.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.















// well-known message types with specialized JSON representation
const wkMessages = [
    any_pb/* Any */.I,
    Duration,
    Empty,
    FieldMask,
    Struct,
    Value,
    ListValue,
    Timestamp,
    Duration,
    DoubleValue,
    FloatValue,
    Int64Value,
    Int32Value,
    UInt32Value,
    UInt64Value,
    BoolValue,
    StringValue,
    BytesValue,
];
// well-known enum types with specialized JSON representation
const wkEnums = [(0,private_enum/* getEnumType */.V3)(NullValue)];
/**
 * Create a registry from a set of descriptors. The types returned by this
 * registry behave exactly like types from generated code.
 *
 * This function accepts google.protobuf.FileDescriptorSet in serialized or
 * deserialized form. Alternatively, it also accepts a DescriptorSet (see
 * createDescriptorSet()).
 *
 * By default, all well-known types with a specialized JSON representation
 * are replaced with their generated counterpart in this package.
 */
function createRegistryFromDescriptors(input, replaceWkt = true) {
    const set = input instanceof Uint8Array || input instanceof FileDescriptorSet
        ? createDescriptorSet(input)
        : input;
    const enums = {};
    const messages = {};
    const services = {};
    if (replaceWkt) {
        for (const mt of wkMessages) {
            messages[mt.typeName] = mt;
        }
        for (const et of wkEnums) {
            enums[et.typeName] = et;
        }
    }
    return {
        /**
         * May raise an error on invalid descriptors.
         */
        findEnum(typeName) {
            const existing = enums[typeName];
            if (existing) {
                return existing;
            }
            const desc = set.enums.get(typeName);
            if (!desc) {
                return undefined;
            }
            const runtime = desc.file.syntax == "proto3" ? proto3/* proto3 */.w : proto2;
            const type = runtime.makeEnumType(typeName, desc.values.map((u) => ({
                no: u.number,
                name: u.name,
                localName: (0,names/* localName */.r1)(u),
            })), {});
            enums[typeName] = type;
            return type;
        },
        /**
         * May raise an error on invalid descriptors.
         */
        findMessage(typeName) {
            const existing = messages[typeName];
            if (existing) {
                return existing;
            }
            const desc = set.messages.get(typeName);
            if (!desc) {
                return undefined;
            }
            const runtime = desc.file.syntax == "proto3" ? proto3/* proto3 */.w : proto2;
            const fields = [];
            const type = runtime.makeMessageType(typeName, () => fields, {
                localName: (0,names/* localName */.r1)(desc),
            });
            messages[typeName] = type;
            for (const field of desc.fields) {
                const fieldInfo = makeFieldInfo(field, this);
                fields.push(fieldInfo);
            }
            return type;
        },
        /**
         * May raise an error on invalid descriptors.
         */
        findService(typeName) {
            const existing = services[typeName];
            if (existing) {
                return existing;
            }
            const desc = set.services.get(typeName);
            if (!desc) {
                return undefined;
            }
            const methods = {};
            for (const method of desc.methods) {
                const I = this.findMessage(method.input.typeName);
                const O = this.findMessage(method.output.typeName);
                (0,assert/* assert */.hu)(I, `message "${method.input.typeName}" for ${method.toString()} not found`);
                (0,assert/* assert */.hu)(O, `output message "${method.output.typeName}" for ${method.toString()} not found`);
                methods[(0,names/* localName */.r1)(method)] = {
                    name: method.name,
                    I,
                    O,
                    kind: method.methodKind,
                    idempotency: method.idempotency,
                    // We do not surface options at this time
                    // options: {},
                };
            }
            return (services[typeName] = {
                typeName: desc.typeName,
                methods,
            });
        },
    };
}
function makeFieldInfo(desc, resolver) {
    switch (desc.fieldKind) {
        case "map":
            return makeMapFieldInfo(desc, resolver);
        case "message":
            return makeMessageFieldInfo(desc, resolver);
        case "enum": {
            const fi = makeEnumFieldInfo(desc, resolver);
            fi.default = desc.getDefaultValue();
            return fi;
        }
        case "scalar": {
            const fi = makeScalarFieldInfo(desc);
            fi.default = desc.getDefaultValue();
            return fi;
        }
    }
}
function makeMapFieldInfo(field, resolver) {
    const base = {
        kind: "map",
        no: field.number,
        name: field.name,
        jsonName: field.jsonName,
        K: field.mapKey,
    };
    if (field.mapValue.message) {
        const messageType = resolver.findMessage(field.mapValue.message.typeName);
        (0,assert/* assert */.hu)(messageType, `message "${field.mapValue.message.typeName}" for ${field.toString()} not found`);
        return Object.assign(Object.assign({}, base), { V: {
                kind: "message",
                T: messageType,
            } });
    }
    if (field.mapValue.enum) {
        const enumType = resolver.findEnum(field.mapValue.enum.typeName);
        (0,assert/* assert */.hu)(enumType, `enum "${field.mapValue.enum.typeName}" for ${field.toString()} not found`);
        return Object.assign(Object.assign({}, base), { V: {
                kind: "enum",
                T: enumType,
            } });
    }
    return Object.assign(Object.assign({}, base), { V: {
            kind: "scalar",
            T: field.mapValue.scalar,
        } });
}
function makeScalarFieldInfo(field) {
    // We are creating _partial_ field info here, so we omit long type bigint,
    // which is the default.
    const longType = field.longType == esm_field/* LongType */.p.STRING
        ? { L: esm_field/* LongType */.p.STRING }
        : {};
    const base = Object.assign({ kind: "scalar", no: field.number, name: field.name, jsonName: field.jsonName, T: field.scalar }, longType);
    if (field.repeated) {
        return Object.assign(Object.assign({}, base), { repeated: true, packed: field.packed, oneof: undefined, T: field.scalar });
    }
    if (field.oneof) {
        return Object.assign(Object.assign({}, base), { oneof: field.oneof.name });
    }
    if (field.optional) {
        return Object.assign(Object.assign({}, base), { opt: true });
    }
    return base;
}
function makeMessageFieldInfo(field, resolver) {
    const messageType = resolver.findMessage(field.message.typeName);
    (0,assert/* assert */.hu)(messageType, `message "${field.message.typeName}" for ${field.toString()} not found`);
    const base = {
        kind: "message",
        no: field.number,
        name: field.name,
        jsonName: field.jsonName,
        T: messageType,
        delimited: field.proto.type == FieldDescriptorProto_Type.GROUP,
    };
    if (field.repeated) {
        return Object.assign(Object.assign({}, base), { repeated: true, packed: field.packed, oneof: undefined });
    }
    if (field.oneof) {
        return Object.assign(Object.assign({}, base), { oneof: field.oneof.name });
    }
    if (field.optional) {
        return Object.assign(Object.assign({}, base), { opt: true });
    }
    return base;
}
function makeEnumFieldInfo(field, resolver) {
    const enumType = resolver.findEnum(field.enum.typeName);
    (0,assert/* assert */.hu)(enumType, `enum "${field.enum.typeName}" for ${field.toString()} not found`);
    const base = {
        kind: "enum",
        no: field.number,
        name: field.name,
        jsonName: field.jsonName,
        T: enumType,
    };
    if (field.repeated) {
        return Object.assign(Object.assign({}, base), { repeated: true, packed: field.packed, oneof: undefined });
    }
    if (field.oneof) {
        return Object.assign(Object.assign({}, base), { oneof: field.oneof.name });
    }
    if (field.optional) {
        return Object.assign(Object.assign({}, base), { opt: true });
    }
    return base;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/to-plain-message.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/* eslint-disable @typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-argument,no-case-declarations */

/**
 * toPlainMessage returns a new object by stripping
 * all methods from a message, leaving only fields and
 * oneof groups. It is recursive, meaning it applies this
 * same logic to all nested message fields as well.
 *
 * If the argument is already a plain message, it is
 * returned as-is.
 */
function toPlainMessage(message) {
    if (!(message instanceof esm_message/* Message */.v)) {
        return message;
    }
    const type = message.getType();
    const target = {};
    for (const member of type.fields.byMember()) {
        const source = message[member.localName];
        let copy;
        if (member.repeated) {
            copy = source.map((e) => toPlainValue(e));
        }
        else if (member.kind == "map") {
            copy = {};
            for (const [key, v] of Object.entries(source)) {
                copy[key] = toPlainValue(v);
            }
        }
        else if (member.kind == "oneof") {
            const f = member.findField(source.case);
            copy = f
                ? { case: source.case, value: toPlainValue(source.value) }
                : { case: undefined };
        }
        else {
            copy = toPlainValue(source);
        }
        target[member.localName] = copy;
    }
    return target;
}
function toPlainValue(value) {
    if (value === undefined) {
        return value;
    }
    if (value instanceof esm_message/* Message */.v) {
        return toPlainMessage(value);
    }
    if (value instanceof Uint8Array) {
        const c = new Uint8Array(value.byteLength);
        c.set(value);
        return c;
    }
    return value;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/compiler/plugin_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * The version number of protocol compiler.
 *
 * @generated from message google.protobuf.compiler.Version
 */
class Version extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Version().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Version().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Version().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(Version, a, b);
    }
}
Version.runtime = proto2;
Version.typeName = "google.protobuf.compiler.Version";
Version.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "major", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 2, name: "minor", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 3, name: "patch", kind: "scalar", T: 5 /* ScalarType.INT32 */, opt: true },
    { no: 4, name: "suffix", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
]);
/**
 * An encoded CodeGeneratorRequest is written to the plugin's stdin.
 *
 * @generated from message google.protobuf.compiler.CodeGeneratorRequest
 */
class CodeGeneratorRequest extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The .proto files that were explicitly listed on the command-line.  The
         * code generator should generate code only for these files.  Each file's
         * descriptor will be included in proto_file, below.
         *
         * @generated from field: repeated string file_to_generate = 1;
         */
        this.fileToGenerate = [];
        /**
         * FileDescriptorProtos for all files in files_to_generate and everything
         * they import.  The files will appear in topological order, so each file
         * appears before any file that imports it.
         *
         * Note: the files listed in files_to_generate will include runtime-retention
         * options only, but all other files will include source-retention options.
         * The source_file_descriptors field below is available in case you need
         * source-retention options for files_to_generate.
         *
         * protoc guarantees that all proto_files will be written after
         * the fields above, even though this is not technically guaranteed by the
         * protobuf wire format.  This theoretically could allow a plugin to stream
         * in the FileDescriptorProtos and handle them one by one rather than read
         * the entire set into memory at once.  However, as of this writing, this
         * is not similarly optimized on protoc's end -- it will store all fields in
         * memory at once before sending them to the plugin.
         *
         * Type names of fields and extensions in the FileDescriptorProto are always
         * fully qualified.
         *
         * @generated from field: repeated google.protobuf.FileDescriptorProto proto_file = 15;
         */
        this.protoFile = [];
        /**
         * File descriptors with all options, including source-retention options.
         * These descriptors are only provided for the files listed in
         * files_to_generate.
         *
         * @generated from field: repeated google.protobuf.FileDescriptorProto source_file_descriptors = 17;
         */
        this.sourceFileDescriptors = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new CodeGeneratorRequest().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new CodeGeneratorRequest().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new CodeGeneratorRequest().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(CodeGeneratorRequest, a, b);
    }
}
CodeGeneratorRequest.runtime = proto2;
CodeGeneratorRequest.typeName = "google.protobuf.compiler.CodeGeneratorRequest";
CodeGeneratorRequest.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "file_to_generate", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 2, name: "parameter", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 15, name: "proto_file", kind: "message", T: FileDescriptorProto, repeated: true },
    { no: 17, name: "source_file_descriptors", kind: "message", T: FileDescriptorProto, repeated: true },
    { no: 3, name: "compiler_version", kind: "message", T: Version, opt: true },
]);
/**
 * The plugin writes an encoded CodeGeneratorResponse to stdout.
 *
 * @generated from message google.protobuf.compiler.CodeGeneratorResponse
 */
class CodeGeneratorResponse extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * @generated from field: repeated google.protobuf.compiler.CodeGeneratorResponse.File file = 15;
         */
        this.file = [];
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new CodeGeneratorResponse().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new CodeGeneratorResponse().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new CodeGeneratorResponse().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(CodeGeneratorResponse, a, b);
    }
}
CodeGeneratorResponse.runtime = proto2;
CodeGeneratorResponse.typeName = "google.protobuf.compiler.CodeGeneratorResponse";
CodeGeneratorResponse.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "error", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "supported_features", kind: "scalar", T: 4 /* ScalarType.UINT64 */, opt: true },
    { no: 15, name: "file", kind: "message", T: CodeGeneratorResponse_File, repeated: true },
]);
/**
 * Sync with code_generator.h.
 *
 * @generated from enum google.protobuf.compiler.CodeGeneratorResponse.Feature
 */
var CodeGeneratorResponse_Feature;
(function (CodeGeneratorResponse_Feature) {
    /**
     * @generated from enum value: FEATURE_NONE = 0;
     */
    CodeGeneratorResponse_Feature[CodeGeneratorResponse_Feature["NONE"] = 0] = "NONE";
    /**
     * @generated from enum value: FEATURE_PROTO3_OPTIONAL = 1;
     */
    CodeGeneratorResponse_Feature[CodeGeneratorResponse_Feature["PROTO3_OPTIONAL"] = 1] = "PROTO3_OPTIONAL";
    /**
     * @generated from enum value: FEATURE_SUPPORTS_EDITIONS = 2;
     */
    CodeGeneratorResponse_Feature[CodeGeneratorResponse_Feature["SUPPORTS_EDITIONS"] = 2] = "SUPPORTS_EDITIONS";
})(CodeGeneratorResponse_Feature || (CodeGeneratorResponse_Feature = {}));
// Retrieve enum metadata with: proto2.getEnumType(CodeGeneratorResponse_Feature)
proto2.util.setEnumType(CodeGeneratorResponse_Feature, "google.protobuf.compiler.CodeGeneratorResponse.Feature", [
    { no: 0, name: "FEATURE_NONE" },
    { no: 1, name: "FEATURE_PROTO3_OPTIONAL" },
    { no: 2, name: "FEATURE_SUPPORTS_EDITIONS" },
]);
/**
 * Represents a single generated file.
 *
 * @generated from message google.protobuf.compiler.CodeGeneratorResponse.File
 */
class CodeGeneratorResponse_File extends esm_message/* Message */.v {
    constructor(data) {
        super();
        proto2.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new CodeGeneratorResponse_File().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new CodeGeneratorResponse_File().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new CodeGeneratorResponse_File().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto2.util.equals(CodeGeneratorResponse_File, a, b);
    }
}
CodeGeneratorResponse_File.runtime = proto2;
CodeGeneratorResponse_File.typeName = "google.protobuf.compiler.CodeGeneratorResponse.File";
CodeGeneratorResponse_File.fields = proto2.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 2, name: "insertion_point", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 15, name: "content", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 16, name: "generated_code_info", kind: "message", T: GeneratedCodeInfo, opt: true },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/source_context_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * `SourceContext` represents information about the source of a
 * protobuf element, like the file in which it is defined.
 *
 * @generated from message google.protobuf.SourceContext
 */
class SourceContext extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The path-qualified name of the .proto file that contained the associated
         * protobuf element.  For example: `"google/protobuf/source_context.proto"`.
         *
         * @generated from field: string file_name = 1;
         */
        this.fileName = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new SourceContext().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new SourceContext().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new SourceContext().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(SourceContext, a, b);
    }
}
SourceContext.runtime = proto3/* proto3 */.w;
SourceContext.typeName = "google.protobuf.SourceContext";
SourceContext.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "file_name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/type_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// @generated by protoc-gen-es v1.6.0 with parameter "bootstrap_wkt=true,ts_nocheck=false,target=ts"
// @generated from file google/protobuf/type.proto (package google.protobuf, syntax proto3)
/* eslint-disable */




/**
 * The syntax in which a protocol buffer element is defined.
 *
 * @generated from enum google.protobuf.Syntax
 */
var Syntax;
(function (Syntax) {
    /**
     * Syntax `proto2`.
     *
     * @generated from enum value: SYNTAX_PROTO2 = 0;
     */
    Syntax[Syntax["PROTO2"] = 0] = "PROTO2";
    /**
     * Syntax `proto3`.
     *
     * @generated from enum value: SYNTAX_PROTO3 = 1;
     */
    Syntax[Syntax["PROTO3"] = 1] = "PROTO3";
    /**
     * Syntax `editions`.
     *
     * @generated from enum value: SYNTAX_EDITIONS = 2;
     */
    Syntax[Syntax["EDITIONS"] = 2] = "EDITIONS";
})(Syntax || (Syntax = {}));
// Retrieve enum metadata with: proto3.getEnumType(Syntax)
proto3/* proto3 */.w.util.setEnumType(Syntax, "google.protobuf.Syntax", [
    { no: 0, name: "SYNTAX_PROTO2" },
    { no: 1, name: "SYNTAX_PROTO3" },
    { no: 2, name: "SYNTAX_EDITIONS" },
]);
/**
 * A protocol buffer message type.
 *
 * @generated from message google.protobuf.Type
 */
class Type extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The fully qualified message name.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        /**
         * The list of fields.
         *
         * @generated from field: repeated google.protobuf.Field fields = 2;
         */
        this.fields = [];
        /**
         * The list of types appearing in `oneof` definitions in this type.
         *
         * @generated from field: repeated string oneofs = 3;
         */
        this.oneofs = [];
        /**
         * The protocol buffer options.
         *
         * @generated from field: repeated google.protobuf.Option options = 4;
         */
        this.options = [];
        /**
         * The source syntax.
         *
         * @generated from field: google.protobuf.Syntax syntax = 6;
         */
        this.syntax = Syntax.PROTO2;
        /**
         * The source edition string, only valid when syntax is SYNTAX_EDITIONS.
         *
         * @generated from field: string edition = 7;
         */
        this.edition = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Type().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Type().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Type().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Type, a, b);
    }
}
Type.runtime = proto3/* proto3 */.w;
Type.typeName = "google.protobuf.Type";
Type.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "fields", kind: "message", T: Field, repeated: true },
    { no: 3, name: "oneofs", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 4, name: "options", kind: "message", T: Option, repeated: true },
    { no: 5, name: "source_context", kind: "message", T: SourceContext },
    { no: 6, name: "syntax", kind: "enum", T: proto3/* proto3 */.w.getEnumType(Syntax) },
    { no: 7, name: "edition", kind: "scalar", T: 9 /* ScalarType.STRING */ },
]);
/**
 * A single field of a message type.
 *
 * @generated from message google.protobuf.Field
 */
class Field extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The field type.
         *
         * @generated from field: google.protobuf.Field.Kind kind = 1;
         */
        this.kind = Field_Kind.TYPE_UNKNOWN;
        /**
         * The field cardinality.
         *
         * @generated from field: google.protobuf.Field.Cardinality cardinality = 2;
         */
        this.cardinality = Field_Cardinality.UNKNOWN;
        /**
         * The field number.
         *
         * @generated from field: int32 number = 3;
         */
        this.number = 0;
        /**
         * The field name.
         *
         * @generated from field: string name = 4;
         */
        this.name = "";
        /**
         * The field type URL, without the scheme, for message or enumeration
         * types. Example: `"type.googleapis.com/google.protobuf.Timestamp"`.
         *
         * @generated from field: string type_url = 6;
         */
        this.typeUrl = "";
        /**
         * The index of the field type in `Type.oneofs`, for message or enumeration
         * types. The first type has index 1; zero means the type is not in the list.
         *
         * @generated from field: int32 oneof_index = 7;
         */
        this.oneofIndex = 0;
        /**
         * Whether to use alternative packed wire representation.
         *
         * @generated from field: bool packed = 8;
         */
        this.packed = false;
        /**
         * The protocol buffer options.
         *
         * @generated from field: repeated google.protobuf.Option options = 9;
         */
        this.options = [];
        /**
         * The field JSON name.
         *
         * @generated from field: string json_name = 10;
         */
        this.jsonName = "";
        /**
         * The string value of the default value of this field. Proto2 syntax only.
         *
         * @generated from field: string default_value = 11;
         */
        this.defaultValue = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Field().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Field().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Field().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Field, a, b);
    }
}
Field.runtime = proto3/* proto3 */.w;
Field.typeName = "google.protobuf.Field";
Field.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "kind", kind: "enum", T: proto3/* proto3 */.w.getEnumType(Field_Kind) },
    { no: 2, name: "cardinality", kind: "enum", T: proto3/* proto3 */.w.getEnumType(Field_Cardinality) },
    { no: 3, name: "number", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 4, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 6, name: "type_url", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 7, name: "oneof_index", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 8, name: "packed", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
    { no: 9, name: "options", kind: "message", T: Option, repeated: true },
    { no: 10, name: "json_name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 11, name: "default_value", kind: "scalar", T: 9 /* ScalarType.STRING */ },
]);
/**
 * Basic field types.
 *
 * @generated from enum google.protobuf.Field.Kind
 */
var Field_Kind;
(function (Field_Kind) {
    /**
     * Field type unknown.
     *
     * @generated from enum value: TYPE_UNKNOWN = 0;
     */
    Field_Kind[Field_Kind["TYPE_UNKNOWN"] = 0] = "TYPE_UNKNOWN";
    /**
     * Field type double.
     *
     * @generated from enum value: TYPE_DOUBLE = 1;
     */
    Field_Kind[Field_Kind["TYPE_DOUBLE"] = 1] = "TYPE_DOUBLE";
    /**
     * Field type float.
     *
     * @generated from enum value: TYPE_FLOAT = 2;
     */
    Field_Kind[Field_Kind["TYPE_FLOAT"] = 2] = "TYPE_FLOAT";
    /**
     * Field type int64.
     *
     * @generated from enum value: TYPE_INT64 = 3;
     */
    Field_Kind[Field_Kind["TYPE_INT64"] = 3] = "TYPE_INT64";
    /**
     * Field type uint64.
     *
     * @generated from enum value: TYPE_UINT64 = 4;
     */
    Field_Kind[Field_Kind["TYPE_UINT64"] = 4] = "TYPE_UINT64";
    /**
     * Field type int32.
     *
     * @generated from enum value: TYPE_INT32 = 5;
     */
    Field_Kind[Field_Kind["TYPE_INT32"] = 5] = "TYPE_INT32";
    /**
     * Field type fixed64.
     *
     * @generated from enum value: TYPE_FIXED64 = 6;
     */
    Field_Kind[Field_Kind["TYPE_FIXED64"] = 6] = "TYPE_FIXED64";
    /**
     * Field type fixed32.
     *
     * @generated from enum value: TYPE_FIXED32 = 7;
     */
    Field_Kind[Field_Kind["TYPE_FIXED32"] = 7] = "TYPE_FIXED32";
    /**
     * Field type bool.
     *
     * @generated from enum value: TYPE_BOOL = 8;
     */
    Field_Kind[Field_Kind["TYPE_BOOL"] = 8] = "TYPE_BOOL";
    /**
     * Field type string.
     *
     * @generated from enum value: TYPE_STRING = 9;
     */
    Field_Kind[Field_Kind["TYPE_STRING"] = 9] = "TYPE_STRING";
    /**
     * Field type group. Proto2 syntax only, and deprecated.
     *
     * @generated from enum value: TYPE_GROUP = 10;
     */
    Field_Kind[Field_Kind["TYPE_GROUP"] = 10] = "TYPE_GROUP";
    /**
     * Field type message.
     *
     * @generated from enum value: TYPE_MESSAGE = 11;
     */
    Field_Kind[Field_Kind["TYPE_MESSAGE"] = 11] = "TYPE_MESSAGE";
    /**
     * Field type bytes.
     *
     * @generated from enum value: TYPE_BYTES = 12;
     */
    Field_Kind[Field_Kind["TYPE_BYTES"] = 12] = "TYPE_BYTES";
    /**
     * Field type uint32.
     *
     * @generated from enum value: TYPE_UINT32 = 13;
     */
    Field_Kind[Field_Kind["TYPE_UINT32"] = 13] = "TYPE_UINT32";
    /**
     * Field type enum.
     *
     * @generated from enum value: TYPE_ENUM = 14;
     */
    Field_Kind[Field_Kind["TYPE_ENUM"] = 14] = "TYPE_ENUM";
    /**
     * Field type sfixed32.
     *
     * @generated from enum value: TYPE_SFIXED32 = 15;
     */
    Field_Kind[Field_Kind["TYPE_SFIXED32"] = 15] = "TYPE_SFIXED32";
    /**
     * Field type sfixed64.
     *
     * @generated from enum value: TYPE_SFIXED64 = 16;
     */
    Field_Kind[Field_Kind["TYPE_SFIXED64"] = 16] = "TYPE_SFIXED64";
    /**
     * Field type sint32.
     *
     * @generated from enum value: TYPE_SINT32 = 17;
     */
    Field_Kind[Field_Kind["TYPE_SINT32"] = 17] = "TYPE_SINT32";
    /**
     * Field type sint64.
     *
     * @generated from enum value: TYPE_SINT64 = 18;
     */
    Field_Kind[Field_Kind["TYPE_SINT64"] = 18] = "TYPE_SINT64";
})(Field_Kind || (Field_Kind = {}));
// Retrieve enum metadata with: proto3.getEnumType(Field_Kind)
proto3/* proto3 */.w.util.setEnumType(Field_Kind, "google.protobuf.Field.Kind", [
    { no: 0, name: "TYPE_UNKNOWN" },
    { no: 1, name: "TYPE_DOUBLE" },
    { no: 2, name: "TYPE_FLOAT" },
    { no: 3, name: "TYPE_INT64" },
    { no: 4, name: "TYPE_UINT64" },
    { no: 5, name: "TYPE_INT32" },
    { no: 6, name: "TYPE_FIXED64" },
    { no: 7, name: "TYPE_FIXED32" },
    { no: 8, name: "TYPE_BOOL" },
    { no: 9, name: "TYPE_STRING" },
    { no: 10, name: "TYPE_GROUP" },
    { no: 11, name: "TYPE_MESSAGE" },
    { no: 12, name: "TYPE_BYTES" },
    { no: 13, name: "TYPE_UINT32" },
    { no: 14, name: "TYPE_ENUM" },
    { no: 15, name: "TYPE_SFIXED32" },
    { no: 16, name: "TYPE_SFIXED64" },
    { no: 17, name: "TYPE_SINT32" },
    { no: 18, name: "TYPE_SINT64" },
]);
/**
 * Whether a field is optional, required, or repeated.
 *
 * @generated from enum google.protobuf.Field.Cardinality
 */
var Field_Cardinality;
(function (Field_Cardinality) {
    /**
     * For fields with unknown cardinality.
     *
     * @generated from enum value: CARDINALITY_UNKNOWN = 0;
     */
    Field_Cardinality[Field_Cardinality["UNKNOWN"] = 0] = "UNKNOWN";
    /**
     * For optional fields.
     *
     * @generated from enum value: CARDINALITY_OPTIONAL = 1;
     */
    Field_Cardinality[Field_Cardinality["OPTIONAL"] = 1] = "OPTIONAL";
    /**
     * For required fields. Proto2 syntax only.
     *
     * @generated from enum value: CARDINALITY_REQUIRED = 2;
     */
    Field_Cardinality[Field_Cardinality["REQUIRED"] = 2] = "REQUIRED";
    /**
     * For repeated fields.
     *
     * @generated from enum value: CARDINALITY_REPEATED = 3;
     */
    Field_Cardinality[Field_Cardinality["REPEATED"] = 3] = "REPEATED";
})(Field_Cardinality || (Field_Cardinality = {}));
// Retrieve enum metadata with: proto3.getEnumType(Field_Cardinality)
proto3/* proto3 */.w.util.setEnumType(Field_Cardinality, "google.protobuf.Field.Cardinality", [
    { no: 0, name: "CARDINALITY_UNKNOWN" },
    { no: 1, name: "CARDINALITY_OPTIONAL" },
    { no: 2, name: "CARDINALITY_REQUIRED" },
    { no: 3, name: "CARDINALITY_REPEATED" },
]);
/**
 * Enum type definition.
 *
 * @generated from message google.protobuf.Enum
 */
class Enum extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Enum type name.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        /**
         * Enum value definitions.
         *
         * @generated from field: repeated google.protobuf.EnumValue enumvalue = 2;
         */
        this.enumvalue = [];
        /**
         * Protocol buffer options.
         *
         * @generated from field: repeated google.protobuf.Option options = 3;
         */
        this.options = [];
        /**
         * The source syntax.
         *
         * @generated from field: google.protobuf.Syntax syntax = 5;
         */
        this.syntax = Syntax.PROTO2;
        /**
         * The source edition string, only valid when syntax is SYNTAX_EDITIONS.
         *
         * @generated from field: string edition = 6;
         */
        this.edition = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Enum().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Enum().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Enum().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Enum, a, b);
    }
}
Enum.runtime = proto3/* proto3 */.w;
Enum.typeName = "google.protobuf.Enum";
Enum.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "enumvalue", kind: "message", T: EnumValue, repeated: true },
    { no: 3, name: "options", kind: "message", T: Option, repeated: true },
    { no: 4, name: "source_context", kind: "message", T: SourceContext },
    { no: 5, name: "syntax", kind: "enum", T: proto3/* proto3 */.w.getEnumType(Syntax) },
    { no: 6, name: "edition", kind: "scalar", T: 9 /* ScalarType.STRING */ },
]);
/**
 * Enum value definition.
 *
 * @generated from message google.protobuf.EnumValue
 */
class EnumValue extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * Enum value name.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        /**
         * Enum value number.
         *
         * @generated from field: int32 number = 2;
         */
        this.number = 0;
        /**
         * Protocol buffer options.
         *
         * @generated from field: repeated google.protobuf.Option options = 3;
         */
        this.options = [];
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new EnumValue().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new EnumValue().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new EnumValue().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(EnumValue, a, b);
    }
}
EnumValue.runtime = proto3/* proto3 */.w;
EnumValue.typeName = "google.protobuf.EnumValue";
EnumValue.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "number", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 3, name: "options", kind: "message", T: Option, repeated: true },
]);
/**
 * A protocol buffer option, which can be attached to a message, field,
 * enumeration, etc.
 *
 * @generated from message google.protobuf.Option
 */
class Option extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The option's name. For protobuf built-in options (options defined in
         * descriptor.proto), this is the short name. For example, `"map_entry"`.
         * For custom options, it should be the fully-qualified name. For example,
         * `"google.api.http"`.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Option().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Option().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Option().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Option, a, b);
    }
}
Option.runtime = proto3/* proto3 */.w;
Option.typeName = "google.protobuf.Option";
Option.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "value", kind: "message", T: any_pb/* Any */.I },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/api_pb.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.




/**
 * Api is a light-weight descriptor for an API Interface.
 *
 * Interfaces are also described as "protocol buffer services" in some contexts,
 * such as by the "service" keyword in a .proto file, but they are different
 * from API Services, which represent a concrete implementation of an interface
 * as opposed to simply a description of methods and bindings. They are also
 * sometimes simply referred to as "APIs" in other contexts, such as the name of
 * this message itself. See https://cloud.google.com/apis/design/glossary for
 * detailed terminology.
 *
 * @generated from message google.protobuf.Api
 */
class Api extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The fully qualified name of this interface, including package name
         * followed by the interface's simple name.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        /**
         * The methods of this interface, in unspecified order.
         *
         * @generated from field: repeated google.protobuf.Method methods = 2;
         */
        this.methods = [];
        /**
         * Any metadata attached to the interface.
         *
         * @generated from field: repeated google.protobuf.Option options = 3;
         */
        this.options = [];
        /**
         * A version string for this interface. If specified, must have the form
         * `major-version.minor-version`, as in `1.10`. If the minor version is
         * omitted, it defaults to zero. If the entire version field is empty, the
         * major version is derived from the package name, as outlined below. If the
         * field is not empty, the version in the package name will be verified to be
         * consistent with what is provided here.
         *
         * The versioning schema uses [semantic
         * versioning](http://semver.org) where the major version number
         * indicates a breaking change and the minor version an additive,
         * non-breaking change. Both version numbers are signals to users
         * what to expect from different versions, and should be carefully
         * chosen based on the product plan.
         *
         * The major version is also reflected in the package name of the
         * interface, which must end in `v<major-version>`, as in
         * `google.feature.v1`. For major versions 0 and 1, the suffix can
         * be omitted. Zero major versions must only be used for
         * experimental, non-GA interfaces.
         *
         *
         * @generated from field: string version = 4;
         */
        this.version = "";
        /**
         * Included interfaces. See [Mixin][].
         *
         * @generated from field: repeated google.protobuf.Mixin mixins = 6;
         */
        this.mixins = [];
        /**
         * The source syntax of the service.
         *
         * @generated from field: google.protobuf.Syntax syntax = 7;
         */
        this.syntax = Syntax.PROTO2;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Api().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Api().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Api().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Api, a, b);
    }
}
Api.runtime = proto3/* proto3 */.w;
Api.typeName = "google.protobuf.Api";
Api.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "methods", kind: "message", T: Method, repeated: true },
    { no: 3, name: "options", kind: "message", T: Option, repeated: true },
    { no: 4, name: "version", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 5, name: "source_context", kind: "message", T: SourceContext },
    { no: 6, name: "mixins", kind: "message", T: Mixin, repeated: true },
    { no: 7, name: "syntax", kind: "enum", T: proto3/* proto3 */.w.getEnumType(Syntax) },
]);
/**
 * Method represents a method of an API interface.
 *
 * @generated from message google.protobuf.Method
 */
class Method extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The simple name of this method.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        /**
         * A URL of the input message type.
         *
         * @generated from field: string request_type_url = 2;
         */
        this.requestTypeUrl = "";
        /**
         * If true, the request is streamed.
         *
         * @generated from field: bool request_streaming = 3;
         */
        this.requestStreaming = false;
        /**
         * The URL of the output message type.
         *
         * @generated from field: string response_type_url = 4;
         */
        this.responseTypeUrl = "";
        /**
         * If true, the response is streamed.
         *
         * @generated from field: bool response_streaming = 5;
         */
        this.responseStreaming = false;
        /**
         * Any metadata attached to the method.
         *
         * @generated from field: repeated google.protobuf.Option options = 6;
         */
        this.options = [];
        /**
         * The source syntax of this method.
         *
         * @generated from field: google.protobuf.Syntax syntax = 7;
         */
        this.syntax = Syntax.PROTO2;
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Method().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Method().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Method().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Method, a, b);
    }
}
Method.runtime = proto3/* proto3 */.w;
Method.typeName = "google.protobuf.Method";
Method.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "request_type_url", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "request_streaming", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
    { no: 4, name: "response_type_url", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 5, name: "response_streaming", kind: "scalar", T: 8 /* ScalarType.BOOL */ },
    { no: 6, name: "options", kind: "message", T: Option, repeated: true },
    { no: 7, name: "syntax", kind: "enum", T: proto3/* proto3 */.w.getEnumType(Syntax) },
]);
/**
 * Declares an API Interface to be included in this interface. The including
 * interface must redeclare all the methods from the included interface, but
 * documentation and options are inherited as follows:
 *
 * - If after comment and whitespace stripping, the documentation
 *   string of the redeclared method is empty, it will be inherited
 *   from the original method.
 *
 * - Each annotation belonging to the service config (http,
 *   visibility) which is not set in the redeclared method will be
 *   inherited.
 *
 * - If an http annotation is inherited, the path pattern will be
 *   modified as follows. Any version prefix will be replaced by the
 *   version of the including interface plus the [root][] path if
 *   specified.
 *
 * Example of a simple mixin:
 *
 *     package google.acl.v1;
 *     service AccessControl {
 *       // Get the underlying ACL object.
 *       rpc GetAcl(GetAclRequest) returns (Acl) {
 *         option (google.api.http).get = "/v1/{resource=**}:getAcl";
 *       }
 *     }
 *
 *     package google.storage.v2;
 *     service Storage {
 *       rpc GetAcl(GetAclRequest) returns (Acl);
 *
 *       // Get a data record.
 *       rpc GetData(GetDataRequest) returns (Data) {
 *         option (google.api.http).get = "/v2/{resource=**}";
 *       }
 *     }
 *
 * Example of a mixin configuration:
 *
 *     apis:
 *     - name: google.storage.v2.Storage
 *       mixins:
 *       - name: google.acl.v1.AccessControl
 *
 * The mixin construct implies that all methods in `AccessControl` are
 * also declared with same name and request/response types in
 * `Storage`. A documentation generator or annotation processor will
 * see the effective `Storage.GetAcl` method after inherting
 * documentation and annotations as follows:
 *
 *     service Storage {
 *       // Get the underlying ACL object.
 *       rpc GetAcl(GetAclRequest) returns (Acl) {
 *         option (google.api.http).get = "/v2/{resource=**}:getAcl";
 *       }
 *       ...
 *     }
 *
 * Note how the version in the path pattern changed from `v1` to `v2`.
 *
 * If the `root` field in the mixin is specified, it should be a
 * relative path under which inherited HTTP paths are placed. Example:
 *
 *     apis:
 *     - name: google.storage.v2.Storage
 *       mixins:
 *       - name: google.acl.v1.AccessControl
 *         root: acls
 *
 * This implies the following inherited HTTP annotation:
 *
 *     service Storage {
 *       // Get the underlying ACL object.
 *       rpc GetAcl(GetAclRequest) returns (Acl) {
 *         option (google.api.http).get = "/v2/acls/{resource=**}:getAcl";
 *       }
 *       ...
 *     }
 *
 * @generated from message google.protobuf.Mixin
 */
class Mixin extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The fully qualified name of the interface which is included.
         *
         * @generated from field: string name = 1;
         */
        this.name = "";
        /**
         * If non-empty specifies a path under which inherited HTTP paths
         * are rooted.
         *
         * @generated from field: string root = 2;
         */
        this.root = "";
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new Mixin().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new Mixin().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new Mixin().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(Mixin, a, b);
    }
}
Mixin.runtime = proto3/* proto3 */.w;
Mixin.typeName = "google.protobuf.Mixin";
Mixin.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 2, name: "root", kind: "scalar", T: 9 /* ScalarType.STRING */ },
]);

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/index.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.















// ideally, we would export these types with sub-path exports:














/***/ }),

/***/ 561:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   v: () => (/* binding */ Message)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Message is the base class of every message, generated, or created at
 * runtime.
 *
 * It is _not_ safe to extend this class. If you want to create a message at
 * run time, use proto3.makeMessageType().
 */
class Message {
    /**
     * Compare with a message of the same type.
     */
    equals(other) {
        return this.getType().runtime.util.equals(this.getType(), this, other);
    }
    /**
     * Create a deep copy.
     */
    clone() {
        return this.getType().runtime.util.clone(this);
    }
    /**
     * Parse from binary data, merging fields.
     *
     * Repeated fields are appended. Map entries are added, overwriting
     * existing keys.
     *
     * If a message field is already present, it will be merged with the
     * new data.
     */
    fromBinary(bytes, options) {
        const type = this.getType(), format = type.runtime.bin, opt = format.makeReadOptions(options);
        format.readMessage(this, opt.readerFactory(bytes), bytes.byteLength, opt);
        return this;
    }
    /**
     * Parse a message from a JSON value.
     */
    fromJson(jsonValue, options) {
        const type = this.getType(), format = type.runtime.json, opt = format.makeReadOptions(options);
        format.readMessage(type, jsonValue, opt, this);
        return this;
    }
    /**
     * Parse a message from a JSON string.
     */
    fromJsonString(jsonString, options) {
        let json;
        try {
            json = JSON.parse(jsonString);
        }
        catch (e) {
            throw new Error(`cannot decode ${this.getType().typeName} from JSON: ${e instanceof Error ? e.message : String(e)}`);
        }
        return this.fromJson(json, options);
    }
    /**
     * Serialize the message to binary data.
     */
    toBinary(options) {
        const type = this.getType(), bin = type.runtime.bin, opt = bin.makeWriteOptions(options), writer = opt.writerFactory();
        bin.writeMessage(this, writer, opt);
        return writer.finish();
    }
    /**
     * Serialize the message to a JSON value, a JavaScript value that can be
     * passed to JSON.stringify().
     */
    toJson(options) {
        const type = this.getType(), json = type.runtime.json, opt = json.makeWriteOptions(options);
        return json.writeMessage(this, opt);
    }
    /**
     * Serialize the message to a JSON string.
     */
    toJsonString(options) {
        var _a;
        const value = this.toJson(options);
        return JSON.stringify(value, null, (_a = options === null || options === void 0 ? void 0 : options.prettySpaces) !== null && _a !== void 0 ? _a : 0);
    }
    /**
     * Override for serialization behavior. This will be invoked when calling
     * JSON.stringify on this message (i.e. JSON.stringify(msg)).
     *
     * Note that this will not serialize google.protobuf.Any with a packed
     * message because the protobuf JSON format specifies that it needs to be
     * unpacked, and this is only possible with a type registry to look up the
     * message type.  As a result, attempting to serialize a message with this
     * type will throw an Error.
     *
     * This method is protected because you should not need to invoke it
     * directly -- instead use JSON.stringify or toJsonString for
     * stringified JSON.  Alternatively, if actual JSON is desired, you should
     * use toJson.
     */
    toJSON() {
        return this.toJson({
            emitDefaultValues: true,
        });
    }
    /**
     * Retrieve the MessageType of this message - a singleton that represents
     * the protobuf message declaration and provides metadata for reflection-
     * based operations.
     */
    getType() {
        // Any class that extends Message _must_ provide a complete static
        // implementation of MessageType.
        // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-return
        return Object.getPrototypeOf(this).constructor;
    }
}


/***/ }),

/***/ 120:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   E_: () => (/* binding */ assertFloat32),
/* harmony export */   fp: () => (/* binding */ assertUInt32),
/* harmony export */   hu: () => (/* binding */ assert),
/* harmony export */   ug: () => (/* binding */ assertInt32)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Assert that condition is truthy or throw error (with message)
 */
function assert(condition, msg) {
    // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions -- we want the implicit conversion to boolean
    if (!condition) {
        throw new Error(msg);
    }
}
const FLOAT32_MAX = 3.4028234663852886e38, FLOAT32_MIN = -3.4028234663852886e38, UINT32_MAX = 0xffffffff, INT32_MAX = 0x7fffffff, INT32_MIN = -0x80000000;
/**
 * Assert a valid signed protobuf 32-bit integer.
 */
function assertInt32(arg) {
    if (typeof arg !== "number")
        throw new Error("invalid int 32: " + typeof arg);
    if (!Number.isInteger(arg) || arg > INT32_MAX || arg < INT32_MIN)
        throw new Error("invalid int 32: " + arg); // eslint-disable-line @typescript-eslint/restrict-plus-operands -- we want the implicit conversion to string
}
/**
 * Assert a valid unsigned protobuf 32-bit integer.
 */
function assertUInt32(arg) {
    if (typeof arg !== "number")
        throw new Error("invalid uint 32: " + typeof arg);
    if (!Number.isInteger(arg) || arg > UINT32_MAX || arg < 0)
        throw new Error("invalid uint 32: " + arg); // eslint-disable-line @typescript-eslint/restrict-plus-operands -- we want the implicit conversion to string
}
/**
 * Assert a valid protobuf float value.
 */
function assertFloat32(arg) {
    if (typeof arg !== "number")
        throw new Error("invalid float 32: " + typeof arg);
    if (!Number.isFinite(arg))
        return;
    if (arg > FLOAT32_MAX || arg < FLOAT32_MIN)
        throw new Error("invalid float 32: " + arg); // eslint-disable-line @typescript-eslint/restrict-plus-operands -- we want the implicit conversion to string
}


/***/ }),

/***/ 744:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Jj: () => (/* binding */ writePacked),
/* harmony export */   NN: () => (/* binding */ writeScalar),
/* harmony export */   gQ: () => (/* binding */ writeMapEntry),
/* harmony export */   gY: () => (/* binding */ makeBinaryFormatCommon),
/* harmony export */   oQ: () => (/* binding */ writeMessageField)
/* harmony export */ });
/* unused harmony export readScalarLTString */
/* harmony import */ var _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(79);
/* harmony import */ var _message_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(561);
/* harmony import */ var _field_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(465);
/* harmony import */ var _field_wrapper_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(432);
/* harmony import */ var _scalars_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(781);
/* harmony import */ var _assert_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(120);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.






/* eslint-disable @typescript-eslint/no-unsafe-return, @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-explicit-any, @typescript-eslint/no-unsafe-argument, @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-call, @typescript-eslint/no-unnecessary-condition, no-case-declarations, prefer-const */
const unknownFieldsSymbol = Symbol("@bufbuild/protobuf/unknown-fields");
// Default options for parsing binary data.
const readDefaults = {
    readUnknownFields: true,
    readerFactory: (bytes) => new _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .BinaryReader */ .oP(bytes),
};
// Default options for serializing binary data.
const writeDefaults = {
    writeUnknownFields: true,
    writerFactory: () => new _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .BinaryWriter */ .Lt(),
};
function makeReadOptions(options) {
    return options ? Object.assign(Object.assign({}, readDefaults), options) : readDefaults;
}
function makeWriteOptions(options) {
    return options ? Object.assign(Object.assign({}, writeDefaults), options) : writeDefaults;
}
function makeBinaryFormatCommon() {
    return {
        makeReadOptions,
        makeWriteOptions,
        listUnknownFields(message) {
            var _a;
            return (_a = message[unknownFieldsSymbol]) !== null && _a !== void 0 ? _a : [];
        },
        discardUnknownFields(message) {
            delete message[unknownFieldsSymbol];
        },
        writeUnknownFields(message, writer) {
            const m = message;
            const c = m[unknownFieldsSymbol];
            if (c) {
                for (const f of c) {
                    writer.tag(f.no, f.wireType).raw(f.data);
                }
            }
        },
        onUnknownField(message, no, wireType, data) {
            const m = message;
            if (!Array.isArray(m[unknownFieldsSymbol])) {
                m[unknownFieldsSymbol] = [];
            }
            m[unknownFieldsSymbol].push({ no, wireType, data });
        },
        readMessage(message, reader, lengthOrEndTagFieldNo, options, delimitedMessageEncoding) {
            const type = message.getType();
            // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
            const end = delimitedMessageEncoding
                ? reader.len
                : reader.pos + lengthOrEndTagFieldNo;
            let fieldNo, wireType;
            while (reader.pos < end) {
                [fieldNo, wireType] = reader.tag();
                if (wireType == _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.EndGroup) {
                    break;
                }
                const field = type.fields.find(fieldNo);
                if (!field) {
                    const data = reader.skip(wireType);
                    if (options.readUnknownFields) {
                        this.onUnknownField(message, fieldNo, wireType, data);
                    }
                    continue;
                }
                let target = message, repeated = field.repeated, localName = field.localName;
                if (field.oneof) {
                    target = target[field.oneof.localName];
                    if (target.case != localName) {
                        delete target.value;
                    }
                    target.case = localName;
                    localName = "value";
                }
                switch (field.kind) {
                    case "scalar":
                    case "enum":
                        const scalarType = field.kind == "enum" ? _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32 : field.T;
                        let read = readScalar;
                        // eslint-disable-next-line @typescript-eslint/no-unsafe-enum-comparison -- acceptable since it's covered by tests
                        if (field.kind == "scalar" && field.L > 0) {
                            read = readScalarLTString;
                        }
                        if (repeated) {
                            let arr = target[localName]; // safe to assume presence of array, oneof cannot contain repeated values
                            if (wireType == _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.LengthDelimited &&
                                scalarType != _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.STRING &&
                                scalarType != _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BYTES) {
                                let e = reader.uint32() + reader.pos;
                                while (reader.pos < e) {
                                    arr.push(read(reader, scalarType));
                                }
                            }
                            else {
                                arr.push(read(reader, scalarType));
                            }
                        }
                        else {
                            target[localName] = read(reader, scalarType);
                        }
                        break;
                    case "message":
                        const messageType = field.T;
                        if (repeated) {
                            // safe to assume presence of array, oneof cannot contain repeated values
                            target[localName].push(readMessageField(reader, new messageType(), options, field));
                        }
                        else {
                            if (target[localName] instanceof _message_js__WEBPACK_IMPORTED_MODULE_2__/* .Message */ .v) {
                                readMessageField(reader, target[localName], options, field);
                            }
                            else {
                                target[localName] = readMessageField(reader, new messageType(), options, field);
                                if (messageType.fieldWrapper &&
                                    !field.oneof &&
                                    !field.repeated) {
                                    target[localName] = messageType.fieldWrapper.unwrapField(target[localName]);
                                }
                            }
                        }
                        break;
                    case "map":
                        let [mapKey, mapVal] = readMapEntry(field, reader, options);
                        // safe to assume presence of map object, oneof cannot contain repeated values
                        target[localName][mapKey] = mapVal;
                        break;
                }
            }
            if (delimitedMessageEncoding && // eslint-disable-line @typescript-eslint/strict-boolean-expressions
                (wireType != _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.EndGroup || fieldNo !== lengthOrEndTagFieldNo)) {
                throw new Error(`invalid end group tag`);
            }
        },
    };
}
// Read a message, avoiding MessageType.fromBinary() to re-use the
// BinaryReadOptions and the IBinaryReader.
function readMessageField(reader, message, options, field) {
    const format = message.getType().runtime.bin;
    const delimited = field === null || field === void 0 ? void 0 : field.delimited;
    format.readMessage(message, reader, delimited ? field === null || field === void 0 ? void 0 : field.no : reader.uint32(), // eslint-disable-line @typescript-eslint/strict-boolean-expressions
    options, delimited);
    return message;
}
// Read a map field, expecting key field = 1, value field = 2
function readMapEntry(field, reader, options) {
    const length = reader.uint32(), end = reader.pos + length;
    let key, val;
    while (reader.pos < end) {
        let [fieldNo] = reader.tag();
        switch (fieldNo) {
            case 1:
                key = readScalar(reader, field.K);
                break;
            case 2:
                switch (field.V.kind) {
                    case "scalar":
                        val = readScalar(reader, field.V.T);
                        break;
                    case "enum":
                        val = reader.int32();
                        break;
                    case "message":
                        val = readMessageField(reader, new field.V.T(), options, undefined);
                        break;
                }
                break;
        }
    }
    if (key === undefined) {
        let keyRaw = (0,_scalars_js__WEBPACK_IMPORTED_MODULE_3__/* .scalarDefaultValue */ .kY)(field.K, _field_js__WEBPACK_IMPORTED_MODULE_1__/* .LongType */ .p.BIGINT);
        key =
            field.K == _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BOOL
                ? keyRaw.toString()
                : keyRaw;
    }
    if (typeof key != "string" && typeof key != "number") {
        key = key.toString();
    }
    if (val === undefined) {
        switch (field.V.kind) {
            case "scalar":
                val = (0,_scalars_js__WEBPACK_IMPORTED_MODULE_3__/* .scalarDefaultValue */ .kY)(field.V.T, _field_js__WEBPACK_IMPORTED_MODULE_1__/* .LongType */ .p.BIGINT);
                break;
            case "enum":
                val = 0;
                break;
            case "message":
                val = new field.V.T();
                break;
        }
    }
    return [key, val];
}
// Read a scalar value, but return 64 bit integral types (int64, uint64,
// sint64, fixed64, sfixed64) as string instead of bigint.
function readScalarLTString(reader, type) {
    const v = readScalar(reader, type);
    return typeof v == "bigint" ? v.toString() : v;
}
// Does not use scalarTypeInfo() for better performance.
function readScalar(reader, type) {
    switch (type) {
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.STRING:
            return reader.string();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BOOL:
            return reader.bool();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.DOUBLE:
            return reader.double();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.FLOAT:
            return reader.float();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32:
            return reader.int32();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT64:
            return reader.int64();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.UINT64:
            return reader.uint64();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.FIXED64:
            return reader.fixed64();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BYTES:
            return reader.bytes();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.FIXED32:
            return reader.fixed32();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.SFIXED32:
            return reader.sfixed32();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.SFIXED64:
            return reader.sfixed64();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.SINT64:
            return reader.sint64();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.UINT32:
            return reader.uint32();
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.SINT32:
            return reader.sint32();
    }
}
function writeMapEntry(writer, options, field, key, value) {
    writer.tag(field.no, _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.LengthDelimited);
    writer.fork();
    // javascript only allows number or string for object properties
    // we convert from our representation to the protobuf type
    let keyValue = key;
    // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check -- we deliberately handle just the special cases for map keys
    switch (field.K) {
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32:
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.FIXED32:
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.UINT32:
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.SFIXED32:
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.SINT32:
            keyValue = Number.parseInt(key);
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BOOL:
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_4__/* .assert */ .hu)(key == "true" || key == "false");
            keyValue = key == "true";
            break;
    }
    // write key, expecting key field number = 1
    writeScalar(writer, field.K, 1, keyValue, true);
    // write value, expecting value field number = 2
    switch (field.V.kind) {
        case "scalar":
            writeScalar(writer, field.V.T, 2, value, true);
            break;
        case "enum":
            writeScalar(writer, _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32, 2, value, true);
            break;
        case "message":
            writer.tag(2, _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.LengthDelimited).bytes(value.toBinary(options));
            break;
    }
    writer.join();
}
function writeMessageField(writer, options, field, value) {
    if (value !== undefined) {
        const message = (0,_field_wrapper_js__WEBPACK_IMPORTED_MODULE_5__/* .wrapField */ .E)(field.T, value);
        // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
        if (field === null || field === void 0 ? void 0 : field.delimited)
            writer
                .tag(field.no, _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.StartGroup)
                .raw(message.toBinary(options))
                .tag(field.no, _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.EndGroup);
        else
            writer
                .tag(field.no, _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.LengthDelimited)
                .bytes(message.toBinary(options));
    }
}
function writeScalar(writer, type, fieldNo, value, emitIntrinsicDefault) {
    let [wireType, method, isIntrinsicDefault] = (0,_scalars_js__WEBPACK_IMPORTED_MODULE_3__/* .scalarTypeInfo */ .T1)(type, value);
    if (!isIntrinsicDefault || emitIntrinsicDefault) {
        writer.tag(fieldNo, wireType)[method](value);
    }
}
function writePacked(writer, type, fieldNo, value) {
    if (!value.length) {
        return;
    }
    writer.tag(fieldNo, _binary_encoding_js__WEBPACK_IMPORTED_MODULE_0__/* .WireType */ .TD.LengthDelimited).fork();
    let [, method] = (0,_scalars_js__WEBPACK_IMPORTED_MODULE_3__/* .scalarTypeInfo */ .T1)(type);
    for (let i = 0; i < value.length; i++) {
        writer[method](value[i]);
    }
    writer.join();
}


/***/ }),

/***/ 609:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   V3: () => (/* binding */ getEnumType),
/* harmony export */   be: () => (/* binding */ makeEnumType),
/* harmony export */   ut: () => (/* binding */ makeEnum),
/* harmony export */   zg: () => (/* binding */ setEnumType)
/* harmony export */ });
/* harmony import */ var _assert_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(120);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

const enumTypeSymbol = Symbol("@bufbuild/protobuf/enum-type");
/**
 * Get reflection information from a generated enum.
 * If this function is called on something other than a generated
 * enum, it raises an error.
 */
function getEnumType(enumObject) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-explicit-any
    const t = enumObject[enumTypeSymbol];
    (0,_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assert */ .hu)(t, "missing enum type on enum object");
    return t; // eslint-disable-line @typescript-eslint/no-unsafe-return
}
/**
 * Sets reflection information on a generated enum.
 */
function setEnumType(enumObject, typeName, values, opt) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-explicit-any
    enumObject[enumTypeSymbol] = makeEnumType(typeName, values.map((v) => ({
        no: v.no,
        name: v.name,
        localName: enumObject[v.no],
    })), opt);
}
/**
 * Create a new EnumType with the given values.
 */
function makeEnumType(typeName, values, 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
_opt) {
    const names = Object.create(null);
    const numbers = Object.create(null);
    const normalValues = [];
    for (const value of values) {
        // We do not surface options at this time
        // const value: EnumValueInfo = {...v, options: v.options ?? emptyReadonlyObject};
        const n = normalizeEnumValue(value);
        normalValues.push(n);
        names[value.name] = n;
        numbers[value.no] = n;
    }
    return {
        typeName,
        values: normalValues,
        // We do not surface options at this time
        // options: opt?.options ?? Object.create(null),
        findName(name) {
            return names[name];
        },
        findNumber(no) {
            return numbers[no];
        },
    };
}
/**
 * Create a new enum object with the given values.
 * Sets reflection information.
 */
function makeEnum(typeName, values, opt) {
    const enumObject = {};
    for (const value of values) {
        const n = normalizeEnumValue(value);
        enumObject[n.localName] = n.no;
        enumObject[n.no] = n.localName;
    }
    setEnumType(enumObject, typeName, values, opt);
    return enumObject;
}
function normalizeEnumValue(value) {
    if ("localName" in value) {
        return value;
    }
    return Object.assign(Object.assign({}, value), { localName: value.name });
}


/***/ }),

/***/ 501:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   i: () => (/* binding */ InternalFieldList)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
class InternalFieldList {
    constructor(fields, normalizer) {
        this._fields = fields;
        this._normalizer = normalizer;
    }
    findJsonName(jsonName) {
        if (!this.jsonNames) {
            const t = {};
            for (const f of this.list()) {
                t[f.jsonName] = t[f.name] = f;
            }
            this.jsonNames = t;
        }
        return this.jsonNames[jsonName];
    }
    find(fieldNo) {
        if (!this.numbers) {
            const t = {};
            for (const f of this.list()) {
                t[f.no] = f;
            }
            this.numbers = t;
        }
        return this.numbers[fieldNo];
    }
    list() {
        if (!this.all) {
            this.all = this._normalizer(this._fields);
        }
        return this.all;
    }
    byNumber() {
        if (!this.numbersAsc) {
            this.numbersAsc = this.list()
                .concat()
                .sort((a, b) => a.no - b.no);
        }
        return this.numbersAsc;
    }
    byMember() {
        if (!this.members) {
            this.members = [];
            const a = this.members;
            let o;
            for (const f of this.list()) {
                if (f.oneof) {
                    if (f.oneof !== o) {
                        o = f.oneof;
                        a.push(o);
                    }
                }
                else {
                    a.push(f);
                }
            }
        }
        return this.members;
    }
}


/***/ }),

/***/ 432:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   E: () => (/* binding */ wrapField),
/* harmony export */   w: () => (/* binding */ getUnwrappedFieldType)
/* harmony export */ });
/* harmony import */ var _message_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(561);
/* harmony import */ var _field_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(465);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Wrap a primitive message field value in its corresponding wrapper
 * message. This function is idempotent.
 */
function wrapField(type, value) {
    if (value instanceof _message_js__WEBPACK_IMPORTED_MODULE_0__/* .Message */ .v || !type.fieldWrapper) {
        return value;
    }
    return type.fieldWrapper.wrapField(value);
}
/**
 * If the given field uses one of the well-known wrapper types, return
 * the primitive type it wraps.
 */
function getUnwrappedFieldType(field) {
    if (field.fieldKind !== "message") {
        return undefined;
    }
    if (field.repeated) {
        return undefined;
    }
    if (field.oneof != undefined) {
        return undefined;
    }
    return wktWrapperToScalarType[field.message.typeName];
}
const wktWrapperToScalarType = {
    "google.protobuf.DoubleValue": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.DOUBLE,
    "google.protobuf.FloatValue": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.FLOAT,
    "google.protobuf.Int64Value": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT64,
    "google.protobuf.UInt64Value": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.UINT64,
    "google.protobuf.Int32Value": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32,
    "google.protobuf.UInt32Value": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.UINT32,
    "google.protobuf.BoolValue": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BOOL,
    "google.protobuf.StringValue": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.STRING,
    "google.protobuf.BytesValue": _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BYTES,
};


/***/ }),

/***/ 215:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   o: () => (/* binding */ InternalOneofInfo)
/* harmony export */ });
/* harmony import */ var _names_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(504);
/* harmony import */ var _assert_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(120);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


class InternalOneofInfo {
    constructor(name) {
        this.kind = "oneof";
        this.repeated = false;
        this.packed = false;
        this.opt = false;
        this.default = undefined;
        this.fields = [];
        this.name = name;
        this.localName = (0,_names_js__WEBPACK_IMPORTED_MODULE_0__/* .localOneofName */ .uA)(name);
    }
    addField(field) {
        (0,_assert_js__WEBPACK_IMPORTED_MODULE_1__/* .assert */ .hu)(field.oneof === this, `field ${field.name} not one of ${this.name}`);
        this.fields.push(field);
    }
    findField(localName) {
        if (!this._lookup) {
            this._lookup = Object.create(null);
            for (let i = 0; i < this.fields.length; i++) {
                this._lookup[this.fields[i].localName] = this.fields[i];
            }
        }
        return this._lookup[localName];
    }
}


/***/ }),

/***/ 814:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   b: () => (/* binding */ makeJsonFormatCommon)
/* harmony export */ });
/* harmony import */ var _message_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(561);
/* harmony import */ var _field_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(465);
/* harmony import */ var _assert_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(120);
/* harmony import */ var _proto_int64_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(210);
/* harmony import */ var _proto_base64_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(236);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/* eslint-disable no-case-declarations, @typescript-eslint/restrict-plus-operands,@typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-argument */
// Default options for parsing JSON.
const jsonReadDefaults = {
    ignoreUnknownFields: false,
};
// Default options for serializing to JSON.
const jsonWriteDefaults = {
    emitDefaultValues: false,
    enumAsInteger: false,
    useProtoFieldName: false,
    prettySpaces: 0,
};
function makeReadOptions(options) {
    return options ? Object.assign(Object.assign({}, jsonReadDefaults), options) : jsonReadDefaults;
}
function makeWriteOptions(options) {
    return options ? Object.assign(Object.assign({}, jsonWriteDefaults), options) : jsonWriteDefaults;
}
function makeJsonFormatCommon(makeWriteField) {
    const writeField = makeWriteField(writeEnum, writeScalar);
    return {
        makeReadOptions,
        makeWriteOptions,
        readMessage(type, json, options, message) {
            if (json == null || Array.isArray(json) || typeof json != "object") {
                throw new Error(`cannot decode message ${type.typeName} from JSON: ${this.debug(json)}`);
            }
            message = message !== null && message !== void 0 ? message : new type();
            const oneofSeen = {};
            for (const [jsonKey, jsonValue] of Object.entries(json)) {
                const field = type.fields.findJsonName(jsonKey);
                if (!field) {
                    if (!options.ignoreUnknownFields) {
                        throw new Error(`cannot decode message ${type.typeName} from JSON: key "${jsonKey}" is unknown`);
                    }
                    continue;
                }
                let localName = field.localName;
                let target = message;
                if (field.oneof) {
                    if (jsonValue === null && field.kind == "scalar") {
                        // see conformance test Required.Proto3.JsonInput.OneofFieldNull{First,Second}
                        continue;
                    }
                    const seen = oneofSeen[field.oneof.localName];
                    if (seen) {
                        throw new Error(`cannot decode message ${type.typeName} from JSON: multiple keys for oneof "${field.oneof.name}" present: "${seen}", "${jsonKey}"`);
                    }
                    oneofSeen[field.oneof.localName] = jsonKey;
                    target = target[field.oneof.localName] = { case: localName };
                    localName = "value";
                }
                if (field.repeated) {
                    if (jsonValue === null) {
                        continue;
                    }
                    if (!Array.isArray(jsonValue)) {
                        throw new Error(`cannot decode field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonValue)}`);
                    }
                    const targetArray = target[localName];
                    for (const jsonItem of jsonValue) {
                        if (jsonItem === null) {
                            throw new Error(`cannot decode field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonItem)}`);
                        }
                        let val;
                        // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check -- "map" is invalid for repeated fields
                        switch (field.kind) {
                            case "message":
                                val = field.T.fromJson(jsonItem, options);
                                break;
                            case "enum":
                                val = readEnum(field.T, jsonItem, options.ignoreUnknownFields);
                                if (val === undefined)
                                    continue;
                                break;
                            case "scalar":
                                try {
                                    val = readScalar(field.T, jsonItem, field.L);
                                }
                                catch (e) {
                                    let m = `cannot decode field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonItem)}`;
                                    if (e instanceof Error && e.message.length > 0) {
                                        m += `: ${e.message}`;
                                    }
                                    throw new Error(m);
                                }
                                break;
                        }
                        targetArray.push(val);
                    }
                }
                else if (field.kind == "map") {
                    if (jsonValue === null) {
                        continue;
                    }
                    if (Array.isArray(jsonValue) || typeof jsonValue != "object") {
                        throw new Error(`cannot decode field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonValue)}`);
                    }
                    const targetMap = target[localName];
                    for (const [jsonMapKey, jsonMapValue] of Object.entries(jsonValue)) {
                        if (jsonMapValue === null) {
                            throw new Error(`cannot decode field ${type.typeName}.${field.name} from JSON: map value null`);
                        }
                        let val;
                        switch (field.V.kind) {
                            case "message":
                                val = field.V.T.fromJson(jsonMapValue, options);
                                break;
                            case "enum":
                                val = readEnum(field.V.T, jsonMapValue, options.ignoreUnknownFields);
                                if (val === undefined)
                                    continue;
                                break;
                            case "scalar":
                                try {
                                    val = readScalar(field.V.T, jsonMapValue, _field_js__WEBPACK_IMPORTED_MODULE_0__/* .LongType */ .p.BIGINT);
                                }
                                catch (e) {
                                    let m = `cannot decode map value for field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonValue)}`;
                                    if (e instanceof Error && e.message.length > 0) {
                                        m += `: ${e.message}`;
                                    }
                                    throw new Error(m);
                                }
                                break;
                        }
                        try {
                            targetMap[readScalar(field.K, field.K == _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BOOL
                                ? jsonMapKey == "true"
                                    ? true
                                    : jsonMapKey == "false"
                                        ? false
                                        : jsonMapKey
                                : jsonMapKey, _field_js__WEBPACK_IMPORTED_MODULE_0__/* .LongType */ .p.BIGINT).toString()] = val;
                        }
                        catch (e) {
                            let m = `cannot decode map key for field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonValue)}`;
                            if (e instanceof Error && e.message.length > 0) {
                                m += `: ${e.message}`;
                            }
                            throw new Error(m);
                        }
                    }
                }
                else {
                    switch (field.kind) {
                        case "message":
                            const messageType = field.T;
                            if (jsonValue === null &&
                                messageType.typeName != "google.protobuf.Value") {
                                if (field.oneof) {
                                    throw new Error(`cannot decode field ${type.typeName}.${field.name} from JSON: null is invalid for oneof field "${jsonKey}"`);
                                }
                                continue;
                            }
                            if (target[localName] instanceof _message_js__WEBPACK_IMPORTED_MODULE_1__/* .Message */ .v) {
                                target[localName].fromJson(jsonValue, options);
                            }
                            else {
                                target[localName] = messageType.fromJson(jsonValue, options);
                                if (messageType.fieldWrapper && !field.oneof) {
                                    target[localName] = messageType.fieldWrapper.unwrapField(target[localName]);
                                }
                            }
                            break;
                        case "enum":
                            const enumValue = readEnum(field.T, jsonValue, options.ignoreUnknownFields);
                            if (enumValue !== undefined) {
                                target[localName] = enumValue;
                            }
                            break;
                        case "scalar":
                            try {
                                target[localName] = readScalar(field.T, jsonValue, field.L);
                            }
                            catch (e) {
                                let m = `cannot decode field ${type.typeName}.${field.name} from JSON: ${this.debug(jsonValue)}`;
                                if (e instanceof Error && e.message.length > 0) {
                                    m += `: ${e.message}`;
                                }
                                throw new Error(m);
                            }
                            break;
                    }
                }
            }
            return message;
        },
        writeMessage(message, options) {
            const type = message.getType();
            const json = {};
            let field;
            try {
                for (const member of type.fields.byMember()) {
                    let jsonValue;
                    if (member.kind == "oneof") {
                        const oneof = message[member.localName];
                        if (oneof.value === undefined) {
                            continue;
                        }
                        field = member.findField(oneof.case);
                        if (!field) {
                            throw "oneof case not found: " + oneof.case;
                        }
                        jsonValue = writeField(field, oneof.value, options);
                    }
                    else {
                        field = member;
                        jsonValue = writeField(field, message[field.localName], options);
                    }
                    if (jsonValue !== undefined) {
                        json[options.useProtoFieldName ? field.name : field.jsonName] =
                            jsonValue;
                    }
                }
            }
            catch (e) {
                const m = field
                    ? `cannot encode field ${type.typeName}.${field.name} to JSON`
                    : `cannot encode message ${type.typeName} to JSON`;
                const r = e instanceof Error ? e.message : String(e);
                throw new Error(m + (r.length > 0 ? `: ${r}` : ""));
            }
            return json;
        },
        readScalar,
        writeScalar,
        debug: debugJsonValue,
    };
}
function debugJsonValue(json) {
    if (json === null) {
        return "null";
    }
    switch (typeof json) {
        case "object":
            return Array.isArray(json) ? "array" : "object";
        case "string":
            return json.length > 100 ? "string" : `"${json.split('"').join('\\"')}"`;
        default:
            return String(json);
    }
}
// May throw an error. If the error message is non-blank, it should be shown.
// It is up to the caller to provide context.
function readScalar(type, json, longType) {
    // every valid case in the switch below returns, and every fall
    // through is regarded as a failure.
    switch (type) {
        // float, double: JSON value will be a number or one of the special string values "NaN", "Infinity", and "-Infinity".
        // Either numbers or strings are accepted. Exponent notation is also accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.DOUBLE:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FLOAT:
            if (json === null)
                return 0.0;
            if (json === "NaN")
                return Number.NaN;
            if (json === "Infinity")
                return Number.POSITIVE_INFINITY;
            if (json === "-Infinity")
                return Number.NEGATIVE_INFINITY;
            if (json === "") {
                // empty string is not a number
                break;
            }
            if (typeof json == "string" && json.trim().length !== json.length) {
                // extra whitespace
                break;
            }
            if (typeof json != "string" && typeof json != "number") {
                break;
            }
            const float = Number(json);
            if (Number.isNaN(float)) {
                // not a number
                break;
            }
            if (!Number.isFinite(float)) {
                // infinity and -infinity are handled by string representation above, so this is an error
                break;
            }
            if (type == _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FLOAT)
                (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assertFloat32 */ .E_)(float);
            return float;
        // int32, fixed32, uint32: JSON value will be a decimal number. Either numbers or strings are accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT32:
            if (json === null)
                return 0;
            let int32;
            if (typeof json == "number")
                int32 = json;
            else if (typeof json == "string" && json.length > 0) {
                if (json.trim().length === json.length)
                    int32 = Number(json);
            }
            if (int32 === undefined)
                break;
            if (type == _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT32)
                (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assertUInt32 */ .fp)(int32);
            else
                (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assertInt32 */ .ug)(int32);
            return int32;
        // int64, fixed64, uint64: JSON value will be a decimal string. Either numbers or strings are accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT64:
            if (json === null)
                return _proto_int64_js__WEBPACK_IMPORTED_MODULE_3__/* .protoInt64 */ .q.zero;
            if (typeof json != "number" && typeof json != "string")
                break;
            const long = _proto_int64_js__WEBPACK_IMPORTED_MODULE_3__/* .protoInt64 */ .q.parse(json);
            // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
            return longType ? long.toString() : long;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT64:
            if (json === null)
                return _proto_int64_js__WEBPACK_IMPORTED_MODULE_3__/* .protoInt64 */ .q.zero;
            if (typeof json != "number" && typeof json != "string")
                break;
            const uLong = _proto_int64_js__WEBPACK_IMPORTED_MODULE_3__/* .protoInt64 */ .q.uParse(json);
            // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
            return longType ? uLong.toString() : uLong;
        // bool:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BOOL:
            if (json === null)
                return false;
            if (typeof json !== "boolean")
                break;
            return json;
        // string:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.STRING:
            if (json === null)
                return "";
            if (typeof json !== "string") {
                break;
            }
            // A string must always contain UTF-8 encoded or 7-bit ASCII.
            // We validate with encodeURIComponent, which appears to be the fastest widely available option.
            try {
                encodeURIComponent(json);
            }
            catch (e) {
                throw new Error("invalid UTF8");
            }
            return json;
        // bytes: JSON value will be the data encoded as a string using standard base64 encoding with paddings.
        // Either standard or URL-safe base64 encoding with/without paddings are accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BYTES:
            if (json === null || json === "")
                return new Uint8Array(0);
            if (typeof json !== "string")
                break;
            return _proto_base64_js__WEBPACK_IMPORTED_MODULE_4__/* .protoBase64 */ .W.dec(json);
    }
    throw new Error();
}
function readEnum(type, json, ignoreUnknownFields) {
    if (json === null) {
        // proto3 requires 0 to be default value for all enums
        return 0;
    }
    // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check
    switch (typeof json) {
        case "number":
            if (Number.isInteger(json)) {
                return json;
            }
            break;
        case "string":
            const value = type.findName(json);
            // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
            if (value || ignoreUnknownFields) {
                return value === null || value === void 0 ? void 0 : value.no;
            }
            break;
    }
    throw new Error(`cannot decode enum ${type.typeName} from JSON: ${debugJsonValue(json)}`);
}
function writeEnum(type, value, emitIntrinsicDefault, enumAsInteger) {
    var _a;
    if (value === undefined) {
        return value;
    }
    if (value === 0 && !emitIntrinsicDefault) {
        // proto3 requires 0 to be default value for all enums
        return undefined;
    }
    if (enumAsInteger) {
        return value;
    }
    if (type.typeName == "google.protobuf.NullValue") {
        return null;
    }
    const val = type.findNumber(value);
    return (_a = val === null || val === void 0 ? void 0 : val.name) !== null && _a !== void 0 ? _a : value; // if we don't know the enum value, just return the number
}
function writeScalar(type, value, emitIntrinsicDefault) {
    if (value === undefined) {
        return undefined;
    }
    switch (type) {
        // int32, fixed32, uint32: JSON value will be a decimal number. Either numbers or strings are accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED32:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT32:
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assert */ .hu)(typeof value == "number");
            return value != 0 || emitIntrinsicDefault ? value : undefined;
        // float, double: JSON value will be a number or one of the special string values "NaN", "Infinity", and "-Infinity".
        // Either numbers or strings are accepted. Exponent notation is also accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FLOAT:
        // assertFloat32(value);
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.DOUBLE: // eslint-disable-line no-fallthrough
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assert */ .hu)(typeof value == "number");
            if (Number.isNaN(value))
                return "NaN";
            if (value === Number.POSITIVE_INFINITY)
                return "Infinity";
            if (value === Number.NEGATIVE_INFINITY)
                return "-Infinity";
            return value !== 0 || emitIntrinsicDefault ? value : undefined;
        // string:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.STRING:
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assert */ .hu)(typeof value == "string");
            return value.length > 0 || emitIntrinsicDefault ? value : undefined;
        // bool:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BOOL:
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assert */ .hu)(typeof value == "boolean");
            return value || emitIntrinsicDefault ? value : undefined;
        // JSON value will be a decimal string. Either numbers or strings are accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT64:
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assert */ .hu)(typeof value == "bigint" ||
                typeof value == "string" ||
                typeof value == "number");
            // We use implicit conversion with `value != 0` to catch both 0n and "0"
            // eslint-disable-next-line @typescript-eslint/ban-ts-comment
            // @ts-ignore
            return emitIntrinsicDefault || value != 0
                ? value.toString(10)
                : undefined;
        // bytes: JSON value will be the data encoded as a string using standard base64 encoding with paddings.
        // Either standard or URL-safe base64 encoding with/without paddings are accepted.
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BYTES:
            (0,_assert_js__WEBPACK_IMPORTED_MODULE_2__/* .assert */ .hu)(value instanceof Uint8Array);
            return emitIntrinsicDefault || value.byteLength > 0
                ? _proto_base64_js__WEBPACK_IMPORTED_MODULE_4__/* .protoBase64 */ .W.enc(value)
                : undefined;
    }
}


/***/ }),

/***/ 504:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GD: () => (/* binding */ safeIdentifier),
/* harmony export */   Rz: () => (/* binding */ localFieldName),
/* harmony export */   Sm: () => (/* binding */ findEnumSharedPrefix),
/* harmony export */   ll: () => (/* binding */ safeObjectProperty),
/* harmony export */   r1: () => (/* binding */ localName),
/* harmony export */   uA: () => (/* binding */ localOneofName),
/* harmony export */   x1: () => (/* binding */ fieldJsonName)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Returns the name of a protobuf element in generated code.
 *
 * Field names - including oneofs - are converted to lowerCamelCase. For
 * messages, enumerations and services, the package name is stripped from
 * the type name. For nested messages and enumerations, the names are joined
 * with an underscore. For methods, the first character is made lowercase.
 */
function localName(desc) {
    switch (desc.kind) {
        case "field":
            return localFieldName(desc.name, desc.oneof !== undefined);
        case "oneof":
            return localOneofName(desc.name);
        case "enum":
        case "message":
        case "service": {
            const pkg = desc.file.proto.package;
            const offset = pkg === undefined ? 0 : pkg.length + 1;
            const name = desc.typeName.substring(offset).replace(/\./g, "_");
            // For services, we only care about safe identifiers, not safe object properties,
            // but we have shipped v1 with a bug that respected object properties, and we
            // do not want to introduce a breaking change, so we continue to escape for
            // safe object properties.
            // See https://github.com/bufbuild/protobuf-es/pull/391
            return safeObjectProperty(safeIdentifier(name));
        }
        case "enum_value": {
            const sharedPrefix = desc.parent.sharedPrefix;
            if (sharedPrefix === undefined) {
                return desc.name;
            }
            const name = desc.name.substring(sharedPrefix.length);
            return safeObjectProperty(name);
        }
        case "rpc": {
            let name = desc.name;
            if (name.length == 0) {
                return name;
            }
            name = name[0].toLowerCase() + name.substring(1);
            return safeObjectProperty(name);
        }
    }
}
/**
 * Returns the name of a field in generated code.
 */
function localFieldName(protoName, inOneof) {
    const name = protoCamelCase(protoName);
    if (inOneof) {
        // oneof member names are not properties, but values of the `case` property.
        return name;
    }
    return safeObjectProperty(safeMessageProperty(name));
}
/**
 * Returns the name of a oneof group in generated code.
 */
function localOneofName(protoName) {
    return localFieldName(protoName, false);
}
/**
 * Returns the JSON name for a protobuf field, exactly like protoc does.
 */
const fieldJsonName = protoCamelCase;
/**
 * Finds a prefix shared by enum values, for example `MY_ENUM_` for
 * `enum MyEnum {MY_ENUM_A=0; MY_ENUM_B=1;}`.
 */
function findEnumSharedPrefix(enumName, valueNames) {
    const prefix = camelToSnakeCase(enumName) + "_";
    for (const name of valueNames) {
        if (!name.toLowerCase().startsWith(prefix)) {
            return undefined;
        }
        const shortName = name.substring(prefix.length);
        if (shortName.length == 0) {
            return undefined;
        }
        if (/^\d/.test(shortName)) {
            // identifiers must not start with numbers
            return undefined;
        }
    }
    return prefix;
}
/**
 * Converts lowerCamelCase or UpperCamelCase into lower_snake_case.
 * This is used to find shared prefixes in an enum.
 */
function camelToSnakeCase(camel) {
    return (camel.substring(0, 1) + camel.substring(1).replace(/[A-Z]/g, (c) => "_" + c)).toLowerCase();
}
/**
 * Converts snake_case to protoCamelCase according to the convention
 * used by protoc to convert a field name to a JSON name.
 */
function protoCamelCase(snakeCase) {
    let capNext = false;
    const b = [];
    for (let i = 0; i < snakeCase.length; i++) {
        let c = snakeCase.charAt(i);
        switch (c) {
            case "_":
                capNext = true;
                break;
            case "0":
            case "1":
            case "2":
            case "3":
            case "4":
            case "5":
            case "6":
            case "7":
            case "8":
            case "9":
                b.push(c);
                capNext = false;
                break;
            default:
                if (capNext) {
                    capNext = false;
                    c = c.toUpperCase();
                }
                b.push(c);
                break;
        }
    }
    return b.join("");
}
/**
 * Names that cannot be used for identifiers, such as class names,
 * but _can_ be used for object properties.
 */
const reservedIdentifiers = new Set([
    // ECMAScript 2015 keywords
    "break",
    "case",
    "catch",
    "class",
    "const",
    "continue",
    "debugger",
    "default",
    "delete",
    "do",
    "else",
    "export",
    "extends",
    "false",
    "finally",
    "for",
    "function",
    "if",
    "import",
    "in",
    "instanceof",
    "new",
    "null",
    "return",
    "super",
    "switch",
    "this",
    "throw",
    "true",
    "try",
    "typeof",
    "var",
    "void",
    "while",
    "with",
    "yield",
    // ECMAScript 2015 future reserved keywords
    "enum",
    "implements",
    "interface",
    "let",
    "package",
    "private",
    "protected",
    "public",
    "static",
    // Class name cannot be 'Object' when targeting ES5 with module CommonJS
    "Object",
    // TypeScript keywords that cannot be used for types (as opposed to variables)
    "bigint",
    "number",
    "boolean",
    "string",
    "object",
    // Identifiers reserved for the runtime, so we can generate legible code
    "globalThis",
    "Uint8Array",
    "Partial",
]);
/**
 * Names that cannot be used for object properties because they are reserved
 * by built-in JavaScript properties.
 */
const reservedObjectProperties = new Set([
    // names reserved by JavaScript
    "constructor",
    "toString",
    "toJSON",
    "valueOf",
]);
/**
 * Names that cannot be used for object properties because they are reserved
 * by the runtime.
 */
const reservedMessageProperties = new Set([
    // names reserved by the runtime
    "getType",
    "clone",
    "equals",
    "fromBinary",
    "fromJson",
    "fromJsonString",
    "toBinary",
    "toJson",
    "toJsonString",
    // names reserved by the runtime for the future
    "toObject",
]);
const fallback = (name) => `${name}$`;
/**
 * Will wrap names that are Object prototype properties or names reserved
 * for `Message`s.
 */
const safeMessageProperty = (name) => {
    if (reservedMessageProperties.has(name)) {
        return fallback(name);
    }
    return name;
};
/**
 * Names that cannot be used for object properties because they are reserved
 * by built-in JavaScript properties.
 */
const safeObjectProperty = (name) => {
    if (reservedObjectProperties.has(name)) {
        return fallback(name);
    }
    return name;
};
/**
 * Names that can be used for identifiers or class properties
 */
const safeIdentifier = (name) => {
    if (reservedIdentifiers.has(name)) {
        return fallback(name);
    }
    return name;
};


/***/ }),

/***/ 493:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  F: () => (/* binding */ makeProtoRuntime)
});

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/enum.js
var private_enum = __webpack_require__(609);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/message.js
var message = __webpack_require__(561);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/message-type.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Create a new message type using the given runtime.
 */
function makeMessageType(runtime, typeName, fields, opt) {
    var _a;
    const localName = (_a = opt === null || opt === void 0 ? void 0 : opt.localName) !== null && _a !== void 0 ? _a : typeName.substring(typeName.lastIndexOf(".") + 1);
    const type = {
        [localName]: function (data) {
            runtime.util.initFields(this);
            runtime.util.initPartial(data, this);
        },
    }[localName];
    Object.setPrototypeOf(type.prototype, new message/* Message */.v());
    Object.assign(type, {
        runtime,
        typeName,
        fields: runtime.util.newFieldList(fields),
        fromBinary(bytes, options) {
            return new type().fromBinary(bytes, options);
        },
        fromJson(jsonValue, options) {
            return new type().fromJson(jsonValue, options);
        },
        fromJsonString(jsonString, options) {
            return new type().fromJsonString(jsonString, options);
        },
        equals(a, b) {
            return runtime.util.equals(type, a, b);
        },
    });
    return type;
}

;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/proto-runtime.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


function makeProtoRuntime(syntax, json, bin, util) {
    return {
        syntax,
        json,
        bin,
        util,
        makeMessageType(typeName, fields, opt) {
            return makeMessageType(this, typeName, fields, opt);
        },
        makeEnum: private_enum/* makeEnum */.ut,
        makeEnumType: private_enum/* makeEnumType */.be,
        getEnumType: private_enum/* getEnumType */.V3,
    };
}


/***/ }),

/***/ 781:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   AA: () => (/* binding */ scalarEquals),
/* harmony export */   T1: () => (/* binding */ scalarTypeInfo),
/* harmony export */   kY: () => (/* binding */ scalarDefaultValue)
/* harmony export */ });
/* harmony import */ var _field_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(465);
/* harmony import */ var _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(79);
/* harmony import */ var _proto_int64_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(210);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/* eslint-disable @typescript-eslint/no-explicit-any */
/**
 * Returns true if both scalar values are equal.
 */
function scalarEquals(type, a, b) {
    if (a === b) {
        // This correctly matches equal values except BYTES and (possibly) 64-bit integers.
        return true;
    }
    // Special case BYTES - we need to compare each byte individually
    if (type == _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BYTES) {
        if (!(a instanceof Uint8Array) || !(b instanceof Uint8Array)) {
            return false;
        }
        if (a.length !== b.length) {
            return false;
        }
        for (let i = 0; i < a.length; i++) {
            if (a[i] !== b[i]) {
                return false;
            }
        }
        return true;
    }
    // Special case 64-bit integers - we support number, string and bigint representation.
    // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check
    switch (type) {
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT64:
            // Loose comparison will match between 0n, 0 and "0".
            return a == b;
    }
    // Anything that hasn't been caught by strict comparison or special cased
    // BYTES and 64-bit integers is not equal.
    return false;
}
/**
 * Returns the default value for the given scalar type, following
 * proto3 semantics.
 */
function scalarDefaultValue(type, longType) {
    switch (type) {
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BOOL:
            return false;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED64:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT64:
            // eslint-disable-next-line @typescript-eslint/no-unsafe-enum-comparison -- acceptable since it's covered by tests
            return longType == 0 ? _proto_int64_js__WEBPACK_IMPORTED_MODULE_1__/* .protoInt64 */ .q.zero : "0";
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.DOUBLE:
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FLOAT:
            return 0.0;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BYTES:
            return new Uint8Array(0);
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.STRING:
            return "";
        default:
            // Handles INT32, UINT32, SINT32, FIXED32, SFIXED32.
            // We do not use individual cases to save a few bytes code size.
            return 0;
    }
}
/**
 * Get information for writing a scalar value.
 *
 * Returns tuple:
 * [0]: appropriate WireType
 * [1]: name of the appropriate method of IBinaryWriter
 * [2]: whether the given value is a default value for proto3 semantics
 *
 * If argument `value` is omitted, [2] is always false.
 */
function scalarTypeInfo(type, value) {
    const isUndefined = value === undefined;
    let wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Varint;
    let isIntrinsicDefault = value === 0;
    // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check -- INT32, UINT32, SINT32 are covered by the defaults
    switch (type) {
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.STRING:
            isIntrinsicDefault = isUndefined || !value.length;
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.LengthDelimited;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BOOL:
            isIntrinsicDefault = value === false;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.DOUBLE:
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Bit64;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FLOAT:
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Bit32;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.INT64:
            isIntrinsicDefault = isUndefined || value == 0; // Loose comparison matches 0n, 0 and "0"
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.UINT64:
            isIntrinsicDefault = isUndefined || value == 0; // Loose comparison matches 0n, 0 and "0"
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED64:
            isIntrinsicDefault = isUndefined || value == 0; // Loose comparison matches 0n, 0 and "0"
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Bit64;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.BYTES:
            isIntrinsicDefault = isUndefined || !value.byteLength;
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.LengthDelimited;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.FIXED32:
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Bit32;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED32:
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Bit32;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SFIXED64:
            isIntrinsicDefault = isUndefined || value == 0;
            wireType = _binary_encoding_js__WEBPACK_IMPORTED_MODULE_2__/* .WireType */ .TD.Bit64;
            break;
        case _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w.SINT64:
            isIntrinsicDefault = isUndefined || value == 0;
            break;
    }
    const method = _field_js__WEBPACK_IMPORTED_MODULE_0__/* .ScalarType */ .w[type].toLowerCase();
    return [wireType, method, isUndefined || isIntrinsicDefault];
}


/***/ }),

/***/ 433:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   f: () => (/* binding */ makeUtilCommon)
/* harmony export */ });
/* harmony import */ var _enum_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(609);
/* harmony import */ var _message_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(561);
/* harmony import */ var _field_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(465);
/* harmony import */ var _scalars_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(781);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.




/* eslint-disable @typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-argument,no-case-declarations */
function makeUtilCommon() {
    return {
        setEnumType: _enum_js__WEBPACK_IMPORTED_MODULE_0__/* .setEnumType */ .zg,
        initPartial(source, target) {
            if (source === undefined) {
                return;
            }
            const type = target.getType();
            for (const member of type.fields.byMember()) {
                const localName = member.localName, t = target, s = source;
                if (s[localName] === undefined) {
                    continue;
                }
                switch (member.kind) {
                    case "oneof":
                        const sk = s[localName].case;
                        if (sk === undefined) {
                            continue;
                        }
                        const sourceField = member.findField(sk);
                        let val = s[localName].value;
                        if (sourceField &&
                            sourceField.kind == "message" &&
                            !(val instanceof sourceField.T)) {
                            val = new sourceField.T(val);
                        }
                        else if (sourceField &&
                            sourceField.kind === "scalar" &&
                            sourceField.T === _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BYTES) {
                            val = toU8Arr(val);
                        }
                        t[localName] = { case: sk, value: val };
                        break;
                    case "scalar":
                    case "enum":
                        let copy = s[localName];
                        if (member.T === _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BYTES) {
                            copy = member.repeated
                                ? copy.map(toU8Arr)
                                : toU8Arr(copy);
                        }
                        t[localName] = copy;
                        break;
                    case "map":
                        switch (member.V.kind) {
                            case "scalar":
                            case "enum":
                                if (member.V.T === _field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.BYTES) {
                                    for (const [k, v] of Object.entries(s[localName])) {
                                        t[localName][k] = toU8Arr(v);
                                    }
                                }
                                else {
                                    Object.assign(t[localName], s[localName]);
                                }
                                break;
                            case "message":
                                const messageType = member.V.T;
                                for (const k of Object.keys(s[localName])) {
                                    let val = s[localName][k];
                                    if (!messageType.fieldWrapper) {
                                        // We only take partial input for messages that are not a wrapper type.
                                        // For those messages, we recursively normalize the partial input.
                                        val = new messageType(val);
                                    }
                                    t[localName][k] = val;
                                }
                                break;
                        }
                        break;
                    case "message":
                        const mt = member.T;
                        if (member.repeated) {
                            t[localName] = s[localName].map((val) => val instanceof mt ? val : new mt(val));
                        }
                        else if (s[localName] !== undefined) {
                            const val = s[localName];
                            if (mt.fieldWrapper) {
                                if (
                                // We can't use BytesValue.typeName as that will create a circular import
                                mt.typeName === "google.protobuf.BytesValue") {
                                    t[localName] = toU8Arr(val);
                                }
                                else {
                                    t[localName] = val;
                                }
                            }
                            else {
                                t[localName] = val instanceof mt ? val : new mt(val);
                            }
                        }
                        break;
                }
            }
        },
        equals(type, a, b) {
            if (a === b) {
                return true;
            }
            if (!a || !b) {
                return false;
            }
            return type.fields.byMember().every((m) => {
                const va = a[m.localName];
                const vb = b[m.localName];
                if (m.repeated) {
                    if (va.length !== vb.length) {
                        return false;
                    }
                    // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check -- repeated fields are never "map"
                    switch (m.kind) {
                        case "message":
                            return va.every((a, i) => m.T.equals(a, vb[i]));
                        case "scalar":
                            return va.every((a, i) => (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(m.T, a, vb[i]));
                        case "enum":
                            return va.every((a, i) => (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(_field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32, a, vb[i]));
                    }
                    throw new Error(`repeated cannot contain ${m.kind}`);
                }
                switch (m.kind) {
                    case "message":
                        return m.T.equals(va, vb);
                    case "enum":
                        return (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(_field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32, va, vb);
                    case "scalar":
                        return (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(m.T, va, vb);
                    case "oneof":
                        if (va.case !== vb.case) {
                            return false;
                        }
                        const s = m.findField(va.case);
                        if (s === undefined) {
                            return true;
                        }
                        // eslint-disable-next-line @typescript-eslint/switch-exhaustiveness-check -- oneof fields are never "map"
                        switch (s.kind) {
                            case "message":
                                return s.T.equals(va.value, vb.value);
                            case "enum":
                                return (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(_field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32, va.value, vb.value);
                            case "scalar":
                                return (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(s.T, va.value, vb.value);
                        }
                        throw new Error(`oneof cannot contain ${s.kind}`);
                    case "map":
                        const keys = Object.keys(va).concat(Object.keys(vb));
                        switch (m.V.kind) {
                            case "message":
                                const messageType = m.V.T;
                                return keys.every((k) => messageType.equals(va[k], vb[k]));
                            case "enum":
                                return keys.every((k) => (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(_field_js__WEBPACK_IMPORTED_MODULE_1__/* .ScalarType */ .w.INT32, va[k], vb[k]));
                            case "scalar":
                                const scalarType = m.V.T;
                                return keys.every((k) => (0,_scalars_js__WEBPACK_IMPORTED_MODULE_2__/* .scalarEquals */ .AA)(scalarType, va[k], vb[k]));
                        }
                        break;
                }
            });
        },
        clone(message) {
            const type = message.getType(), target = new type(), any = target;
            for (const member of type.fields.byMember()) {
                const source = message[member.localName];
                let copy;
                if (member.repeated) {
                    copy = source.map(cloneSingularField);
                }
                else if (member.kind == "map") {
                    copy = any[member.localName];
                    for (const [key, v] of Object.entries(source)) {
                        copy[key] = cloneSingularField(v);
                    }
                }
                else if (member.kind == "oneof") {
                    const f = member.findField(source.case);
                    copy = f
                        ? { case: source.case, value: cloneSingularField(source.value) }
                        : { case: undefined };
                }
                else {
                    copy = cloneSingularField(source);
                }
                any[member.localName] = copy;
            }
            return target;
        },
    };
}
// clone a single field value - i.e. the element type of repeated fields, the value type of maps
function cloneSingularField(value) {
    if (value === undefined) {
        return value;
    }
    if (value instanceof _message_js__WEBPACK_IMPORTED_MODULE_3__/* .Message */ .v) {
        return value.clone();
    }
    if (value instanceof Uint8Array) {
        const c = new Uint8Array(value.byteLength);
        c.set(value);
        return c;
    }
    return value;
}
// converts any ArrayLike<number> to Uint8Array if necessary.
function toU8Arr(input) {
    return input instanceof Uint8Array ? input : new Uint8Array(input);
}


/***/ }),

/***/ 236:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   W: () => (/* binding */ protoBase64)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/* eslint-disable @typescript-eslint/ban-ts-comment, @typescript-eslint/no-unnecessary-condition, prefer-const */
// lookup table from base64 character to byte
let encTable = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".split("");
// lookup table from base64 character *code* to byte because lookup by number is fast
let decTable = [];
for (let i = 0; i < encTable.length; i++)
    decTable[encTable[i].charCodeAt(0)] = i;
// support base64url variants
decTable["-".charCodeAt(0)] = encTable.indexOf("+");
decTable["_".charCodeAt(0)] = encTable.indexOf("/");
const protoBase64 = {
    /**
     * Decodes a base64 string to a byte array.
     *
     * - ignores white-space, including line breaks and tabs
     * - allows inner padding (can decode concatenated base64 strings)
     * - does not require padding
     * - understands base64url encoding:
     *   "-" instead of "+",
     *   "_" instead of "/",
     *   no padding
     */
    dec(base64Str) {
        // estimate byte size, not accounting for inner padding and whitespace
        let es = (base64Str.length * 3) / 4;
        if (base64Str[base64Str.length - 2] == "=")
            es -= 2;
        else if (base64Str[base64Str.length - 1] == "=")
            es -= 1;
        let bytes = new Uint8Array(es), bytePos = 0, // position in byte array
        groupPos = 0, // position in base64 group
        b, // current byte
        p = 0; // previous byte
        for (let i = 0; i < base64Str.length; i++) {
            b = decTable[base64Str.charCodeAt(i)];
            if (b === undefined) {
                switch (base64Str[i]) {
                    // @ts-ignore TS7029: Fallthrough case in switch
                    case "=":
                        groupPos = 0; // reset state when padding found
                    // @ts-ignore TS7029: Fallthrough case in switch
                    case "\n":
                    case "\r":
                    case "\t":
                    case " ":
                        continue; // skip white-space, and padding
                    default:
                        throw Error("invalid base64 string.");
                }
            }
            switch (groupPos) {
                case 0:
                    p = b;
                    groupPos = 1;
                    break;
                case 1:
                    bytes[bytePos++] = (p << 2) | ((b & 48) >> 4);
                    p = b;
                    groupPos = 2;
                    break;
                case 2:
                    bytes[bytePos++] = ((p & 15) << 4) | ((b & 60) >> 2);
                    p = b;
                    groupPos = 3;
                    break;
                case 3:
                    bytes[bytePos++] = ((p & 3) << 6) | b;
                    groupPos = 0;
                    break;
            }
        }
        if (groupPos == 1)
            throw Error("invalid base64 string.");
        return bytes.subarray(0, bytePos);
    },
    /**
     * Encode a byte array to a base64 string.
     */
    enc(bytes) {
        let base64 = "", groupPos = 0, // position in base64 group
        b, // current byte
        p = 0; // carry over from previous byte
        for (let i = 0; i < bytes.length; i++) {
            b = bytes[i];
            switch (groupPos) {
                case 0:
                    base64 += encTable[b >> 2];
                    p = (b & 3) << 4;
                    groupPos = 1;
                    break;
                case 1:
                    base64 += encTable[p | (b >> 4)];
                    p = (b & 15) << 2;
                    groupPos = 2;
                    break;
                case 2:
                    base64 += encTable[p | (b >> 6)];
                    base64 += encTable[b & 63];
                    groupPos = 0;
                    break;
            }
        }
        // add output padding
        if (groupPos) {
            base64 += encTable[p];
            base64 += "=";
            if (groupPos == 1)
                base64 += "=";
        }
        return base64;
    },
};


/***/ }),

/***/ 210:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   q: () => (/* binding */ protoInt64)
/* harmony export */ });
/* harmony import */ var _private_assert_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(120);
/* harmony import */ var _google_varint_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(818);
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


function makeInt64Support() {
    const dv = new DataView(new ArrayBuffer(8));
    // note that Safari 14 implements BigInt, but not the DataView methods
    const ok = typeof BigInt === "function" &&
        typeof dv.getBigInt64 === "function" &&
        typeof dv.getBigUint64 === "function" &&
        typeof dv.setBigInt64 === "function" &&
        typeof dv.setBigUint64 === "function" &&
        (typeof process != "object" ||
            typeof process.env != "object" ||
            process.env.BUF_BIGINT_DISABLE !== "1");
    if (ok) {
        const MIN = BigInt("-9223372036854775808"), MAX = BigInt("9223372036854775807"), UMIN = BigInt("0"), UMAX = BigInt("18446744073709551615");
        return {
            zero: BigInt(0),
            supported: true,
            parse(value) {
                const bi = typeof value == "bigint" ? value : BigInt(value);
                if (bi > MAX || bi < MIN) {
                    throw new Error(`int64 invalid: ${value}`);
                }
                return bi;
            },
            uParse(value) {
                const bi = typeof value == "bigint" ? value : BigInt(value);
                if (bi > UMAX || bi < UMIN) {
                    throw new Error(`uint64 invalid: ${value}`);
                }
                return bi;
            },
            enc(value) {
                dv.setBigInt64(0, this.parse(value), true);
                return {
                    lo: dv.getInt32(0, true),
                    hi: dv.getInt32(4, true),
                };
            },
            uEnc(value) {
                dv.setBigInt64(0, this.uParse(value), true);
                return {
                    lo: dv.getInt32(0, true),
                    hi: dv.getInt32(4, true),
                };
            },
            dec(lo, hi) {
                dv.setInt32(0, lo, true);
                dv.setInt32(4, hi, true);
                return dv.getBigInt64(0, true);
            },
            uDec(lo, hi) {
                dv.setInt32(0, lo, true);
                dv.setInt32(4, hi, true);
                return dv.getBigUint64(0, true);
            },
        };
    }
    const assertInt64String = (value) => (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assert */ .hu)(/^-?[0-9]+$/.test(value), `int64 invalid: ${value}`);
    const assertUInt64String = (value) => (0,_private_assert_js__WEBPACK_IMPORTED_MODULE_0__/* .assert */ .hu)(/^[0-9]+$/.test(value), `uint64 invalid: ${value}`);
    return {
        zero: "0",
        supported: false,
        parse(value) {
            if (typeof value != "string") {
                value = value.toString();
            }
            assertInt64String(value);
            return value;
        },
        uParse(value) {
            if (typeof value != "string") {
                value = value.toString();
            }
            assertUInt64String(value);
            return value;
        },
        enc(value) {
            if (typeof value != "string") {
                value = value.toString();
            }
            assertInt64String(value);
            return (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .int64FromString */ .CZ)(value);
        },
        uEnc(value) {
            if (typeof value != "string") {
                value = value.toString();
            }
            assertUInt64String(value);
            return (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .int64FromString */ .CZ)(value);
        },
        dec(lo, hi) {
            return (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .int64ToString */ .Ak)(lo, hi);
        },
        uDec(lo, hi) {
            return (0,_google_varint_js__WEBPACK_IMPORTED_MODULE_1__/* .uInt64ToString */ .Fd)(lo, hi);
        },
    };
}
const protoInt64 = makeInt64Support();


/***/ }),

/***/ 850:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  w: () => (/* binding */ proto3)
});

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/proto-runtime.js + 1 modules
var proto_runtime = __webpack_require__(493);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/field.js
var esm_field = __webpack_require__(465);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/binary-format-common.js
var binary_format_common = __webpack_require__(744);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/binary-format-proto3.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/* eslint-disable @typescript-eslint/no-unsafe-member-access, @typescript-eslint/no-unsafe-argument, @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unnecessary-condition, @typescript-eslint/strict-boolean-expressions, prefer-const, no-case-declarations */
function makeBinaryFormatProto3() {
    return Object.assign(Object.assign({}, (0,binary_format_common/* makeBinaryFormatCommon */.gY)()), { writeMessage(message, writer, options) {
            const type = message.getType();
            for (const field of type.fields.byNumber()) {
                let value, // this will be our field value, whether it is member of a oneof or regular field
                repeated = field.repeated, localName = field.localName;
                if (field.oneof) {
                    const oneof = message[field.oneof.localName];
                    if (oneof.case !== localName) {
                        continue; // field is not selected, skip
                    }
                    value = oneof.value;
                }
                else {
                    value = message[localName];
                }
                switch (field.kind) {
                    case "scalar":
                    case "enum":
                        let scalarType = field.kind == "enum" ? esm_field/* ScalarType */.w.INT32 : field.T;
                        if (repeated) {
                            if (field.packed) {
                                (0,binary_format_common/* writePacked */.Jj)(writer, scalarType, field.no, value);
                            }
                            else {
                                for (const item of value) {
                                    (0,binary_format_common/* writeScalar */.NN)(writer, scalarType, field.no, item, true);
                                }
                            }
                        }
                        else {
                            if (value !== undefined) {
                                (0,binary_format_common/* writeScalar */.NN)(writer, scalarType, field.no, value, !!field.oneof || field.opt);
                            }
                        }
                        break;
                    case "message":
                        if (repeated) {
                            for (const item of value) {
                                (0,binary_format_common/* writeMessageField */.oQ)(writer, options, field, item);
                            }
                        }
                        else {
                            (0,binary_format_common/* writeMessageField */.oQ)(writer, options, field, value);
                        }
                        break;
                    case "map":
                        for (const [key, val] of Object.entries(value)) {
                            (0,binary_format_common/* writeMapEntry */.gQ)(writer, options, field, key, val);
                        }
                        break;
                }
            }
            if (options.writeUnknownFields) {
                this.writeUnknownFields(message, writer);
            }
            return writer;
        } });
}

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/field-wrapper.js
var field_wrapper = __webpack_require__(432);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/assert.js
var assert = __webpack_require__(120);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/json-format-common.js
var json_format_common = __webpack_require__(814);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/json-format-proto3.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/* eslint-disable no-case-declarations, @typescript-eslint/restrict-plus-operands,@typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-return,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-call,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-argument */
function makeJsonFormatProto3() {
    return (0,json_format_common/* makeJsonFormatCommon */.b)((writeEnum, writeScalar) => {
        return function writeField(field, value, options) {
            if (field.kind == "map") {
                const jsonObj = {};
                switch (field.V.kind) {
                    case "scalar":
                        for (const [entryKey, entryValue] of Object.entries(value)) {
                            const val = writeScalar(field.V.T, entryValue, true);
                            (0,assert/* assert */.hu)(val !== undefined);
                            jsonObj[entryKey.toString()] = val; // JSON standard allows only (double quoted) string as property key
                        }
                        break;
                    case "message":
                        for (const [entryKey, entryValue] of Object.entries(value)) {
                            // JSON standard allows only (double quoted) string as property key
                            jsonObj[entryKey.toString()] = entryValue.toJson(options);
                        }
                        break;
                    case "enum":
                        const enumType = field.V.T;
                        for (const [entryKey, entryValue] of Object.entries(value)) {
                            (0,assert/* assert */.hu)(entryValue === undefined || typeof entryValue == "number");
                            const val = writeEnum(enumType, entryValue, true, options.enumAsInteger);
                            (0,assert/* assert */.hu)(val !== undefined);
                            jsonObj[entryKey.toString()] = val; // JSON standard allows only (double quoted) string as property key
                        }
                        break;
                }
                return options.emitDefaultValues || Object.keys(jsonObj).length > 0
                    ? jsonObj
                    : undefined;
            }
            else if (field.repeated) {
                const jsonArr = [];
                switch (field.kind) {
                    case "scalar":
                        for (let i = 0; i < value.length; i++) {
                            jsonArr.push(writeScalar(field.T, value[i], true));
                        }
                        break;
                    case "enum":
                        for (let i = 0; i < value.length; i++) {
                            jsonArr.push(writeEnum(field.T, value[i], true, options.enumAsInteger));
                        }
                        break;
                    case "message":
                        for (let i = 0; i < value.length; i++) {
                            jsonArr.push((0,field_wrapper/* wrapField */.E)(field.T, value[i]).toJson(options));
                        }
                        break;
                }
                return options.emitDefaultValues || jsonArr.length > 0
                    ? jsonArr
                    : undefined;
            }
            else {
                switch (field.kind) {
                    case "scalar":
                        return writeScalar(field.T, value, !!field.oneof || field.opt || options.emitDefaultValues);
                    case "enum":
                        return writeEnum(field.T, value, !!field.oneof || field.opt || options.emitDefaultValues, options.enumAsInteger);
                    case "message":
                        return value !== undefined
                            ? (0,field_wrapper/* wrapField */.E)(field.T, value).toJson(options)
                            : undefined;
                }
            }
        };
    });
}

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/util-common.js
var util_common = __webpack_require__(433);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/field-list.js
var field_list = __webpack_require__(501);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/scalars.js
var scalars = __webpack_require__(781);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/field.js
var private_field = __webpack_require__(215);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/private/names.js
var names = __webpack_require__(504);
;// CONCATENATED MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto3.js
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.









/**
 * Provides functionality for messages defined with the proto3 syntax.
 */
const proto3 = (0,proto_runtime/* makeProtoRuntime */.F)("proto3", makeJsonFormatProto3(), makeBinaryFormatProto3(), Object.assign(Object.assign({}, (0,util_common/* makeUtilCommon */.f)()), { newFieldList(fields) {
        return new field_list/* InternalFieldList */.i(fields, normalizeFieldInfosProto3);
    },
    initFields(target) {
        for (const member of target.getType().fields.byMember()) {
            if (member.opt) {
                continue;
            }
            const name = member.localName, t = target;
            if (member.repeated) {
                t[name] = [];
                continue;
            }
            switch (member.kind) {
                case "oneof":
                    t[name] = { case: undefined };
                    break;
                case "enum":
                    t[name] = 0;
                    break;
                case "map":
                    t[name] = {};
                    break;
                case "scalar":
                    t[name] = (0,scalars/* scalarDefaultValue */.kY)(member.T, member.L); // eslint-disable-line @typescript-eslint/no-unsafe-assignment
                    break;
                case "message":
                    // message fields are always optional in proto3
                    break;
            }
        }
    } }));
/* eslint-disable @typescript-eslint/no-explicit-any,@typescript-eslint/no-unsafe-assignment,@typescript-eslint/no-unsafe-member-access,@typescript-eslint/no-unsafe-argument */
function normalizeFieldInfosProto3(fieldInfos) {
    var _a, _b, _c, _d;
    const r = [];
    let o;
    for (const field of typeof fieldInfos == "function"
        ? fieldInfos()
        : fieldInfos) {
        const f = field;
        f.localName = (0,names/* localFieldName */.Rz)(field.name, field.oneof !== undefined);
        f.jsonName = (_a = field.jsonName) !== null && _a !== void 0 ? _a : (0,names/* fieldJsonName */.x1)(field.name);
        f.repeated = (_b = field.repeated) !== null && _b !== void 0 ? _b : false;
        if (field.kind == "scalar") {
            f.L = (_c = field.L) !== null && _c !== void 0 ? _c : esm_field/* LongType */.p.BIGINT;
        }
        // We do not surface options at this time
        // f.options = field.options ?? emptyReadonlyObject;
        if (field.oneof !== undefined) {
            const ooname = typeof field.oneof == "string" ? field.oneof : field.oneof.name;
            if (!o || o.name != ooname) {
                o = new private_field/* InternalOneofInfo */.o(ooname);
            }
            f.oneof = o;
            o.addField(f);
        }
        // proto3 specific:
        if (field.kind == "message") {
            f.delimited = false;
        }
        // From the proto3 language guide:
        // > In proto3, repeated fields of scalar numeric types are packed by default.
        // This information is incomplete - according to the conformance tests, BOOL
        // and ENUM are packed by default as well. This means only STRING and BYTES
        // are not packed by default, which makes sense because they are length-delimited.
        f.packed =
            (_d = field.packed) !== null && _d !== void 0 ? _d : (field.kind == "enum" ||
                (field.kind == "scalar" &&
                    field.T != esm_field/* ScalarType */.w.BYTES &&
                    field.T != esm_field/* ScalarType */.w.STRING));
        r.push(f);
    }
    return r;
}


/***/ }),

/***/ 328:
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   t: () => (/* binding */ MethodKind),
/* harmony export */   w: () => (/* binding */ MethodIdempotency)
/* harmony export */ });
// Copyright 2021-2023 Buf Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * MethodKind represents the four method types that can be declared in
 * protobuf with the `stream` keyword:
 *
 * 1. Unary:           rpc (Input) returns (Output)
 * 2. ServerStreaming: rpc (Input) returns (stream Output)
 * 3. ClientStreaming: rpc (stream Input) returns (Output)
 * 4. BiDiStreaming:   rpc (stream Input) returns (stream Output)
 */
var MethodKind;
(function (MethodKind) {
    MethodKind[MethodKind["Unary"] = 0] = "Unary";
    MethodKind[MethodKind["ServerStreaming"] = 1] = "ServerStreaming";
    MethodKind[MethodKind["ClientStreaming"] = 2] = "ClientStreaming";
    MethodKind[MethodKind["BiDiStreaming"] = 3] = "BiDiStreaming";
})(MethodKind || (MethodKind = {}));
/**
 * Is this method side-effect-free (or safe in HTTP parlance), or just
 * idempotent, or neither? HTTP based RPC implementation may choose GET verb
 * for safe methods, and PUT verb for idempotent methods instead of the
 * default POST.
 *
 * This enum matches the protobuf enum google.protobuf.MethodOptions.IdempotencyLevel,
 * defined in the well-known type google/protobuf/descriptor.proto, but
 * drops UNKNOWN.
 */
var MethodIdempotency;
(function (MethodIdempotency) {
    /**
     * Idempotent, no side effects.
     */
    MethodIdempotency[MethodIdempotency["NoSideEffects"] = 1] = "NoSideEffects";
    /**
     * Idempotent, but may have side effects.
     */
    MethodIdempotency[MethodIdempotency["Idempotent"] = 2] = "Idempotent";
})(MethodIdempotency || (MethodIdempotency = {}));


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Change: () => (/* reexport */ Change),
  Client: () => (/* reexport */ Client),
  ClientEventType: () => (/* reexport */ ClientEventType),
  ClientStatus: () => (/* reexport */ ClientStatus),
  Counter: () => (/* reexport */ Counter),
  DocEventType: () => (/* reexport */ DocEventType),
  Document: () => (/* reexport */ Document),
  DocumentSyncResultType: () => (/* reexport */ DocumentSyncResultType),
  EventSourceDevPanel: () => (/* reexport */ EventSourceDevPanel),
  EventSourceSDK: () => (/* reexport */ EventSourceSDK),
  Primitive: () => (/* reexport */ Primitive),
  StreamConnectionStatus: () => (/* reexport */ StreamConnectionStatus),
  SyncMode: () => (/* reexport */ SyncMode),
  Text: () => (/* reexport */ Text),
  TimeTicket: () => (/* reexport */ TimeTicket),
  Tree: () => (/* reexport */ Tree),
  converter: () => (/* reexport */ converter),
  "default": () => (/* binding */ src_yorkie),
  setLogLevel: () => (/* reexport */ setLogLevel)
});

;// CONCATENATED MODULE: ./src/util/logger.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["Trivial"] = 0] = "Trivial";
    LogLevel[LogLevel["Debug"] = 1] = "Debug";
    LogLevel[LogLevel["Info"] = 2] = "Info";
    LogLevel[LogLevel["Warn"] = 3] = "Warn";
    LogLevel[LogLevel["Error"] = 4] = "Error";
    LogLevel[LogLevel["Fatal"] = 5] = "Fatal";
})(LogLevel || (LogLevel = {}));
let level = LogLevel.Info;
/**
 * `setLogLevel` sets log level.
 */
function setLogLevel(l) {
    level = l;
}
const logger = {
    trivial: (...messages) => {
        if (level > LogLevel.Trivial) {
            return;
        }
        if (typeof console != 'undefined') {
            console.log('YORKIE T:', ...messages);
        }
    },
    debug: (...messages) => {
        if (level > LogLevel.Debug) {
            return;
        }
        if (typeof console != 'undefined') {
            console.log('YORKIE D:', ...messages);
        }
    },
    info: (...messages) => {
        if (level > LogLevel.Info) {
            return;
        }
        if (typeof console != 'undefined') {
            console.log('YORKIE I:', ...messages);
        }
    },
    warn: (...messages) => {
        if (level > LogLevel.Warn) {
            return;
        }
        if (typeof console != 'undefined') {
            if (typeof console.warn !== 'undefined') {
                console.warn('YORKIE W:', ...messages);
            }
            else {
                console.log('YORKIE W:', ...messages);
            }
        }
    },
    error: (...messages) => {
        if (level > LogLevel.Error) {
            return;
        }
        if (typeof console != 'undefined') {
            if (typeof console.error !== 'undefined') {
                console.error('YORKIE E:', ...messages);
            }
            else {
                console.log('YORKIE E:', ...messages);
            }
        }
    },
    fatal: (message, ...messages) => {
        if (typeof console != 'undefined') {
            if (typeof console.error !== 'undefined') {
                console.error('YORKIE F:', ...messages);
            }
            else {
                console.log('YORKIE F:', ...messages);
            }
        }
        throw new Error(`YORKIE F: ${message}`);
    },
    isEnabled: (l) => {
        return level <= l;
    },
};

;// CONCATENATED MODULE: ./src/util/uuid.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `uuid` generates uuid string
 * @see http://www.ietf.org/rfc/rfc4122.txt
 */
function uuid() {
    return 'xxxxxxxx-xxxx-4xxxy-xxxx-xxxxxxxxxxx'.replace(/[xy]/g, (c) => {
        const r = (Math.random() * 16) | 0;
        const v = c === 'x' ? r : (r & 0x3) | 0x8;
        return v.toString(16);
    });
}

;// CONCATENATED MODULE: ./src/util/observable.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


const Noop = () => {
    // Do nothing
};
/**
 * `ObserverProxy` is proxy of `Observer`.
 */
class ObserverProxy {
    constructor(executor) {
        this.finalized = false;
        this.observers = [];
        try {
            executor(this);
        }
        catch (error) {
            this.error(error);
        }
    }
    /**
     * `next` iterates next observer synchronously.
     */
    next(value) {
        this.forEachObserver((observer) => {
            observer.next(value);
        });
    }
    /**
     * `error` invoke error.
     */
    error(error) {
        this.forEachObserver((observer) => {
            observer.error(error);
        });
        this.close(error);
    }
    /**
     * `complete` completes observer.
     */
    complete() {
        this.forEachObserver((observer) => {
            observer.complete();
        });
        this.close();
    }
    /**
     * `subscribe` is a function for subscribing observer.
     */
    subscribe(nextOrObserver, error, complete) {
        let observer;
        if (!nextOrObserver) {
            logger.fatal('missing observer');
        }
        if (this.finalized) {
            logger.fatal('observable is finalized due to previous error');
        }
        if (typeof nextOrObserver === 'object') {
            observer = nextOrObserver;
        }
        else {
            observer = {
                next: nextOrObserver,
                error,
                complete,
            };
        }
        if (observer.next === undefined) {
            observer.next = Noop;
        }
        if (observer.error === undefined) {
            observer.error = Noop;
        }
        if (observer.complete === undefined) {
            observer.complete = Noop;
        }
        const id = uuid();
        const unsub = this.unsubscribeOne.bind(this, id);
        this.observers.push({
            subscriptionID: id,
            observer: observer,
        });
        if (this.finalized) {
            try {
                if (this.finalError) {
                    observer.error(this.finalError);
                }
                else {
                    observer.complete();
                }
            }
            catch (err) {
                // nothing
                logger.warn(err);
            }
        }
        return unsub;
    }
    unsubscribeOne(id) {
        var _a;
        this.observers = (_a = this.observers) === null || _a === void 0 ? void 0 : _a.filter((it) => it.subscriptionID !== id);
    }
    forEachObserver(fn) {
        if (this.finalized) {
            return;
        }
        for (let i = 0; i < this.observers.length; i++) {
            this.sendOne(i, fn);
        }
    }
    sendOne(i, fn) {
        if (this.observers !== undefined && this.observers[i] !== undefined) {
            try {
                fn(this.observers[i].observer);
            }
            catch (err) {
                logger.error(err);
            }
        }
    }
    close(err) {
        if (this.finalized) {
            return;
        }
        this.finalized = true;
        if (err !== undefined) {
            this.finalError = err;
        }
        this.observers = undefined;
    }
}
/**
 * `createObservable` creates a new instance of ObserverProxy
 * and subscribe the instance.
 */
function createObservable(executor) {
    const proxy = new ObserverProxy(executor);
    return {
        subscribe: proxy.subscribe.bind(proxy),
        getProxy: () => {
            return proxy;
        },
    };
}

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/service-type.js
var service_type = __webpack_require__(328);
;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/any-client.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Create any client for the given service.
 *
 * The given createMethod function is called for each method definition
 * of the service. The function it returns is added to the client object
 * as a method.
 */
function makeAnyClient(service, createMethod) {
    const client = {};
    for (const [localName, methodInfo] of Object.entries(service.methods)) {
        const method = createMethod(Object.assign(Object.assign({}, methodInfo), { localName,
            service }));
        if (method != null) {
            client[localName] = method;
        }
    }
    return client;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/code.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Connect represents categories of errors as codes, and each code maps to a
 * specific HTTP status code. The codes and their semantics were chosen to
 * match gRPC. Only the codes below are valid — there are no user-defined
 * codes.
 *
 * See the specification at https://connectrpc.com/docs/protocol#error-codes
 * for details.
 */
var code_Code;
(function (Code) {
    /**
     * Canceled, usually be the user
     */
    Code[Code["Canceled"] = 1] = "Canceled";
    /**
     * Unknown error
     */
    Code[Code["Unknown"] = 2] = "Unknown";
    /**
     * Argument invalid regardless of system state
     */
    Code[Code["InvalidArgument"] = 3] = "InvalidArgument";
    /**
     * Operation expired, may or may not have completed.
     */
    Code[Code["DeadlineExceeded"] = 4] = "DeadlineExceeded";
    /**
     * Entity not found.
     */
    Code[Code["NotFound"] = 5] = "NotFound";
    /**
     * Entity already exists.
     */
    Code[Code["AlreadyExists"] = 6] = "AlreadyExists";
    /**
     * Operation not authorized.
     */
    Code[Code["PermissionDenied"] = 7] = "PermissionDenied";
    /**
     * Quota exhausted.
     */
    Code[Code["ResourceExhausted"] = 8] = "ResourceExhausted";
    /**
     * Argument invalid in current system state.
     */
    Code[Code["FailedPrecondition"] = 9] = "FailedPrecondition";
    /**
     * Operation aborted.
     */
    Code[Code["Aborted"] = 10] = "Aborted";
    /**
     * Out of bounds, use instead of FailedPrecondition.
     */
    Code[Code["OutOfRange"] = 11] = "OutOfRange";
    /**
     * Operation not implemented or disabled.
     */
    Code[Code["Unimplemented"] = 12] = "Unimplemented";
    /**
     * Internal error, reserved for "serious errors".
     */
    Code[Code["Internal"] = 13] = "Internal";
    /**
     * Unavailable, client should back off and retry.
     */
    Code[Code["Unavailable"] = 14] = "Unavailable";
    /**
     * Unrecoverable data loss or corruption.
     */
    Code[Code["DataLoss"] = 15] = "DataLoss";
    /**
     * Request isn't authenticated.
     */
    Code[Code["Unauthenticated"] = 16] = "Unauthenticated";
})(code_Code || (code_Code = {}));

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/message.js
var esm_message = __webpack_require__(561);
;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-connect/code-string.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * codeToString returns the string representation of a Code.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function codeToString(value) {
    const name = code_Code[value];
    if (typeof name != "string") {
        return value.toString();
    }
    return (name[0].toLowerCase() +
        name.substring(1).replace(/[A-Z]/g, (c) => "_" + c.toLowerCase()));
}
let stringToCode;
/**
 * codeFromString parses the string representation of a Code in snake_case.
 * For example, the string "permission_denied" parses into Code.PermissionDenied.
 *
 * If the given string cannot be parsed, the function returns undefined.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function codeFromString(value) {
    if (!stringToCode) {
        stringToCode = {};
        for (const value of Object.values(Code)) {
            if (typeof value == "string") {
                continue;
            }
            stringToCode[codeToString(value)] = value;
        }
    }
    return stringToCode[value];
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/connect-error.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * ConnectError captures four pieces of information: a Code, an error
 * message, an optional cause of the error, and an optional collection of
 * arbitrary Protobuf messages called  "details".
 *
 * Because developer tools typically show just the error message, we prefix
 * it with the status code, so that the most important information is always
 * visible immediately.
 *
 * Error details are wrapped with google.protobuf.Any on the wire, so that
 * a server or middleware can attach arbitrary data to an error. Use the
 * method findDetails() to retrieve the details.
 */
class connect_error_ConnectError extends Error {
    /**
     * Create a new ConnectError.
     * If no code is provided, code "unknown" is used.
     * Outgoing details are only relevant for the server side - a service may
     * raise an error with details, and it is up to the protocol implementation
     * to encode and send the details along with error.
     */
    constructor(message, code = code_Code.Unknown, metadata, outgoingDetails, cause) {
        super(createMessage(message, code));
        this.name = "ConnectError";
        // see https://www.typescriptlang.org/docs/handbook/release-notes/typescript-2-2.html#example
        Object.setPrototypeOf(this, new.target.prototype);
        this.rawMessage = message;
        this.code = code;
        this.metadata = new Headers(metadata !== null && metadata !== void 0 ? metadata : {});
        this.details = outgoingDetails !== null && outgoingDetails !== void 0 ? outgoingDetails : [];
        this.cause = cause;
    }
    /**
     * Convert any value - typically a caught error into a ConnectError,
     * following these rules:
     * - If the value is already a ConnectError, return it as is.
     * - If the value is an AbortError from the fetch API, return the message
     *   of the AbortError with code Canceled.
     * - For other Errors, return the error message with code Unknown by default.
     * - For other values, return the values String representation as a message,
     *   with the code Unknown by default.
     * The original value will be used for the "cause" property for the new
     * ConnectError.
     */
    static from(reason, code = code_Code.Unknown) {
        if (reason instanceof connect_error_ConnectError) {
            return reason;
        }
        if (reason instanceof Error) {
            if (reason.name == "AbortError") {
                // Fetch requests can only be canceled with an AbortController.
                // We detect that condition by looking at the name of the raised
                // error object, and translate to the appropriate status code.
                return new connect_error_ConnectError(reason.message, code_Code.Canceled);
            }
            return new connect_error_ConnectError(reason.message, code, undefined, undefined, reason);
        }
        return new connect_error_ConnectError(String(reason), code, undefined, undefined, reason);
    }
    findDetails(typeOrRegistry) {
        const registry = "typeName" in typeOrRegistry
            ? {
                findMessage: (typeName) => typeName === typeOrRegistry.typeName ? typeOrRegistry : undefined,
            }
            : typeOrRegistry;
        const details = [];
        for (const data of this.details) {
            if (data instanceof esm_message/* Message */.v) {
                if (registry.findMessage(data.getType().typeName)) {
                    details.push(data);
                }
                continue;
            }
            const type = registry.findMessage(data.type);
            if (type) {
                try {
                    details.push(type.fromBinary(data.value));
                }
                catch (_) {
                    // We silently give up if we are unable to parse the detail, because
                    // that appears to be the least worst behavior.
                    // It is very unlikely that a user surrounds a catch body handling the
                    // error with another try-catch statement, and we do not want to
                    // recommend doing so.
                }
            }
        }
        return details;
    }
}
/**
 * Create an error message, prefixing the given code.
 */
function createMessage(message, code) {
    return message.length
        ? `[${codeToString(code)}] ${message}`
        : `[${codeToString(code)}]`;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/async-iterable.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var __asyncValues = (undefined && undefined.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (undefined && undefined.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (undefined && undefined.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __asyncDelegator = (undefined && undefined.__asyncDelegator) || function (o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
};




function pipeTo(source, ...rest) {
    const [transforms, sink, opt] = pickTransformsAndSink(rest);
    let iterable = source;
    let abortable;
    if ((opt === null || opt === void 0 ? void 0 : opt.propagateDownStreamError) === true) {
        iterable = abortable = makeIterableAbortable(iterable);
    }
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    iterable = pipe(iterable, ...transforms, { propagateDownStreamError: false });
    return sink(iterable).catch((reason) => {
        if (abortable) {
            return abortable.abort(reason).then(() => Promise.reject(reason));
        }
        return Promise.reject(reason);
    });
}
// pick transforms, the sink, and options from the pipeTo() rest parameter
function pickTransformsAndSink(rest) {
    let opt;
    if (typeof rest[rest.length - 1] != "function") {
        opt = rest.pop();
    }
    const sink = rest.pop();
    return [rest, sink, opt];
}
/**
 * Creates an AsyncIterableSink that concatenates all elements from the input.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function sinkAll() {
    return async function (iterable) {
        var _a, e_1, _b, _c;
        const all = [];
        try {
            for (var _d = true, iterable_1 = __asyncValues(iterable), iterable_1_1; iterable_1_1 = await iterable_1.next(), _a = iterable_1_1.done, !_a; _d = true) {
                _c = iterable_1_1.value;
                _d = false;
                const chunk = _c;
                all.push(chunk);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = iterable_1.return)) await _b.call(iterable_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return all;
    };
}
/**
 * Creates an AsyncIterableSink that concatenates all chunks from the input into
 * a single Uint8Array.
 *
 * The iterable raises an error if the more than readMaxBytes are read.
 *
 * An optional length hint can be provided to optimize allocation and validation.
 * If more or less bytes are present in the source that the length hint indicates,
 * and error is raised.
 * If the length hint is larger than readMaxBytes, an error is raised.
 * If the length hint is not a positive integer, it is ignored.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function sinkAllBytes(readMaxBytes, lengthHint) {
    return async function (iterable) {
        return await readAllBytes(iterable, readMaxBytes, lengthHint);
    };
}
function pipe(source, ...rest) {
    var _a;
    return __asyncGenerator(this, arguments, function* pipe_1() {
        const [transforms, opt] = pickTransforms(rest);
        let abortable;
        const sourceIt = source[Symbol.asyncIterator]();
        const cachedSource = {
            [Symbol.asyncIterator]() {
                return sourceIt;
            },
        };
        let iterable = cachedSource;
        if ((opt === null || opt === void 0 ? void 0 : opt.propagateDownStreamError) === true) {
            iterable = abortable = makeIterableAbortable(iterable);
        }
        for (const t of transforms) {
            iterable = t(iterable);
        }
        const it = iterable[Symbol.asyncIterator]();
        try {
            for (;;) {
                const r = yield __await(it.next());
                if (r.done === true) {
                    break;
                }
                if (!abortable) {
                    yield yield __await(r.value);
                    continue;
                }
                try {
                    yield yield __await(r.value);
                }
                catch (e) {
                    yield __await(abortable.abort(e)); // propagate downstream error to the source
                    throw e;
                }
            }
        }
        finally {
            if ((opt === null || opt === void 0 ? void 0 : opt.propagateDownStreamError) === true) {
                // Call return on the source iterable to indicate
                // that we will no longer consume it and it should
                // cleanup any allocated resources.
                (_a = sourceIt.return) === null || _a === void 0 ? void 0 : _a.call(sourceIt).catch(() => {
                    // return returns a promise, which we don't care about.
                    //
                    // Uncaught promises are thrown at sometime/somewhere by the event loop,
                    // this is to ensure error is caught and ignored.
                });
            }
        }
    });
}
function pickTransforms(rest) {
    let opt;
    if (typeof rest[rest.length - 1] != "function") {
        opt = rest.pop();
    }
    return [rest, opt];
}
/**
 * Creates an AsyncIterableTransform that catches any error from the input, and
 * passes it to the given catchError function.
 *
 * The catchError function may return a final value.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformCatch(catchError) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            // we deliberate avoid a for-await loop because we only want to catch upstream
            // errors, not downstream errors (yield).
            const it = iterable[Symbol.asyncIterator]();
            for (;;) {
                let r;
                try {
                    r = yield __await(it.next());
                }
                catch (e) {
                    const caught = yield __await(catchError(e));
                    if (caught !== undefined) {
                        yield yield __await(caught);
                    }
                    break;
                }
                if (r.done === true) {
                    break;
                }
                yield yield __await(r.value);
            }
        });
    };
}
/**
 * Creates an AsyncIterableTransform that catches any error from the input, and
 * passes it to the given function. Unlike transformCatch(), the given function
 * is also called when no error is raised.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformCatchFinally(catchFinally) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            // we deliberate avoid a for-await loop because we only want to catch upstream
            // errors, not downstream errors (yield).
            let err;
            const it = iterable[Symbol.asyncIterator]();
            for (;;) {
                let r;
                try {
                    r = yield __await(it.next());
                }
                catch (e) {
                    err = e;
                    break;
                }
                if (r.done === true) {
                    break;
                }
                yield yield __await(r.value);
            }
            const caught = yield __await(catchFinally(err));
            if (caught !== undefined) {
                yield yield __await(caught);
            }
        });
    };
}
/**
 * Creates an AsyncIterableTransform that appends a value.
 *
 * The element to append is provided by a function. If the function returns
 * undefined, no element is appended.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformAppend(provide) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_2, _b, _c;
            try {
                for (var _d = true, iterable_2 = __asyncValues(iterable), iterable_2_1; iterable_2_1 = yield __await(iterable_2.next()), _a = iterable_2_1.done, !_a; _d = true) {
                    _c = iterable_2_1.value;
                    _d = false;
                    const chunk = _c;
                    yield yield __await(chunk);
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_2.return)) yield __await(_b.call(iterable_2));
                }
                finally { if (e_2) throw e_2.error; }
            }
            const append = yield __await(provide());
            if (append !== undefined) {
                yield yield __await(append);
            }
        });
    };
}
/**
 * Creates an AsyncIterableTransform that prepends an element.
 *
 * The element to prepend is provided by a function. If the function returns
 * undefined, no element is appended.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformPrepend(provide) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_3, _b, _c;
            const prepend = yield __await(provide());
            if (prepend !== undefined) {
                yield yield __await(prepend);
            }
            try {
                for (var _d = true, iterable_3 = __asyncValues(iterable), iterable_3_1; iterable_3_1 = yield __await(iterable_3.next()), _a = iterable_3_1.done, !_a; _d = true) {
                    _c = iterable_3_1.value;
                    _d = false;
                    const chunk = _c;
                    yield yield __await(chunk);
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_3.return)) yield __await(_b.call(iterable_3));
                }
                finally { if (e_3) throw e_3.error; }
            }
        });
    };
}
/**
 * Creates an AsyncIterableTransform that reads all bytes from the input, and
 * concatenates them to a single Uint8Array.
 *
 * The iterable raises an error if the more than readMaxBytes are read.
 *
 * An optional length hint can be provided to optimize allocation and validation.
 * If more or less bytes are present in the source that the length hint indicates,
 * and error is raised.
 * If the length hint is larger than readMaxBytes, an error is raised.
 * If the length hint is not a positive integer, it is ignored.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformReadAllBytes(readMaxBytes, lengthHint) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            yield yield __await(yield __await(readAllBytes(iterable, readMaxBytes, lengthHint)));
        });
    };
}
function transformSerializeEnvelope(serialization, endStreamFlag, endSerialization) {
    if (endStreamFlag === undefined || endSerialization === undefined) {
        return function (iterable) {
            return __asyncGenerator(this, arguments, function* () {
                var _a, e_4, _b, _c;
                try {
                    for (var _d = true, iterable_4 = __asyncValues(iterable), iterable_4_1; iterable_4_1 = yield __await(iterable_4.next()), _a = iterable_4_1.done, !_a; _d = true) {
                        _c = iterable_4_1.value;
                        _d = false;
                        const chunk = _c;
                        const data = serialization.serialize(chunk);
                        yield yield __await({ flags: 0, data });
                    }
                }
                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                finally {
                    try {
                        if (!_d && !_a && (_b = iterable_4.return)) yield __await(_b.call(iterable_4));
                    }
                    finally { if (e_4) throw e_4.error; }
                }
            });
        };
    }
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_5, _b, _c;
            try {
                for (var _d = true, iterable_5 = __asyncValues(iterable), iterable_5_1; iterable_5_1 = yield __await(iterable_5.next()), _a = iterable_5_1.done, !_a; _d = true) {
                    _c = iterable_5_1.value;
                    _d = false;
                    const chunk = _c;
                    let data;
                    let flags = 0;
                    if (chunk.end) {
                        flags = flags | endStreamFlag;
                        data = endSerialization.serialize(chunk.value);
                    }
                    else {
                        data = serialization.serialize(chunk.value);
                    }
                    yield yield __await({ flags, data });
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_5.return)) yield __await(_b.call(iterable_5));
                }
                finally { if (e_5) throw e_5.error; }
            }
        });
    };
}
function transformParseEnvelope(serialization, endStreamFlag, endSerialization) {
    // code path always yields ParsedEnvelopedMessage<T, E>
    if (endSerialization && endStreamFlag !== undefined) {
        return function (iterable) {
            return __asyncGenerator(this, arguments, function* () {
                var _a, e_6, _b, _c;
                try {
                    for (var _d = true, iterable_6 = __asyncValues(iterable), iterable_6_1; iterable_6_1 = yield __await(iterable_6.next()), _a = iterable_6_1.done, !_a; _d = true) {
                        _c = iterable_6_1.value;
                        _d = false;
                        const { flags, data } = _c;
                        if ((flags & endStreamFlag) === endStreamFlag) {
                            yield yield __await({ value: endSerialization.parse(data), end: true });
                        }
                        else {
                            yield yield __await({ value: serialization.parse(data), end: false });
                        }
                    }
                }
                catch (e_6_1) { e_6 = { error: e_6_1 }; }
                finally {
                    try {
                        if (!_d && !_a && (_b = iterable_6.return)) yield __await(_b.call(iterable_6));
                    }
                    finally { if (e_6) throw e_6.error; }
                }
            });
        };
    }
    // code path always yields T
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_7, _b, _c;
            try {
                for (var _d = true, iterable_7 = __asyncValues(iterable), iterable_7_1; iterable_7_1 = yield __await(iterable_7.next()), _a = iterable_7_1.done, !_a; _d = true) {
                    _c = iterable_7_1.value;
                    _d = false;
                    const { flags, data } = _c;
                    if (endStreamFlag !== undefined &&
                        (flags & endStreamFlag) === endStreamFlag) {
                        if (endSerialization === null) {
                            throw new ConnectError("unexpected end flag", Code.InvalidArgument);
                        }
                        // skips end-of-stream envelope
                        continue;
                    }
                    yield yield __await(serialization.parse(data));
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_7.return)) yield __await(_b.call(iterable_7));
                }
                finally { if (e_7) throw e_7.error; }
            }
        });
    };
}
/**
 * Creates an AsyncIterableTransform that takes enveloped messages as a source,
 * and compresses them if they are larger than compressMinBytes.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformCompressEnvelope(compression, compressMinBytes) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_8, _b, _c;
            try {
                for (var _d = true, iterable_8 = __asyncValues(iterable), iterable_8_1; iterable_8_1 = yield __await(iterable_8.next()), _a = iterable_8_1.done, !_a; _d = true) {
                    _c = iterable_8_1.value;
                    _d = false;
                    const env = _c;
                    yield yield __await(yield __await(envelopeCompress(env, compression, compressMinBytes)));
                }
            }
            catch (e_8_1) { e_8 = { error: e_8_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_8.return)) yield __await(_b.call(iterable_8));
                }
                finally { if (e_8) throw e_8.error; }
            }
        });
    };
}
/**
 * Creates an AsyncIterableTransform that takes enveloped messages as a source,
 * and decompresses them using the given compression.
 *
 * The iterable raises an error if the decompressed payload of an enveloped
 * message is larger than readMaxBytes, or if no compression is provided.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformDecompressEnvelope(compression, readMaxBytes) {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_9, _b, _c;
            try {
                for (var _d = true, iterable_9 = __asyncValues(iterable), iterable_9_1; iterable_9_1 = yield __await(iterable_9.next()), _a = iterable_9_1.done, !_a; _d = true) {
                    _c = iterable_9_1.value;
                    _d = false;
                    const env = _c;
                    yield yield __await(yield __await(envelopeDecompress(env, compression, readMaxBytes)));
                }
            }
            catch (e_9_1) { e_9 = { error: e_9_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_9.return)) yield __await(_b.call(iterable_9));
                }
                finally { if (e_9) throw e_9.error; }
            }
        });
    };
}
/**
 * Create an AsyncIterableTransform that takes enveloped messages as a source,
 * and joins them into a stream of raw bytes.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformJoinEnvelopes() {
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_10, _b, _c;
            try {
                for (var _d = true, iterable_10 = __asyncValues(iterable), iterable_10_1; iterable_10_1 = yield __await(iterable_10.next()), _a = iterable_10_1.done, !_a; _d = true) {
                    _c = iterable_10_1.value;
                    _d = false;
                    const { flags, data } = _c;
                    yield yield __await(encodeEnvelope(flags, data));
                }
            }
            catch (e_10_1) { e_10 = { error: e_10_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_10.return)) yield __await(_b.call(iterable_10));
                }
                finally { if (e_10) throw e_10.error; }
            }
        });
    };
}
/**
 * Create an AsyncIterableTransform that takes raw bytes as a source, and splits
 * them into enveloped messages.
 *
 * The iterable raises an error
 * - if the payload of an enveloped message is larger than readMaxBytes,
 * - if the stream ended before an enveloped message fully arrived,
 * - or if the stream ended with extraneous data.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function transformSplitEnvelope(readMaxBytes) {
    // append chunk to buffer, returning updated buffer
    function append(buffer, chunk) {
        const n = new Uint8Array(buffer.byteLength + chunk.byteLength);
        n.set(buffer);
        n.set(chunk, buffer.length);
        return n;
    }
    // tuple 0: envelope, or undefined if incomplete
    // tuple 1: remainder of the buffer
    function shiftEnvelope(buffer, header) {
        if (buffer.byteLength < 5 + header.length) {
            return [undefined, buffer];
        }
        return [
            { flags: header.flags, data: buffer.subarray(5, 5 + header.length) },
            buffer.subarray(5 + header.length),
        ];
    }
    // undefined: header is incomplete
    function peekHeader(buffer) {
        if (buffer.byteLength < 5) {
            return undefined;
        }
        const view = new DataView(buffer.buffer, buffer.byteOffset, buffer.byteLength);
        const length = view.getUint32(1); // 4 bytes message length
        const flags = view.getUint8(0); // first byte is flags
        return { length, flags };
    }
    return function (iterable) {
        return __asyncGenerator(this, arguments, function* () {
            var _a, e_11, _b, _c;
            let buffer = new Uint8Array(0);
            try {
                for (var _d = true, iterable_11 = __asyncValues(iterable), iterable_11_1; iterable_11_1 = yield __await(iterable_11.next()), _a = iterable_11_1.done, !_a; _d = true) {
                    _c = iterable_11_1.value;
                    _d = false;
                    const chunk = _c;
                    buffer = append(buffer, chunk);
                    for (;;) {
                        const header = peekHeader(buffer);
                        if (!header) {
                            break;
                        }
                        assertReadMaxBytes(readMaxBytes, header.length, true);
                        let env;
                        [env, buffer] = shiftEnvelope(buffer, header);
                        if (!env) {
                            break;
                        }
                        yield yield __await(env);
                    }
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = iterable_11.return)) yield __await(_b.call(iterable_11));
                }
                finally { if (e_11) throw e_11.error; }
            }
            if (buffer.byteLength > 0) {
                const header = peekHeader(buffer);
                let message = "protocol error: incomplete envelope";
                if (header) {
                    message = `protocol error: promised ${header.length} bytes in enveloped message, got ${buffer.byteLength - 5} bytes`;
                }
                throw new ConnectError(message, Code.InvalidArgument);
            }
        });
    };
}
/**
 * Reads all bytes from the source, and concatenates them to a single Uint8Array.
 *
 * Raises an error if:
 * - more than readMaxBytes are read
 * - lengthHint is a positive integer, but larger than readMaxBytes
 * - lengthHint is a positive integer, and the source contains more or less bytes
 *   than promised
 *
 * @private Internal code, does not follow semantic versioning.
 */
async function readAllBytes(iterable, readMaxBytes, lengthHint) {
    var _a, e_12, _b, _c, _d, e_13, _e, _f;
    const [ok, hint] = parseLengthHint(lengthHint);
    if (ok) {
        if (hint > readMaxBytes) {
            assertReadMaxBytes(readMaxBytes, hint, true);
        }
        const buffer = new Uint8Array(hint);
        let offset = 0;
        try {
            for (var _g = true, iterable_12 = __asyncValues(iterable), iterable_12_1; iterable_12_1 = await iterable_12.next(), _a = iterable_12_1.done, !_a; _g = true) {
                _c = iterable_12_1.value;
                _g = false;
                const chunk = _c;
                if (offset + chunk.byteLength > hint) {
                    throw new ConnectError(`protocol error: promised ${hint} bytes, received ${offset + chunk.byteLength}`, Code.InvalidArgument);
                }
                buffer.set(chunk, offset);
                offset += chunk.byteLength;
            }
        }
        catch (e_12_1) { e_12 = { error: e_12_1 }; }
        finally {
            try {
                if (!_g && !_a && (_b = iterable_12.return)) await _b.call(iterable_12);
            }
            finally { if (e_12) throw e_12.error; }
        }
        if (offset < hint) {
            throw new ConnectError(`protocol error: promised ${hint} bytes, received ${offset}`, Code.InvalidArgument);
        }
        return buffer;
    }
    const chunks = [];
    let count = 0;
    try {
        for (var _h = true, iterable_13 = __asyncValues(iterable), iterable_13_1; iterable_13_1 = await iterable_13.next(), _d = iterable_13_1.done, !_d; _h = true) {
            _f = iterable_13_1.value;
            _h = false;
            const chunk = _f;
            count += chunk.byteLength;
            assertReadMaxBytes(readMaxBytes, count);
            chunks.push(chunk);
        }
    }
    catch (e_13_1) { e_13 = { error: e_13_1 }; }
    finally {
        try {
            if (!_h && !_d && (_e = iterable_13.return)) await _e.call(iterable_13);
        }
        finally { if (e_13) throw e_13.error; }
    }
    const all = new Uint8Array(count);
    let offset = 0;
    for (let chunk = chunks.shift(); chunk; chunk = chunks.shift()) {
        all.set(chunk, offset);
        offset += chunk.byteLength;
    }
    return all;
}
// parse the lengthHint argument of readAllBytes()
function parseLengthHint(lengthHint) {
    if (lengthHint === undefined || lengthHint === null) {
        return [false, 0];
    }
    const n = typeof lengthHint == "string" ? parseInt(lengthHint, 10) : lengthHint;
    if (!Number.isSafeInteger(n) || n < 0) {
        return [false, n];
    }
    return [true, n];
}
/**
 * Wait for the first element of an iterable without modifying the iterable.
 * This consumes the first element, but pushes it back on the stack.
 *
 * @private Internal code, does not follow semantic versioning.
 */
async function untilFirst(iterable) {
    const it = iterable[Symbol.asyncIterator]();
    let first = await it.next();
    return {
        [Symbol.asyncIterator]() {
            const w = {
                async next() {
                    if (first !== null) {
                        const n = first;
                        first = null;
                        return n;
                    }
                    return await it.next();
                },
            };
            if (it.throw !== undefined) {
                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion -- can't handle mutated object sensibly
                w.throw = (e) => it.throw(e);
            }
            if (it.return !== undefined) {
                // eslint-disable-next-line @typescript-eslint/no-non-null-assertion,@typescript-eslint/no-explicit-any -- can't handle mutated object sensibly
                w.return = (value) => it.return(value);
            }
            return w;
        },
    };
}
/**
 * Wrap the given iterable and return an iterable with an abort() method.
 *
 * This function exists purely for convenience. Where one would typically have
 * to access the iterator directly, advance through all elements, and call
 * AsyncIterator.throw() to notify the upstream iterable, this function allows
 * to use convenient for-await loops and still notify the upstream iterable:
 *
 * ```ts
 * const abortable = makeIterableAbortable(iterable);
 * for await (const ele of abortable) {
 *   await abortable.abort("ERR");
 * }
 * ```
 * There are a couple of limitations of this function:
 * - the given async iterable must implement throw
 * - the async iterable cannot be re-use
 * - if source catches errors and yields values for them, they are ignored, and
 *   the source may still dangle
 *
 * There are four possible ways an async function* can handle yield errors:
 * 1. don't catch errors at all - Abortable.abort() will resolve "rethrown"
 * 2. catch errors and rethrow - Abortable.abort() will resolve "rethrown"
 * 3. catch errors and return - Abortable.abort() will resolve "completed"
 * 4. catch errors and yield a value - Abortable.abort() will resolve "caught"
 *
 * Note that catching errors and yielding a value is problematic, and it should
 * be documented that this may leave the source in a dangling state.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function makeIterableAbortable(iterable) {
    const innerCandidate = iterable[Symbol.asyncIterator]();
    if (innerCandidate.throw === undefined) {
        throw new Error("AsyncIterable does not implement throw");
    }
    const inner = innerCandidate;
    let aborted;
    let resultPromise;
    let it = {
        next() {
            resultPromise = inner.next().finally(() => {
                resultPromise = undefined;
            });
            return resultPromise;
        },
        throw(e) {
            return inner.throw(e);
        },
    };
    if (innerCandidate.return !== undefined) {
        it = Object.assign(Object.assign({}, it), { return(value) {
                return inner.return(value);
            } });
    }
    let used = false;
    return {
        abort(reason) {
            if (aborted) {
                return aborted.state;
            }
            const f = () => {
                return inner.throw(reason).then((r) => (r.done === true ? "completed" : "caught"), () => "rethrown");
            };
            if (resultPromise) {
                aborted = { reason, state: resultPromise.then(f, f) };
                return aborted.state;
            }
            aborted = { reason, state: f() };
            return aborted.state;
        },
        [Symbol.asyncIterator]() {
            if (used) {
                throw new Error("AsyncIterable cannot be re-used");
            }
            used = true;
            return it;
        },
    };
}
/**
 * Create a new WritableIterable.
 */
function createWritableIterable() {
    // We start with two queues to capture the read and write attempts.
    //
    // The writes and reads each check of their counterpart is
    // already available and either interact/add themselves to the queue.
    const readQueue = [];
    const writeQueue = [];
    let err = undefined;
    let nextResolve;
    let nextReject;
    let nextPromise = new Promise((resolve, reject) => {
        nextResolve = resolve;
        nextReject = reject;
    });
    let closed = false;
    // drain the readQueue in case of error/writer is closed by sending a
    // done result.
    function drain() {
        for (const next of readQueue.splice(0, readQueue.length)) {
            next({ done: true, value: undefined });
        }
    }
    return {
        close() {
            closed = true;
            drain();
        },
        async write(payload) {
            if (closed) {
                throw err !== null && err !== void 0 ? err : new Error("cannot write, WritableIterable already closed");
            }
            const read = readQueue.shift();
            if (read === undefined) {
                // We didn't find a pending read so we add the payload to the write queue.
                writeQueue.push(payload);
            }
            else {
                // We found a pending read so we respond with the payload.
                read({ done: false, value: payload });
                if (readQueue.length > 0) {
                    // If there are more in the read queue we can mark the write as complete.
                    // as the error reporting is not guaranteed to be sequential and therefore cannot
                    // to linked to a specific write.
                    return;
                }
            }
            // We await the next call for as many times as there are items in the queue + 1
            //
            // If there are no items in the write queue that means write happened and we just have
            // to wait for one more call likewise if we are the nth write in the queue we
            // have to wait for n writes to complete and one more.
            const limit = writeQueue.length + 1;
            for (let i = 0; i < limit; i++) {
                await nextPromise;
            }
        },
        [Symbol.asyncIterator]() {
            return {
                next() {
                    // Resolve the nextPromise to indicate
                    // pending writes that a read attempt has been made
                    // after their write.
                    //
                    // We also need to reset the promise for future writes.
                    nextResolve();
                    nextPromise = new Promise((resolve, reject) => {
                        nextResolve = resolve;
                        nextReject = reject;
                    });
                    const write = writeQueue.shift();
                    if (write !== undefined) {
                        // We found a pending write so response with the payload.
                        return Promise.resolve({ done: false, value: write });
                    }
                    if (closed) {
                        return Promise.resolve({ done: true, value: undefined });
                    }
                    // We return a promise immediately that is either resolved/rejected
                    // as writes happen.
                    let readResolve;
                    const readPromise = new Promise((resolve) => (readResolve = resolve));
                    readQueue.push(readResolve); // eslint-disable-line @typescript-eslint/no-non-null-assertion
                    return readPromise;
                },
                throw(throwErr) {
                    err = throwErr;
                    closed = true;
                    writeQueue.splice(0, writeQueue.length);
                    nextPromise.catch(() => {
                        // To make sure that the nextPromise is always resolved.
                    });
                    // This will reject all pending writes.
                    nextReject(err);
                    drain();
                    return Promise.resolve({ done: true, value: undefined });
                },
                return() {
                    closed = true;
                    writeQueue.splice(0, writeQueue.length);
                    // Resolve once for the write awaiting confirmation.
                    nextResolve();
                    // Reject all future writes.
                    nextPromise = Promise.reject(new Error("cannot write, consumer called return"));
                    nextPromise.catch(() => {
                        // To make sure that the nextPromise is always resolved.
                    });
                    drain();
                    return Promise.resolve({ done: true, value: undefined });
                },
            };
        },
    };
}
/**
 * Create an asynchronous iterable from an array.
 *
 * @private Internal code, does not follow semantic versioning.
 */
// eslint-disable-next-line @typescript-eslint/require-await
function createAsyncIterable(items) {
    return __asyncGenerator(this, arguments, function* createAsyncIterable_1() {
        yield __await(yield* __asyncDelegator(__asyncValues(items)));
    });
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/promise-client.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var promise_client_asyncValues = (undefined && undefined.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var promise_client_await = (undefined && undefined.__await) || function (v) { return this instanceof promise_client_await ? (this.v = v, this) : new promise_client_await(v); }
var promise_client_asyncDelegator = (undefined && undefined.__asyncDelegator) || function (o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: promise_client_await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
};
var promise_client_asyncGenerator = (undefined && undefined.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof promise_client_await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};





/**
 * Create a PromiseClient for the given service, invoking RPCs through the
 * given transport.
 */
function createPromiseClient(service, transport) {
    return makeAnyClient(service, (method) => {
        switch (method.kind) {
            case service_type/* MethodKind */.t.Unary:
                return createUnaryFn(transport, service, method);
            case service_type/* MethodKind */.t.ServerStreaming:
                return createServerStreamingFn(transport, service, method);
            case service_type/* MethodKind */.t.ClientStreaming:
                return createClientStreamingFn(transport, service, method);
            case service_type/* MethodKind */.t.BiDiStreaming:
                return createBiDiStreamingFn(transport, service, method);
            default:
                return null;
        }
    });
}
function createUnaryFn(transport, service, method) {
    return async function (input, options) {
        var _a, _b;
        const response = await transport.unary(service, method, options === null || options === void 0 ? void 0 : options.signal, options === null || options === void 0 ? void 0 : options.timeoutMs, options === null || options === void 0 ? void 0 : options.headers, input, options === null || options === void 0 ? void 0 : options.contextValues);
        (_a = options === null || options === void 0 ? void 0 : options.onHeader) === null || _a === void 0 ? void 0 : _a.call(options, response.header);
        (_b = options === null || options === void 0 ? void 0 : options.onTrailer) === null || _b === void 0 ? void 0 : _b.call(options, response.trailer);
        return response.message;
    };
}
function createServerStreamingFn(transport, service, method) {
    return function (input, options) {
        return handleStreamResponse(transport.stream(service, method, options === null || options === void 0 ? void 0 : options.signal, options === null || options === void 0 ? void 0 : options.timeoutMs, options === null || options === void 0 ? void 0 : options.headers, createAsyncIterable([input]), options === null || options === void 0 ? void 0 : options.contextValues), options);
    };
}
function createClientStreamingFn(transport, service, method) {
    return async function (request, options) {
        var _a, e_1, _b, _c;
        var _d, _e;
        const response = await transport.stream(service, method, options === null || options === void 0 ? void 0 : options.signal, options === null || options === void 0 ? void 0 : options.timeoutMs, options === null || options === void 0 ? void 0 : options.headers, request, options === null || options === void 0 ? void 0 : options.contextValues);
        (_d = options === null || options === void 0 ? void 0 : options.onHeader) === null || _d === void 0 ? void 0 : _d.call(options, response.header);
        let singleMessage;
        try {
            for (var _f = true, _g = promise_client_asyncValues(response.message), _h; _h = await _g.next(), _a = _h.done, !_a; _f = true) {
                _c = _h.value;
                _f = false;
                const message = _c;
                singleMessage = message;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_f && !_a && (_b = _g.return)) await _b.call(_g);
            }
            finally { if (e_1) throw e_1.error; }
        }
        if (!singleMessage) {
            throw new connect_error_ConnectError("protocol error: missing response message", code_Code.Internal);
        }
        (_e = options === null || options === void 0 ? void 0 : options.onTrailer) === null || _e === void 0 ? void 0 : _e.call(options, response.trailer);
        return singleMessage;
    };
}
function createBiDiStreamingFn(transport, service, method) {
    return function (request, options) {
        return handleStreamResponse(transport.stream(service, method, options === null || options === void 0 ? void 0 : options.signal, options === null || options === void 0 ? void 0 : options.timeoutMs, options === null || options === void 0 ? void 0 : options.headers, request, options === null || options === void 0 ? void 0 : options.contextValues), options);
    };
}
function handleStreamResponse(stream, options) {
    const it = (function () {
        var _a, _b;
        return promise_client_asyncGenerator(this, arguments, function* () {
            const response = yield promise_client_await(stream);
            (_a = options === null || options === void 0 ? void 0 : options.onHeader) === null || _a === void 0 ? void 0 : _a.call(options, response.header);
            yield promise_client_await(yield* promise_client_asyncDelegator(promise_client_asyncValues(response.message)));
            (_b = options === null || options === void 0 ? void 0 : options.onTrailer) === null || _b === void 0 ? void 0 : _b.call(options, response.trailer);
        });
    })()[Symbol.asyncIterator]();
    // Create a new iterable to omit throw/return.
    return {
        [Symbol.asyncIterator]: () => ({
            next: () => it.next(),
        }),
    };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/context-values.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * createContextValues creates a new ContextValues.
 */
function createContextValues() {
    return {
        get(key) {
            return key.id in this ? this[key.id] : key.defaultValue;
        },
        set(key, value) {
            this[key.id] = value;
            return this;
        },
        delete(key) {
            delete this[key.id];
            return this;
        },
    };
}
/**
 * createContextKey creates a new ContextKey.
 */
function createContextKey(defaultValue, options) {
    return { id: Symbol(options === null || options === void 0 ? void 0 : options.description), defaultValue };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/serialization.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Sets default JSON serialization options for connect-es.
 *
 * With standard protobuf JSON serialization, unknown JSON fields are
 * rejected by default. In connect-es, unknown JSON fields are ignored
 * by default.
 */
function getJsonOptions(options) {
    var _a;
    const o = Object.assign({}, options);
    (_a = o.ignoreUnknownFields) !== null && _a !== void 0 ? _a : (o.ignoreUnknownFields = true);
    return o;
}
/**
 * Create an object that provides convenient access to request and response
 * message serialization for a given method.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function createMethodSerializationLookup(method, binaryOptions, jsonOptions, limitOptions) {
    const inputBinary = limitSerialization(createBinarySerialization(method.I, binaryOptions), limitOptions);
    const inputJson = limitSerialization(createJsonSerialization(method.I, jsonOptions), limitOptions);
    const outputBinary = limitSerialization(createBinarySerialization(method.O, binaryOptions), limitOptions);
    const outputJson = limitSerialization(createJsonSerialization(method.O, jsonOptions), limitOptions);
    return {
        getI(useBinaryFormat) {
            return useBinaryFormat ? inputBinary : inputJson;
        },
        getO(useBinaryFormat) {
            return useBinaryFormat ? outputBinary : outputJson;
        },
    };
}
/**
 * Returns functions to normalize and serialize the input message
 * of an RPC, and to parse the output message of an RPC.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function createClientMethodSerializers(method, useBinaryFormat, jsonOptions, binaryOptions) {
    const input = useBinaryFormat
        ? createBinarySerialization(method.I, binaryOptions)
        : createJsonSerialization(method.I, jsonOptions);
    const output = useBinaryFormat
        ? createBinarySerialization(method.O, binaryOptions)
        : createJsonSerialization(method.O, jsonOptions);
    return { parse: output.parse, serialize: input.serialize };
}
/**
 * Apply I/O limits to a Serialization object, returning a new object.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function limitSerialization(serialization, limitOptions) {
    return {
        serialize(data) {
            const bytes = serialization.serialize(data);
            assertWriteMaxBytes(limitOptions.writeMaxBytes, bytes.byteLength);
            return bytes;
        },
        parse(data) {
            assertReadMaxBytes(limitOptions.readMaxBytes, data.byteLength, true);
            return serialization.parse(data);
        },
    };
}
/**
 * Creates a Serialization object for serializing the given protobuf message
 * with the protobuf binary format.
 */
function createBinarySerialization(messageType, options) {
    return {
        parse(data) {
            try {
                return messageType.fromBinary(data, options);
            }
            catch (e) {
                const m = e instanceof Error ? e.message : String(e);
                throw new connect_error_ConnectError(`parse binary: ${m}`, code_Code.InvalidArgument);
            }
        },
        serialize(data) {
            try {
                return data.toBinary(options);
            }
            catch (e) {
                const m = e instanceof Error ? e.message : String(e);
                throw new connect_error_ConnectError(`serialize binary: ${m}`, code_Code.Internal);
            }
        },
    };
}
/**
 * Creates a Serialization object for serializing the given protobuf message
 * with the protobuf canonical JSON encoding.
 *
 * By default, unknown fields are ignored.
 */
function createJsonSerialization(messageType, options) {
    var _a, _b;
    const textEncoder = (_a = options === null || options === void 0 ? void 0 : options.textEncoder) !== null && _a !== void 0 ? _a : new TextEncoder();
    const textDecoder = (_b = options === null || options === void 0 ? void 0 : options.textDecoder) !== null && _b !== void 0 ? _b : new TextDecoder();
    const o = getJsonOptions(options);
    return {
        parse(data) {
            try {
                const json = textDecoder.decode(data);
                return messageType.fromJsonString(json, o);
            }
            catch (e) {
                throw connect_error_ConnectError.from(e, code_Code.InvalidArgument);
            }
        },
        serialize(data) {
            try {
                const json = data.toJsonString(o);
                return textEncoder.encode(json);
            }
            catch (e) {
                throw connect_error_ConnectError.from(e, code_Code.Internal);
            }
        },
    };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/signals.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Create an AbortController that is automatically aborted if one of the given
 * signals is aborted.
 *
 * For convenience, the linked AbortSignals can be undefined.
 *
 * If the controller or any of the signals is aborted, all event listeners are
 * removed.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function createLinkedAbortController(...signals) {
    const controller = new AbortController();
    const sa = signals
        .filter((s) => s !== undefined)
        .concat(controller.signal);
    for (const signal of sa) {
        if (signal.aborted) {
            onAbort.apply(signal);
            break;
        }
        signal.addEventListener("abort", onAbort);
    }
    function onAbort() {
        if (!controller.signal.aborted) {
            controller.abort(getAbortSignalReason(this));
        }
        for (const signal of sa) {
            signal.removeEventListener("abort", onAbort);
        }
    }
    return controller;
}
/**
 * Create a deadline signal. The returned object contains an AbortSignal, but
 * also a cleanup function to stop the timer, which must be called once the
 * calling code is no longer interested in the signal.
 *
 * Ideally, we would simply use AbortSignal.timeout(), but it is not widely
 * available yet.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function createDeadlineSignal(timeoutMs) {
    const controller = new AbortController();
    const listener = () => {
        controller.abort(new connect_error_ConnectError("the operation timed out", code_Code.DeadlineExceeded));
    };
    let timeoutId;
    if (timeoutMs !== undefined) {
        if (timeoutMs <= 0)
            listener();
        else
            timeoutId = setTimeout(listener, timeoutMs);
    }
    return {
        signal: controller.signal,
        cleanup: () => clearTimeout(timeoutId),
    };
}
/**
 * Returns the reason why an AbortSignal was aborted. Returns undefined if the
 * signal has not been aborted.
 *
 * The property AbortSignal.reason is not widely available. This function
 * returns an AbortError if the signal is aborted, but reason is undefined.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function getAbortSignalReason(signal) {
    if (!signal.aborted) {
        return undefined;
    }
    if (signal.reason !== undefined) {
        return signal.reason;
    }
    // AbortSignal.reason is available in Node.js v16, v18, and later,
    // and in all browsers since early 2022.
    const e = new Error("This operation was aborted");
    e.name = "AbortError";
    return e;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/normalize.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 *  Takes a partial protobuf messages of the
 *  specified message type as input, and returns full instances.
 */
function normalize(type, message) {
    return message instanceof esm_message/* Message */.v ? message : new type(message);
}
/**
 * Takes an AsyncIterable of partial protobuf messages of the
 * specified message type as input, and yields full instances.
 */
function normalizeIterable(messageType, input) {
    function transform(result) {
        if (result.done === true) {
            return result;
        }
        return {
            done: result.done,
            value: normalize(messageType, result.value),
        };
    }
    return {
        [Symbol.asyncIterator]() {
            const it = input[Symbol.asyncIterator]();
            const res = {
                next: () => it.next().then(transform),
            };
            if (it.throw !== undefined) {
                res.throw = (e) => it.throw(e).then(transform); // eslint-disable-line @typescript-eslint/no-non-null-assertion
            }
            if (it.return !== undefined) {
                res.return = (v) => it.return(v).then(transform); // eslint-disable-line @typescript-eslint/no-non-null-assertion
            }
            return res;
        },
    };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/run-call.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Runs a unary method with the given interceptors. Note that this function
 * is only used when implementing a Transport.
 */
function runUnaryCall(opt) {
    const next = applyInterceptors(opt.next, opt.interceptors);
    const [signal, abort, done] = setupSignal(opt);
    const req = Object.assign(Object.assign({}, opt.req), { message: normalize(opt.req.method.I, opt.req.message), signal });
    return next(req).then((res) => {
        done();
        return res;
    }, abort);
}
/**
 * Runs a server-streaming method with the given interceptors. Note that this
 * function is only used when implementing a Transport.
 */
function runStreamingCall(opt) {
    const next = applyInterceptors(opt.next, opt.interceptors);
    const [signal, abort, done] = setupSignal(opt);
    const req = Object.assign(Object.assign({}, opt.req), { message: normalizeIterable(opt.req.method.I, opt.req.message), signal });
    let doneCalled = false;
    // Call return on the request iterable to indicate
    // that we will no longer consume it and it should
    // cleanup any allocated resources.
    signal.addEventListener("abort", function () {
        var _a, _b;
        const it = opt.req.message[Symbol.asyncIterator]();
        // If the signal is aborted due to an error, we want to throw
        // the error to the request iterator.
        if (!doneCalled) {
            (_a = it.throw) === null || _a === void 0 ? void 0 : _a.call(it, this.reason).catch(() => {
                // throw returns a promise, which we don't care about.
                //
                // Uncaught promises are thrown at sometime/somewhere by the event loop,
                // this is to ensure error is caught and ignored.
            });
        }
        (_b = it.return) === null || _b === void 0 ? void 0 : _b.call(it).catch(() => {
            // return returns a promise, which we don't care about.
            //
            // Uncaught promises are thrown at sometime/somewhere by the event loop,
            // this is to ensure error is caught and ignored.
        });
    });
    return next(req).then((res) => {
        return Object.assign(Object.assign({}, res), { message: {
                [Symbol.asyncIterator]() {
                    const it = res.message[Symbol.asyncIterator]();
                    return {
                        next() {
                            return it.next().then((r) => {
                                if (r.done == true) {
                                    doneCalled = true;
                                    done();
                                }
                                return r;
                            }, abort);
                        },
                        // We deliberately omit throw/return.
                    };
                },
            } });
    }, abort);
}
/**
 * Create an AbortSignal for Transport implementations. The signal is available
 * in UnaryRequest and StreamingRequest, and is triggered when the call is
 * aborted (via a timeout or explicit cancellation), errored (e.g. when reading
 * an error from the server from the wire), or finished successfully.
 *
 * Transport implementations can pass the signal to HTTP clients to ensure that
 * there are no unused connections leak.
 *
 * Returns a tuple:
 * [0]: The signal, which is also aborted if the optional deadline is reached.
 * [1]: Function to call if the Transport encountered an error.
 * [2]: Function to call if the Transport finished without an error.
 */
function setupSignal(opt) {
    const { signal, cleanup } = createDeadlineSignal(opt.timeoutMs);
    const controller = createLinkedAbortController(opt.signal, signal);
    return [
        controller.signal,
        function abort(reason) {
            // We peek at the deadline signal because fetch() will throw an error on
            // abort that discards the signal reason.
            const e = connect_error_ConnectError.from(signal.aborted ? getAbortSignalReason(signal) : reason);
            controller.abort(e);
            cleanup();
            return Promise.reject(e);
        },
        function done() {
            cleanup();
            controller.abort();
        },
    ];
}
/**
 * applyInterceptors takes the given UnaryFn or ServerStreamingFn, and wraps
 * it with each of the given interceptors, returning a new UnaryFn or
 * ServerStreamingFn.
 */
function applyInterceptors(next, interceptors) {
    var _a;
    return ((_a = interceptors === null || interceptors === void 0 ? void 0 : interceptors.concat().reverse().reduce(
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
    (n, i) => i(n), next)) !== null && _a !== void 0 ? _a : next);
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/create-method-url.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Create a URL for the given RPC. This simply adds the qualified
 * service name, a slash, and the method name to the path of the given
 * baseUrl.
 *
 * For example, the baseUri https://example.com and method "Say" from
 * the service example.ElizaService results in:
 * https://example.com/example.ElizaService/Say
 *
 * This format is used by the protocols Connect, gRPC and Twirp.
 *
 * Note that this function also accepts a protocol-relative baseUrl.
 * If given an empty string or "/" as a baseUrl, it returns just the
 * path.
 */
function createMethodUrl(baseUrl, service, method) {
    const s = typeof service == "string" ? service : service.typeName;
    const m = typeof method == "string" ? method : method.name;
    return baseUrl.toString().replace(/\/?$/, `/${s}/${m}`);
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol/envelope.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Create a WHATWG ReadableStream of enveloped messages from a ReadableStream
 * of bytes.
 *
 * Ideally, this would simply be a TransformStream, but ReadableStream.pipeThrough
 * does not have the necessary availability at this time.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function createEnvelopeReadableStream(stream) {
    let reader;
    let buffer = new Uint8Array(0);
    function append(chunk) {
        const n = new Uint8Array(buffer.length + chunk.length);
        n.set(buffer);
        n.set(chunk, buffer.length);
        buffer = n;
    }
    return new ReadableStream({
        start() {
            reader = stream.getReader();
        },
        async pull(controller) {
            let header = undefined;
            for (;;) {
                if (header === undefined && buffer.byteLength >= 5) {
                    let length = 0;
                    for (let i = 1; i < 5; i++) {
                        length = (length << 8) + buffer[i];
                    }
                    header = { flags: buffer[0], length };
                }
                if (header !== undefined && buffer.byteLength >= header.length + 5) {
                    break;
                }
                const result = await reader.read();
                if (result.done) {
                    break;
                }
                append(result.value);
            }
            if (header === undefined) {
                if (buffer.byteLength == 0) {
                    controller.close();
                    return;
                }
                controller.error(new connect_error_ConnectError("premature end of stream", code_Code.DataLoss));
                return;
            }
            const data = buffer.subarray(5, 5 + header.length);
            buffer = buffer.subarray(5 + header.length);
            controller.enqueue({
                flags: header.flags,
                data,
            });
        },
    });
}
/**
 * Compress an EnvelopedMessage.
 *
 * Raises Internal if an enveloped message is already compressed.
 *
 * @private Internal code, does not follow semantic versioning.
 */
async function envelope_envelopeCompress(envelope, compression, compressMinBytes) {
    let { flags, data } = envelope;
    if ((flags & compressedFlag) === compressedFlag) {
        throw new ConnectError("invalid envelope, already compressed", Code.Internal);
    }
    if (compression && data.byteLength >= compressMinBytes) {
        data = await compression.compress(data);
        flags = flags | compressedFlag;
    }
    return { data, flags };
}
/**
 * Decompress an EnvelopedMessage.
 *
 * Raises InvalidArgument if an envelope is compressed, but compression is null.
 *
 * Relies on the provided Compression to raise ResourceExhausted if the
 * *decompressed* message size is larger than readMaxBytes. If the envelope is
 * not compressed, readMaxBytes is not honored.
 *
 * @private Internal code, does not follow semantic versioning.
 */
async function envelope_envelopeDecompress(envelope, compression, readMaxBytes) {
    let { flags, data } = envelope;
    if ((flags & compressedFlag) === compressedFlag) {
        if (!compression) {
            throw new ConnectError("received compressed envelope, but do not know how to decompress", Code.InvalidArgument);
        }
        data = await compression.decompress(data, readMaxBytes);
        flags = flags ^ compressedFlag;
    }
    return { data, flags };
}
/**
 * Encode a single enveloped message.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function envelope_encodeEnvelope(flags, data) {
    const bytes = new Uint8Array(data.length + 5);
    bytes.set(data, 5);
    const v = new DataView(bytes.buffer, bytes.byteOffset, bytes.byteLength);
    v.setUint8(0, flags); // first byte is flags
    v.setUint32(1, data.length); // 4 bytes message length
    return bytes;
}
/**
 * Encode a set of enveloped messages.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function encodeEnvelopes(...envelopes) {
    const len = envelopes.reduce((previousValue, currentValue) => previousValue + currentValue.data.length + 5, 0);
    const bytes = new Uint8Array(len);
    const v = new DataView(bytes.buffer);
    let offset = 0;
    for (const e of envelopes) {
        v.setUint8(offset, e.flags); // first byte is flags
        v.setUint32(offset + 1, e.data.length); // 4 bytes message length
        bytes.set(e.data, offset + 5);
        offset += e.data.length + 5;
    }
    return bytes;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc/headers.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * @private Internal code, does not follow semantic versioning.
 */
const headerContentType = "Content-Type";
const headers_headerEncoding = "Grpc-Encoding";
const headers_headerAcceptEncoding = "Grpc-Accept-Encoding";
const headerTimeout = "Grpc-Timeout";
const headers_headerGrpcStatus = "Grpc-Status";
const headers_headerGrpcMessage = "Grpc-Message";
const headers_headerStatusDetailsBin = "Grpc-Status-Details-Bin";
const headerMessageType = "Grpc-Message-Type";
const headerUserAgent = "User-Agent";

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc-web/headers.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * @private Internal code, does not follow semantic versioning.
 */

/**
 * gRPC-web does not use the standard header User-Agent.
 *
 * @private Internal code, does not follow semantic versioning.
 */
const headerXUserAgent = "X-User-Agent";
/**
 * The canonical grpc/grpc-web JavaScript implementation sets
 * this request header with value "1".
 * Some servers may rely on the header to identify gRPC-web
 * requests. For example the proxy by improbable:
 * https://github.com/improbable-eng/grpc-web/blob/53aaf4cdc0fede7103c1b06f0cfc560c003a5c41/go/grpcweb/wrapper.go#L231
 *
 * @private Internal code, does not follow semantic versioning.
 */
const headerXGrpcWeb = "X-Grpc-Web";

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc-web/content-type.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Regular Expression that matches any valid gRPC-web Content-Type header value.
 * Note that this includes application/grpc-web-text with the additional base64
 * encoding.
 *
 * @private Internal code, does not follow semantic versioning.
 */
const contentTypeRegExp = /^application\/grpc-web(-text)?(?:\+(?:(json)(?:; ?charset=utf-?8)?|proto))?$/i;
const contentTypeProto = "application/grpc-web+proto";
const contentTypeJson = "application/grpc-web+json";
/**
 * Parse a gRPC-web Content-Type header value.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function parseContentType(contentType) {
    const match = contentType === null || contentType === void 0 ? void 0 : contentType.match(contentTypeRegExp);
    if (!match) {
        return undefined;
    }
    const text = !!match[1];
    const binary = !match[2];
    return { text, binary };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc-web/request-header.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


/**
 * Creates headers for a gRPC-web request.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function requestHeader(useBinaryFormat, timeoutMs, userProvidedHeaders, setUserAgent) {
    const result = new Headers(userProvidedHeaders !== null && userProvidedHeaders !== void 0 ? userProvidedHeaders : {});
    // Note that we do not support the grpc-web-text format.
    // https://github.com/grpc/grpc/blob/master/doc/PROTOCOL-WEB.md#protocol-differences-vs-grpc-over-http2
    result.set(headerContentType, useBinaryFormat ? contentTypeProto : contentTypeJson);
    result.set(headerXGrpcWeb, "1");
    // Note that we do not strictly comply with gRPC user agents.
    // We use "connect-es/1.2.3" where gRPC would use "grpc-es/1.2.3".
    // See https://github.com/grpc/grpc/blob/c462bb8d485fc1434ecfae438823ca8d14cf3154/doc/PROTOCOL-HTTP2.md#user-agents
    result.set(headerXUserAgent, "connect-es/1.2.0");
    if (setUserAgent) {
        result.set(headerUserAgent, "connect-es/1.2.0");
    }
    if (timeoutMs !== undefined) {
        result.set(headerTimeout, `${timeoutMs}m`);
    }
    return result;
}
/**
 * Creates headers for a gRPC-web request with compression.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function requestHeaderWithCompression(useBinaryFormat, timeoutMs, userProvidedHeaders, acceptCompression, sendCompression, setUserAgent) {
    const result = requestHeader(useBinaryFormat, timeoutMs, userProvidedHeaders, setUserAgent);
    if (sendCompression != null) {
        result.set(headerEncoding, sendCompression.name);
    }
    if (acceptCompression.length > 0) {
        result.set(headerAcceptEncoding, acceptCompression.map((c) => c.name).join(","));
    }
    return result;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc/http-status.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Determine the gRPC-web error code for the given HTTP status code.
 * See https://github.com/grpc/grpc/blob/master/doc/http-grpc-status-mapping.md.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function codeFromHttpStatus(httpStatus) {
    switch (httpStatus) {
        case 400: // Bad Request
            return code_Code.Internal;
        case 401: // Unauthorized
            return code_Code.Unauthenticated;
        case 403: // Forbidden
            return code_Code.PermissionDenied;
        case 404: // Not Found
            return code_Code.Unimplemented;
        case 429: // Too Many Requests
            return code_Code.Unavailable;
        case 502: // Bad Gateway
            return code_Code.Unavailable;
        case 503: // Service Unavailable
            return code_Code.Unavailable;
        case 504: // Gateway Timeout
            return code_Code.Unavailable;
        default:
            // 200 is UNKNOWN because there should be a grpc-status in case of truly OK response.
            return code_Code.Unknown;
    }
}

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto3.js + 2 modules
var proto3 = __webpack_require__(850);
// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/google/protobuf/any_pb.js
var any_pb = __webpack_require__(733);
;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc/gen/status_pb.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * The `Status` type defines a logical error model that is suitable for different
 * programming environments, including REST APIs and RPC APIs. It is used by
 * [gRPC](https://github.com/grpc). The error model is designed to be:
 *
 * - Simple to use and understand for most users
 * - Flexible enough to meet unexpected needs
 *
 * # Overview
 *
 * The `Status` message contains three pieces of data: error code, error message,
 * and error details. The error code should be an enum value of
 * [google.rpc.Code][google.rpc.Code], but it may accept additional error codes if needed.  The
 * error message should be a developer-facing English message that helps
 * developers *understand* and *resolve* the error. If a localized user-facing
 * error message is needed, put the localized message in the error details or
 * localize it in the client. The optional error details may contain arbitrary
 * information about the error. There is a predefined set of error detail types
 * in the package `google.rpc` which can be used for common error conditions.
 *
 * # Language mapping
 *
 * The `Status` message is the logical representation of the error model, but it
 * is not necessarily the actual wire format. When the `Status` message is
 * exposed in different client libraries and different wire protocols, it can be
 * mapped differently. For example, it will likely be mapped to some exceptions
 * in Java, but more likely mapped to some error codes in C.
 *
 * # Other uses
 *
 * The error model and the `Status` message can be used in a variety of
 * environments, either with or without APIs, to provide a
 * consistent developer experience across different environments.
 *
 * Example uses of this error model include:
 *
 * - Partial errors. If a service needs to return partial errors to the client,
 *     it may embed the `Status` in the normal response to indicate the partial
 *     errors.
 *
 * - Workflow errors. A typical workflow has multiple steps. Each step may
 *     have a `Status` message for error reporting purpose.
 *
 * - Batch operations. If a client uses batch request and batch response, the
 *     `Status` message should be used directly inside batch response, one for
 *     each error sub-response.
 *
 * - Asynchronous operations. If an API call embeds asynchronous operation
 *     results in its response, the status of those operations should be
 *     represented directly using the `Status` message.
 *
 * - Logging. If some API errors are stored in logs, the message `Status` could
 *     be used directly after any stripping needed for security/privacy reasons.
 *
 * @generated from message google.rpc.Status
 */
class status_pb_Status extends esm_message/* Message */.v {
    constructor(data) {
        super();
        /**
         * The status code, which should be an enum value of [google.rpc.Code][google.rpc.Code].
         *
         * @generated from field: int32 code = 1;
         */
        this.code = 0;
        /**
         * A developer-facing error message, which should be in English. Any
         * user-facing error message should be localized and sent in the
         * [google.rpc.Status.details][google.rpc.Status.details] field, or localized by the client.
         *
         * @generated from field: string message = 2;
         */
        this.message = "";
        /**
         * A list of messages that carry the error details.  There will be a
         * common set of message types for APIs to use.
         *
         * @generated from field: repeated google.protobuf.Any details = 3;
         */
        this.details = [];
        proto3/* proto3 */.w.util.initPartial(data, this);
    }
    static fromBinary(bytes, options) {
        return new status_pb_Status().fromBinary(bytes, options);
    }
    static fromJson(jsonValue, options) {
        return new status_pb_Status().fromJson(jsonValue, options);
    }
    static fromJsonString(jsonString, options) {
        return new status_pb_Status().fromJsonString(jsonString, options);
    }
    static equals(a, b) {
        return proto3/* proto3 */.w.util.equals(status_pb_Status, a, b);
    }
}
status_pb_Status.runtime = proto3/* proto3 */.w;
status_pb_Status.typeName = "google.rpc.Status";
status_pb_Status.fields = proto3/* proto3 */.w.util.newFieldList(() => [
    { no: 1, name: "code", kind: "scalar", T: 5 /* ScalarType.INT32 */ },
    { no: 2, name: "message", kind: "scalar", T: 9 /* ScalarType.STRING */ },
    { no: 3, name: "details", kind: "message", T: any_pb/* Any */.I, repeated: true },
]);

// EXTERNAL MODULE: ./node_modules/@bufbuild/protobuf/dist/esm/proto-base64.js
var proto_base64 = __webpack_require__(236);
;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/http-headers.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



/**
 * Encode a single binary header value according to the Connect
 * and gRPC specifications.
 *
 * This function accepts raw binary data from a buffer, a string
 * with UTF-8 text, or a protobuf message. It encodes the input
 * with unpadded base64 and returns a string that can be used for
 * a header whose name ends with `-bin`.
 */
function http_headers_encodeBinaryHeader(value) {
    let bytes;
    if (value instanceof Message) {
        bytes = value.toBinary();
    }
    else if (typeof value == "string") {
        bytes = new TextEncoder().encode(value);
    }
    else {
        bytes = value instanceof Uint8Array ? value : new Uint8Array(value);
    }
    return protoBase64.enc(bytes).replace(/=+$/, "");
}
function decodeBinaryHeader(value, type, options) {
    try {
        const bytes = proto_base64/* protoBase64 */.W.dec(value);
        if (type) {
            return type.fromBinary(bytes, options);
        }
        return bytes;
    }
    catch (e) {
        throw connect_error_ConnectError.from(e, code_Code.DataLoss);
    }
}
/**
 * Merge two or more Headers objects by appending all fields from
 * all inputs to a new Headers object.
 */
function appendHeaders(...headers) {
    const h = new Headers();
    for (const e of headers) {
        e.forEach((value, key) => {
            h.append(key, value);
        });
    }
    return h;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc/trailer-status.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.






/**
 * The value of the Grpc-Status header or trailer in case of success.
 * Used by the gRPC and gRPC-web protocols.
 *
 * @private Internal code, does not follow semantic versioning.
 */
const grpcStatusOk = "0";
/**
 * Sets the fields "grpc-status" and "grpc-message" in the given
 * Headers object.
 * If an error is given and contains error details, the function
 * will also set the field "grpc-status-details-bin" with an encoded
 * google.rpc.Status message including the error details.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function setTrailerStatus(target, error) {
    if (error) {
        target.set(headerGrpcStatus, error.code.toString(10));
        target.set(headerGrpcMessage, encodeURIComponent(error.rawMessage));
        if (error.details.length > 0) {
            const status = new Status({
                code: error.code,
                message: error.rawMessage,
                details: error.details.map((value) => value instanceof Message
                    ? Any.pack(value)
                    : new Any({
                        typeUrl: `type.googleapis.com/${value.type}`,
                        value: value.value,
                    })),
            });
            target.set(headerStatusDetailsBin, encodeBinaryHeader(status));
        }
    }
    else {
        target.set(headerGrpcStatus, grpcStatusOk.toString());
    }
    return target;
}
/**
 * Find an error status in the given Headers object, which can be either
 * a trailer, or a header (as allowed for so-called trailers-only responses).
 * The field "grpc-status-details-bin" is inspected, and if not present,
 * the fields "grpc-status" and "grpc-message" are used.
 * Returns an error only if the gRPC status code is > 0.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function findTrailerError(headerOrTrailer) {
    // TODO
    // let code: Code;
    // let message: string = "";
    var _a;
    // Prefer the protobuf-encoded data to the grpc-status header.
    const statusBytes = headerOrTrailer.get(headers_headerStatusDetailsBin);
    if (statusBytes != null) {
        const status = decodeBinaryHeader(statusBytes, status_pb_Status);
        if (status.code == 0) {
            return undefined;
        }
        const error = new connect_error_ConnectError(status.message, status.code, headerOrTrailer);
        error.details = status.details.map((any) => ({
            type: any.typeUrl.substring(any.typeUrl.lastIndexOf("/") + 1),
            value: any.value,
        }));
        return error;
    }
    const grpcStatus = headerOrTrailer.get(headers_headerGrpcStatus);
    if (grpcStatus != null) {
        if (grpcStatus === grpcStatusOk) {
            return undefined;
        }
        const code = parseInt(grpcStatus, 10);
        if (code in code_Code) {
            return new connect_error_ConnectError(decodeURIComponent((_a = headerOrTrailer.get(headers_headerGrpcMessage)) !== null && _a !== void 0 ? _a : ""), code, headerOrTrailer);
        }
        return new connect_error_ConnectError(`invalid grpc-status: ${grpcStatus}`, code_Code.Internal, headerOrTrailer);
    }
    return undefined;
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc-web/validate-response.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.





/**
 * Validates response status and header for the gRPC-web protocol.
 *
 * Throws a ConnectError if the header contains an error status,
 * or if the HTTP status indicates an error.
 *
 * Returns an object that indicates whether a gRPC status was found
 * in the response header. In this case, clients can not expect a
 * trailer.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function validateResponse(status, headers) {
    var _a;
    // For compatibility with the `grpc-web` package, we treat all HTTP status
    // codes in the 200 range as valid, not just HTTP 200.
    if (status >= 200 && status < 300) {
        const err = findTrailerError(headers);
        if (err) {
            throw err;
        }
        return { foundStatus: headers.has(headers_headerGrpcStatus) };
    }
    throw new connect_error_ConnectError(decodeURIComponent((_a = headers.get(headers_headerGrpcMessage)) !== null && _a !== void 0 ? _a : `HTTP ${status}`), codeFromHttpStatus(status), headers);
}
/**
 * Validates response status and header for the gRPC-web protocol.
 * This function is identical to validateResponse(), but also verifies
 * that a given encoding header is acceptable.
 *
 * Returns an object with the response compression, and a boolean
 * indicating whether a gRPC status was found in the response header
 * (in this case, clients can not expect a trailer).
 *
 * @private Internal code, does not follow semantic versioning.
 */
function validateResponseWithCompression(acceptCompression, status, headers) {
    const { foundStatus } = validateResponse(status, headers);
    let compression;
    const encoding = headers.get(headerEncoding);
    if (encoding !== null && encoding.toLowerCase() !== "identity") {
        compression = acceptCompression.find((c) => c.name === encoding);
        if (!compression) {
            throw new ConnectError(`unsupported response encoding "${encoding}"`, Code.InvalidArgument, headers);
        }
    }
    return {
        foundStatus,
        compression,
    };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc-web/trailer.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * trailerFlag indicates that the data in a EnvelopedMessage
 * is a set of trailers of the gRPC-web protocol.
 *
 * @private Internal code, does not follow semantic versioning.
 */
const trailerFlag = 0b10000000;
/**
 * Parse a gRPC-web trailer, a set of header fields separated by CRLF.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function trailerParse(data) {
    const headers = new Headers();
    const lines = new TextDecoder().decode(data).split("\r\n");
    for (const line of lines) {
        if (line === "") {
            continue;
        }
        const i = line.indexOf(":");
        if (i > 0) {
            const name = line.substring(0, i).trim();
            const value = line.substring(i + 1).trim();
            headers.append(name, value);
        }
    }
    return headers;
}
/**
 * Serialize a Headers object as a gRPC-web trailer.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function trailerSerialize(trailer) {
    const lines = [];
    trailer.forEach((value, key) => {
        lines.push(`${key}: ${value}\r\n`);
    });
    return new TextEncoder().encode(lines.join(""));
}
/**
 * Create a Serialization object that serializes a gRPC-web trailer, a Headers
 * object that is serialized as a set of header fields, separated by CRLF.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function createTrailerSerialization() {
    return {
        serialize: trailerSerialize,
        parse: trailerParse,
    };
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect/dist/esm/protocol-grpc/validate-trailer.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * Validates a trailer for the gRPC and the gRPC-web protocol.
 * Throws a ConnectError if the trailer contains an error status.
 *
 * @private Internal code, does not follow semantic versioning.
 */
function validateTrailer(trailer, header) {
    const err = findTrailerError(trailer);
    if (err) {
        header.forEach((value, key) => {
            err.metadata.append(key, value);
        });
        throw err;
    }
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect-web/dist/esm/assert-fetch-api.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * Asserts that the fetch API is available.
 */
function assertFetchApi() {
    try {
        new Headers();
    }
    catch (_) {
        throw new Error("connect-web requires the fetch API. Are you running on an old version of Node.js? Node.js is not supported in Connect for Web - please stay tuned for Connect for Node.");
    }
}

;// CONCATENATED MODULE: ./node_modules/@connectrpc/connect-web/dist/esm/grpc-web-transport.js
// Copyright 2021-2023 The Connect Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
var grpc_web_transport_await = (undefined && undefined.__await) || function (v) { return this instanceof grpc_web_transport_await ? (this.v = v, this) : new grpc_web_transport_await(v); }
var grpc_web_transport_asyncGenerator = (undefined && undefined.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof grpc_web_transport_await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};





/**
 * Create a Transport for the gRPC-web protocol. The protocol encodes
 * trailers in the response body and makes unary and server-streaming
 * methods available to web browsers. It uses the fetch API to make
 * HTTP requests.
 *
 * Note that this transport does not implement the grpc-web-text format,
 * which applies base64 encoding to the request and response bodies to
 * support reading streaming responses from an XMLHttpRequest.
 */
function createGrpcWebTransport(options) {
    var _a;
    assertFetchApi();
    const useBinaryFormat = (_a = options.useBinaryFormat) !== null && _a !== void 0 ? _a : true;
    return {
        async unary(service, method, signal, timeoutMs, header, message, contextValues) {
            var _a;
            const { serialize, parse } = createClientMethodSerializers(method, useBinaryFormat, options.jsonOptions, options.binaryOptions);
            timeoutMs =
                timeoutMs === undefined
                    ? options.defaultTimeoutMs
                    : timeoutMs <= 0
                        ? undefined
                        : timeoutMs;
            return await runUnaryCall({
                interceptors: options.interceptors,
                signal,
                timeoutMs,
                req: {
                    stream: false,
                    service,
                    method,
                    url: createMethodUrl(options.baseUrl, service, method),
                    init: {
                        method: "POST",
                        credentials: (_a = options.credentials) !== null && _a !== void 0 ? _a : "same-origin",
                        redirect: "error",
                        mode: "cors",
                    },
                    header: requestHeader(useBinaryFormat, timeoutMs, header, false),
                    contextValues: contextValues !== null && contextValues !== void 0 ? contextValues : createContextValues(),
                    message,
                },
                next: async (req) => {
                    var _a;
                    const fetch = (_a = options.fetch) !== null && _a !== void 0 ? _a : globalThis.fetch;
                    const response = await fetch(req.url, Object.assign(Object.assign({}, req.init), { headers: req.header, signal: req.signal, body: envelope_encodeEnvelope(0, serialize(req.message)) }));
                    validateResponse(response.status, response.headers);
                    if (!response.body) {
                        throw "missing response body";
                    }
                    const reader = createEnvelopeReadableStream(response.body).getReader();
                    let trailer;
                    let message;
                    for (;;) {
                        const r = await reader.read();
                        if (r.done) {
                            break;
                        }
                        const { flags, data } = r.value;
                        if (flags === trailerFlag) {
                            if (trailer !== undefined) {
                                throw "extra trailer";
                            }
                            // Unary responses require exactly one response message, but in
                            // case of an error, it is perfectly valid to have a response body
                            // that only contains error trailers.
                            trailer = trailerParse(data);
                            continue;
                        }
                        if (message !== undefined) {
                            throw "extra message";
                        }
                        message = parse(data);
                    }
                    if (trailer === undefined) {
                        throw "missing trailer";
                    }
                    validateTrailer(trailer, response.headers);
                    if (message === undefined) {
                        throw "missing message";
                    }
                    return {
                        stream: false,
                        header: response.headers,
                        message,
                        trailer,
                    };
                },
            });
        },
        async stream(service, method, signal, timeoutMs, header, input, contextValues) {
            var _a;
            const { serialize, parse } = createClientMethodSerializers(method, useBinaryFormat, options.jsonOptions, options.binaryOptions);
            function parseResponseBody(body, foundStatus, trailerTarget, header) {
                return grpc_web_transport_asyncGenerator(this, arguments, function* parseResponseBody_1() {
                    const reader = createEnvelopeReadableStream(body).getReader();
                    if (foundStatus) {
                        // A grpc-status: 0 response header was present. This is a "trailers-only"
                        // response (a response without a body and no trailers).
                        //
                        // The spec seems to disallow a trailers-only response for status 0 - we are
                        // lenient and only verify that the body is empty.
                        //
                        // > [...] Trailers-Only is permitted for calls that produce an immediate error.
                        // See https://github.com/grpc/grpc/blob/master/doc/PROTOCOL-HTTP2.md
                        if (!(yield grpc_web_transport_await(reader.read())).done) {
                            throw "extra data for trailers-only";
                        }
                        return yield grpc_web_transport_await(void 0);
                    }
                    let trailerReceived = false;
                    for (;;) {
                        const result = yield grpc_web_transport_await(reader.read());
                        if (result.done) {
                            break;
                        }
                        const { flags, data } = result.value;
                        if ((flags & trailerFlag) === trailerFlag) {
                            if (trailerReceived) {
                                throw "extra trailer";
                            }
                            trailerReceived = true;
                            const trailer = trailerParse(data);
                            validateTrailer(trailer, header);
                            trailer.forEach((value, key) => trailerTarget.set(key, value));
                            continue;
                        }
                        if (trailerReceived) {
                            throw "extra message";
                        }
                        yield yield grpc_web_transport_await(parse(data));
                        continue;
                    }
                    if (!trailerReceived) {
                        throw "missing trailer";
                    }
                });
            }
            async function createRequestBody(input) {
                if (method.kind != service_type/* MethodKind */.t.ServerStreaming) {
                    throw "The fetch API does not support streaming request bodies";
                }
                const r = await input[Symbol.asyncIterator]().next();
                if (r.done == true) {
                    throw "missing request message";
                }
                return envelope_encodeEnvelope(0, serialize(r.value));
            }
            timeoutMs =
                timeoutMs === undefined
                    ? options.defaultTimeoutMs
                    : timeoutMs <= 0
                        ? undefined
                        : timeoutMs;
            return runStreamingCall({
                interceptors: options.interceptors,
                signal,
                timeoutMs,
                req: {
                    stream: true,
                    service,
                    method,
                    url: createMethodUrl(options.baseUrl, service, method),
                    init: {
                        method: "POST",
                        credentials: (_a = options.credentials) !== null && _a !== void 0 ? _a : "same-origin",
                        redirect: "error",
                        mode: "cors",
                    },
                    header: requestHeader(useBinaryFormat, timeoutMs, header, false),
                    contextValues: contextValues !== null && contextValues !== void 0 ? contextValues : createContextValues(),
                    message: input,
                },
                next: async (req) => {
                    var _a;
                    const fetch = (_a = options.fetch) !== null && _a !== void 0 ? _a : globalThis.fetch;
                    const fRes = await fetch(req.url, Object.assign(Object.assign({}, req.init), { headers: req.header, signal: req.signal, body: await createRequestBody(req.message) }));
                    const { foundStatus } = validateResponse(fRes.status, fRes.headers);
                    if (!fRes.body) {
                        throw "missing response body";
                    }
                    const trailer = new Headers();
                    const res = Object.assign(Object.assign({}, req), { header: fRes.headers, trailer, message: parseResponseBody(fRes.body, foundStatus, trailer, fRes.headers) });
                    return res;
                },
            });
        },
    };
}

// EXTERNAL MODULE: ./src/api/yorkie/v1/yorkie_connect.js
var yorkie_connect = __webpack_require__(295);
// EXTERNAL MODULE: ./src/api/yorkie/v1/resources_pb.js
var resources_pb = __webpack_require__(646);
;// CONCATENATED MODULE: ./node_modules/long/index.js
/**
 * @license
 * Copyright 2009 The Closure Library Authors
 * Copyright 2020 Daniel Wirtz / The long.js Authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * SPDX-License-Identifier: Apache-2.0
 */

// WebAssembly optimizations to do native i64 multiplication and divide
var wasm = null;
try {
  wasm = new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([
    0, 97, 115, 109, 1, 0, 0, 0, 1, 13, 2, 96, 0, 1, 127, 96, 4, 127, 127, 127, 127, 1, 127, 3, 7, 6, 0, 1, 1, 1, 1, 1, 6, 6, 1, 127, 1, 65, 0, 11, 7, 50, 6, 3, 109, 117, 108, 0, 1, 5, 100, 105, 118, 95, 115, 0, 2, 5, 100, 105, 118, 95, 117, 0, 3, 5, 114, 101, 109, 95, 115, 0, 4, 5, 114, 101, 109, 95, 117, 0, 5, 8, 103, 101, 116, 95, 104, 105, 103, 104, 0, 0, 10, 191, 1, 6, 4, 0, 35, 0, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 126, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 127, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 128, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 129, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11, 36, 1, 1, 126, 32, 0, 173, 32, 1, 173, 66, 32, 134, 132, 32, 2, 173, 32, 3, 173, 66, 32, 134, 132, 130, 34, 4, 66, 32, 135, 167, 36, 0, 32, 4, 167, 11
  ])), {}).exports;
} catch (e) {
  // no wasm support :(
}

/**
 * Constructs a 64 bit two's-complement integer, given its low and high 32 bit values as *signed* integers.
 *  See the from* functions below for more convenient ways of constructing Longs.
 * @exports Long
 * @class A Long class for representing a 64 bit two's-complement integer value.
 * @param {number} low The low (signed) 32 bits of the long
 * @param {number} high The high (signed) 32 bits of the long
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @constructor
 */
function Long(low, high, unsigned) {

  /**
   * The low 32 bits as a signed value.
   * @type {number}
   */
  this.low = low | 0;

  /**
   * The high 32 bits as a signed value.
   * @type {number}
   */
  this.high = high | 0;

  /**
   * Whether unsigned or not.
   * @type {boolean}
   */
  this.unsigned = !!unsigned;
}

// The internal representation of a long is the two given signed, 32-bit values.
// We use 32-bit pieces because these are the size of integers on which
// Javascript performs bit-operations.  For operations like addition and
// multiplication, we split each number into 16 bit pieces, which can easily be
// multiplied within Javascript's floating-point representation without overflow
// or change in sign.
//
// In the algorithms below, we frequently reduce the negative case to the
// positive case by negating the input(s) and then post-processing the result.
// Note that we must ALWAYS check specially whether those values are MIN_VALUE
// (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
// a positive number, it overflows back into a negative).  Not handling this
// case would often result in infinite recursion.
//
// Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the from*
// methods on which they depend.

/**
 * An indicator used to reliably determine if an object is a Long or not.
 * @type {boolean}
 * @const
 * @private
 */
Long.prototype.__isLong__;

Object.defineProperty(Long.prototype, "__isLong__", { value: true });

/**
 * @function
 * @param {*} obj Object
 * @returns {boolean}
 * @inner
 */
function isLong(obj) {
  return (obj && obj["__isLong__"]) === true;
}

/**
 * @function
 * @param {*} value number
 * @returns {number}
 * @inner
 */
function ctz32(value) {
  var c = Math.clz32(value & -value);
  return value ? 31 - c : c;
}

/**
 * Tests if the specified object is a Long.
 * @function
 * @param {*} obj Object
 * @returns {boolean}
 */
Long.isLong = isLong;

/**
 * A cache of the Long representations of small integer values.
 * @type {!Object}
 * @inner
 */
var INT_CACHE = {};

/**
 * A cache of the Long representations of small unsigned integer values.
 * @type {!Object}
 * @inner
 */
var UINT_CACHE = {};

/**
 * @param {number} value
 * @param {boolean=} unsigned
 * @returns {!Long}
 * @inner
 */
function fromInt(value, unsigned) {
  var obj, cachedObj, cache;
  if (unsigned) {
    value >>>= 0;
    if (cache = (0 <= value && value < 256)) {
      cachedObj = UINT_CACHE[value];
      if (cachedObj)
        return cachedObj;
    }
    obj = fromBits(value, 0, true);
    if (cache)
      UINT_CACHE[value] = obj;
    return obj;
  } else {
    value |= 0;
    if (cache = (-128 <= value && value < 128)) {
      cachedObj = INT_CACHE[value];
      if (cachedObj)
        return cachedObj;
    }
    obj = fromBits(value, value < 0 ? -1 : 0, false);
    if (cache)
      INT_CACHE[value] = obj;
    return obj;
  }
}

/**
 * Returns a Long representing the given 32 bit integer value.
 * @function
 * @param {number} value The 32 bit integer in question
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @returns {!Long} The corresponding Long value
 */
Long.fromInt = fromInt;

/**
 * @param {number} value
 * @param {boolean=} unsigned
 * @returns {!Long}
 * @inner
 */
function fromNumber(value, unsigned) {
  if (isNaN(value))
    return unsigned ? UZERO : ZERO;
  if (unsigned) {
    if (value < 0)
      return UZERO;
    if (value >= TWO_PWR_64_DBL)
      return MAX_UNSIGNED_VALUE;
  } else {
    if (value <= -TWO_PWR_63_DBL)
      return MIN_VALUE;
    if (value + 1 >= TWO_PWR_63_DBL)
      return MAX_VALUE;
  }
  if (value < 0)
    return fromNumber(-value, unsigned).neg();
  return fromBits((value % TWO_PWR_32_DBL) | 0, (value / TWO_PWR_32_DBL) | 0, unsigned);
}

/**
 * Returns a Long representing the given value, provided that it is a finite number. Otherwise, zero is returned.
 * @function
 * @param {number} value The number in question
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @returns {!Long} The corresponding Long value
 */
Long.fromNumber = fromNumber;

/**
 * @param {number} lowBits
 * @param {number} highBits
 * @param {boolean=} unsigned
 * @returns {!Long}
 * @inner
 */
function fromBits(lowBits, highBits, unsigned) {
  return new Long(lowBits, highBits, unsigned);
}

/**
 * Returns a Long representing the 64 bit integer that comes by concatenating the given low and high bits. Each is
 *  assumed to use 32 bits.
 * @function
 * @param {number} lowBits The low 32 bits
 * @param {number} highBits The high 32 bits
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @returns {!Long} The corresponding Long value
 */
Long.fromBits = fromBits;

/**
 * @function
 * @param {number} base
 * @param {number} exponent
 * @returns {number}
 * @inner
 */
var pow_dbl = Math.pow; // Used 4 times (4*8 to 15+4)

/**
 * @param {string} str
 * @param {(boolean|number)=} unsigned
 * @param {number=} radix
 * @returns {!Long}
 * @inner
 */
function fromString(str, unsigned, radix) {
  if (str.length === 0)
    throw Error('empty string');
  if (typeof unsigned === 'number') {
    // For goog.math.long compatibility
    radix = unsigned;
    unsigned = false;
  } else {
    unsigned = !!unsigned;
  }
  if (str === "NaN" || str === "Infinity" || str === "+Infinity" || str === "-Infinity")
    return unsigned ? UZERO : ZERO;
  radix = radix || 10;
  if (radix < 2 || 36 < radix)
    throw RangeError('radix');

  var p;
  if ((p = str.indexOf('-')) > 0)
    throw Error('interior hyphen');
  else if (p === 0) {
    return fromString(str.substring(1), unsigned, radix).neg();
  }

  // Do several (8) digits each time through the loop, so as to
  // minimize the calls to the very expensive emulated div.
  var radixToPower = fromNumber(pow_dbl(radix, 8));

  var result = ZERO;
  for (var i = 0; i < str.length; i += 8) {
    var size = Math.min(8, str.length - i),
      value = parseInt(str.substring(i, i + size), radix);
    if (size < 8) {
      var power = fromNumber(pow_dbl(radix, size));
      result = result.mul(power).add(fromNumber(value));
    } else {
      result = result.mul(radixToPower);
      result = result.add(fromNumber(value));
    }
  }
  result.unsigned = unsigned;
  return result;
}

/**
 * Returns a Long representation of the given string, written using the specified radix.
 * @function
 * @param {string} str The textual representation of the Long
 * @param {(boolean|number)=} unsigned Whether unsigned or not, defaults to signed
 * @param {number=} radix The radix in which the text is written (2-36), defaults to 10
 * @returns {!Long} The corresponding Long value
 */
Long.fromString = fromString;

/**
 * @function
 * @param {!Long|number|string|!{low: number, high: number, unsigned: boolean}} val
 * @param {boolean=} unsigned
 * @returns {!Long}
 * @inner
 */
function fromValue(val, unsigned) {
  if (typeof val === 'number')
    return fromNumber(val, unsigned);
  if (typeof val === 'string')
    return fromString(val, unsigned);
  // Throws for non-objects, converts non-instanceof Long:
  return fromBits(val.low, val.high, typeof unsigned === 'boolean' ? unsigned : val.unsigned);
}

/**
 * Converts the specified value to a Long using the appropriate from* function for its type.
 * @function
 * @param {!Long|number|string|!{low: number, high: number, unsigned: boolean}} val Value
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @returns {!Long}
 */
Long.fromValue = fromValue;

// NOTE: the compiler should inline these constant values below and then remove these variables, so there should be
// no runtime penalty for these.

/**
 * @type {number}
 * @const
 * @inner
 */
var TWO_PWR_16_DBL = 1 << 16;

/**
 * @type {number}
 * @const
 * @inner
 */
var TWO_PWR_24_DBL = 1 << 24;

/**
 * @type {number}
 * @const
 * @inner
 */
var TWO_PWR_32_DBL = TWO_PWR_16_DBL * TWO_PWR_16_DBL;

/**
 * @type {number}
 * @const
 * @inner
 */
var TWO_PWR_64_DBL = TWO_PWR_32_DBL * TWO_PWR_32_DBL;

/**
 * @type {number}
 * @const
 * @inner
 */
var TWO_PWR_63_DBL = TWO_PWR_64_DBL / 2;

/**
 * @type {!Long}
 * @const
 * @inner
 */
var TWO_PWR_24 = fromInt(TWO_PWR_24_DBL);

/**
 * @type {!Long}
 * @inner
 */
var ZERO = fromInt(0);

/**
 * Signed zero.
 * @type {!Long}
 */
Long.ZERO = ZERO;

/**
 * @type {!Long}
 * @inner
 */
var UZERO = fromInt(0, true);

/**
 * Unsigned zero.
 * @type {!Long}
 */
Long.UZERO = UZERO;

/**
 * @type {!Long}
 * @inner
 */
var ONE = fromInt(1);

/**
 * Signed one.
 * @type {!Long}
 */
Long.ONE = ONE;

/**
 * @type {!Long}
 * @inner
 */
var UONE = fromInt(1, true);

/**
 * Unsigned one.
 * @type {!Long}
 */
Long.UONE = UONE;

/**
 * @type {!Long}
 * @inner
 */
var NEG_ONE = fromInt(-1);

/**
 * Signed negative one.
 * @type {!Long}
 */
Long.NEG_ONE = NEG_ONE;

/**
 * @type {!Long}
 * @inner
 */
var MAX_VALUE = fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0, false);

/**
 * Maximum signed value.
 * @type {!Long}
 */
Long.MAX_VALUE = MAX_VALUE;

/**
 * @type {!Long}
 * @inner
 */
var MAX_UNSIGNED_VALUE = fromBits(0xFFFFFFFF | 0, 0xFFFFFFFF | 0, true);

/**
 * Maximum unsigned value.
 * @type {!Long}
 */
Long.MAX_UNSIGNED_VALUE = MAX_UNSIGNED_VALUE;

/**
 * @type {!Long}
 * @inner
 */
var MIN_VALUE = fromBits(0, 0x80000000 | 0, false);

/**
 * Minimum signed value.
 * @type {!Long}
 */
Long.MIN_VALUE = MIN_VALUE;

/**
 * @alias Long.prototype
 * @inner
 */
var LongPrototype = Long.prototype;

/**
 * Converts the Long to a 32 bit integer, assuming it is a 32 bit integer.
 * @this {!Long}
 * @returns {number}
 */
LongPrototype.toInt = function toInt() {
  return this.unsigned ? this.low >>> 0 : this.low;
};

/**
 * Converts the Long to a the nearest floating-point representation of this value (double, 53 bit mantissa).
 * @this {!Long}
 * @returns {number}
 */
LongPrototype.toNumber = function toNumber() {
  if (this.unsigned)
    return ((this.high >>> 0) * TWO_PWR_32_DBL) + (this.low >>> 0);
  return this.high * TWO_PWR_32_DBL + (this.low >>> 0);
};

/**
 * Converts the Long to a string written in the specified radix.
 * @this {!Long}
 * @param {number=} radix Radix (2-36), defaults to 10
 * @returns {string}
 * @override
 * @throws {RangeError} If `radix` is out of range
 */
LongPrototype.toString = function toString(radix) {
  radix = radix || 10;
  if (radix < 2 || 36 < radix)
    throw RangeError('radix');
  if (this.isZero())
    return '0';
  if (this.isNegative()) { // Unsigned Longs are never negative
    if (this.eq(MIN_VALUE)) {
      // We need to change the Long value before it can be negated, so we remove
      // the bottom-most digit in this base and then recurse to do the rest.
      var radixLong = fromNumber(radix),
        div = this.div(radixLong),
        rem1 = div.mul(radixLong).sub(this);
      return div.toString(radix) + rem1.toInt().toString(radix);
    } else
      return '-' + this.neg().toString(radix);
  }

  // Do several (6) digits each time through the loop, so as to
  // minimize the calls to the very expensive emulated div.
  var radixToPower = fromNumber(pow_dbl(radix, 6), this.unsigned),
    rem = this;
  var result = '';
  while (true) {
    var remDiv = rem.div(radixToPower),
      intval = rem.sub(remDiv.mul(radixToPower)).toInt() >>> 0,
      digits = intval.toString(radix);
    rem = remDiv;
    if (rem.isZero())
      return digits + result;
    else {
      while (digits.length < 6)
        digits = '0' + digits;
      result = '' + digits + result;
    }
  }
};

/**
 * Gets the high 32 bits as a signed integer.
 * @this {!Long}
 * @returns {number} Signed high bits
 */
LongPrototype.getHighBits = function getHighBits() {
  return this.high;
};

/**
 * Gets the high 32 bits as an unsigned integer.
 * @this {!Long}
 * @returns {number} Unsigned high bits
 */
LongPrototype.getHighBitsUnsigned = function getHighBitsUnsigned() {
  return this.high >>> 0;
};

/**
 * Gets the low 32 bits as a signed integer.
 * @this {!Long}
 * @returns {number} Signed low bits
 */
LongPrototype.getLowBits = function getLowBits() {
  return this.low;
};

/**
 * Gets the low 32 bits as an unsigned integer.
 * @this {!Long}
 * @returns {number} Unsigned low bits
 */
LongPrototype.getLowBitsUnsigned = function getLowBitsUnsigned() {
  return this.low >>> 0;
};

/**
 * Gets the number of bits needed to represent the absolute value of this Long.
 * @this {!Long}
 * @returns {number}
 */
LongPrototype.getNumBitsAbs = function getNumBitsAbs() {
  if (this.isNegative()) // Unsigned Longs are never negative
    return this.eq(MIN_VALUE) ? 64 : this.neg().getNumBitsAbs();
  var val = this.high != 0 ? this.high : this.low;
  for (var bit = 31; bit > 0; bit--)
    if ((val & (1 << bit)) != 0)
      break;
  return this.high != 0 ? bit + 33 : bit + 1;
};

/**
 * Tests if this Long's value equals zero.
 * @this {!Long}
 * @returns {boolean}
 */
LongPrototype.isZero = function isZero() {
  return this.high === 0 && this.low === 0;
};

/**
 * Tests if this Long's value equals zero. This is an alias of {@link Long#isZero}.
 * @returns {boolean}
 */
LongPrototype.eqz = LongPrototype.isZero;

/**
 * Tests if this Long's value is negative.
 * @this {!Long}
 * @returns {boolean}
 */
LongPrototype.isNegative = function isNegative() {
  return !this.unsigned && this.high < 0;
};

/**
 * Tests if this Long's value is positive or zero.
 * @this {!Long}
 * @returns {boolean}
 */
LongPrototype.isPositive = function isPositive() {
  return this.unsigned || this.high >= 0;
};

/**
 * Tests if this Long's value is odd.
 * @this {!Long}
 * @returns {boolean}
 */
LongPrototype.isOdd = function isOdd() {
  return (this.low & 1) === 1;
};

/**
 * Tests if this Long's value is even.
 * @this {!Long}
 * @returns {boolean}
 */
LongPrototype.isEven = function isEven() {
  return (this.low & 1) === 0;
};

/**
 * Tests if this Long's value equals the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.equals = function equals(other) {
  if (!isLong(other))
    other = fromValue(other);
  if (this.unsigned !== other.unsigned && (this.high >>> 31) === 1 && (other.high >>> 31) === 1)
    return false;
  return this.high === other.high && this.low === other.low;
};

/**
 * Tests if this Long's value equals the specified's. This is an alias of {@link Long#equals}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.eq = LongPrototype.equals;

/**
 * Tests if this Long's value differs from the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.notEquals = function notEquals(other) {
  return !this.eq(/* validates */ other);
};

/**
 * Tests if this Long's value differs from the specified's. This is an alias of {@link Long#notEquals}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.neq = LongPrototype.notEquals;

/**
 * Tests if this Long's value differs from the specified's. This is an alias of {@link Long#notEquals}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.ne = LongPrototype.notEquals;

/**
 * Tests if this Long's value is less than the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.lessThan = function lessThan(other) {
  return this.comp(/* validates */ other) < 0;
};

/**
 * Tests if this Long's value is less than the specified's. This is an alias of {@link Long#lessThan}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.lt = LongPrototype.lessThan;

/**
 * Tests if this Long's value is less than or equal the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.lessThanOrEqual = function lessThanOrEqual(other) {
  return this.comp(/* validates */ other) <= 0;
};

/**
 * Tests if this Long's value is less than or equal the specified's. This is an alias of {@link Long#lessThanOrEqual}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.lte = LongPrototype.lessThanOrEqual;

/**
 * Tests if this Long's value is less than or equal the specified's. This is an alias of {@link Long#lessThanOrEqual}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.le = LongPrototype.lessThanOrEqual;

/**
 * Tests if this Long's value is greater than the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.greaterThan = function greaterThan(other) {
  return this.comp(/* validates */ other) > 0;
};

/**
 * Tests if this Long's value is greater than the specified's. This is an alias of {@link Long#greaterThan}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.gt = LongPrototype.greaterThan;

/**
 * Tests if this Long's value is greater than or equal the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.greaterThanOrEqual = function greaterThanOrEqual(other) {
  return this.comp(/* validates */ other) >= 0;
};

/**
 * Tests if this Long's value is greater than or equal the specified's. This is an alias of {@link Long#greaterThanOrEqual}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.gte = LongPrototype.greaterThanOrEqual;

/**
 * Tests if this Long's value is greater than or equal the specified's. This is an alias of {@link Long#greaterThanOrEqual}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {boolean}
 */
LongPrototype.ge = LongPrototype.greaterThanOrEqual;

/**
 * Compares this Long's value with the specified's.
 * @this {!Long}
 * @param {!Long|number|string} other Other value
 * @returns {number} 0 if they are the same, 1 if the this is greater and -1
 *  if the given one is greater
 */
LongPrototype.compare = function compare(other) {
  if (!isLong(other))
    other = fromValue(other);
  if (this.eq(other))
    return 0;
  var thisNeg = this.isNegative(),
    otherNeg = other.isNegative();
  if (thisNeg && !otherNeg)
    return -1;
  if (!thisNeg && otherNeg)
    return 1;
  // At this point the sign bits are the same
  if (!this.unsigned)
    return this.sub(other).isNegative() ? -1 : 1;
  // Both are positive if at least one is unsigned
  return (other.high >>> 0) > (this.high >>> 0) || (other.high === this.high && (other.low >>> 0) > (this.low >>> 0)) ? -1 : 1;
};

/**
 * Compares this Long's value with the specified's. This is an alias of {@link Long#compare}.
 * @function
 * @param {!Long|number|string} other Other value
 * @returns {number} 0 if they are the same, 1 if the this is greater and -1
 *  if the given one is greater
 */
LongPrototype.comp = LongPrototype.compare;

/**
 * Negates this Long's value.
 * @this {!Long}
 * @returns {!Long} Negated Long
 */
LongPrototype.negate = function negate() {
  if (!this.unsigned && this.eq(MIN_VALUE))
    return MIN_VALUE;
  return this.not().add(ONE);
};

/**
 * Negates this Long's value. This is an alias of {@link Long#negate}.
 * @function
 * @returns {!Long} Negated Long
 */
LongPrototype.neg = LongPrototype.negate;

/**
 * Returns the sum of this and the specified Long.
 * @this {!Long}
 * @param {!Long|number|string} addend Addend
 * @returns {!Long} Sum
 */
LongPrototype.add = function add(addend) {
  if (!isLong(addend))
    addend = fromValue(addend);

  // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

  var a48 = this.high >>> 16;
  var a32 = this.high & 0xFFFF;
  var a16 = this.low >>> 16;
  var a00 = this.low & 0xFFFF;

  var b48 = addend.high >>> 16;
  var b32 = addend.high & 0xFFFF;
  var b16 = addend.low >>> 16;
  var b00 = addend.low & 0xFFFF;

  var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
  c00 += a00 + b00;
  c16 += c00 >>> 16;
  c00 &= 0xFFFF;
  c16 += a16 + b16;
  c32 += c16 >>> 16;
  c16 &= 0xFFFF;
  c32 += a32 + b32;
  c48 += c32 >>> 16;
  c32 &= 0xFFFF;
  c48 += a48 + b48;
  c48 &= 0xFFFF;
  return fromBits((c16 << 16) | c00, (c48 << 16) | c32, this.unsigned);
};

/**
 * Returns the difference of this and the specified Long.
 * @this {!Long}
 * @param {!Long|number|string} subtrahend Subtrahend
 * @returns {!Long} Difference
 */
LongPrototype.subtract = function subtract(subtrahend) {
  if (!isLong(subtrahend))
    subtrahend = fromValue(subtrahend);
  return this.add(subtrahend.neg());
};

/**
 * Returns the difference of this and the specified Long. This is an alias of {@link Long#subtract}.
 * @function
 * @param {!Long|number|string} subtrahend Subtrahend
 * @returns {!Long} Difference
 */
LongPrototype.sub = LongPrototype.subtract;

/**
 * Returns the product of this and the specified Long.
 * @this {!Long}
 * @param {!Long|number|string} multiplier Multiplier
 * @returns {!Long} Product
 */
LongPrototype.multiply = function multiply(multiplier) {
  if (this.isZero())
    return this;
  if (!isLong(multiplier))
    multiplier = fromValue(multiplier);

  // use wasm support if present
  if (wasm) {
    var low = wasm["mul"](this.low,
      this.high,
      multiplier.low,
      multiplier.high);
    return fromBits(low, wasm["get_high"](), this.unsigned);
  }

  if (multiplier.isZero())
    return this.unsigned ? UZERO : ZERO;
  if (this.eq(MIN_VALUE))
    return multiplier.isOdd() ? MIN_VALUE : ZERO;
  if (multiplier.eq(MIN_VALUE))
    return this.isOdd() ? MIN_VALUE : ZERO;

  if (this.isNegative()) {
    if (multiplier.isNegative())
      return this.neg().mul(multiplier.neg());
    else
      return this.neg().mul(multiplier).neg();
  } else if (multiplier.isNegative())
    return this.mul(multiplier.neg()).neg();

  // If both longs are small, use float multiplication
  if (this.lt(TWO_PWR_24) && multiplier.lt(TWO_PWR_24))
    return fromNumber(this.toNumber() * multiplier.toNumber(), this.unsigned);

  // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
  // We can skip products that would overflow.

  var a48 = this.high >>> 16;
  var a32 = this.high & 0xFFFF;
  var a16 = this.low >>> 16;
  var a00 = this.low & 0xFFFF;

  var b48 = multiplier.high >>> 16;
  var b32 = multiplier.high & 0xFFFF;
  var b16 = multiplier.low >>> 16;
  var b00 = multiplier.low & 0xFFFF;

  var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
  c00 += a00 * b00;
  c16 += c00 >>> 16;
  c00 &= 0xFFFF;
  c16 += a16 * b00;
  c32 += c16 >>> 16;
  c16 &= 0xFFFF;
  c16 += a00 * b16;
  c32 += c16 >>> 16;
  c16 &= 0xFFFF;
  c32 += a32 * b00;
  c48 += c32 >>> 16;
  c32 &= 0xFFFF;
  c32 += a16 * b16;
  c48 += c32 >>> 16;
  c32 &= 0xFFFF;
  c32 += a00 * b32;
  c48 += c32 >>> 16;
  c32 &= 0xFFFF;
  c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
  c48 &= 0xFFFF;
  return fromBits((c16 << 16) | c00, (c48 << 16) | c32, this.unsigned);
};

/**
 * Returns the product of this and the specified Long. This is an alias of {@link Long#multiply}.
 * @function
 * @param {!Long|number|string} multiplier Multiplier
 * @returns {!Long} Product
 */
LongPrototype.mul = LongPrototype.multiply;

/**
 * Returns this Long divided by the specified. The result is signed if this Long is signed or
 *  unsigned if this Long is unsigned.
 * @this {!Long}
 * @param {!Long|number|string} divisor Divisor
 * @returns {!Long} Quotient
 */
LongPrototype.divide = function divide(divisor) {
  if (!isLong(divisor))
    divisor = fromValue(divisor);
  if (divisor.isZero())
    throw Error('division by zero');

  // use wasm support if present
  if (wasm) {
    // guard against signed division overflow: the largest
    // negative number / -1 would be 1 larger than the largest
    // positive number, due to two's complement.
    if (!this.unsigned &&
      this.high === -0x80000000 &&
      divisor.low === -1 && divisor.high === -1) {
      // be consistent with non-wasm code path
      return this;
    }
    var low = (this.unsigned ? wasm["div_u"] : wasm["div_s"])(
      this.low,
      this.high,
      divisor.low,
      divisor.high
    );
    return fromBits(low, wasm["get_high"](), this.unsigned);
  }

  if (this.isZero())
    return this.unsigned ? UZERO : ZERO;
  var approx, rem, res;
  if (!this.unsigned) {
    // This section is only relevant for signed longs and is derived from the
    // closure library as a whole.
    if (this.eq(MIN_VALUE)) {
      if (divisor.eq(ONE) || divisor.eq(NEG_ONE))
        return MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      else if (divisor.eq(MIN_VALUE))
        return ONE;
      else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shr(1);
        approx = halfThis.div(divisor).shl(1);
        if (approx.eq(ZERO)) {
          return divisor.isNegative() ? ONE : NEG_ONE;
        } else {
          rem = this.sub(divisor.mul(approx));
          res = approx.add(rem.div(divisor));
          return res;
        }
      }
    } else if (divisor.eq(MIN_VALUE))
      return this.unsigned ? UZERO : ZERO;
    if (this.isNegative()) {
      if (divisor.isNegative())
        return this.neg().div(divisor.neg());
      return this.neg().div(divisor).neg();
    } else if (divisor.isNegative())
      return this.div(divisor.neg()).neg();
    res = ZERO;
  } else {
    // The algorithm below has not been made for unsigned longs. It's therefore
    // required to take special care of the MSB prior to running it.
    if (!divisor.unsigned)
      divisor = divisor.toUnsigned();
    if (divisor.gt(this))
      return UZERO;
    if (divisor.gt(this.shru(1))) // 15 >>> 1 = 7 ; with divisor = 8 ; true
      return UONE;
    res = UZERO;
  }

  // Repeat the following until the remainder is less than other:  find a
  // floating-point that approximates remainder / other *from below*, add this
  // into the result, and subtract it from the remainder.  It is critical that
  // the approximate value is less than or equal to the real value so that the
  // remainder never becomes negative.
  rem = this;
  while (rem.gte(divisor)) {
    // Approximate the result of division. This may be a little greater or
    // smaller than the actual value.
    approx = Math.max(1, Math.floor(rem.toNumber() / divisor.toNumber()));

    // We will tweak the approximate result by changing it in the 48-th digit or
    // the smallest non-fractional digit, whichever is larger.
    var log2 = Math.ceil(Math.log(approx) / Math.LN2),
      delta = (log2 <= 48) ? 1 : pow_dbl(2, log2 - 48),

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      approxRes = fromNumber(approx),
      approxRem = approxRes.mul(divisor);
    while (approxRem.isNegative() || approxRem.gt(rem)) {
      approx -= delta;
      approxRes = fromNumber(approx, this.unsigned);
      approxRem = approxRes.mul(divisor);
    }

    // We know the answer can't be zero... and actually, zero would cause
    // infinite recursion since we would make no progress.
    if (approxRes.isZero())
      approxRes = ONE;

    res = res.add(approxRes);
    rem = rem.sub(approxRem);
  }
  return res;
};

/**
 * Returns this Long divided by the specified. This is an alias of {@link Long#divide}.
 * @function
 * @param {!Long|number|string} divisor Divisor
 * @returns {!Long} Quotient
 */
LongPrototype.div = LongPrototype.divide;

/**
 * Returns this Long modulo the specified.
 * @this {!Long}
 * @param {!Long|number|string} divisor Divisor
 * @returns {!Long} Remainder
 */
LongPrototype.modulo = function modulo(divisor) {
  if (!isLong(divisor))
    divisor = fromValue(divisor);

  // use wasm support if present
  if (wasm) {
    var low = (this.unsigned ? wasm["rem_u"] : wasm["rem_s"])(
      this.low,
      this.high,
      divisor.low,
      divisor.high
    );
    return fromBits(low, wasm["get_high"](), this.unsigned);
  }

  return this.sub(this.div(divisor).mul(divisor));
};

/**
 * Returns this Long modulo the specified. This is an alias of {@link Long#modulo}.
 * @function
 * @param {!Long|number|string} divisor Divisor
 * @returns {!Long} Remainder
 */
LongPrototype.mod = LongPrototype.modulo;

/**
 * Returns this Long modulo the specified. This is an alias of {@link Long#modulo}.
 * @function
 * @param {!Long|number|string} divisor Divisor
 * @returns {!Long} Remainder
 */
LongPrototype.rem = LongPrototype.modulo;

/**
 * Returns the bitwise NOT of this Long.
 * @this {!Long}
 * @returns {!Long}
 */
LongPrototype.not = function not() {
  return fromBits(~this.low, ~this.high, this.unsigned);
};

/**
 * Returns count leading zeros of this Long.
 * @this {!Long}
 * @returns {!number}
 */
LongPrototype.countLeadingZeros = function countLeadingZeros() {
  return this.high ? Math.clz32(this.high) : Math.clz32(this.low) + 32;
};

/**
 * Returns count leading zeros. This is an alias of {@link Long#countLeadingZeros}.
 * @function
 * @param {!Long}
 * @returns {!number}
 */
LongPrototype.clz = LongPrototype.countLeadingZeros;

/**
 * Returns count trailing zeros of this Long.
 * @this {!Long}
 * @returns {!number}
 */
LongPrototype.countTrailingZeros = function countTrailingZeros() {
  return this.low ? ctz32(this.low) : ctz32(this.high) + 32;
};

/**
 * Returns count trailing zeros. This is an alias of {@link Long#countTrailingZeros}.
 * @function
 * @param {!Long}
 * @returns {!number}
 */
LongPrototype.ctz = LongPrototype.countTrailingZeros;

/**
 * Returns the bitwise AND of this Long and the specified.
 * @this {!Long}
 * @param {!Long|number|string} other Other Long
 * @returns {!Long}
 */
LongPrototype.and = function and(other) {
  if (!isLong(other))
    other = fromValue(other);
  return fromBits(this.low & other.low, this.high & other.high, this.unsigned);
};

/**
 * Returns the bitwise OR of this Long and the specified.
 * @this {!Long}
 * @param {!Long|number|string} other Other Long
 * @returns {!Long}
 */
LongPrototype.or = function or(other) {
  if (!isLong(other))
    other = fromValue(other);
  return fromBits(this.low | other.low, this.high | other.high, this.unsigned);
};

/**
 * Returns the bitwise XOR of this Long and the given one.
 * @this {!Long}
 * @param {!Long|number|string} other Other Long
 * @returns {!Long}
 */
LongPrototype.xor = function xor(other) {
  if (!isLong(other))
    other = fromValue(other);
  return fromBits(this.low ^ other.low, this.high ^ other.high, this.unsigned);
};

/**
 * Returns this Long with bits shifted to the left by the given amount.
 * @this {!Long}
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shiftLeft = function shiftLeft(numBits) {
  if (isLong(numBits))
    numBits = numBits.toInt();
  if ((numBits &= 63) === 0)
    return this;
  else if (numBits < 32)
    return fromBits(this.low << numBits, (this.high << numBits) | (this.low >>> (32 - numBits)), this.unsigned);
  else
    return fromBits(0, this.low << (numBits - 32), this.unsigned);
};

/**
 * Returns this Long with bits shifted to the left by the given amount. This is an alias of {@link Long#shiftLeft}.
 * @function
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shl = LongPrototype.shiftLeft;

/**
 * Returns this Long with bits arithmetically shifted to the right by the given amount.
 * @this {!Long}
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shiftRight = function shiftRight(numBits) {
  if (isLong(numBits))
    numBits = numBits.toInt();
  if ((numBits &= 63) === 0)
    return this;
  else if (numBits < 32)
    return fromBits((this.low >>> numBits) | (this.high << (32 - numBits)), this.high >> numBits, this.unsigned);
  else
    return fromBits(this.high >> (numBits - 32), this.high >= 0 ? 0 : -1, this.unsigned);
};

/**
 * Returns this Long with bits arithmetically shifted to the right by the given amount. This is an alias of {@link Long#shiftRight}.
 * @function
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shr = LongPrototype.shiftRight;

/**
 * Returns this Long with bits logically shifted to the right by the given amount.
 * @this {!Long}
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shiftRightUnsigned = function shiftRightUnsigned(numBits) {
  if (isLong(numBits)) numBits = numBits.toInt();
  if ((numBits &= 63) === 0) return this;
  if (numBits < 32) return fromBits((this.low >>> numBits) | (this.high << (32 - numBits)), this.high >>> numBits, this.unsigned);
  if (numBits === 32) return fromBits(this.high, 0, this.unsigned);
  return fromBits(this.high >>> (numBits - 32), 0, this.unsigned);
};

/**
 * Returns this Long with bits logically shifted to the right by the given amount. This is an alias of {@link Long#shiftRightUnsigned}.
 * @function
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shru = LongPrototype.shiftRightUnsigned;

/**
 * Returns this Long with bits logically shifted to the right by the given amount. This is an alias of {@link Long#shiftRightUnsigned}.
 * @function
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Shifted Long
 */
LongPrototype.shr_u = LongPrototype.shiftRightUnsigned;

/**
 * Returns this Long with bits rotated to the left by the given amount.
 * @this {!Long}
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Rotated Long
 */
LongPrototype.rotateLeft = function rotateLeft(numBits) {
  var b;
  if (isLong(numBits)) numBits = numBits.toInt();
  if ((numBits &= 63) === 0) return this;
  if (numBits === 32) return fromBits(this.high, this.low, this.unsigned);
  if (numBits < 32) {
    b = (32 - numBits);
    return fromBits(((this.low << numBits) | (this.high >>> b)), ((this.high << numBits) | (this.low >>> b)), this.unsigned);
  }
  numBits -= 32;
  b = (32 - numBits);
  return fromBits(((this.high << numBits) | (this.low >>> b)), ((this.low << numBits) | (this.high >>> b)), this.unsigned);
}
/**
 * Returns this Long with bits rotated to the left by the given amount. This is an alias of {@link Long#rotateLeft}.
 * @function
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Rotated Long
 */
LongPrototype.rotl = LongPrototype.rotateLeft;

/**
 * Returns this Long with bits rotated to the right by the given amount.
 * @this {!Long}
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Rotated Long
 */
LongPrototype.rotateRight = function rotateRight(numBits) {
  var b;
  if (isLong(numBits)) numBits = numBits.toInt();
  if ((numBits &= 63) === 0) return this;
  if (numBits === 32) return fromBits(this.high, this.low, this.unsigned);
  if (numBits < 32) {
    b = (32 - numBits);
    return fromBits(((this.high << b) | (this.low >>> numBits)), ((this.low << b) | (this.high >>> numBits)), this.unsigned);
  }
  numBits -= 32;
  b = (32 - numBits);
  return fromBits(((this.low << b) | (this.high >>> numBits)), ((this.high << b) | (this.low >>> numBits)), this.unsigned);
}
/**
 * Returns this Long with bits rotated to the right by the given amount. This is an alias of {@link Long#rotateRight}.
 * @function
 * @param {number|!Long} numBits Number of bits
 * @returns {!Long} Rotated Long
 */
LongPrototype.rotr = LongPrototype.rotateRight;

/**
 * Converts this Long to signed.
 * @this {!Long}
 * @returns {!Long} Signed long
 */
LongPrototype.toSigned = function toSigned() {
  if (!this.unsigned)
    return this;
  return fromBits(this.low, this.high, false);
};

/**
 * Converts this Long to unsigned.
 * @this {!Long}
 * @returns {!Long} Unsigned long
 */
LongPrototype.toUnsigned = function toUnsigned() {
  if (this.unsigned)
    return this;
  return fromBits(this.low, this.high, true);
};

/**
 * Converts this Long to its byte representation.
 * @param {boolean=} le Whether little or big endian, defaults to big endian
 * @this {!Long}
 * @returns {!Array.<number>} Byte representation
 */
LongPrototype.toBytes = function toBytes(le) {
  return le ? this.toBytesLE() : this.toBytesBE();
};

/**
 * Converts this Long to its little endian byte representation.
 * @this {!Long}
 * @returns {!Array.<number>} Little endian byte representation
 */
LongPrototype.toBytesLE = function toBytesLE() {
  var hi = this.high,
    lo = this.low;
  return [
    lo & 0xff,
    lo >>> 8 & 0xff,
    lo >>> 16 & 0xff,
    lo >>> 24,
    hi & 0xff,
    hi >>> 8 & 0xff,
    hi >>> 16 & 0xff,
    hi >>> 24
  ];
};

/**
 * Converts this Long to its big endian byte representation.
 * @this {!Long}
 * @returns {!Array.<number>} Big endian byte representation
 */
LongPrototype.toBytesBE = function toBytesBE() {
  var hi = this.high,
    lo = this.low;
  return [
    hi >>> 24,
    hi >>> 16 & 0xff,
    hi >>> 8 & 0xff,
    hi & 0xff,
    lo >>> 24,
    lo >>> 16 & 0xff,
    lo >>> 8 & 0xff,
    lo & 0xff
  ];
};

/**
 * Creates a Long from its byte representation.
 * @param {!Array.<number>} bytes Byte representation
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @param {boolean=} le Whether little or big endian, defaults to big endian
 * @returns {Long} The corresponding Long value
 */
Long.fromBytes = function fromBytes(bytes, unsigned, le) {
  return le ? Long.fromBytesLE(bytes, unsigned) : Long.fromBytesBE(bytes, unsigned);
};

/**
 * Creates a Long from its little endian byte representation.
 * @param {!Array.<number>} bytes Little endian byte representation
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @returns {Long} The corresponding Long value
 */
Long.fromBytesLE = function fromBytesLE(bytes, unsigned) {
  return new Long(
    bytes[0] |
    bytes[1] << 8 |
    bytes[2] << 16 |
    bytes[3] << 24,
    bytes[4] |
    bytes[5] << 8 |
    bytes[6] << 16 |
    bytes[7] << 24,
    unsigned
  );
};

/**
 * Creates a Long from its big endian byte representation.
 * @param {!Array.<number>} bytes Big endian byte representation
 * @param {boolean=} unsigned Whether unsigned or not, defaults to signed
 * @returns {Long} The corresponding Long value
 */
Long.fromBytesBE = function fromBytesBE(bytes, unsigned) {
  return new Long(
    bytes[4] << 24 |
    bytes[5] << 16 |
    bytes[6] << 8 |
    bytes[7],
    bytes[0] << 24 |
    bytes[1] << 16 |
    bytes[2] << 8 |
    bytes[3],
    unsigned
  );
};

/* harmony default export */ const node_modules_long = (Long);

;// CONCATENATED MODULE: ./src/util/error.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var error_Code;
(function (Code) {
    // Ok is returned when the operation completed successfully.
    Code["Ok"] = "ok";
    // ClientNotActive is returned when the client is not active.
    Code["ClientNotActive"] = "client-not-active";
    // Unimplemented is returned when the operation is not implemented.
    Code["Unimplemented"] = "unimplemented";
    // Unsupported is returned when the operation is not supported.
    Code["Unsupported"] = "unsupported";
    // DocumentNotAttached is returned when the document is not attached.
    Code["DocumentNotAttached"] = "document-not-attached";
    // DocumentNotDetached is returned when the document is not detached.
    Code["DocumentNotDetached"] = "document-not-detached";
    // DocumentRemoved is returned when the document is removed.
    Code["DocumentRemoved"] = "document-removed";
    // InvalidObjectKey is returned when the object key is invalid.
    Code["InvalidObjectKey"] = "invalid-object-key";
    // InvalidArgument is returned when the argument is invalid.
    Code["InvalidArgument"] = "invalid-argument";
})(error_Code || (error_Code = {}));
/**
 * `YorkieError` is an error returned by a Yorkie operation.
 */
class YorkieError extends Error {
    constructor(code, message) {
        super(message);
        this.code = code;
        this.message = message;
        this.name = 'YorkieError';
        this.toString = () => `${this.name}: [code=${this.code}]: ${this.message}`;
    }
}

;// CONCATENATED MODULE: ./src/util/object.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `deepcopy` returns a deep copy of the given object.
 */
function deepcopy(object) {
    if (object instanceof Map) {
        const pairs = Array.from(object);
        return new Map(JSON.parse(JSON.stringify(pairs)));
    }
    return JSON.parse(JSON.stringify(object));
}
/**
 `isEmpty` returns whether parameter object is empty or not
 */
const isEmpty = (object) => {
    if (!object) {
        return true;
    }
    return Object.entries(object).length === 0;
};
/**
 * `stringifyObjectValues` makes values of attributes to JSON parsable string.
 */
const stringifyObjectValues = (attributes) => {
    const attrs = {};
    for (const [key, value] of Object.entries(attributes)) {
        attrs[key] = JSON.stringify(value);
    }
    return attrs;
};
/**
 `parseObjectValues` returns the JSON parsable string values to the origin states.
 */
const parseObjectValues = (attrs) => {
    const attributes = {};
    for (const [key, value] of Object.entries(attrs)) {
        attributes[key] = JSON.parse(value);
    }
    return attributes;
};

;// CONCATENATED MODULE: ./src/document/presence/presence.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `PresenceChangeType` represents the type of presence change.
 */
var PresenceChangeType;
(function (PresenceChangeType) {
    PresenceChangeType["Put"] = "put";
    PresenceChangeType["Clear"] = "clear";
})(PresenceChangeType || (PresenceChangeType = {}));
/**
 * `Presence` represents a proxy for the Presence to be manipulated from the outside.
 */
class Presence {
    constructor(changeContext, presence) {
        this.context = changeContext;
        this.presence = presence;
    }
    /**
     * `set` updates the presence based on the partial presence.
     */
    set(presence, option) {
        for (const key of Object.keys(presence)) {
            this.presence[key] = presence[key];
        }
        this.context.setPresenceChange({
            type: PresenceChangeType.Put,
            presence: deepcopy(this.presence),
        });
        this.context.setReversePresence(presence, option);
    }
    /**
     * `get` returns the presence value of the given key.
     */
    get(key) {
        return this.presence[key];
    }
    /**
     * `clear` clears the presence.
     * @internal
     */
    clear() {
        this.presence = {};
        this.context.setPresenceChange({
            type: PresenceChangeType.Clear,
        });
    }
}

;// CONCATENATED MODULE: ./src/document/time/actor_id.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `InitialActorID` is the initial value of ActorID.
 */
const InitialActorID = '000000000000000000000000';
/**
 * `MaxActorID` is the maximum value of ActorID.
 */
const MaxActorID = 'FFFFFFFFFFFFFFFFFFFFFFFF';

;// CONCATENATED MODULE: ./src/document/time/ticket.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


const TicketComparator = (p1, p2) => {
    return p1.compare(p2);
};
/**
 * `TimeTicket` is a timestamp of the logical clock. Ticket is immutable.
 * It is created by `ChangeID`.
 *
 * @public
 */
class TimeTicket {
    /** @hideconstructor */
    constructor(lamport, delimiter, actorID) {
        this.lamport = lamport;
        this.delimiter = delimiter;
        this.actorID = actorID;
    }
    /**
     * `of` creates an instance of Ticket.
     */
    static of(lamport, delimiter, actorID) {
        return new TimeTicket(lamport, delimiter, actorID);
    }
    /**
     * `fromStruct` creates an instance of Ticket from the struct.
     */
    static fromStruct(struct) {
        return TimeTicket.of(node_modules_long.fromString(struct.lamport, true), struct.delimiter, struct.actorID);
    }
    /**
     * `toIDString` returns the lamport string for this Ticket.
     */
    toIDString() {
        return `${this.lamport.toString()}:${this.actorID}:${this.delimiter}`;
    }
    /**
     * `toStruct` returns the structure of this Ticket.
     */
    toStruct() {
        return {
            lamport: this.getLamportAsString(),
            delimiter: this.getDelimiter(),
            actorID: this.getActorID(),
        };
    }
    /**
     * `toTestString` returns a string containing the meta data of the ticket
     * for debugging purpose.
     */
    toTestString() {
        return `${this.lamport.toString()}:${this.actorID.slice(-2)}:${this.delimiter}`;
    }
    /**
     * `setActor` creates a new instance of Ticket with the given actorID.
     */
    setActor(actorID) {
        return new TimeTicket(this.lamport, this.delimiter, actorID);
    }
    /**
     * `getLamportAsString` returns the lamport string.
     */
    getLamportAsString() {
        return this.lamport.toString();
    }
    /**
     * `getLamport` returns the lamport.
     */
    getLamport() {
        return this.lamport;
    }
    /**
     * `getDelimiter` returns delimiter.
     */
    getDelimiter() {
        return this.delimiter;
    }
    /**
     * `getActorID` returns actorID.
     */
    getActorID() {
        return this.actorID;
    }
    /**
     * `after` returns whether the given ticket was created later.
     */
    after(other) {
        return this.compare(other) > 0;
    }
    /**
     * `equals` returns whether the given ticket was created.
     */
    equals(other) {
        return this.compare(other) === 0;
    }
    /**
     * `compare` returns an integer comparing two Ticket.
     *  The result will be 0 if id==other, -1 if `id < other`, and +1 if `id > other`.
     *  If the receiver or argument is nil, it would panic at runtime.
     */
    compare(other) {
        if (this.lamport.greaterThan(other.lamport)) {
            return 1;
        }
        else if (other.lamport.greaterThan(this.lamport)) {
            return -1;
        }
        const compare = this.actorID.localeCompare(other.actorID);
        if (compare !== 0) {
            return compare;
        }
        if (this.delimiter > other.delimiter) {
            return 1;
        }
        else if (other.delimiter > this.delimiter) {
            return -1;
        }
        return 0;
    }
}
const InitialDelimiter = 0;
const MaxDelemiter = 4294967295; // UInt32 MAX_VALUE
const MaxLamport = node_modules_long.MAX_VALUE;
const InitialTimeTicket = new TimeTicket(node_modules_long.fromNumber(0), InitialDelimiter, InitialActorID);
const NextTimeTicket = new TimeTicket(node_modules_long.fromNumber(1), InitialDelimiter + 1, InitialActorID);
const MaxTimeTicket = new TimeTicket(MaxLamport, MaxDelemiter, MaxActorID);

;// CONCATENATED MODULE: ./src/document/json/strings.ts
/**
 * `EscapeString` escapes the given string.
 */
function escapeString(str) {
    return str.replace(/["'\\\n\r\f\b\t\u2028\u2029]/g, function (character) {
        switch (character) {
            case '"':
            case '\\':
                return '\\' + character;
            case '\n':
                return '\\n';
            case '\r':
                return '\\r';
            case '\f':
                return '\\f';
            case '\b':
                return '\\b';
            case '\t':
                return '\\t';
            case '\u2028':
                return '\\u2028';
            case '\u2029':
                return '\\u2029';
            default:
                return character;
        }
    });
}

;// CONCATENATED MODULE: ./src/document/crdt/element.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `CRDTElement` represents an element that has `TimeTicket`s.
 *
 * @internal
 */
class CRDTElement {
    constructor(createdAt) {
        this.createdAt = createdAt;
    }
    /**
     * `getCreatedAt` returns the creation time of this element.
     */
    getCreatedAt() {
        return this.createdAt;
    }
    /**
     * `getID` returns the creation time of this element.
     */
    getID() {
        return this.createdAt;
    }
    /**
     * `getMovedAt` returns the move time of this element.
     */
    getMovedAt() {
        return this.movedAt;
    }
    /**
     * `getRemovedAt` returns the removal time of this element.
     */
    getRemovedAt() {
        return this.removedAt;
    }
    /**
     * `getPositionedAt` returns the time of this element when it was positioned
     * in the document by undo/redo or move operation.
     */
    getPositionedAt() {
        if (!this.movedAt) {
            return this.createdAt;
        }
        return this.movedAt;
    }
    /**
     * `setMovedAt` sets the move time of this element.
     */
    setMovedAt(movedAt) {
        if (!this.movedAt || (movedAt && movedAt.after(this.movedAt))) {
            this.movedAt = movedAt;
            return true;
        }
        return false;
    }
    /**
     * `setRemovedAt` sets the remove time of this element.
     */
    setRemovedAt(removedAt) {
        this.removedAt = removedAt;
    }
    /**
     * `remove` removes this element.
     */
    remove(removedAt) {
        if (removedAt &&
            removedAt.after(this.getPositionedAt()) &&
            (!this.removedAt || removedAt.after(this.removedAt))) {
            // NOTE(chacha912): If it's a CRDTContainer, removedAt is marked only on
            // the top-level element, without marking all descendant elements. This
            // enhances the speed of deletion.
            this.removedAt = removedAt;
            return true;
        }
        return false;
    }
    /**
     * `isRemoved` check if this element was removed.
     */
    isRemoved() {
        return !!this.removedAt;
    }
}
/**
 *
 * `CRDTContainer` represents CRDTArray or CRDtObject.
 */
class CRDTContainer extends CRDTElement {
    constructor(createdAt) {
        super(createdAt);
    }
}
/**
 * `CRDTGCElement` represents element which has garbage collecting method.
 */
class CRDTGCElement extends CRDTElement {
}

;// CONCATENATED MODULE: ./src/document/crdt/element_rht.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `ElementRHTNode` is a node of ElementRHT.
 */
class ElementRHTNode {
    constructor(strKey, value) {
        this.strKey = strKey;
        this.value = value;
    }
    /**
     * `of` creates a instance of ElementRHTNode.
     */
    static of(strKey, value) {
        return new ElementRHTNode(strKey, value);
    }
    /**
     * `isRemoved` checks whether this value was removed.
     */
    isRemoved() {
        return this.value.isRemoved();
    }
    /**
     * `getStrKey` returns the key of this node.
     */
    getStrKey() {
        return this.strKey;
    }
    /**
     * `getValue` return the value(element) of this node
     */
    getValue() {
        return this.value;
    }
    /**
     * `remove` removes a value base on removing time.
     */
    remove(removedAt) {
        return this.value.remove(removedAt);
    }
}
/**
 * ElementRHT is a hashtable with logical clock(Replicated hashtable)
 *
 */
class ElementRHT {
    constructor() {
        this.nodeMapByKey = new Map();
        this.nodeMapByCreatedAt = new Map();
    }
    /**
     * `create` creates an instance of ElementRHT.
     */
    static create() {
        return new ElementRHT();
    }
    /**
     * `set` sets the value of the given key.
     */
    set(key, value, executedAt) {
        let removed;
        const node = this.nodeMapByKey.get(key);
        if (node != null && !node.isRemoved() && node.remove(executedAt)) {
            removed = node.getValue();
        }
        const newNode = ElementRHTNode.of(key, value);
        this.nodeMapByCreatedAt.set(value.getCreatedAt().toIDString(), newNode);
        if (node == null || executedAt.after(node.getValue().getPositionedAt())) {
            this.nodeMapByKey.set(key, newNode);
            value.setMovedAt(executedAt);
        }
        return removed;
    }
    /**
     * `delete` deletes the Element of the given key.
     */
    delete(createdAt, executedAt) {
        if (!this.nodeMapByCreatedAt.has(createdAt.toIDString())) {
            logger.fatal(`fail to find ${createdAt.toIDString()}`);
        }
        const node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        node.remove(executedAt);
        return node.getValue();
    }
    /**
     * `subPathOf` returns the sub path of the given element.
     */
    subPathOf(createdAt) {
        const node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        if (!node) {
            return;
        }
        return node.getStrKey();
    }
    /**
     * `purge` physically purge child element.
     */
    purge(element) {
        const node = this.nodeMapByCreatedAt.get(element.getCreatedAt().toIDString());
        if (!node) {
            logger.fatal(`fail to find ${element.getCreatedAt().toIDString()}`);
            return;
        }
        const nodeByKey = this.nodeMapByKey.get(node.getStrKey());
        if (node === nodeByKey) {
            this.nodeMapByKey.delete(nodeByKey.getStrKey());
        }
        this.nodeMapByCreatedAt.delete(node.getValue().getCreatedAt().toIDString());
    }
    /**
     * `deleteByKey` deletes the Element of the given key and removed time.
     */
    deleteByKey(key, removedAt) {
        const node = this.nodeMapByKey.get(key);
        if (node == null) {
            return;
        }
        if (!node.remove(removedAt)) {
            return;
        }
        return node.getValue();
    }
    /**
     * `has` returns whether the element exists of the given key or not.
     */
    has(key) {
        const node = this.nodeMapByKey.get(key);
        if (node == null) {
            return false;
        }
        return !node.isRemoved();
    }
    /**
     * `getByID` returns the node of the given createdAt.
     */
    getByID(createdAt) {
        return this.nodeMapByCreatedAt.get(createdAt.toIDString());
    }
    /**
     * `get` returns the node of the given key.
     */
    get(key) {
        const node = this.nodeMapByKey.get(key);
        if (!node || node.isRemoved()) {
            return;
        }
        return node;
    }
    // eslint-disable-next-line jsdoc/require-jsdoc
    *[Symbol.iterator]() {
        for (const [, node] of this.nodeMapByKey) {
            yield node;
        }
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/object.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `CRDTObject` represents an object data type, but unlike regular JSON,
 * it has `TimeTicket`s which are created by logical clock.
 *
 */
class CRDTObject extends CRDTContainer {
    /** @hideconstructor */
    constructor(createdAt, memberNodes) {
        super(createdAt);
        this.memberNodes = memberNodes;
    }
    /**
     * `create` creates a new instance of CRDTObject.
     */
    static create(createdAt, value) {
        if (!value) {
            return new CRDTObject(createdAt, ElementRHT.create());
        }
        const memberNodes = ElementRHT.create();
        for (const [k, v] of Object.entries(value)) {
            memberNodes.set(k, v.deepcopy(), v.getCreatedAt());
        }
        return new CRDTObject(createdAt, memberNodes);
    }
    /**
     * `subPathOf` returns the sub path of the given element.
     */
    subPathOf(createdAt) {
        return this.memberNodes.subPathOf(createdAt);
    }
    /**
     * `purge` physically purges the given element.
     */
    purge(value) {
        this.memberNodes.purge(value);
    }
    /**
     * `set` sets the given element of the given key.
     */
    set(key, value, executedAt) {
        return this.memberNodes.set(key, value, executedAt);
    }
    /**
     * `delete` deletes the element of the given key.
     */
    delete(createdAt, executedAt) {
        return this.memberNodes.delete(createdAt, executedAt);
    }
    /**
     * `deleteByKey` deletes the element of the given key and execution time.
     */
    deleteByKey(key, executedAt) {
        return this.memberNodes.deleteByKey(key, executedAt);
    }
    /**
     * `get` returns the value of the given key.
     */
    get(key) {
        const node = this.memberNodes.get(key);
        return node === null || node === void 0 ? void 0 : node.getValue();
    }
    /**
     * `getByID` returns the element of the given createAt.
     */
    getByID(createdAt) {
        const node = this.memberNodes.getByID(createdAt);
        return node === null || node === void 0 ? void 0 : node.getValue();
    }
    /**
     * `has` returns whether the element exists of the given key or not.
     */
    has(key) {
        return this.memberNodes.has(key);
    }
    /**
     * `toJSON` returns the JSON encoding of this object.
     */
    toJSON() {
        const json = [];
        for (const [key, value] of this) {
            json.push(`"${escapeString(key)}":${value.toJSON()}`);
        }
        return `{${json.join(',')}}`;
    }
    /**
     * `toJS` returns the JavaScript object of this object.
     */
    toJS() {
        return JSON.parse(this.toJSON());
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     */
    toJSForTest() {
        const values = {};
        for (const [key, elem] of this) {
            const { createdAt, value, type } = elem.toJSForTest();
            values[key] = {
                key,
                createdAt,
                value,
                type,
            };
        }
        return {
            createdAt: this.getCreatedAt().toTestString(),
            value: values,
            type: 'YORKIE_OBJECT',
        };
    }
    /**
     * `getKeys` returns array of keys in this object.
     */
    getKeys() {
        const keys = Array();
        for (const [key] of this) {
            keys.push(key);
        }
        return keys;
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of this object.
     */
    toSortedJSON() {
        var _a;
        const keys = Array();
        for (const [key] of this) {
            keys.push(key);
        }
        const json = [];
        for (const key of keys.sort()) {
            const node = (_a = this.memberNodes.get(key)) === null || _a === void 0 ? void 0 : _a.getValue();
            json.push(`"${escapeString(key)}":${node.toSortedJSON()}`);
        }
        return `{${json.join(',')}}`;
    }
    /**
     * `getRHT` RHTNodes returns the RHTPQMap nodes.
     */
    getRHT() {
        return this.memberNodes;
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const clone = CRDTObject.create(this.getCreatedAt());
        for (const node of this.memberNodes) {
            clone.memberNodes.set(node.getStrKey(), node.getValue().deepcopy(), this.getPositionedAt());
        }
        clone.remove(this.getRemovedAt());
        return clone;
    }
    /**
     * `getDescendants` returns the descendants of this object by traversing.
     */
    getDescendants(callback) {
        for (const node of this.memberNodes) {
            const element = node.getValue();
            if (callback(element, this)) {
                return;
            }
            if (element instanceof CRDTContainer) {
                element.getDescendants(callback);
            }
        }
    }
    /**
     * eslint-disable-next-line jsdoc/require-jsdoc
     * @internal
     */
    *[Symbol.iterator]() {
        const keySet = new Set();
        for (const node of this.memberNodes) {
            if (!keySet.has(node.getStrKey())) {
                keySet.add(node.getStrKey());
                if (!node.isRemoved()) {
                    yield [node.getStrKey(), node.getValue()];
                }
            }
        }
    }
}

;// CONCATENATED MODULE: ./src/document/operation/operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `OpSource` represents the source of the operation. It is used to handle
 * corner cases in the operations created by undo/redo allow the removed
 * elements when executing them.
 */
var OpSource;
(function (OpSource) {
    OpSource["Local"] = "local";
    OpSource["Remote"] = "remote";
    OpSource["UndoRedo"] = "undoredo";
})(OpSource || (OpSource = {}));
/**
 * `Operation` represents an operation to be executed on a document.
 */
class Operation {
    constructor(parentCreatedAt, executedAt) {
        this.parentCreatedAt = parentCreatedAt;
        this.executedAt = executedAt;
    }
    /**
     * `getParentCreatedAt` returns the creation time of the target element to
     * execute the operation.
     */
    getParentCreatedAt() {
        return this.parentCreatedAt;
    }
    /**
     * `getExecutedAt` returns execution time of this operation.
     */
    getExecutedAt() {
        // NOTE(chacha912): When an operation is in the undo/redo stack,
        // it doesn't have an executedAt yet. The executedAt is set when
        // the operation is executed through undo or redo.
        if (!this.executedAt) {
            throw new Error(`executedAt has not been set yet`);
        }
        return this.executedAt;
    }
    /**
     * `setActor` sets the given actor to this operation.
     */
    setActor(actorID) {
        if (this.executedAt) {
            this.executedAt = this.executedAt.setActor(actorID);
        }
    }
    /**
     * `setExecutedAt` sets the executedAt.
     */
    setExecutedAt(executedAt) {
        this.executedAt = executedAt;
    }
}

;// CONCATENATED MODULE: ./src/util/splay_tree.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `SplayNode` is a node of SplayTree.
 */
class SplayNode {
    constructor(value) {
        this.value = value;
        this.initWeight();
    }
    /**
     * `getNodeString` returns a string of weight and value of this node.
     */
    getNodeString() {
        return `${this.weight}${this.value}`;
    }
    /**
     * `getValue` returns value of this node.
     */
    getValue() {
        return this.value;
    }
    /**
     * `getLeftWeight` returns left weight of this node.
     */
    getLeftWeight() {
        return !this.hasLeft() ? 0 : this.left.getWeight();
    }
    /**
     * `getRightWeight` returns right weight of this node.
     */
    getRightWeight() {
        return !this.hasRight() ? 0 : this.right.getWeight();
    }
    /**
     * `getWeight` returns weight of this node.
     */
    getWeight() {
        return this.weight;
    }
    /**
     * `getLeft` returns a left node.
     */
    getLeft() {
        return this.left;
    }
    /**
     * `getRight` returns a right node.
     */
    getRight() {
        return this.right;
    }
    /**
     * `getParent` returns parent of this node.
     */
    getParent() {
        return this.parent;
    }
    /**
     * `hasLeft` check if the left node exists
     */
    hasLeft() {
        return !!this.left;
    }
    /**
     * `hasRight` check if the right node exists
     */
    hasRight() {
        return !!this.right;
    }
    /**
     * `hasParent` check if the parent node exists
     */
    hasParent() {
        return !!this.parent;
    }
    /**
     * `setLeft` sets a left node.
     */
    setLeft(left) {
        this.left = left;
    }
    /**
     * `setRight` sets a right node.
     */
    setRight(right) {
        this.right = right;
    }
    /**
     * `setParent` sets a parent node.
     */
    setParent(parent) {
        this.parent = parent;
    }
    /**
     * `unlink` unlink parent, right and left node.
     */
    unlink() {
        this.parent = undefined;
        this.right = undefined;
        this.left = undefined;
    }
    /**
     * `hasLinks` checks if parent, right and left node exists.
     */
    hasLinks() {
        return this.hasParent() || this.hasLeft() || this.hasRight();
    }
    /**
     * `increaseWeight` increases weight.
     */
    increaseWeight(weight) {
        this.weight += weight;
    }
    /**
     * `initWeight` sets initial weight of this node.
     */
    initWeight() {
        this.weight = this.getLength();
    }
}
/**
 * SplayTree is weighted binary search tree which is based on Splay tree.
 * original paper on Splay Trees:
 * @see https://www.cs.cmu.edu/~sleator/papers/self-adjusting.pdf
 */
class SplayTree {
    constructor(root) {
        this.root = root;
    }
    /**
     * `length` returns the size of this tree.
     */
    get length() {
        return this.root ? this.root.getWeight() : 0;
    }
    /**
     * `find` returns the Node and offset of the given index.
     */
    find(pos) {
        if (!this.root || pos < 0) {
            return [undefined, 0];
        }
        let node = this.root;
        for (;;) {
            if (node.hasLeft() && pos <= node.getLeftWeight()) {
                node = node.getLeft();
            }
            else if (node.hasRight() &&
                node.getLeftWeight() + node.getLength() < pos) {
                pos -= node.getLeftWeight() + node.getLength();
                node = node.getRight();
            }
            else {
                pos -= node.getLeftWeight();
                break;
            }
        }
        if (pos > node.getLength()) {
            logger.fatal(`out of index range: pos: ${pos} > node.length: ${node.getLength()}`);
        }
        return [node, pos];
    }
    /**
     * Find the index of the given node in BST.
     *
     * @param node - the given node
     * @returns the index of given node
     */
    indexOf(node) {
        if (!node || (node !== this.root && !node.hasLinks())) {
            return -1;
        }
        let index = 0;
        let current = node;
        let prev;
        while (current) {
            if (!prev || prev === current.getRight()) {
                index +=
                    current.getLength() +
                        (current.hasLeft() ? current.getLeftWeight() : 0);
            }
            prev = current;
            current = current.getParent();
        }
        return index - node.getLength();
    }
    /**
     * `getRoot` returns root of this tree.
     */
    getRoot() {
        return this.root;
    }
    /**
     * `insert` inserts the node at the last.
     */
    insert(newNode) {
        return this.insertAfter(this.root, newNode);
    }
    /**
     * `insertAfter` inserts the node after the given previous node.
     */
    insertAfter(target, newNode) {
        // TODO(Eithea): Consider moving the code below to insert()
        if (!target) {
            this.root = newNode;
            return newNode;
        }
        this.splayNode(target);
        this.root = newNode;
        newNode.setRight(target.getRight());
        if (target.hasRight()) {
            target.getRight().setParent(newNode);
        }
        newNode.setLeft(target);
        target.setParent(newNode);
        target.setRight();
        this.updateWeight(target);
        this.updateWeight(newNode);
        return newNode;
    }
    /**
     * `updateWeight` recalculates the weight of this node with the value and children.
     */
    updateWeight(node) {
        node.initWeight();
        if (node.hasLeft()) {
            node.increaseWeight(node.getLeftWeight());
        }
        if (node.hasRight()) {
            node.increaseWeight(node.getRightWeight());
        }
    }
    updateTreeWeight(node) {
        while (node) {
            this.updateWeight(node);
            node = node.getParent();
        }
    }
    /**
     * `splayNode` moves the given node to the root.
     */
    splayNode(node) {
        if (!node) {
            return;
        }
        for (;;) {
            if (this.isLeftChild(node.getParent()) && this.isRightChild(node)) {
                // zig-zag
                this.rotateLeft(node);
                this.rotateRight(node);
            }
            else if (this.isRightChild(node.getParent()) &&
                this.isLeftChild(node)) {
                // zig-zag
                this.rotateRight(node);
                this.rotateLeft(node);
            }
            else if (this.isLeftChild(node.getParent()) && this.isLeftChild(node)) {
                // zig-zig
                this.rotateRight(node.getParent());
                this.rotateRight(node);
            }
            else if (this.isRightChild(node.getParent()) &&
                this.isRightChild(node)) {
                // zig-zig
                this.rotateLeft(node.getParent());
                this.rotateLeft(node);
            }
            else {
                // zig
                if (this.isLeftChild(node)) {
                    this.rotateRight(node);
                }
                else if (this.isRightChild(node)) {
                    this.rotateLeft(node);
                }
                this.updateWeight(node);
                return;
            }
        }
    }
    /**
     * `delete` deletes target node of this tree.
     */
    delete(node) {
        this.splayNode(node);
        const leftTree = new SplayTree(node.getLeft());
        if (leftTree.root) {
            leftTree.root.setParent();
        }
        const rightTree = new SplayTree(node.getRight());
        if (rightTree.root) {
            rightTree.root.setParent();
        }
        if (leftTree.root) {
            const rightmostNode = leftTree.getRightmost();
            leftTree.splayNode(rightmostNode);
            leftTree.root.setRight(rightTree.root);
            if (rightTree.root) {
                rightTree.root.setParent(leftTree.root);
            }
            this.root = leftTree.root;
        }
        else {
            this.root = rightTree.root;
        }
        node.unlink();
        if (this.root) {
            this.updateWeight(this.root);
        }
    }
    /**
     * `deleteRange` separates the range between given 2 boundaries from this Tree.
     * This function separates the range to delete as a subtree
     * by splaying outer boundary nodes.
     * leftBoundary must exist because of 0-indexed initial dummy node of tree,
     * but rightBoundary can be nil means range to delete includes the end of tree.
     * Refer to the design document in https://github.com/yorkie-team/yorkie/tree/main/design
     */
    deleteRange(leftBoundary, rightBoundary) {
        if (!rightBoundary) {
            this.splayNode(leftBoundary);
            this.cutOffRight(leftBoundary);
            return;
        }
        this.splayNode(leftBoundary);
        this.splayNode(rightBoundary);
        if (rightBoundary.getLeft() != leftBoundary) {
            this.rotateRight(leftBoundary);
        }
        this.cutOffRight(leftBoundary);
    }
    cutOffRight(root) {
        const nodesToFreeWeight = [];
        this.traversePostorder(root.getRight(), nodesToFreeWeight);
        for (const node of nodesToFreeWeight) {
            node.initWeight();
        }
        this.updateTreeWeight(root);
    }
    /**
     * `toTestString` returns a string containing the meta data of the Node
     * for debugging purpose.
     */
    toTestString() {
        const metaString = [];
        this.traverseInorder(this.root, metaString);
        return metaString
            .map((n) => `[${n.getWeight()},${n.getLength()}]${n.getValue() || ''}`)
            .join('');
    }
    /**
     * `checkWeight` returns false when there is an incorrect weight node.
     * for debugging purpose.
     */
    checkWeight() {
        const nodes = [];
        this.traverseInorder(this.root, nodes);
        for (const node of nodes) {
            if (node.getWeight() !=
                node.getLength() + node.getLeftWeight() + node.getRightWeight()) {
                return false;
            }
        }
        return true;
    }
    getRightmost() {
        let node = this.root;
        while (node.hasRight()) {
            node = node.getRight();
        }
        return node;
    }
    traverseInorder(node, stack) {
        if (!node) {
            return;
        }
        this.traverseInorder(node.getLeft(), stack);
        stack.push(node);
        this.traverseInorder(node.getRight(), stack);
    }
    traversePostorder(node, stack) {
        if (!node) {
            return;
        }
        this.traversePostorder(node.getLeft(), stack);
        this.traversePostorder(node.getRight(), stack);
        stack.push(node);
    }
    rotateLeft(pivot) {
        const root = pivot.getParent();
        if (root.hasParent()) {
            if (root === root.getParent().getLeft()) {
                root.getParent().setLeft(pivot);
            }
            else {
                root.getParent().setRight(pivot);
            }
        }
        else {
            this.root = pivot;
        }
        pivot.setParent(root.getParent());
        root.setRight(pivot.getLeft());
        if (root.hasRight()) {
            root.getRight().setParent(root);
        }
        pivot.setLeft(root);
        pivot.getLeft().setParent(pivot);
        this.updateWeight(root);
        this.updateWeight(pivot);
    }
    rotateRight(pivot) {
        const root = pivot.getParent();
        if (root.hasParent()) {
            if (root === root.getParent().getLeft()) {
                root.getParent().setLeft(pivot);
            }
            else {
                root.getParent().setRight(pivot);
            }
        }
        else {
            this.root = pivot;
        }
        pivot.setParent(root.getParent());
        root.setLeft(pivot.getRight());
        if (root.hasLeft()) {
            root.getLeft().setParent(root);
        }
        pivot.setRight(root);
        pivot.getRight().setParent(pivot);
        this.updateWeight(root);
        this.updateWeight(pivot);
    }
    isLeftChild(node) {
        if (node && node.hasParent()) {
            return node.getParent().getLeft() === node;
        }
        return false;
    }
    isRightChild(node) {
        if (node && node.hasParent()) {
            return node.getParent().getRight() === node;
        }
        return false;
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/primitive.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




var PrimitiveType;
(function (PrimitiveType) {
    PrimitiveType[PrimitiveType["Null"] = 0] = "Null";
    PrimitiveType[PrimitiveType["Boolean"] = 1] = "Boolean";
    PrimitiveType[PrimitiveType["Integer"] = 2] = "Integer";
    PrimitiveType[PrimitiveType["Long"] = 3] = "Long";
    PrimitiveType[PrimitiveType["Double"] = 4] = "Double";
    PrimitiveType[PrimitiveType["String"] = 5] = "String";
    PrimitiveType[PrimitiveType["Bytes"] = 6] = "Bytes";
    PrimitiveType[PrimitiveType["Date"] = 7] = "Date";
})(PrimitiveType || (PrimitiveType = {}));
/**
 * `Primitive` represents primitive data type including logical clock.
 * It has a type and a value.
 */
class Primitive extends CRDTElement {
    constructor(value, createdAt) {
        super(createdAt);
        this.valueType = Primitive.getPrimitiveType(value);
        this.value = value === undefined ? null : value;
    }
    /**
     * `of` creates a new instance of Primitive.
     */
    static of(value, createdAt) {
        return new Primitive(value, createdAt);
    }
    /**
     * `valueFromBytes` parses the given bytes into value.
     */
    static valueFromBytes(primitiveType, bytes) {
        switch (primitiveType) {
            case PrimitiveType.Null:
                return null;
            case PrimitiveType.Boolean:
                return bytes[0] ? true : false;
            case PrimitiveType.Integer:
                return bytes[0] | (bytes[1] << 8) | (bytes[2] << 16) | (bytes[3] << 24);
            case PrimitiveType.Double: {
                const view = new DataView(bytes.buffer);
                bytes.forEach(function (b, i) {
                    view.setUint8(i, b);
                });
                return view.getFloat64(0, true);
            }
            case PrimitiveType.String:
                return new TextDecoder('utf-8').decode(bytes);
            case PrimitiveType.Long:
                return node_modules_long.fromBytesLE(Array.from(bytes));
            case PrimitiveType.Bytes:
                return bytes;
            case PrimitiveType.Date:
                return new Date(node_modules_long.fromBytesLE(Array.from(bytes), true).toNumber());
            default:
                throw new YorkieError(error_Code.Unimplemented, `unimplemented type: ${primitiveType}`);
        }
    }
    /**
     * `toJSON` returns the JSON encoding of the value.
     */
    toJSON() {
        if (this.valueType === PrimitiveType.String) {
            return `"${escapeString(this.value)}"`;
        }
        // TODO(hackerwins): We need to consider the case where the value is
        // a byte array and a date.
        return `${this.value}`;
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of the value.
     */
    toSortedJSON() {
        return this.toJSON();
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     */
    toJSForTest() {
        return {
            createdAt: this.getCreatedAt().toTestString(),
            value: this.value,
            type: 'YORKIE_PRIMITIVE',
        };
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const primitive = Primitive.of(this.value, this.getCreatedAt());
        primitive.setMovedAt(this.getMovedAt());
        primitive.setRemovedAt(this.getRemovedAt());
        return primitive;
    }
    /**
     * `getType` returns the type of the value.
     */
    getType() {
        return this.valueType;
    }
    /**
     * `getPrimitiveType` returns the primitive type of the value.
     */
    static getPrimitiveType(value) {
        switch (typeof value) {
            case 'undefined':
                return PrimitiveType.Null;
            case 'boolean':
                return PrimitiveType.Boolean;
            case 'number':
                if (this.isInteger(value)) {
                    return PrimitiveType.Integer;
                }
                else {
                    return PrimitiveType.Double;
                }
            case 'string':
                return PrimitiveType.String;
            case 'object':
                if (value === null) {
                    return PrimitiveType.Null;
                }
                else if (value instanceof node_modules_long) {
                    return PrimitiveType.Long;
                }
                else if (value instanceof Uint8Array) {
                    return PrimitiveType.Bytes;
                }
                else if (value instanceof Date) {
                    return PrimitiveType.Date;
                }
        }
        return;
    }
    /**
     * `isSupport` check if the given value is supported type.
     */
    static isSupport(value) {
        const primitiveType = Primitive.getPrimitiveType(value);
        if (primitiveType === undefined) {
            return false;
        }
        return true;
    }
    /**
     * `isInteger` checks if the given number is integer.
     */
    static isInteger(num) {
        return num % 1 === 0;
    }
    /**
     * `isNumericType` checks numeric type by JSONPrimitive
     */
    isNumericType() {
        const t = this.valueType;
        return (t === PrimitiveType.Integer ||
            t === PrimitiveType.Long ||
            t === PrimitiveType.Double);
    }
    /**
     * `getValue` returns the value of Primitive.
     */
    getValue() {
        return this.value;
    }
    /**
     * `toBytes` creates an array representing the value.
     */
    toBytes() {
        switch (this.valueType) {
            case PrimitiveType.Null: {
                return new Uint8Array();
            }
            case PrimitiveType.Boolean: {
                const boolVal = this.value;
                return boolVal ? new Uint8Array([1]) : new Uint8Array([0]);
            }
            case PrimitiveType.Integer: {
                const intVal = this.value;
                return new Uint8Array([
                    intVal & 0xff,
                    (intVal >> 8) & 0xff,
                    (intVal >> 16) & 0xff,
                    (intVal >> 24) & 0xff,
                ]);
            }
            case PrimitiveType.Double: {
                const doubleVal = this.value;
                const uint8Array = new Uint8Array(8);
                const view = new DataView(uint8Array.buffer);
                view.setFloat64(0, doubleVal, true);
                return uint8Array;
            }
            case PrimitiveType.String: {
                return new TextEncoder().encode(this.value);
            }
            case PrimitiveType.Long: {
                const longVal = this.value;
                const longToBytes = longVal.toBytesLE();
                return Uint8Array.from(longToBytes);
            }
            case PrimitiveType.Bytes: {
                const bytesVal = this.value;
                return bytesVal;
            }
            case PrimitiveType.Date: {
                const dateVal = this.value;
                const dateToBytes = node_modules_long.fromNumber(dateVal.getTime(), true).toBytesLE();
                return Uint8Array.from(dateToBytes);
            }
            default:
                throw new YorkieError(error_Code.Unimplemented, `unimplemented type: ${this.valueType}`);
        }
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/rga_tree_list.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




/**
 * `RGATreeListNode` is a node of RGATreeList.
 */
class RGATreeListNode extends SplayNode {
    constructor(value) {
        super(value);
        this.value = value;
    }
    /**
     * `createAfter` creates a new node after the given node.
     */
    static createAfter(prev, value) {
        const newNode = new RGATreeListNode(value);
        const prevNext = prev.next;
        prev.next = newNode;
        newNode.prev = prev;
        newNode.next = prevNext;
        if (prevNext) {
            prevNext.prev = newNode;
        }
        return newNode;
    }
    /**
     * `remove` removes value based on removing time.
     */
    remove(removedAt) {
        return this.value.remove(removedAt);
    }
    /**
     * `getCreatedAt` returns creation time of this value
     */
    getCreatedAt() {
        return this.value.getCreatedAt();
    }
    /**
     * `getPositionedAt` returns the time of this element when it was positioned
     * in the array.
     */
    getPositionedAt() {
        return this.value.getPositionedAt();
    }
    /**
     * `release` releases prev and next node.
     */
    release() {
        if (this.prev) {
            this.prev.next = this.next;
        }
        if (this.next) {
            this.next.prev = this.prev;
        }
        this.prev = undefined;
        this.next = undefined;
    }
    /**
     * `getLength` returns the length of this node.
     */
    getLength() {
        return this.value.isRemoved() ? 0 : 1;
    }
    /**
     * `getPrev` returns a previous node.
     */
    getPrev() {
        return this.prev;
    }
    /**
     * `getNext` returns a next node.
     */
    getNext() {
        return this.next;
    }
    /**
     * `getValue` returns a element value.
     */
    getValue() {
        return this.value;
    }
    /**
     * `isRemoved` checks if the value was removed.
     */
    isRemoved() {
        return this.value.isRemoved();
    }
}
/**
 * `RGATreeList` is a replicated growable array.
 *
 * @internal
 */
class RGATreeList {
    constructor() {
        const dummyValue = Primitive.of(0, InitialTimeTicket);
        dummyValue.setRemovedAt(InitialTimeTicket);
        this.dummyHead = new RGATreeListNode(dummyValue);
        this.last = this.dummyHead;
        this.nodeMapByIndex = new SplayTree();
        this.nodeMapByCreatedAt = new Map();
        this.nodeMapByIndex.insert(this.dummyHead);
        this.nodeMapByCreatedAt.set(this.dummyHead.getCreatedAt().toIDString(), this.dummyHead);
    }
    /**
     * `create` creates instance of RGATreeList.
     */
    static create() {
        return new RGATreeList();
    }
    /**
     * `length` returns size of RGATreeList.
     */
    get length() {
        return this.nodeMapByIndex.length;
    }
    /**
     * `findNextBeforeExecutedAt` returns the node by the given createdAt and
     * executedAt. It passes through nodes created after executedAt from the
     * given node and returns the next node.
     * @param createdAt - created time
     * @param executedAt - executed time
     * @returns next node
     */
    findNextBeforeExecutedAt(createdAt, executedAt) {
        let node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        if (!node) {
            logger.fatal(`cant find the given node: ${createdAt.toIDString()}`);
        }
        while (node.getNext() &&
            node.getNext().getPositionedAt().after(executedAt)) {
            node = node.getNext();
        }
        return node;
    }
    release(node) {
        if (this.last === node) {
            this.last = node.getPrev();
        }
        node.release();
        this.nodeMapByIndex.delete(node);
        this.nodeMapByCreatedAt.delete(node.getValue().getCreatedAt().toIDString());
    }
    /**
     * `insertAfter` adds a new node with the value after the given node.
     */
    insertAfter(prevCreatedAt, value, executedAt = value.getCreatedAt()) {
        const prevNode = this.findNextBeforeExecutedAt(prevCreatedAt, executedAt);
        const newNode = RGATreeListNode.createAfter(prevNode, value);
        if (prevNode === this.last) {
            this.last = newNode;
        }
        this.nodeMapByIndex.insertAfter(prevNode, newNode);
        this.nodeMapByCreatedAt.set(newNode.getCreatedAt().toIDString(), newNode);
    }
    /**
     * `moveAfter` moves the given `createdAt` element
     * after the `prevCreatedAt` element.
     */
    moveAfter(prevCreatedAt, createdAt, executedAt) {
        const prevNode = this.nodeMapByCreatedAt.get(prevCreatedAt.toIDString());
        if (!prevNode) {
            logger.fatal(`cant find the given node: ${prevCreatedAt.toIDString()}`);
        }
        const node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        if (!node) {
            logger.fatal(`cant find the given node: ${createdAt.toIDString()}`);
        }
        if (prevNode !== node &&
            (!node.getValue().getMovedAt() ||
                executedAt.after(node.getValue().getMovedAt()))) {
            this.release(node);
            this.insertAfter(prevNode.getCreatedAt(), node.getValue(), executedAt);
            node.getValue().setMovedAt(executedAt);
        }
    }
    /**
     * `insert` adds the given element after the last node.
     */
    insert(value) {
        this.insertAfter(this.last.getCreatedAt(), value);
    }
    /**
     * `getByID` returns the element of the given creation time.
     */
    getByID(createdAt) {
        return this.nodeMapByCreatedAt.get(createdAt.toIDString());
    }
    /**
     * `subPathOf` returns the sub path of the given element.
     */
    subPathOf(createdAt) {
        const node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        if (!node) {
            return;
        }
        return String(this.nodeMapByIndex.indexOf(node));
    }
    /**
     * `purge` physically purges element.
     */
    purge(element) {
        const node = this.nodeMapByCreatedAt.get(element.getCreatedAt().toIDString());
        if (!node) {
            logger.fatal(`fail to find the given createdAt: ${element
                .getCreatedAt()
                .toIDString()}`);
        }
        this.release(node);
    }
    /**
     * `getByIndex` returns node of the given index.
     */
    getByIndex(idx) {
        if (idx >= this.length) {
            return;
        }
        const [node, offset] = this.nodeMapByIndex.find(idx);
        let rgaNode = node;
        if ((idx === 0 && node === this.dummyHead) || offset > 0) {
            do {
                if (rgaNode) {
                    rgaNode = rgaNode.getNext();
                }
            } while (rgaNode && rgaNode.isRemoved());
        }
        return rgaNode;
    }
    /**
     * `getPrevCreatedAt` returns a creation time of the previous node.
     */
    getPrevCreatedAt(createdAt) {
        let node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        do {
            node = node.getPrev();
        } while (this.dummyHead !== node && node.isRemoved());
        return node.getValue().getCreatedAt();
    }
    /**
     * `delete` deletes the node of the given creation time.
     */
    delete(createdAt, editedAt) {
        const node = this.nodeMapByCreatedAt.get(createdAt.toIDString());
        const alreadyRemoved = node.isRemoved();
        if (node.remove(editedAt) && !alreadyRemoved) {
            this.nodeMapByIndex.splayNode(node);
        }
        return node.getValue();
    }
    /**
     * `deleteByIndex` deletes the node of the given index.
     */
    deleteByIndex(index, editedAt) {
        const node = this.getByIndex(index);
        if (!node) {
            return;
        }
        if (node.remove(editedAt)) {
            this.nodeMapByIndex.splayNode(node);
        }
        return node.getValue();
    }
    /**
     * `getHead` returns the value of head elements.
     */
    getHead() {
        return this.dummyHead.getValue();
    }
    /**
     * `getLast` returns the value of last elements.
     */
    getLast() {
        return this.last.getValue();
    }
    /**
     * `getLastCreatedAt` returns the creation time of last element.
     */
    getLastCreatedAt() {
        return this.last.getCreatedAt();
    }
    /**
     * `toTestString` returns a String containing the meta data of the node id
     * for debugging purpose.
     */
    toTestString() {
        const json = [];
        for (const node of this) {
            const elem = `${node.getCreatedAt().toIDString()}:${node
                .getValue()
                .toJSON()}`;
            if (node.isRemoved()) {
                json.push(`{${elem}}`);
            }
            else {
                json.push(`[${elem}]`);
            }
        }
        return json.join('');
    }
    // eslint-disable-next-line jsdoc/require-jsdoc
    *[Symbol.iterator]() {
        let node = this.dummyHead.getNext();
        while (node) {
            yield node;
            node = node.getNext();
        }
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/array.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * `CRDTArray` represents an array data type containing `CRDTElement`s.
 *
 * @internal
 */
class CRDTArray extends CRDTContainer {
    /** @hideconstructor */
    constructor(createdAt, elements) {
        super(createdAt);
        this.elements = elements;
    }
    /**
     * `create` creates a new instance of Array.
     */
    static create(createdAt, value) {
        if (!value) {
            return new CRDTArray(createdAt, RGATreeList.create());
        }
        const elements = RGATreeList.create();
        for (const v of value) {
            elements.insertAfter(elements.getLastCreatedAt(), v.deepcopy());
        }
        return new CRDTArray(createdAt, elements);
    }
    /**
     * `subPathOf` returns the sub path of the given element.
     */
    subPathOf(createdAt) {
        return this.elements.subPathOf(createdAt);
    }
    /**
     * `purge` physically purge the given element.
     */
    purge(element) {
        this.elements.purge(element);
    }
    /**
     * `insertAfter` adds a new node after the the given node.
     */
    insertAfter(prevCreatedAt, value) {
        this.elements.insertAfter(prevCreatedAt, value);
    }
    /**
     * `moveAfter` moves the given `createdAt` element after the `prevCreatedAt`.
     */
    moveAfter(prevCreatedAt, createdAt, executedAt) {
        this.elements.moveAfter(prevCreatedAt, createdAt, executedAt);
    }
    /**
     * `get` returns the element of the given index.
     */
    get(index) {
        const node = this.elements.getByIndex(index);
        return node === null || node === void 0 ? void 0 : node.getValue();
    }
    /**
     * `getByID` returns the element of the given createAt.
     */
    getByID(createdAt) {
        const node = this.elements.getByID(createdAt);
        return node === null || node === void 0 ? void 0 : node.getValue();
    }
    /**
     * `getHead` returns dummy head element.
     */
    getHead() {
        return this.elements.getHead();
    }
    /**
     * `getLast` returns last element.
     */
    getLast() {
        return this.elements.getLast();
    }
    /**
     * `getPrevCreatedAt` returns the creation time of the previous node.
     */
    getPrevCreatedAt(createdAt) {
        return this.elements.getPrevCreatedAt(createdAt);
    }
    /**
     * `delete` deletes the element of the given creation time.
     */
    delete(createdAt, editedAt) {
        return this.elements.delete(createdAt, editedAt);
    }
    /**
     * `deleteByIndex` deletes the element of given index and editedAt.
     */
    deleteByIndex(index, editedAt) {
        return this.elements.deleteByIndex(index, editedAt);
    }
    /**
     * `getLastCreatedAt` get last created element.
     */
    getLastCreatedAt() {
        return this.elements.getLastCreatedAt();
    }
    /**
     * `length` returns length of this elements.
     */
    get length() {
        return this.elements.length;
    }
    /**
     * eslint-disable-next-line jsdoc/require-jsdoc
     * @internal
     */
    *[Symbol.iterator]() {
        for (const node of this.elements) {
            if (!node.isRemoved()) {
                yield node.getValue();
            }
        }
    }
    /**
     * `toTestString` returns a String containing the meta data of this value
     * for debugging purpose.
     */
    toTestString() {
        return this.elements.toTestString();
    }
    /**
     * `getDescendants` traverse the descendants of this array.
     */
    getDescendants(callback) {
        for (const node of this.elements) {
            const element = node.getValue();
            if (callback(element, this)) {
                return;
            }
            if (element instanceof CRDTContainer) {
                element.getDescendants(callback);
            }
        }
    }
    /**
     * `toJSON` returns the JSON encoding of this array.
     */
    toJSON() {
        const json = [];
        for (const value of this) {
            json.push(value.toJSON());
        }
        return `[${json.join(',')}]`;
    }
    /**
     * `toJS` return the javascript object of this array.
     */
    toJS() {
        return JSON.parse(this.toJSON());
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     */
    toJSForTest() {
        const values = {};
        for (let i = 0; i < this.length; i++) {
            const { createdAt, value, type } = this.get(i).toJSForTest();
            values[i] = {
                key: String(i),
                createdAt,
                value,
                type,
            };
        }
        return {
            createdAt: this.getCreatedAt().toTestString(),
            value: values,
            type: 'YORKIE_ARRAY',
        };
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of this array.
     */
    toSortedJSON() {
        return this.toJSON();
    }
    /**
     * `getElements` returns an array of elements contained in this RGATreeList.
     */
    getElements() {
        return this.elements;
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const clone = CRDTArray.create(this.getCreatedAt());
        for (const node of this.elements) {
            clone.elements.insertAfter(clone.getLastCreatedAt(), node.getValue().deepcopy());
        }
        clone.remove(this.getRemovedAt());
        return clone;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/remove_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */






/**
 * `RemoveOperation` is an operation that removes an element from `CRDTContainer`.
 */
class RemoveOperation extends Operation {
    constructor(parentCreatedAt, createdAt, executedAt) {
        super(parentCreatedAt, executedAt);
        this.createdAt = createdAt;
    }
    /**
     * `create` creates a new instance of RemoveOperation.
     */
    static create(parentCreatedAt, createdAt, executedAt) {
        return new RemoveOperation(parentCreatedAt, createdAt, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root, source) {
        var _a;
        const container = root.findByCreatedAt(this.getParentCreatedAt());
        if (!container) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(container instanceof CRDTContainer)) {
            logger.fatal(`only object and array can execute remove: ${container}`);
        }
        // NOTE(chacha912): Handle cases where operation cannot be executed during undo and redo.
        if (source === OpSource.UndoRedo) {
            let parent = container.getByID(this.createdAt);
            while (parent) {
                if (parent.getRemovedAt()) {
                    return;
                }
                parent = (_a = root.findElementPairByCreatedAt(parent.getCreatedAt())) === null || _a === void 0 ? void 0 : _a.parent;
            }
        }
        const key = container.subPathOf(this.createdAt);
        const reverseOp = this.toReverseOperation(container);
        const elem = container.delete(this.createdAt, this.getExecutedAt());
        root.registerRemovedElement(elem);
        const opInfos = container instanceof CRDTArray
            ? [
                {
                    type: 'remove',
                    path: root.createPath(this.getParentCreatedAt()),
                    index: Number(key),
                },
            ]
            : [
                {
                    type: 'remove',
                    path: root.createPath(this.getParentCreatedAt()),
                    key,
                },
            ];
        return { opInfos, reverseOp };
    }
    /**
     * `toReverseOperation` returns the reverse operation of this operation.
     */
    toReverseOperation(parentObject) {
        // TODO(Hyemmie): consider CRDTArray
        if (parentObject instanceof CRDTObject) {
            const key = parentObject.subPathOf(this.createdAt);
            if (key !== undefined) {
                const value = parentObject.get(key);
                if (value !== undefined) {
                    return SetOperation.create(key, value.deepcopy(), this.getParentCreatedAt());
                }
            }
        }
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.getParentCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        return `${this.getParentCreatedAt().toTestString()}.REMOVE.${this.createdAt.toTestString()}`;
    }
    /**
     * `getCreatedAt` returns the creation time of the target element.
     */
    getCreatedAt() {
        return this.createdAt;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/set_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




/**
 * `SetOperation` represents an operation that stores the value corresponding to the
 * given key in the Object.
 */
class SetOperation extends Operation {
    constructor(key, value, parentCreatedAt, executedAt) {
        super(parentCreatedAt, executedAt);
        this.key = key;
        this.value = value;
    }
    /**
     * `create` creates a new instance of SetOperation.
     */
    static create(key, value, parentCreatedAt, executedAt) {
        return new SetOperation(key, value, parentCreatedAt, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root, source) {
        var _a;
        const obj = root.findByCreatedAt(this.getParentCreatedAt());
        if (!obj) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(obj instanceof CRDTObject)) {
            logger.fatal(`fail to execute, only object can execute set`);
        }
        // NOTE(chacha912): Handle cases where operation cannot be executed during undo and redo.
        if (source === OpSource.UndoRedo) {
            let parent = obj;
            while (parent) {
                if (parent.getRemovedAt()) {
                    return;
                }
                parent = (_a = root.findElementPairByCreatedAt(parent.getCreatedAt())) === null || _a === void 0 ? void 0 : _a.parent;
            }
        }
        const previousValue = obj.get(this.key);
        const reverseOp = this.toReverseOperation(previousValue);
        const value = this.value.deepcopy();
        const removed = obj.set(this.key, value, this.getExecutedAt());
        // NOTE(chacha912): When resetting elements with the pre-existing createdAt
        // during undo/redo, it's essential to handle previously tombstoned elements.
        // In non-GC languages, there may be a need to execute both deregister and purge.
        if (source === OpSource.UndoRedo &&
            root.findByCreatedAt(value.getCreatedAt())) {
            root.deregisterElement(value);
        }
        root.registerElement(value, obj);
        if (removed) {
            root.registerRemovedElement(removed);
        }
        return {
            opInfos: [
                {
                    type: 'set',
                    path: root.createPath(this.getParentCreatedAt()),
                    key: this.key,
                },
            ],
            reverseOp,
        };
    }
    /**
     * `toReverseOperation` returns the reverse operation of this operation.
     */
    toReverseOperation(value) {
        let reverseOp = RemoveOperation.create(this.getParentCreatedAt(), this.value.getCreatedAt());
        if (value !== undefined && !value.isRemoved()) {
            reverseOp = SetOperation.create(this.key, value.deepcopy(), this.getParentCreatedAt());
        }
        return reverseOp;
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.value.getCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        return `${this.getParentCreatedAt().toTestString()}.SET.${this.key}=${this.value.toSortedJSON()}`;
    }
    /**
     * `getKey` returns the key of this operation.
     */
    getKey() {
        return this.key;
    }
    /**
     * `getValue` returns the value of this operation.
     */
    getValue() {
        return this.value;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/add_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `AddOperation` is an operation representing adding an element to an Array.
 */
class AddOperation extends Operation {
    constructor(parentCreatedAt, prevCreatedAt, value, executedAt) {
        super(parentCreatedAt, executedAt);
        this.prevCreatedAt = prevCreatedAt;
        this.value = value;
    }
    /**
     * `create` creates a new instance of AddOperation.
     */
    static create(parentCreatedAt, prevCreatedAt, value, executedAt) {
        return new AddOperation(parentCreatedAt, prevCreatedAt, value, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTArray)) {
            logger.fatal(`fail to execute, only array can execute add`);
        }
        const array = parentObject;
        const value = this.value.deepcopy();
        array.insertAfter(this.prevCreatedAt, value);
        root.registerElement(value, array);
        return {
            opInfos: [
                {
                    type: 'add',
                    path: root.createPath(this.getParentCreatedAt()),
                    index: Number(array.subPathOf(this.getEffectedCreatedAt())),
                },
            ],
        };
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.value.getCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        return `${this.getParentCreatedAt().toTestString()}.ADD.${this.value.toJSON()}`;
    }
    /**
     * `getPrevCreatedAt` returns the creation time of previous element.
     */
    getPrevCreatedAt() {
        return this.prevCreatedAt;
    }
    /**
     * `getValue` returns the value of this operation.
     */
    getValue() {
        return this.value;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/move_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `MoveOperation` is an operation representing moving an element to an Array.
 */
class MoveOperation extends Operation {
    constructor(parentCreatedAt, prevCreatedAt, createdAt, executedAt) {
        super(parentCreatedAt, executedAt);
        this.prevCreatedAt = prevCreatedAt;
        this.createdAt = createdAt;
    }
    /**
     * `create` creates a new instance of MoveOperation.
     */
    static create(parentCreatedAt, prevCreatedAt, createdAt, executedAt) {
        return new MoveOperation(parentCreatedAt, prevCreatedAt, createdAt, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTArray)) {
            logger.fatal(`fail to execute, only array can execute move`);
        }
        const array = parentObject;
        const previousIndex = Number(array.subPathOf(this.createdAt));
        array.moveAfter(this.prevCreatedAt, this.createdAt, this.getExecutedAt());
        const index = Number(array.subPathOf(this.createdAt));
        return {
            opInfos: [
                {
                    type: 'move',
                    path: root.createPath(this.getParentCreatedAt()),
                    index,
                    previousIndex,
                },
            ],
        };
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.createdAt;
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        return `${this.getParentCreatedAt().toTestString()}.MOVE`;
    }
    /**
     * `getPrevCreatedAt` returns the creation time of previous element.
     */
    getPrevCreatedAt() {
        return this.prevCreatedAt;
    }
    /**
     * `getCreatedAt` returns the creation time of the target element.
     */
    getCreatedAt() {
        return this.createdAt;
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/rht.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `RHTNode` is a node of RHT(Replicated Hashtable).
 */
class RHTNode {
    constructor(key, value, updatedAt, isRemoved) {
        this.key = key;
        this.value = value;
        this.updatedAt = updatedAt;
        this._isRemoved = isRemoved;
    }
    /**
     * `of` creates a new instance of RHTNode.
     */
    static of(key, value, createdAt, isRemoved) {
        return new RHTNode(key, value, createdAt, isRemoved);
    }
    /**
     * `getKey` returns a key of node.
     */
    getKey() {
        return this.key;
    }
    /**
     * `getValue` returns a value of node.
     */
    getValue() {
        return this.value;
    }
    /**
     * `getUpdatedAt` returns updated time of node.
     */
    getUpdatedAt() {
        return this.updatedAt;
    }
    /**
     * `isRemoved` returns whether the node has been removed or not.
     */
    isRemoved() {
        return this._isRemoved;
    }
}
/**
 * RHT is replicated hash table by creation time.
 * For more details about RHT: @see http://csl.skku.edu/papers/jpdc11.pdf
 */
class RHT {
    constructor() {
        this.nodeMapByKey = new Map();
        this.numberOfRemovedElement = 0;
    }
    /**
     * `create` creates a new instance of RHT.
     */
    static create() {
        return new RHT();
    }
    /**
     * `set` sets the value of the given key.
     */
    set(key, value, executedAt) {
        const prev = this.nodeMapByKey.get(key);
        if (prev === undefined || executedAt.after(prev.getUpdatedAt())) {
            if (prev !== undefined && !prev.isRemoved()) {
                this.numberOfRemovedElement -= 1;
            }
            const node = RHTNode.of(key, value, executedAt, false);
            this.nodeMapByKey.set(key, node);
        }
    }
    /**
     * `remove` removes the Element of the given key.
     */
    remove(key, executedAt) {
        const prev = this.nodeMapByKey.get(key);
        if (prev === undefined || executedAt.after(prev.getUpdatedAt())) {
            if (prev === undefined) {
                this.numberOfRemovedElement += 1;
                const node = RHTNode.of(key, '', executedAt, true);
                this.nodeMapByKey.set(key, node);
                return '';
            }
            const alreadyRemoved = prev.isRemoved();
            if (!alreadyRemoved) {
                this.numberOfRemovedElement += 1;
            }
            const node = RHTNode.of(key, prev.getValue(), executedAt, true);
            this.nodeMapByKey.set(key, node);
            if (alreadyRemoved) {
                return '';
            }
            return prev.getValue();
        }
        return '';
    }
    /**
     * `has` returns whether the element exists of the given key or not.
     */
    has(key) {
        if (this.nodeMapByKey.has(key)) {
            const node = this.nodeMapByKey.get(key);
            return node !== undefined && !node.isRemoved();
        }
        return false;
    }
    /**
     * `get` returns the value of the given key.
     */
    get(key) {
        if (!this.nodeMapByKey.has(key)) {
            return;
        }
        return this.nodeMapByKey.get(key).getValue();
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const rht = new RHT();
        for (const [, node] of this.nodeMapByKey) {
            rht.set(node.getKey(), node.getValue(), node.getUpdatedAt());
        }
        return rht;
    }
    /**
     * `toJSON` returns the JSON encoding of this hashtable.
     */
    toJSON() {
        if (!this.size()) {
            return '{}';
        }
        const items = [];
        for (const [key, node] of this.nodeMapByKey) {
            if (!node.isRemoved()) {
                items.push(`"${escapeString(key)}":"${escapeString(node.getValue())}"`);
            }
        }
        return `{${items.join(',')}}`;
    }
    /**
     * `toXML` converts the given RHT to XML string.
     */
    toXML() {
        if (!this.size()) {
            return '';
        }
        const attrs = [...this.nodeMapByKey]
            .filter(([, v]) => v instanceof RHTNode && !v.isRemoved())
            .sort((a, b) => a[0].localeCompare(b[0]))
            .map(([k, v]) => `${k}="${JSON.parse(v.getValue())}"`);
        return ` ${attrs.join(' ')}`;
    }
    /**
     * `size` returns the size of RHT
     */
    size() {
        return this.nodeMapByKey.size - this.numberOfRemovedElement;
    }
    /**
     * `toObject` returns the object of this hashtable.
     */
    toObject() {
        const obj = {};
        for (const [key, node] of this.nodeMapByKey) {
            if (!node.isRemoved()) {
                obj[key] = node.getValue();
            }
        }
        return obj;
    }
    // eslint-disable-next-line jsdoc/require-jsdoc
    *[Symbol.iterator]() {
        for (const [, node] of this.nodeMapByKey) {
            yield node;
        }
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/text.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */





/**
 * `TextChangeType` is the type of TextChange.
 *
 */
var TextChangeType;
(function (TextChangeType) {
    TextChangeType["Content"] = "content";
    TextChangeType["Style"] = "style";
})(TextChangeType || (TextChangeType = {}));
/**
 * `CRDTTextValue` is a value of Text
 * which has a attributes that expresses the text style.
 * Attributes are represented by RHT.
 *
 */
class CRDTTextValue {
    /** @hideconstructor */
    constructor(content) {
        this.attributes = RHT.create();
        this.content = content;
    }
    /**
     * `create` creates a instance of CRDTTextValue.
     */
    static create(content) {
        return new CRDTTextValue(content);
    }
    /**
     * `length` returns the length of value.
     */
    get length() {
        return this.content.length;
    }
    /**
     * `substring` returns a sub-string value of the given range.
     */
    substring(indexStart, indexEnd) {
        const value = new CRDTTextValue(this.content.substring(indexStart, indexEnd));
        value.attributes = this.attributes.deepcopy();
        return value;
    }
    /**
     * `setAttr` sets attribute of the given key, updated time and value.
     */
    setAttr(key, content, updatedAt) {
        this.attributes.set(key, content, updatedAt);
    }
    /**
     * `getAttr` returns the attributes of this value.
     */
    getAttrs() {
        return this.attributes;
    }
    /**
     * `toString` returns the string representation of this value.
     */
    toString() {
        return this.content;
    }
    /**
     * `toJSON` returns the JSON encoding of this value.
     */
    toJSON() {
        const content = escapeString(this.content);
        const attrsObj = this.attributes.toObject();
        const attrs = [];
        for (const [key, v] of Object.entries(attrsObj)) {
            const value = JSON.parse(v);
            const item = typeof value === 'string'
                ? `"${escapeString(key)}":"${escapeString(value)}"`
                : `"${escapeString(key)}":${String(value)}`;
            attrs.push(item);
        }
        attrs.sort();
        if (attrs.length === 0) {
            return `{"val":"${content}"}`;
        }
        return `{"attrs":{${attrs.join(',')}},"val":"${content}"}`;
    }
    /**
     * `getAttributes` returns the attributes of this value.
     */
    getAttributes() {
        return this.attributes.toObject();
    }
    /**
     * `getContent` returns the internal content.
     */
    getContent() {
        return this.content;
    }
}
/**
 *  `CRDTText` is a custom CRDT data type to represent the contents of text editors.
 *
 */
class CRDTText extends CRDTGCElement {
    constructor(rgaTreeSplit, createdAt) {
        super(createdAt);
        this.rgaTreeSplit = rgaTreeSplit;
    }
    /**
     * `create` a instance of Text.
     */
    static create(rgaTreeSplit, createdAt) {
        return new CRDTText(rgaTreeSplit, createdAt);
    }
    /**
     * `edit` edits the given range with the given value and attributes.
     *
     * @internal
     */
    edit(range, content, editedAt, attributes, latestCreatedAtMapByActor) {
        const crdtTextValue = content ? CRDTTextValue.create(content) : undefined;
        if (crdtTextValue && attributes) {
            for (const [k, v] of Object.entries(attributes)) {
                crdtTextValue.setAttr(k, v, editedAt);
            }
        }
        const [caretPos, latestCreatedAtMap, valueChanges] = this.rgaTreeSplit.edit(range, editedAt, crdtTextValue, latestCreatedAtMapByActor);
        const changes = valueChanges.map((change) => ({
            ...change,
            value: change.value
                ? {
                    attributes: parseObjectValues(change.value.getAttributes()),
                    content: change.value.getContent(),
                }
                : {
                    attributes: undefined,
                    content: '',
                },
            type: TextChangeType.Content,
        }));
        return [latestCreatedAtMap, changes, [caretPos, caretPos]];
    }
    /**
     * `setStyle` applies the style of the given range.
     * 01. split nodes with from and to
     * 02. style nodes between from and to
     *
     * @param range - range of RGATreeSplitNode
     * @param attributes - style attributes
     * @param editedAt - edited time
     * @internal
     */
    setStyle(range, attributes, editedAt, latestCreatedAtMapByActor) {
        // 01. split nodes with from and to
        const [, toRight] = this.rgaTreeSplit.findNodeWithSplit(range[1], editedAt);
        const [, fromRight] = this.rgaTreeSplit.findNodeWithSplit(range[0], editedAt);
        // 02. style nodes between from and to
        const changes = [];
        const nodes = this.rgaTreeSplit.findBetween(fromRight, toRight);
        const createdAtMapByActor = new Map();
        const toBeStyleds = [];
        for (const node of nodes) {
            const actorID = node.getCreatedAt().getActorID();
            const latestCreatedAt = (latestCreatedAtMapByActor === null || latestCreatedAtMapByActor === void 0 ? void 0 : latestCreatedAtMapByActor.size)
                ? latestCreatedAtMapByActor.has(actorID)
                    ? latestCreatedAtMapByActor.get(actorID)
                    : InitialTimeTicket
                : MaxTimeTicket;
            if (node.canStyle(editedAt, latestCreatedAt)) {
                const latestCreatedAt = createdAtMapByActor.get(actorID);
                const createdAt = node.getCreatedAt();
                if (!latestCreatedAt || createdAt.after(latestCreatedAt)) {
                    createdAtMapByActor.set(actorID, createdAt);
                }
                toBeStyleds.push(node);
            }
        }
        for (const node of toBeStyleds) {
            if (node.isRemoved()) {
                continue;
            }
            const [fromIdx, toIdx] = this.rgaTreeSplit.findIndexesFromRange(node.createPosRange());
            changes.push({
                type: TextChangeType.Style,
                actor: editedAt.getActorID(),
                from: fromIdx,
                to: toIdx,
                value: {
                    attributes: parseObjectValues(attributes),
                },
            });
            for (const [key, value] of Object.entries(attributes)) {
                node.getValue().setAttr(key, value, editedAt);
            }
        }
        return [createdAtMapByActor, changes];
    }
    /**
     * `indexRangeToPosRange` returns the position range of the given index range.
     */
    indexRangeToPosRange(fromIdx, toIdx) {
        const fromPos = this.rgaTreeSplit.indexToPos(fromIdx);
        if (fromIdx === toIdx) {
            return [fromPos, fromPos];
        }
        return [fromPos, this.rgaTreeSplit.indexToPos(toIdx)];
    }
    /**
     * `length` returns size of RGATreeList.
     */
    get length() {
        return this.rgaTreeSplit.length;
    }
    /**
     * `checkWeight` returns false when there is an incorrect weight node.
     * for debugging purpose.
     */
    checkWeight() {
        return this.rgaTreeSplit.checkWeight();
    }
    /**
     * `toJSON` returns the JSON encoding of this text.
     */
    toJSON() {
        const json = [];
        for (const node of this.rgaTreeSplit) {
            if (!node.isRemoved()) {
                json.push(node.getValue().toJSON());
            }
        }
        return `[${json.join(',')}]`;
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of this text.
     */
    toSortedJSON() {
        return this.toJSON();
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     */
    toJSForTest() {
        return {
            createdAt: this.getCreatedAt().toTestString(),
            value: JSON.parse(this.toJSON()),
            type: 'YORKIE_TEXT',
        };
    }
    /**
     * `toString` returns the string representation of this text.
     */
    toString() {
        return this.rgaTreeSplit.toString();
    }
    /**
     * `values` returns the content-attributes pair array of this text.
     */
    values() {
        const values = [];
        for (const node of this.rgaTreeSplit) {
            if (!node.isRemoved()) {
                const value = node.getValue();
                values.push({
                    attributes: parseObjectValues(value.getAttributes()),
                    content: value.getContent(),
                });
            }
        }
        return values;
    }
    /**
     * `getRGATreeSplit` returns rgaTreeSplit.
     *
     * @internal
     */
    getRGATreeSplit() {
        return this.rgaTreeSplit;
    }
    /**
     * `toTestString` returns a String containing the meta data of this value
     * for debugging purpose.
     */
    toTestString() {
        return this.rgaTreeSplit.toTestString();
    }
    /**
     * `getRemovedNodesLen` returns length of removed nodes
     */
    getRemovedNodesLen() {
        return this.rgaTreeSplit.getRemovedNodesLen();
    }
    /**
     * `purgeRemovedNodesBefore` purges removed nodes before the given time.
     *
     * @internal
     */
    purgeRemovedNodesBefore(ticket) {
        return this.rgaTreeSplit.purgeRemovedNodesBefore(ticket);
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const text = new CRDTText(this.rgaTreeSplit.deepcopy(), this.getCreatedAt());
        text.remove(this.getRemovedAt());
        return text;
    }
    /**
     * `findIndexesFromRange` returns pair of integer offsets of the given range.
     */
    findIndexesFromRange(range) {
        return this.rgaTreeSplit.findIndexesFromRange(range);
    }
}

;// CONCATENATED MODULE: ./src/document/operation/edit_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `EditOperation` is an operation representing editing Text. Most of the same as
 * Edit, but with additional style properties, attributes.
 */
class EditOperation extends Operation {
    constructor(parentCreatedAt, fromPos, toPos, maxCreatedAtMapByActor, content, attributes, executedAt) {
        super(parentCreatedAt, executedAt);
        this.fromPos = fromPos;
        this.toPos = toPos;
        this.maxCreatedAtMapByActor = maxCreatedAtMapByActor;
        this.content = content;
        this.attributes = attributes;
    }
    /**
     * `create` creates a new instance of EditOperation.
     */
    static create(parentCreatedAt, fromPos, toPos, maxCreatedAtMapByActor, content, attributes, executedAt) {
        return new EditOperation(parentCreatedAt, fromPos, toPos, maxCreatedAtMapByActor, content, attributes, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTText)) {
            logger.fatal(`fail to execute, only Text can execute edit`);
        }
        const text = parentObject;
        const [, changes] = text.edit([this.fromPos, this.toPos], this.content, this.getExecutedAt(), Object.fromEntries(this.attributes), this.maxCreatedAtMapByActor);
        if (!this.fromPos.equals(this.toPos)) {
            root.registerElementHasRemovedNodes(text);
        }
        return {
            opInfos: changes.map(({ from, to, value }) => {
                return {
                    type: 'edit',
                    from,
                    to,
                    value,
                    path: root.createPath(this.getParentCreatedAt()),
                };
            }),
        };
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.getParentCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        const parent = this.getParentCreatedAt().toTestString();
        const fromPos = this.fromPos.toTestString();
        const toPos = this.toPos.toTestString();
        const content = this.content;
        return `${parent}.EDIT(${fromPos},${toPos},${content})`;
    }
    /**
     * `getFromPos` returns the start point of the editing range.
     */
    getFromPos() {
        return this.fromPos;
    }
    /**
     * `getToPos` returns the end point of the editing range.
     */
    getToPos() {
        return this.toPos;
    }
    /**
     * `getContent` returns the content of Edit.
     */
    getContent() {
        return this.content;
    }
    /**
     * `getAttributes` returns the attributes of this Edit.
     */
    getAttributes() {
        return this.attributes || new Map();
    }
    /**
     * `getMaxCreatedAtMapByActor` returns the map that stores the latest creation time
     * by actor for the nodes included in the editing range.
     */
    getMaxCreatedAtMapByActor() {
        return this.maxCreatedAtMapByActor;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/style_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 *  `StyleOperation` is an operation applies the style of the given range to Text.
 */
class StyleOperation extends Operation {
    constructor(parentCreatedAt, fromPos, toPos, maxCreatedAtMapByActor, attributes, executedAt) {
        super(parentCreatedAt, executedAt);
        this.fromPos = fromPos;
        this.toPos = toPos;
        this.maxCreatedAtMapByActor = maxCreatedAtMapByActor;
        this.attributes = attributes;
    }
    /**
     * `create` creates a new instance of StyleOperation.
     */
    static create(parentCreatedAt, fromPos, toPos, maxCreatedAtMapByActor, attributes, executedAt) {
        return new StyleOperation(parentCreatedAt, fromPos, toPos, maxCreatedAtMapByActor, attributes, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTText)) {
            logger.fatal(`fail to execute, only Text can execute edit`);
        }
        const text = parentObject;
        const [, changes] = text.setStyle([this.fromPos, this.toPos], this.attributes ? Object.fromEntries(this.attributes) : {}, this.getExecutedAt(), this.maxCreatedAtMapByActor);
        return {
            opInfos: changes.map(({ from, to, value }) => {
                return {
                    type: 'style',
                    from,
                    to,
                    value,
                    path: root.createPath(this.getParentCreatedAt()),
                };
            }),
        };
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.getParentCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        const parent = this.getParentCreatedAt().toTestString();
        const fromPos = this.fromPos.toTestString();
        const toPos = this.toPos.toTestString();
        const attributes = this.attributes;
        return `${parent}.STYL(${fromPos},${toPos},${JSON.stringify(attributes)})`;
    }
    /**
     * `getFromPos` returns the start point of the editing range.
     */
    getFromPos() {
        return this.fromPos;
    }
    /**
     * `getToPos` returns the end point of the editing range.
     */
    getToPos() {
        return this.toPos;
    }
    /**
     * `getAttributes` returns the attributes of this operation.
     */
    getAttributes() {
        return this.attributes;
    }
    /**
     * `getMaxCreatedAtMapByActor` returns the map that stores the latest creation time
     * by actor for the nodes included in the editing range.
     */
    getMaxCreatedAtMapByActor() {
        return this.maxCreatedAtMapByActor;
    }
}

;// CONCATENATED MODULE: ./src/util/index_tree.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * About `index`, `path`, `size` and `TreePos` in crdt.IndexTree.
 *
 * `index` of crdt.IndexTree represents a absolute position of a node in the tree.
 * `size` is used to calculate the relative index of nodes in the tree.
 * `index` in yorkie.IndexTree inspired by ProseMirror's index.
 *
 * For example, empty paragraph's size is 0 and index 0 is the position of the:
 *    0
 * <p> </p>,                                p.size = 0
 *
 * If a paragraph has <i>, its size becomes 2 and there are 3 indexes:
 *     0   1    2
 *  <p> <i> </i> </p>                       p.size = 2, i.size = 0
 *
 * If the paragraph has <i> and <b>, its size becomes 4:
 *     0   1    2   3   4
 *  <p> <i> </i> <b> </b> </p>              p.size = 4, i.size = 0, b.size = 0
 *     0   1    2   3    4    5   6
 *  <p> <i> </i> <b> </b> <s> </s> </p>     p.size = 6, i.size = 0, b.size = 0, s.size = 0
 *
 * If a paragraph has text, its size becomes length of the characters:
 *     0 1 2 3
 *  <p> A B C </p>                          p.size = 3,   text.size = 3
 *
 * So the size of a node is the sum of the size and type of its children:
 *  `size = children(element type).length * 2 + children.reduce((child, acc) => child.size + acc, 0)`
 *
 * `TreePos` is also used to represent the position in the tree. It contains node and offset.
 * `TreePos` can be converted to `index` and vice versa.
 *
 * For example, if a paragraph has <i>, there are 3 indexes:
 *     0   1    2
 *  <p> <i> </i> </p>                       p.size = 2, i.size = 0
 *
 * In this case, index of TreePos(p, 0) is 0, index of TreePos(p, 1) is 2.
 * Index 1 can be converted to TreePos(i, 0).
 *
 * `path` of crdt.IndexTree represents a position like `index` in crdt.IndexTree.
 * It contains offsets of each node from the root node as elements except the last.
 * The last element of the path represents the position in the parent node.
 *
 * Let's say we have a tree like this:
 *                     0 1 2
 * <p> <i> a b </i> <b> c d </b> </p>
 *
 * The path of the position between 'c' and 'd' is [1, 1]. The first element of the
 * path is the offset of the <b> in <p> and the second element represents the position
 * between 'c' and 'd' in <b>.
 */
/**
 * `ElementPaddingSize` is the size of an element node as a child of another element node.
 * Because an element node could be considered as a pair of open and close tags.
 */
const ElementPaddingSize = 2;
/**
 * `DefaultRootType` is the default type of the root node.
 * It is used when the type of the root node is not specified.
 */
const DefaultRootType = 'root';
/**
 * `DefaultTextType` is the default type of the text node.
 * It is used when the type of the text node is not specified.
 */
const DefaultTextType = 'text';
/**
 * `addSizeOfLeftSiblings` returns the size of left siblings of the given offset.
 */
function addSizeOfLeftSiblings(parent, offset) {
    let acc = 0;
    const siblings = parent.children;
    for (let i = 0; i < offset; i++) {
        const leftSibling = siblings[i];
        if (!leftSibling || leftSibling.isRemoved) {
            continue;
        }
        acc += leftSibling.paddedSize;
    }
    return acc;
}
/**
 * `IndexTreeNode` is the node of IndexTree. It is used to represent the
 * document of text-based editors.
 */
class IndexTreeNode {
    constructor(type, children = []) {
        this.type = type;
        this.size = 0;
        this._children = children;
        if (this.isText && this._children.length > 0) {
            throw new Error(`Text node cannot have children: ${this.type}`);
        }
    }
    /**
     * `updateAncestorsSize` updates the size of the ancestors.
     */
    updateAncestorsSize() {
        let parent = this.parent;
        const sign = this.isRemoved ? -1 : 1;
        while (parent) {
            parent.size += this.paddedSize * sign;
            parent = parent.parent;
        }
    }
    /**
     * `isText` returns true if the node is a text node.
     */
    get isText() {
        // TODO(hackerwins): We need to get the type of text node from user.
        // Consider the use schema to get the type of text node.
        return this.type === DefaultTextType;
    }
    /**
     * `paddedSize` returns the size of the node including padding size.
     */
    get paddedSize() {
        return this.size + (this.isText ? 0 : ElementPaddingSize);
    }
    /**
     * `isAncenstorOf` returns true if the node is an ancestor of the given node.
     */
    isAncestorOf(node) {
        return ancestorOf(this, node);
    }
    /**
     * `nextSibling` returns the next sibling of the node.
     */
    get nextSibling() {
        const offset = this.parent.findOffset(this);
        const sibling = this.parent.children[offset + 1];
        if (sibling) {
            return sibling;
        }
        return undefined;
    }
    /**
     * `splitText` splits the given node at the given offset.
     */
    splitText(offset, absOffset) {
        if (offset === 0 || offset === this.size) {
            return;
        }
        const leftValue = this.value.slice(0, offset);
        const rightValue = this.value.slice(offset);
        if (!rightValue.length) {
            return;
        }
        this.value = leftValue;
        const rightNode = this.cloneText(offset + absOffset);
        rightNode.value = rightValue;
        this.parent.insertAfterInternal(rightNode, this);
        return rightNode;
    }
    /**
     * `children` returns the children of the node.
     */
    get children() {
        // Tombstone nodes remain awhile in the tree during editing.
        // They will be removed after the editing is done.
        // So, we need to filter out the tombstone nodes to get the real children.
        return this._children.filter((child) => !child.isRemoved);
    }
    /**
     * `allChildren` returns all the children of the node including tombstone nodes.
     * It returns the shallow copy of the children.
     */
    get allChildren() {
        return [...this._children];
    }
    /**
     * `hasTextChild` returns true if the node's children consist of only text children.
     */
    hasTextChild() {
        return (this.children.length > 0 && this.children.every((child) => child.isText));
    }
    /**
     * `append` appends the given nodes to the children.
     */
    append(...newNode) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        this._children.push(...newNode);
        for (const node of newNode) {
            node.parent = this;
            node.updateAncestorsSize();
        }
    }
    /**
     * `prepend` prepends the given nodes to the children.
     */
    prepend(...newNode) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        this._children.unshift(...newNode);
        for (const node of newNode) {
            node.parent = this;
            if (!node.isRemoved) {
                node.updateAncestorsSize();
            }
        }
    }
    /**
     * `insertBefore` inserts the given node before the given child.
     */
    insertBefore(newNode, referenceNode) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        const offset = this._children.indexOf(referenceNode);
        if (offset === -1) {
            throw new Error('child not found');
        }
        this.insertAtInternal(newNode, offset);
        newNode.updateAncestorsSize();
    }
    /**
     * `insertAfter` inserts the given node after the given child.
     */
    insertAfter(newNode, referenceNode) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        const offset = this._children.indexOf(referenceNode);
        if (offset === -1) {
            throw new Error('child not found');
        }
        this.insertAtInternal(newNode, offset + 1);
        newNode.updateAncestorsSize();
    }
    /**
     * `insertAt` inserts the given node at the given offset.
     */
    insertAt(newNode, offset) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        this.insertAtInternal(newNode, offset);
        newNode.updateAncestorsSize();
    }
    /**
     * `removeChild` removes the given child.
     */
    removeChild(child) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        const offset = this._children.indexOf(child);
        if (offset === -1) {
            throw new Error('child not found');
        }
        this._children.splice(offset, 1);
        child.parent = undefined;
    }
    /**
     * `splitElement` splits the given element at the given offset.
     */
    splitElement(offset, issueTimeTicket) {
        /**
         * TODO(hackerwins): Define ID of split node for concurrent editing.
         * Text has fixed content and its split nodes could have limited offset
         * range. But element node could have arbitrary children and its split
         * nodes could have arbitrary offset range. So, id could be duplicated
         * and its order could be broken when concurrent editing happens.
         * Currently, we use the similar ID of split element with the split text.
         */
        const clone = this.cloneElement(issueTimeTicket);
        this.parent.insertAfterInternal(clone, this);
        clone.updateAncestorsSize();
        const leftChildren = this.children.slice(0, offset);
        const rightChildren = this.children.slice(offset);
        this._children = leftChildren;
        clone._children = rightChildren;
        this.size = this._children.reduce((acc, child) => acc + child.paddedSize, 0);
        clone.size = clone._children.reduce((acc, child) => acc + child.paddedSize, 0);
        for (const child of clone._children) {
            child.parent = clone;
        }
        return clone;
    }
    /**
     * `insertAfterInternal` inserts the given node after the given child.
     * This method does not update the size of the ancestors.
     */
    insertAfterInternal(newNode, referenceNode) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        const offset = this._children.indexOf(referenceNode);
        if (offset === -1) {
            throw new Error('child not found');
        }
        this.insertAtInternal(newNode, offset + 1);
    }
    /**
     * `insertAtInternal` inserts the given node at the given index.
     * This method does not update the size of the ancestors.
     */
    insertAtInternal(newNode, offset) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        this._children.splice(offset, 0, newNode);
        newNode.parent = this;
    }
    /**
     * findOffset returns the offset of the given node in the children.
     * It excludes the removed nodes.
     */
    findOffset(node) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        if (node.isRemoved) {
            const index = this._children.indexOf(node);
            // If nodes are removed, the offset of the removed node is the number of
            // nodes before the node excluding the removed nodes.
            const refined = this.allChildren
                .splice(0, index)
                .filter((node) => !node.isRemoved).length;
            return refined;
        }
        return this.children.indexOf(node);
    }
    /**
     * `findBranchOffset` returns offset of the given descendant node in this node.
     * If the given node is not a descendant of this node, it returns -1.
     */
    findBranchOffset(node) {
        if (this.isText) {
            throw new Error('Text node cannot have children');
        }
        let current = node;
        while (current) {
            const offset = this._children.indexOf(current);
            if (offset !== -1) {
                return offset;
            }
            current = current.parent;
        }
        return -1;
    }
}
/**
 * `ancestorOf` returns true if the given node is an ancestor of the other node.
 */
function ancestorOf(ancestor, node) {
    if (ancestor === node) {
        return false;
    }
    while (node.parent) {
        if (node.parent === ancestor) {
            return true;
        }
        node = node.parent;
    }
    return false;
}
/**
 * `TokenType` represents the type of token in XML representation.
 */
var TokenType;
(function (TokenType) {
    /**
     * `Start` represents that the start token type.
     */
    TokenType["Start"] = "Start";
    /**
     * `End` represents that the end token type.
     */
    TokenType["End"] = "End";
    /**
     * `Text` represents that the text token type.
     */
    TokenType["Text"] = "Text";
})(TokenType || (TokenType = {}));
/**
 * `tokensBetween` iterates the tokens between the given range.
 *
 * For example, if the tree is <p><i>abc</i></p>, the tokens are
 * [p, Start], [i, Start], [abc, Text], [i, End], [p, End].
 *
 * If the given range is collapsed, the callback is not called.
 * It traverses the tree based on the concept of token.
 * NOTE(sejongk): Nodes should not be removed in callback, because it leads wrong behaviors.
 */
function tokensBetween(root, from, to, callback) {
    if (from > to) {
        throw new Error(`from is greater than to: ${from} > ${to}`);
    }
    if (from > root.size) {
        throw new Error(`from is out of range: ${from} > ${root.size}`);
    }
    if (to > root.size) {
        throw new Error(`to is out of range: ${to} > ${root.size}`);
    }
    if (from === to) {
        return;
    }
    let pos = 0;
    for (const child of root.children) {
        // If the child is an element node, the size of the child.
        if (from - child.paddedSize < pos && pos < to) {
            // If the child is an element node, the range of the child
            // is from - 1 to to - 1. Because the range of the element node is from
            // the open tag to the close tag.
            const fromChild = child.isText ? from - pos : from - pos - 1;
            const toChild = child.isText ? to - pos : to - pos - 1;
            // If the range spans outside the child,
            // the callback is called with the child.
            const startContained = !child.isText && fromChild < 0;
            const endContained = !child.isText && toChild > child.size;
            if (child.isText || startContained) {
                callback([child, child.isText ? TokenType.Text : TokenType.Start], endContained);
            }
            tokensBetween(child, Math.max(0, fromChild), Math.min(toChild, child.size), callback);
            if (endContained) {
                callback([child, TokenType.End], endContained);
            }
        }
        pos += child.paddedSize;
    }
}
/**
 * `traverse` traverses the tree with postorder traversal.
 */
function traverse(node, callback, depth = 0) {
    for (const child of node.children) {
        traverse(child, callback, depth + 1);
    }
    callback(node, depth);
}
/**
 * `traverseAll` traverses the whole tree (include tombstones) with postorder traversal.
 */
function traverseAll(node, callback, depth = 0) {
    for (const child of node._children) {
        traverseAll(child, callback, depth + 1);
    }
    callback(node, depth);
}
/**
 * `findTreePos` finds the position of the given index in the given node.
 */
function findTreePos(node, index, preferText = true) {
    if (index > node.size) {
        throw new Error(`index is out of range: ${index} > ${node.size}`);
    }
    if (node.isText) {
        return { node, offset: index };
    }
    // offset is the index of the child node.
    // pos is the window of the index in the given node.
    let offset = 0;
    let pos = 0;
    for (const child of node.children) {
        // The pos is in bothsides of the text node, we should traverse
        // inside of the text node if preferText is true.
        if (preferText && child.isText && child.size >= index - pos) {
            return findTreePos(child, index - pos, preferText);
        }
        // The position is in leftside of the element node.
        if (index === pos) {
            return { node, offset };
        }
        // The position is in rightside of the element node and preferText is false.
        if (!preferText && child.paddedSize === index - pos) {
            return { node, offset: offset + 1 };
        }
        // The position is in middle the element node.
        if (child.paddedSize > index - pos) {
            // If we traverse inside of the element node, we should skip the open.
            const skipOpenSize = 1;
            return findTreePos(child, index - pos - skipOpenSize, preferText);
        }
        pos += child.paddedSize;
        offset += 1;
    }
    // The position is in rightmost of the given node.
    return { node, offset };
}
/**
 * `getAncestors` returns the ancestors of the given node.
 */
function getAncestors(node) {
    const ancestors = [];
    let parent = node.parent;
    while (parent) {
        ancestors.unshift(parent);
        parent = parent.parent;
    }
    return ancestors;
}
/**
 * `findCommonAncestor` finds the lowest common ancestor of the given nodes.
 */
function findCommonAncestor(nodeA, nodeB) {
    if (nodeA === nodeB) {
        return nodeA;
    }
    const ancestorsOfA = getAncestors(nodeA);
    const ancestorsOfB = getAncestors(nodeB);
    let commonAncestor;
    for (let i = 0; i < ancestorsOfA.length; i++) {
        const ancestorOfA = ancestorsOfA[i];
        const ancestorOfB = ancestorsOfB[i];
        if (ancestorOfA !== ancestorOfB) {
            break;
        }
        commonAncestor = ancestorOfA;
    }
    return commonAncestor;
}
/**
 * `findLeftmost` finds the leftmost node of the given tree.
 */
function findLeftmost(node) {
    if (node.isText || node.children.length === 0) {
        return node;
    }
    return findLeftmost(node.children[0]);
}
/**
 * `findTextPos` returns the tree position of the given path element.
 */
function findTextPos(node, pathElement) {
    if (node.size < pathElement) {
        throw new Error('unacceptable path');
    }
    for (let i = 0; i < node.children.length; i++) {
        const child = node.children[i];
        if (child.size < pathElement) {
            pathElement -= child.size;
        }
        else {
            node = child;
            break;
        }
    }
    return { node, offset: pathElement };
}
/**
 * `IndexTree` is a tree structure for linear indexing.
 */
class IndexTree {
    constructor(root) {
        this.root = root;
    }
    /**
     * `tokensBetween` returns the tokens between the given range.
     */
    tokensBetween(from, to, callback) {
        tokensBetween(this.root, from, to, callback);
    }
    /**
     * `traverse` traverses the tree with postorder traversal.
     */
    traverse(callback) {
        traverse(this.root, callback, 0);
    }
    /**
     * `traverseAll` traverses the whole tree (include tombstones) with postorder traversal.
     */
    traverseAll(callback) {
        traverseAll(this.root, callback, 0);
    }
    /**
     * findTreePos finds the position of the given index in the tree.
     */
    findTreePos(index, preferText = true) {
        return findTreePos(this.root, index, preferText);
    }
    /**
     * `treePosToPath` returns path from given treePos
     */
    treePosToPath(treePos) {
        const path = [];
        let node = treePos.node;
        if (node.isText) {
            const offset = node.parent.findOffset(node);
            if (offset === -1) {
                throw new Error('invalid treePos');
            }
            const sizeOfLeftSiblings = addSizeOfLeftSiblings(node.parent, offset);
            path.push(sizeOfLeftSiblings + treePos.offset);
            node = node.parent;
        }
        else if (node.hasTextChild()) {
            // TODO(hackerwins): The function does not consider the situation
            // where Element and Text nodes are mixed in the Element's Children.
            const sizeOfLeftSiblings = addSizeOfLeftSiblings(node, treePos.offset);
            path.push(sizeOfLeftSiblings);
        }
        else {
            path.push(treePos.offset);
        }
        while (node.parent) {
            const offset = node.parent.findOffset(node);
            if (offset === -1) {
                throw new Error('invalid treePos');
            }
            path.push(offset);
            node = node.parent;
        }
        return path.reverse();
    }
    /**
     * `pathToIndex` returns index from given path
     */
    pathToIndex(path) {
        const treePos = this.pathToTreePos(path);
        return this.indexOf(treePos);
    }
    /**
     * `pathToTreePos` returns treePos from given path
     */
    pathToTreePos(path) {
        if (!path.length) {
            throw new Error('unacceptable path');
        }
        let node = this.root;
        for (let i = 0; i < path.length - 1; i++) {
            const pathElement = path[i];
            node = node.children[pathElement];
            if (!node) {
                throw new Error('unacceptable path');
            }
        }
        if (node.hasTextChild()) {
            return findTextPos(node, path[path.length - 1]);
        }
        if (node.children.length < path[path.length - 1]) {
            throw new Error('unacceptable path');
        }
        return {
            node,
            offset: path[path.length - 1],
        };
    }
    /**
     * `getRoot` returns the root node of the tree.
     */
    getRoot() {
        return this.root;
    }
    /**
     * `getSize` returns the size of the tree.
     */
    get size() {
        return this.root.size;
    }
    /**
     * `findPostorderRight` finds right node of the given tree position with
     *  postorder traversal.
     */
    findPostorderRight(treePos) {
        const { node, offset } = treePos;
        if (node.isText) {
            if (node.size === offset) {
                const nextSibling = node.nextSibling;
                if (nextSibling) {
                    return nextSibling;
                }
                return node.parent;
            }
            return node;
        }
        if (node.children.length === offset) {
            return node;
        }
        return findLeftmost(node.children[offset]);
    }
    /**
     * `indexOf` returns the index of the given tree position.
     */
    indexOf(pos) {
        let { node } = pos;
        const { offset } = pos;
        let size = 0;
        let depth = 1;
        if (node.isText) {
            size += offset;
            const parent = node.parent;
            const offsetOfNode = parent.findOffset(node);
            if (offsetOfNode === -1) {
                throw new Error('invalid pos');
            }
            size += addSizeOfLeftSiblings(parent, offsetOfNode);
            node = node.parent;
        }
        else {
            size += addSizeOfLeftSiblings(node, offset);
        }
        while (node === null || node === void 0 ? void 0 : node.parent) {
            const parent = node.parent;
            const offsetOfNode = parent.findOffset(node);
            if (offsetOfNode === -1) {
                throw new Error('invalid pos');
            }
            size += addSizeOfLeftSiblings(parent, offsetOfNode);
            depth++;
            node = node.parent;
        }
        return size + depth - 1;
    }
    /**
     * `indexToPath` returns the path of the given index.
     */
    indexToPath(index) {
        const treePos = this.findTreePos(index);
        return this.treePosToPath(treePos);
    }
}

;// CONCATENATED MODULE: ./src/util/comparator.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
const DefaultComparator = (a, b) => {
    if (a === b) {
        return 0;
    }
    else if (a < b) {
        return -1;
    }
    else {
        return 1;
    }
};

;// CONCATENATED MODULE: ./src/util/llrb_tree.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `LLRBNode` is node of LLRBTree.
 */
class LLRBNode {
    constructor(key, value, isRed) {
        this.key = key;
        this.value = value;
        this.isRed = isRed;
    }
}
/**
 * `SortedMapIterator` is a interator for traversing LLRBTree.
 */
class SortedMapIterator {
    constructor(root) {
        this.stack = [];
        this.traverseInorder(root);
    }
    // TODO: Replace with iterative approach, if we encounter performance problem.
    traverseInorder(node) {
        if (!node) {
            return;
        }
        this.traverseInorder(node.left);
        this.stack.push({
            key: node.key,
            value: node.value,
        });
        this.traverseInorder(node.right);
    }
}
/**
 * LLRBTree is an implementation of Left-learning Red-Black Tree.
 *
 * Original paper on Left-leaning Red-Black Trees:
 * @see http://www.cs.princeton.edu/~rs/talks/LLRB/LLRB.pdf
 *
 * Invariant 1: No red node has a red child
 * Invariant 2: Every leaf path has the same number of black nodes
 * Invariant 3: Only the left child can be red (left leaning)
 */
class LLRBTree {
    constructor(comparator) {
        this.comparator =
            typeof comparator !== 'undefined' ? comparator : DefaultComparator;
        this.counter = 0;
    }
    /**
     * `put` puts the value of the given key.
     */
    put(key, value) {
        this.root = this.putInternal(key, value, this.root);
        this.root.isRed = false;
        return value;
    }
    /**
     * `get` gets a value of the given key.
     */
    get(key) {
        const node = this.getInternal(key, this.root);
        return node ? node.value : undefined;
    }
    /**
     * `remove` removes a element of key.
     */
    remove(key) {
        if (!this.isRed(this.root.left) && !this.isRed(this.root.right)) {
            this.root.isRed = true;
        }
        this.root = this.removeInternal(this.root, key);
        if (this.root) {
            this.root.isRed = false;
        }
    }
    /**
     * `getIterator` returns a new instance of SortedMapIterator.
     */
    getIterator() {
        return new SortedMapIterator(this.root);
    }
    /**
     * `values` returns value array of LLRBTree.
     */
    values() {
        const values = [];
        for (const entry of this.getIterator().stack) {
            values.push(entry.value);
        }
        return values;
    }
    /**
     * `floorEntry` returns the entry for the greatest key less than or equal to the
     *  given key. If there is no such key, returns `undefined`.
     */
    floorEntry(key) {
        let node = this.root;
        while (node) {
            const compare = this.comparator(key, node.key);
            if (compare > 0) {
                if (node.right) {
                    node.right.parent = node;
                    node = node.right;
                }
                else {
                    return node;
                }
            }
            else if (compare < 0) {
                if (node.left) {
                    node.left.parent = node;
                    node = node.left;
                }
                else {
                    let parent = node.parent;
                    let childNode = node;
                    while (parent && childNode === parent.left) {
                        childNode = parent;
                        parent = parent.parent;
                    }
                    return parent;
                }
            }
            else {
                return node;
            }
        }
        return;
    }
    /**
     * `lastEntry` returns last entry of LLRBTree.
     */
    lastEntry() {
        if (!this.root) {
            return this.root;
        }
        let node = this.root;
        while (node.right) {
            node = node.right;
        }
        return node;
    }
    /**
     * `size` is a size of LLRBTree.
     */
    size() {
        return this.counter;
    }
    /**
     * `isEmpty` checks if size is empty.
     */
    isEmpty() {
        return this.counter === 0;
    }
    getInternal(key, node) {
        while (node) {
            const compare = this.comparator(key, node.key);
            if (compare === 0) {
                return node;
            }
            else if (compare < 0) {
                node = node.left;
            }
            else if (compare > 0) {
                node = node.right;
            }
        }
        return;
    }
    putInternal(key, value, node) {
        if (!node) {
            this.counter += 1;
            return new LLRBNode(key, value, true);
        }
        const compare = this.comparator(key, node.key);
        if (compare < 0) {
            node.left = this.putInternal(key, value, node.left);
        }
        else if (compare > 0) {
            node.right = this.putInternal(key, value, node.right);
        }
        else {
            node.value = value;
        }
        if (this.isRed(node.right) && !this.isRed(node.left)) {
            node = this.rotateLeft(node);
        }
        if (this.isRed(node.left) && this.isRed(node.left.left)) {
            node = this.rotateRight(node);
        }
        if (this.isRed(node.left) && this.isRed(node.right)) {
            this.flipColors(node);
        }
        return node;
    }
    removeInternal(node, key) {
        if (this.comparator(key, node.key) < 0) {
            if (!this.isRed(node.left) && !this.isRed(node.left.left)) {
                node = this.moveRedLeft(node);
            }
            node.left = this.removeInternal(node.left, key);
        }
        else {
            if (this.isRed(node.left)) {
                node = this.rotateRight(node);
            }
            if (this.comparator(key, node.key) === 0 && !node.right) {
                this.counter -= 1;
                return;
            }
            if (!this.isRed(node.right) && !this.isRed(node.right.left)) {
                node = this.moveRedRight(node);
            }
            if (this.comparator(key, node.key) === 0) {
                this.counter -= 1;
                const smallest = this.min(node.right);
                node.value = smallest.value;
                node.key = smallest.key;
                node.right = this.removeMin(node.right);
            }
            else {
                node.right = this.removeInternal(node.right, key);
            }
        }
        return this.fixUp(node);
    }
    min(node) {
        if (!node.left) {
            return node;
        }
        else {
            return this.min(node.left);
        }
    }
    removeMin(node) {
        if (!node.left) {
            return;
        }
        if (!this.isRed(node.left) && !this.isRed(node.left.left)) {
            node = this.moveRedLeft(node);
        }
        node.left = this.removeMin(node.left);
        return this.fixUp(node);
    }
    fixUp(node) {
        if (this.isRed(node.right)) {
            node = this.rotateLeft(node);
        }
        if (this.isRed(node.left) && this.isRed(node.left.left)) {
            node = this.rotateRight(node);
        }
        if (this.isRed(node.left) && this.isRed(node.right)) {
            this.flipColors(node);
        }
        return node;
    }
    moveRedLeft(node) {
        this.flipColors(node);
        if (this.isRed(node.right.left)) {
            node.right = this.rotateRight(node.right);
            node = this.rotateLeft(node);
            this.flipColors(node);
        }
        return node;
    }
    moveRedRight(node) {
        this.flipColors(node);
        if (this.isRed(node.left.left)) {
            node = this.rotateRight(node);
            this.flipColors(node);
        }
        return node;
    }
    isRed(node) {
        return node && node.isRed;
    }
    rotateLeft(node) {
        const x = node.right;
        node.right = x.left;
        x.left = node;
        x.isRed = x.left.isRed;
        x.left.isRed = true;
        return x;
    }
    rotateRight(node) {
        const x = node.left;
        node.left = x.right;
        x.right = node;
        x.isRed = x.right.isRed;
        x.right.isRed = true;
        return x;
    }
    flipColors(node) {
        node.isRed = !node.isRed;
        node.left.isRed = !node.left.isRed;
        node.right.isRed = !node.right.isRed;
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/tree.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */






/**
 * `TreeChangeType` represents the type of change in the tree.
 */
var TreeChangeType;
(function (TreeChangeType) {
    TreeChangeType["Content"] = "content";
    TreeChangeType["Style"] = "style";
    TreeChangeType["RemoveStyle"] = "removeStyle";
})(TreeChangeType || (TreeChangeType = {}));
/**
 * `CRDTTreePos` represent a position in the tree. It is used to identify a
 * position in the tree. It is composed of the parent ID and the left sibling
 * ID. If there's no left sibling in parent's children, then left sibling is
 * parent.
 */
class CRDTTreePos {
    constructor(parentID, leftSiblingID) {
        this.parentID = parentID;
        this.leftSiblingID = leftSiblingID;
    }
    /**
     * `of` creates a new instance of CRDTTreePos.
     */
    static of(parentID, leftSiblingID) {
        return new CRDTTreePos(parentID, leftSiblingID);
    }
    /**
     * `fromTreePos` creates a new instance of CRDTTreePos from the given TreePos.
     */
    static fromTreePos(pos) {
        const { offset } = pos;
        let { node } = pos;
        let leftNode;
        if (node.isText) {
            if (node.parent.children[0] === node && offset === 0) {
                leftNode = node.parent;
            }
            else {
                leftNode = node;
            }
            node = node.parent;
        }
        else {
            if (offset === 0) {
                leftNode = node;
            }
            else {
                leftNode = node.children[offset - 1];
            }
        }
        return CRDTTreePos.of(node.id, CRDTTreeNodeID.of(leftNode.getCreatedAt(), leftNode.getOffset() + offset));
    }
    /**
     * `getParentID` returns the parent ID.
     */
    getParentID() {
        return this.parentID;
    }
    /**
     * `fromStruct` creates a new instance of CRDTTreeNodeID from the given struct.
     */
    static fromStruct(struct) {
        return CRDTTreePos.of(CRDTTreeNodeID.of(TimeTicket.fromStruct(struct.parentID.createdAt), struct.parentID.offset), CRDTTreeNodeID.of(TimeTicket.fromStruct(struct.leftSiblingID.createdAt), struct.leftSiblingID.offset));
    }
    /**
     * `toStruct` returns the structure of this position.
     */
    toStruct() {
        return {
            parentID: {
                createdAt: this.getParentID().getCreatedAt().toStruct(),
                offset: this.getParentID().getOffset(),
            },
            leftSiblingID: {
                createdAt: this.getLeftSiblingID().getCreatedAt().toStruct(),
                offset: this.getLeftSiblingID().getOffset(),
            },
        };
    }
    /**
     * `toTreeNodes` converts the pos to parent and left sibling nodes.
     * If the position points to the middle of a node, then the left sibling node
     * is the node that contains the position. Otherwise, the left sibling node is
     * the node that is located at the left of the position.
     */
    toTreeNodes(tree) {
        const parentID = this.getParentID();
        const leftSiblingID = this.getLeftSiblingID();
        const parentNode = tree.findFloorNode(parentID);
        let leftNode = tree.findFloorNode(leftSiblingID);
        if (!parentNode || !leftNode) {
            throw new Error(`cannot find node at ${this}`);
        }
        /**
         * NOTE(hackerwins): If the left node and the parent node are the same,
         * it means that the position is the left-most of the parent node.
         * We need to skip finding the left of the position.
         */
        if (!leftSiblingID.equals(parentID) &&
            leftSiblingID.getOffset() > 0 &&
            leftSiblingID.getOffset() === leftNode.id.getOffset() &&
            leftNode.insPrevID) {
            leftNode = tree.findFloorNode(leftNode.insPrevID);
        }
        return [parentNode, leftNode];
    }
    /**
     * `getLeftSiblingID` returns the left sibling ID.
     */
    getLeftSiblingID() {
        return this.leftSiblingID;
    }
    /**
     * `equals` returns whether the given pos equals to this or not.
     */
    equals(other) {
        return (this.getParentID()
            .getCreatedAt()
            .equals(other.getParentID().getCreatedAt()) &&
            this.getParentID().getOffset() === other.getParentID().getOffset() &&
            this.getLeftSiblingID()
                .getCreatedAt()
                .equals(other.getLeftSiblingID().getCreatedAt()) &&
            this.getLeftSiblingID().getOffset() ===
                other.getLeftSiblingID().getOffset());
    }
}
/**
 * `CRDTTreeNodeID` represent an ID of a node in the tree. It is used to
 * identify a node in the tree. It is composed of the creation time of the node
 * and the offset from the beginning of the node if the node is split.
 *
 * Some of replicas may have nodes that are not split yet. In this case, we can
 * use `map.floorEntry()` to find the adjacent node.
 */
class CRDTTreeNodeID {
    constructor(createdAt, offset) {
        this.createdAt = createdAt;
        this.offset = offset;
    }
    /**
     * `of` creates a new instance of CRDTTreeNodeID.
     */
    static of(createdAt, offset) {
        return new CRDTTreeNodeID(createdAt, offset);
    }
    /**
     * `fromStruct` creates a new instance of CRDTTreeNodeID from the given struct.
     */
    static fromStruct(struct) {
        return CRDTTreeNodeID.of(TimeTicket.fromStruct(struct.createdAt), struct.offset);
    }
    /**
     * `createComparator` creates a comparator for CRDTTreeNodeID.
     */
    static createComparator() {
        return (idA, idB) => {
            const compare = idA.getCreatedAt().compare(idB.getCreatedAt());
            if (compare !== 0) {
                return compare;
            }
            if (idA.getOffset() > idB.getOffset()) {
                return 1;
            }
            else if (idA.getOffset() < idB.getOffset()) {
                return -1;
            }
            return 0;
        };
    }
    /**
     * `getCreatedAt` returns the creation time of the node.
     */
    getCreatedAt() {
        return this.createdAt;
    }
    /**
     * `equals` returns whether given ID equals to this ID or not.
     */
    equals(other) {
        return (this.createdAt.compare(other.createdAt) === 0 &&
            this.offset === other.offset);
    }
    /**
     * `getOffset` returns returns the offset of the node.
     */
    getOffset() {
        return this.offset;
    }
    /**
     * `setOffset` sets the offset of the node.
     */
    setOffset(offset) {
        this.offset = offset;
    }
    /**
     * `toStruct` returns the structure of this position.
     */
    toStruct() {
        return {
            createdAt: this.createdAt.toStruct(),
            offset: this.offset,
        };
    }
    /**
     * `toIDString` returns a string that can be used as an ID for this position.
     */
    toIDString() {
        return `${this.createdAt.toIDString()}:${this.offset}`;
    }
    /**
     * `toTestString` returns a string containing the meta data of the ticket
     * for debugging purpose.
     */
    toTestString() {
        return `${this.createdAt.toTestString()}:${this.offset}`;
    }
}
/**
 * `CRDTTreeNode` is a node of CRDTTree. It is includes the logical clock and
 * links to other nodes to resolve conflicts.
 */
class CRDTTreeNode extends IndexTreeNode {
    constructor(id, type, opts, attributes, removedAt) {
        super(type);
        this._value = '';
        this.id = id;
        this.removedAt = removedAt;
        attributes && (this.attrs = attributes);
        if (typeof opts === 'string') {
            this.value = opts;
        }
        else if (Array.isArray(opts)) {
            this._children = opts;
        }
    }
    /**
     * `create` creates a new instance of CRDTTreeNode.
     */
    static create(id, type, opts, attributes) {
        return new CRDTTreeNode(id, type, opts, attributes);
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        var _a;
        const clone = new CRDTTreeNode(this.id, this.type);
        clone.removedAt = this.removedAt;
        clone._value = this._value;
        clone.size = this.size;
        clone.attrs = (_a = this.attrs) === null || _a === void 0 ? void 0 : _a.deepcopy();
        clone._children = this._children.map((child) => {
            const childClone = child.deepcopy();
            childClone.parent = clone;
            return childClone;
        });
        clone.insPrevID = this.insPrevID;
        clone.insNextID = this.insNextID;
        return clone;
    }
    /**
     * `value` returns the value of the node.
     */
    get value() {
        if (!this.isText) {
            throw new Error(`cannot get value of element node: ${this.type}`);
        }
        return this._value;
    }
    /**
     * `value` sets the value of the node.
     */
    set value(v) {
        if (!this.isText) {
            throw new Error(`cannot set value of element node: ${this.type}`);
        }
        this._value = v;
        this.size = v.length;
    }
    /**
     * `isRemoved` returns whether the node is removed or not.
     */
    get isRemoved() {
        return !!this.removedAt;
    }
    /**
     * `remove` marks the node as removed.
     */
    remove(removedAt) {
        const alived = !this.removedAt;
        if (!this.removedAt || this.removedAt.compare(removedAt) > 0) {
            this.removedAt = removedAt;
        }
        if (alived) {
            if (!this.parent.removedAt) {
                this.updateAncestorsSize();
            }
            else {
                this.parent.size -= this.paddedSize;
            }
        }
    }
    /**
     * `cloneText` clones this text node with the given offset.
     */
    cloneText(offset) {
        return new CRDTTreeNode(CRDTTreeNodeID.of(this.id.getCreatedAt(), offset), this.type, undefined, undefined, this.removedAt);
    }
    /**
     * `cloneElement` clones this element node with the given issueTimeTicket function.
     */
    cloneElement(issueTimeTicket) {
        return new CRDTTreeNode(CRDTTreeNodeID.of(issueTimeTicket(), 0), this.type, undefined, undefined, this.removedAt);
    }
    /**
     * `split` splits the given offset of this node.
     */
    split(tree, offset, issueTimeTicket) {
        const split = this.isText
            ? this.splitText(offset, this.id.getOffset())
            : this.splitElement(offset, issueTimeTicket);
        if (split) {
            split.insPrevID = this.id;
            if (this.insNextID) {
                const insNext = tree.findFloorNode(this.insNextID);
                insNext.insPrevID = split.id;
                split.insNextID = this.insNextID;
            }
            this.insNextID = split.id;
            tree.registerNode(split);
        }
        return split;
    }
    /**
     * `getCreatedAt` returns the creation time of this element.
     */
    getCreatedAt() {
        return this.id.getCreatedAt();
    }
    /**
     * `getOffset` returns the offset of a pos.
     */
    getOffset() {
        return this.id.getOffset();
    }
    /**
     * `canDelete` checks if node is able to delete.
     */
    canDelete(editedAt, latestCreatedAt) {
        return (!this.getCreatedAt().after(latestCreatedAt) &&
            (!this.removedAt || editedAt.after(this.removedAt)));
    }
}
/**
 * toTreeNode converts the given CRDTTreeNode to TreeNode.
 */
function toTreeNode(node) {
    var _a;
    if (node.isText) {
        const currentNode = node;
        return {
            type: currentNode.type,
            value: currentNode.value,
        };
    }
    return {
        type: node.type,
        children: node.children.map(toTreeNode),
        attributes: node.attrs
            ? parseObjectValues((_a = node.attrs) === null || _a === void 0 ? void 0 : _a.toObject())
            : undefined,
    };
}
/**
 * toXML converts the given CRDTNode to XML string.
 */
function toXML(node) {
    var _a;
    if (node.isText) {
        const currentNode = node;
        return currentNode.value;
    }
    return `<${node.type}${((_a = node.attrs) === null || _a === void 0 ? void 0 : _a.toXML()) || ''}>${node.children
        .map((child) => toXML(child))
        .join('')}</${node.type}>`;
}
/**
 * `toTestTreeNode` converts the given CRDTNode JSON for debugging.
 */
function toTestTreeNode(node) {
    if (node.isText) {
        const currentNode = node;
        return {
            type: currentNode.type,
            value: currentNode.value,
            size: currentNode.size,
            isRemoved: currentNode.isRemoved,
        };
    }
    return {
        type: node.type,
        children: node.children.map(toTestTreeNode),
        size: node.size,
        isRemoved: node.isRemoved,
    };
}
/**
 * `CRDTTree` is a CRDT implementation of a tree.
 */
class CRDTTree extends CRDTGCElement {
    constructor(root, createdAt) {
        super(createdAt);
        this.indexTree = new IndexTree(root);
        this.nodeMapByID = new LLRBTree(CRDTTreeNodeID.createComparator());
        this.removedNodeMap = new Map();
        this.indexTree.traverse((node) => {
            this.nodeMapByID.put(node.id, node);
        });
    }
    /**
     * `create` creates a new instance of `CRDTTree`.
     */
    static create(root, ticket) {
        return new CRDTTree(root, ticket);
    }
    /**
     * `findFloorNode` finds node of given id.
     */
    findFloorNode(id) {
        const entry = this.nodeMapByID.floorEntry(id);
        if (!entry || !entry.key.getCreatedAt().equals(id.getCreatedAt())) {
            return;
        }
        return entry.value;
    }
    /**
     * `registerNode` registers the given node to the tree.
     */
    registerNode(node) {
        this.nodeMapByID.put(node.id, node);
    }
    /**
     * `findNodesAndSplitText` finds `TreePos` of the given `CRDTTreeNodeID` and
     * splits nodes if the position is in the middle of a text node.
     *
     * The ids of the given `pos` are the ids of the node in the CRDT perspective.
     * This is different from `TreePos` which is a position of the tree in the
     * physical perspective.
     *
     * If `editedAt` is given, then it is used to find the appropriate left node
     * for concurrent insertion.
     */
    findNodesAndSplitText(pos, editedAt) {
        // 01. Find the parent and left sibling node of the given position.
        const [parent, leftSibling] = pos.toTreeNodes(this);
        let leftNode = leftSibling;
        // 02. Determine whether the position is left-most and the exact parent
        // in the current tree.
        const isLeftMost = parent === leftNode;
        const realParent = leftNode.parent && !isLeftMost ? leftNode.parent : parent;
        // 03. Split text node if the left node is a text node.
        if (leftNode.isText) {
            leftNode.split(this, pos.getLeftSiblingID().getOffset() - leftNode.id.getOffset());
        }
        // 04. Find the appropriate left node. If some nodes are inserted at the
        // same position concurrently, then we need to find the appropriate left
        // node. This is similar to RGA.
        if (editedAt) {
            const allChildren = realParent.allChildren;
            const index = isLeftMost ? 0 : allChildren.indexOf(leftNode) + 1;
            for (let i = index; i < allChildren.length; i++) {
                const next = allChildren[i];
                if (!next.id.getCreatedAt().after(editedAt)) {
                    break;
                }
                leftNode = next;
            }
        }
        return [realParent, leftNode];
    }
    /**
     * `style` applies the given attributes of the given range.
     */
    style(range, attributes, editedAt) {
        const [fromParent, fromLeft] = this.findNodesAndSplitText(range[0], editedAt);
        const [toParent, toLeft] = this.findNodesAndSplitText(range[1], editedAt);
        const changes = [];
        const value = attributes ? parseObjectValues(attributes) : undefined;
        this.traverseInPosRange(fromParent, fromLeft, toParent, toLeft, ([node]) => {
            if (!node.isRemoved && !node.isText && attributes) {
                if (!node.attrs) {
                    node.attrs = new RHT();
                }
                for (const [key, value] of Object.entries(attributes)) {
                    node.attrs.set(key, value, editedAt);
                }
                changes.push({
                    type: TreeChangeType.Style,
                    from: this.toIndex(fromParent, fromLeft),
                    to: this.toIndex(toParent, toLeft),
                    fromPath: this.toPath(fromParent, fromLeft),
                    toPath: this.toPath(toParent, toLeft),
                    actor: editedAt.getActorID(),
                    value,
                });
            }
        });
        return changes;
    }
    /**
     * `removeStyle` removes the given attributes of the given range.
     */
    removeStyle(range, attributesToRemove, editedAt) {
        const [fromParent, fromLeft] = this.findNodesAndSplitText(range[0], editedAt);
        const [toParent, toLeft] = this.findNodesAndSplitText(range[1], editedAt);
        const changes = [];
        const value = attributesToRemove ? attributesToRemove : undefined;
        this.traverseInPosRange(fromParent, fromLeft, toParent, toLeft, ([node]) => {
            if (!node.isRemoved && !node.isText && attributesToRemove) {
                if (!node.attrs) {
                    node.attrs = new RHT();
                }
                for (const value of attributesToRemove) {
                    node.attrs.remove(value, editedAt);
                }
                changes.push({
                    type: TreeChangeType.RemoveStyle,
                    from: this.toIndex(fromParent, fromLeft),
                    to: this.toIndex(toParent, toLeft),
                    fromPath: this.toPath(fromParent, fromLeft),
                    toPath: this.toPath(toParent, toLeft),
                    actor: editedAt.getActorID(),
                    value,
                });
            }
        });
        return changes;
    }
    /**
     * `edit` edits the tree with the given range and content.
     * If the content is undefined, the range will be removed.
     */
    edit(range, contents, splitLevel, editedAt, issueTimeTicket, latestCreatedAtMapByActor) {
        // 01. find nodes from the given range and split nodes.
        const [fromParent, fromLeft] = this.findNodesAndSplitText(range[0], editedAt);
        const [toParent, toLeft] = this.findNodesAndSplitText(range[1], editedAt);
        const fromIdx = this.toIndex(fromParent, fromLeft);
        const fromPath = this.toPath(fromParent, fromLeft);
        const nodesToBeRemoved = [];
        const tokensToBeRemoved = [];
        const toBeMovedToFromParents = [];
        const latestCreatedAtMap = new Map();
        this.traverseInPosRange(fromParent, fromLeft, toParent, toLeft, ([node, tokenType], ended) => {
            // NOTE(hackerwins): If the node overlaps as a start tag with the
            // range then we need to move the remaining children to fromParent.
            if (tokenType === TokenType.Start && !ended) {
                // TODO(hackerwins): Define more clearly merge-able rules
                // between two parents. For now, we only merge two parents are
                // both element nodes having text children.
                // e.g. <p>a|b</p><p>c|d</p> -> <p>a|d</p>
                // if (!fromParent.hasTextChild() || !toParent.hasTextChild()) {
                //   return;
                // }
                for (const child of node.children) {
                    toBeMovedToFromParents.push(child);
                }
            }
            const actorID = node.getCreatedAt().getActorID();
            const latestCreatedAt = latestCreatedAtMapByActor
                ? latestCreatedAtMapByActor.has(actorID)
                    ? latestCreatedAtMapByActor.get(actorID)
                    : InitialTimeTicket
                : MaxTimeTicket;
            // NOTE(sejongk): If the node is removable or its parent is going to
            // be removed, then this node should be removed.
            if (node.canDelete(editedAt, latestCreatedAt) ||
                nodesToBeRemoved.includes(node.parent)) {
                const latestCreatedAt = latestCreatedAtMap.get(actorID);
                const createdAt = node.getCreatedAt();
                if (!latestCreatedAt || createdAt.after(latestCreatedAt)) {
                    latestCreatedAtMap.set(actorID, createdAt);
                }
                // NOTE(hackerwins): If the node overlaps as an end token with the
                // range then we need to keep the node.
                if (tokenType === TokenType.Text || tokenType === TokenType.Start) {
                    nodesToBeRemoved.push(node);
                }
                tokensToBeRemoved.push([node, tokenType]);
            }
        });
        // NOTE(hackerwins): If concurrent deletion happens, we need to separate the
        // range(from, to) into multiple ranges.
        const changes = this.makeDeletionChanges(tokensToBeRemoved, editedAt);
        // 02. Delete: delete the nodes that are marked as removed.
        for (const node of nodesToBeRemoved) {
            node.remove(editedAt);
            if (node.isRemoved) {
                this.removedNodeMap.set(node.id.toIDString(), node);
            }
        }
        // 03. Merge: move the nodes that are marked as moved.
        for (const node of toBeMovedToFromParents) {
            if (!node.removedAt) {
                fromParent.append(node);
            }
        }
        // 04. Split: split the element nodes for the given split level.
        if (splitLevel > 0) {
            let splitCount = 0;
            let parent = fromParent;
            let left = fromLeft;
            while (splitCount < splitLevel) {
                parent.split(this, parent.findOffset(left) + 1, issueTimeTicket);
                left = parent;
                parent = parent.parent;
                splitCount++;
            }
            changes.push({
                type: TreeChangeType.Content,
                from: fromIdx,
                to: fromIdx,
                fromPath,
                toPath: fromPath,
                actor: editedAt.getActorID(),
            });
        }
        // 05. Insert: insert the given nodes at the given position.
        if (contents === null || contents === void 0 ? void 0 : contents.length) {
            const aliveContents = [];
            let leftInChildren = fromLeft; // tree
            for (const content of contents) {
                // 05-1. Insert the content nodes to the tree.
                if (leftInChildren === fromParent) {
                    // 05-1-1. when there's no leftSibling, then insert content into very front of parent's children.
                    fromParent.insertAt(content, 0);
                }
                else {
                    // 05-1-2. insert after leftSibling
                    fromParent.insertAfter(content, leftInChildren);
                }
                leftInChildren = content;
                traverseAll(content, (node) => {
                    // If insertion happens during concurrent editing and parent node has been removed,
                    // make new nodes as tombstone immediately.
                    if (fromParent.isRemoved) {
                        node.remove(editedAt);
                        this.removedNodeMap.set(node.id.toIDString(), node);
                    }
                    this.nodeMapByID.put(node.id, node);
                });
                if (!content.isRemoved) {
                    aliveContents.push(content);
                }
            }
            if (aliveContents.length) {
                const value = aliveContents.map((content) => toTreeNode(content));
                if (changes.length && changes[changes.length - 1].from === fromIdx) {
                    changes[changes.length - 1].value = value;
                }
                else {
                    changes.push({
                        type: TreeChangeType.Content,
                        from: fromIdx,
                        to: fromIdx,
                        fromPath,
                        toPath: fromPath,
                        actor: editedAt.getActorID(),
                        value,
                    });
                }
            }
        }
        return [changes, latestCreatedAtMap];
    }
    /**
     * `editT` edits the given range with the given value.
     * This method uses indexes instead of a pair of TreePos for testing.
     */
    editT(range, contents, splitLevel, editedAt, issueTimeTicket) {
        const fromPos = this.findPos(range[0]);
        const toPos = this.findPos(range[1]);
        this.edit([fromPos, toPos], contents, splitLevel, editedAt, issueTimeTicket);
    }
    /**
     * `move` move the given source range to the given target range.
     */
    move(target, source, ticket) {
        // TODO(hackerwins, easylogic): Implement this with keeping references of the nodes.
        throw new Error(`not implemented: ${target}, ${source}, ${ticket}`);
    }
    /**
     * `purgeRemovedNodesBefore` physically purges nodes that have been removed.
     */
    purgeRemovedNodesBefore(ticket) {
        var _a;
        const nodesToBeRemoved = new Set();
        let count = 0;
        for (const [, node] of this.removedNodeMap) {
            if (node.removedAt && ticket.compare(node.removedAt) >= 0) {
                nodesToBeRemoved.add(node);
                count++;
            }
        }
        for (const node of nodesToBeRemoved) {
            (_a = node.parent) === null || _a === void 0 ? void 0 : _a.removeChild(node);
            this.nodeMapByID.remove(node.id);
            this.purge(node);
            this.removedNodeMap.delete(node.id.toIDString());
        }
        return count;
    }
    /**
     * `purge` physically purges the given node from RGATreeSplit.
     */
    purge(node) {
        const insPrevID = node.insPrevID;
        const insNextID = node.insNextID;
        if (insPrevID) {
            const insPrev = this.findFloorNode(insPrevID);
            insPrev.insNextID = insNextID;
        }
        if (insNextID) {
            const insNext = this.findFloorNode(insNextID);
            insNext.insPrevID = insPrevID;
        }
        node.insPrevID = undefined;
        node.insNextID = undefined;
    }
    /**
     * `findPos` finds the position of the given index in the tree.
     */
    findPos(index, preferText = true) {
        const treePos = this.indexTree.findTreePos(index, preferText);
        return CRDTTreePos.fromTreePos(treePos);
    }
    /**
     * `getRemovedNodesLen` returns size of removed nodes.
     */
    getRemovedNodesLen() {
        return this.removedNodeMap.size;
    }
    /**
     * `pathToPosRange` converts the given path of the node to the range of the position.
     */
    pathToPosRange(path) {
        const fromIdx = this.pathToIndex(path);
        return [this.findPos(fromIdx), this.findPos(fromIdx + 1)];
    }
    /**
     * `pathToPos` finds the position of the given index in the tree by path.
     */
    pathToPos(path) {
        const index = this.indexTree.pathToIndex(path);
        return this.findPos(index);
    }
    /**
     * `getRoot` returns the root node of the tree.
     */
    getRoot() {
        return this.indexTree.getRoot();
    }
    /**
     * `getSize` returns the size of the tree.
     */
    getSize() {
        return this.indexTree.size;
    }
    /**
     * `getIndexTree` returns the index tree.
     */
    getIndexTree() {
        return this.indexTree;
    }
    /**
     * toXML returns the XML encoding of this tree.
     */
    toXML() {
        return toXML(this.indexTree.getRoot());
    }
    /**
     * `toJSON` returns the JSON encoding of this tree.
     */
    toJSON() {
        return JSON.stringify(this.getRootTreeNode());
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     *
     * @internal
     */
    toJSForTest() {
        return {
            createdAt: this.getCreatedAt().toTestString(),
            value: JSON.parse(this.toJSON()),
            type: 'YORKIE_TREE',
        };
    }
    /**
     * `toJSInfoForTest` returns detailed TreeNode information for use in Devtools.
     *
     * @internal
     */
    toJSInfoForTest() {
        const rootNode = this.indexTree.getRoot();
        const toTreeNodeInfo = (node, parentID = undefined, depth = 0) => {
            var _a, _b, _c;
            const nodeInfo = {
                type: node.type,
                parent: parentID,
                size: node.size,
                id: node.id.toTestString(),
                removedAt: (_a = node.removedAt) === null || _a === void 0 ? void 0 : _a.toTestString(),
                insPrev: (_b = node.insPrevID) === null || _b === void 0 ? void 0 : _b.toTestString(),
                insNext: (_c = node.insNextID) === null || _c === void 0 ? void 0 : _c.toTestString(),
                value: node.isText ? node.value : undefined,
                isRemoved: node.isRemoved,
                children: [],
                depth,
            };
            for (const child of node.children) {
                nodeInfo.children.push(toTreeNodeInfo(child, nodeInfo.id, depth + 1));
            }
            return nodeInfo;
        };
        return toTreeNodeInfo(rootNode);
    }
    /**
     * `getRootTreeNode` returns the converted value of this tree to TreeNode.
     */
    getRootTreeNode() {
        return toTreeNode(this.indexTree.getRoot());
    }
    /**
     * `toTestTreeNode` returns the JSON of this tree for debugging.
     */
    toTestTreeNode() {
        return toTestTreeNode(this.indexTree.getRoot());
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of this tree.
     */
    toSortedJSON() {
        return this.toJSON();
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const root = this.getRoot();
        return new CRDTTree(root.deepcopy(), this.getCreatedAt());
    }
    /**
     * `toPath` converts the given CRDTTreeNodeID to the path of the tree.
     */
    toPath(parentNode, leftNode) {
        const treePos = this.toTreePos(parentNode, leftNode);
        if (!treePos) {
            return [];
        }
        return this.indexTree.treePosToPath(treePos);
    }
    /**
     * `toIndex` converts the given CRDTTreeNodeID to the index of the tree.
     */
    toIndex(parentNode, leftNode) {
        const treePos = this.toTreePos(parentNode, leftNode);
        if (!treePos) {
            return -1;
        }
        return this.indexTree.indexOf(treePos);
    }
    /**
     * `indexToPath` converts the given tree index to path.
     */
    indexToPath(index) {
        return this.indexTree.indexToPath(index);
    }
    /**
     * `pathToIndex` converts the given path to index.
     */
    pathToIndex(path) {
        return this.indexTree.pathToIndex(path);
    }
    /**
     * `indexRangeToPosRange` returns the position range from the given index range.
     */
    indexRangeToPosRange(range) {
        const fromPos = this.findPos(range[0]);
        if (range[0] === range[1]) {
            return [fromPos, fromPos];
        }
        return [fromPos, this.findPos(range[1])];
    }
    /**
     * `indexRangeToPosStructRange` converts the integer index range into the Tree position range structure.
     */
    indexRangeToPosStructRange(range) {
        const [fromIdx, toIdx] = range;
        const fromPos = this.findPos(fromIdx);
        if (fromIdx === toIdx) {
            return [fromPos.toStruct(), fromPos.toStruct()];
        }
        return [fromPos.toStruct(), this.findPos(toIdx).toStruct()];
    }
    /**
     * `posRangeToPathRange` converts the given position range to the path range.
     */
    posRangeToPathRange(range) {
        const [fromParent, fromLeft] = this.findNodesAndSplitText(range[0]);
        const [toParent, toLeft] = this.findNodesAndSplitText(range[1]);
        return [this.toPath(fromParent, fromLeft), this.toPath(toParent, toLeft)];
    }
    /**
     * `posRangeToIndexRange` converts the given position range to the path range.
     */
    posRangeToIndexRange(range) {
        const [fromParent, fromLeft] = this.findNodesAndSplitText(range[0]);
        const [toParent, toLeft] = this.findNodesAndSplitText(range[1]);
        return [this.toIndex(fromParent, fromLeft), this.toIndex(toParent, toLeft)];
    }
    /**
     * `traverseInPosRange` traverses the tree in the given position range.
     */
    traverseInPosRange(fromParent, fromLeft, toParent, toLeft, callback) {
        const fromIdx = this.toIndex(fromParent, fromLeft);
        const toIdx = this.toIndex(toParent, toLeft);
        return this.indexTree.tokensBetween(fromIdx, toIdx, callback);
    }
    /**
     * `toTreePos` converts the given nodes to the position of the IndexTree.
     */
    toTreePos(parentNode, leftNode) {
        if (!parentNode || !leftNode) {
            return;
        }
        if (parentNode.isRemoved) {
            let childNode;
            while (parentNode.isRemoved) {
                childNode = parentNode;
                parentNode = childNode.parent;
            }
            const offset = parentNode.findOffset(childNode);
            return {
                node: parentNode,
                offset,
            };
        }
        if (parentNode === leftNode) {
            return {
                node: parentNode,
                offset: 0,
            };
        }
        let offset = parentNode.findOffset(leftNode);
        if (!leftNode.isRemoved) {
            if (leftNode.isText) {
                return {
                    node: leftNode,
                    offset: leftNode.paddedSize,
                };
            }
            offset++;
        }
        return {
            node: parentNode,
            offset,
        };
    }
    /**
     * `makeDeletionChanges` converts nodes to be deleted to deletion changes.
     */
    makeDeletionChanges(candidates, editedAt) {
        const changes = [];
        const ranges = [];
        // Generate ranges by accumulating consecutive nodes.
        let start = null;
        let end = null;
        for (let i = 0; i < candidates.length; i++) {
            const cur = candidates[i];
            const next = candidates[i + 1];
            if (!start) {
                start = cur;
            }
            end = cur;
            const rightToken = this.findRightToken(cur);
            if (!rightToken ||
                !next ||
                rightToken[0] !== next[0] ||
                rightToken[1] !== next[1]) {
                ranges.push([start, end]);
                start = null;
                end = null;
            }
        }
        // Convert each range to a deletion change.
        for (const range of ranges) {
            const [start, end] = range;
            const [fromLeft, fromLeftTokenType] = this.findLeftToken(start);
            const [toLeft, toLeftTokenType] = end;
            const fromParent = fromLeftTokenType === TokenType.Start ? fromLeft : fromLeft.parent;
            const toParent = toLeftTokenType === TokenType.Start ? toLeft : toLeft.parent;
            const fromIdx = this.toIndex(fromParent, fromLeft);
            const toIdx = this.toIndex(toParent, toLeft);
            if (fromIdx < toIdx) {
                // When the range is overlapped with the previous one, compact them.
                if (changes.length > 0 && fromIdx === changes[changes.length - 1].to) {
                    changes[changes.length - 1].to = toIdx;
                    changes[changes.length - 1].toPath = this.toPath(toParent, toLeft);
                }
                else {
                    changes.push({
                        type: TreeChangeType.Content,
                        from: fromIdx,
                        to: toIdx,
                        fromPath: this.toPath(fromParent, fromLeft),
                        toPath: this.toPath(toParent, toLeft),
                        actor: editedAt.getActorID(),
                    });
                }
            }
        }
        return changes.reverse();
    }
    /**
     * `findRightToken` returns the token to the right of the given token in the tree.
     */
    findRightToken([node, tokenType,]) {
        if (tokenType === TokenType.Start) {
            const children = node.allChildren;
            if (children.length > 0) {
                return [
                    children[0],
                    children[0].isText ? TokenType.Text : TokenType.Start,
                ];
            }
            return [node, TokenType.End];
        }
        const parent = node.parent;
        const siblings = parent.allChildren;
        const offset = siblings.indexOf(node);
        if (parent && offset === siblings.length - 1) {
            return [parent, TokenType.End];
        }
        const next = siblings[offset + 1];
        return [next, next.isText ? TokenType.Text : TokenType.Start];
    }
    /**
     * `findLeftToken` returns the token to the left of the given token in the tree.
     */
    findLeftToken([node, tokenType,]) {
        if (tokenType === TokenType.End) {
            const children = node.allChildren;
            if (children.length > 0) {
                const lastChild = children[children.length - 1];
                return [lastChild, lastChild.isText ? TokenType.Text : TokenType.End];
            }
            return [node, TokenType.Start];
        }
        const parent = node.parent;
        const siblings = parent.allChildren;
        const offset = siblings.indexOf(node);
        if (parent && offset === 0) {
            return [parent, TokenType.Start];
        }
        const prev = siblings[offset - 1];
        return [prev, prev.isText ? TokenType.Text : TokenType.End];
    }
}

;// CONCATENATED MODULE: ./src/document/operation/tree_edit_operation.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




/**
 * `TreeEditOperation` is an operation representing Tree editing.
 */
class TreeEditOperation extends Operation {
    constructor(parentCreatedAt, fromPos, toPos, contents, splitLevel, maxCreatedAtMapByActor, executedAt) {
        super(parentCreatedAt, executedAt);
        this.fromPos = fromPos;
        this.toPos = toPos;
        this.contents = contents;
        this.splitLevel = splitLevel;
        this.maxCreatedAtMapByActor = maxCreatedAtMapByActor;
    }
    /**
     * `create` creates a new instance of EditOperation.
     */
    static create(parentCreatedAt, fromPos, toPos, contents, splitLevel, maxCreatedAtMapByActor, executedAt) {
        return new TreeEditOperation(parentCreatedAt, fromPos, toPos, contents, splitLevel, maxCreatedAtMapByActor, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        var _a;
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTTree)) {
            logger.fatal(`fail to execute, only Tree can execute edit`);
        }
        const editedAt = this.getExecutedAt();
        const tree = parentObject;
        const [changes] = tree.edit([this.fromPos, this.toPos], (_a = this.contents) === null || _a === void 0 ? void 0 : _a.map((content) => content.deepcopy()), this.splitLevel, editedAt, 
        /**
         * TODO(sejongk): When splitting element nodes, a new nodeID is assigned with a different timeTicket.
         * In the same change context, the timeTickets share the same lamport and actorID but have different delimiters,
         * incremented by one for each.
         * Therefore, it is possible to simulate later timeTickets using `editedAt` and the length of `contents`.
         * This logic might be unclear; consider refactoring for multi-level concurrent editing in the Tree implementation.
         */
        (() => {
            let delimiter = editedAt.getDelimiter();
            if (this.contents !== undefined) {
                delimiter += this.contents.length;
            }
            const issueTimeTicket = () => TimeTicket.of(editedAt.getLamport(), ++delimiter, editedAt.getActorID());
            return issueTimeTicket;
        })(), this.maxCreatedAtMapByActor);
        if (!this.fromPos.equals(this.toPos)) {
            root.registerElementHasRemovedNodes(tree);
        }
        return {
            opInfos: changes.map(({ from, to, value, splitLevel, fromPath, toPath }) => {
                return {
                    type: 'tree-edit',
                    path: root.createPath(this.getParentCreatedAt()),
                    from,
                    to,
                    value,
                    splitLevel,
                    fromPath,
                    toPath,
                };
            }),
        };
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.getParentCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        const parent = this.getParentCreatedAt().toTestString();
        const fromPos = `${this.fromPos
            .getLeftSiblingID()
            .getCreatedAt()
            .toTestString()}:${this.fromPos.getLeftSiblingID().getOffset()}`;
        const toPos = `${this.toPos
            .getLeftSiblingID()
            .getCreatedAt()
            .toTestString()}:${this.toPos.getLeftSiblingID().getOffset()}`;
        const contents = this.contents;
        return `${parent}.EDIT(${fromPos},${toPos},${contents === null || contents === void 0 ? void 0 : contents.join('')})`;
    }
    /**
     * `getFromPos` returns the start point of the editing range.
     */
    getFromPos() {
        return this.fromPos;
    }
    /**
     * `getToPos` returns the end point of the editing range.
     */
    getToPos() {
        return this.toPos;
    }
    /**
     * `getContent` returns the content of Edit.
     */
    getContents() {
        return this.contents;
    }
    /**
     * `getSplitLevel` returns the split level of Edit.
     */
    getSplitLevel() {
        return this.splitLevel;
    }
    /**
     * `getMaxCreatedAtMapByActor` returns the map that stores the latest creation time
     * by actor for the nodes included in the editing range.
     */
    getMaxCreatedAtMapByActor() {
        return this.maxCreatedAtMapByActor;
    }
}

;// CONCATENATED MODULE: ./src/document/change/change_id.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `ChangeID` is for identifying the Change. This is immutable.
 */
class ChangeID {
    constructor(clientSeq, lamport, actor) {
        this.clientSeq = clientSeq;
        this.lamport = lamport;
        this.actor = actor;
    }
    /**
     * `of` creates a new instance of ChangeID.
     */
    static of(clientSeq, lamport, actor) {
        return new ChangeID(clientSeq, lamport, actor);
    }
    /**
     * `next` creates a next ID of this ID.
     */
    next() {
        return new ChangeID(this.clientSeq + 1, this.lamport.add(1), this.actor);
    }
    /**
     * `syncLamport` syncs lamport timestamp with the given ID.
     *
     * {@link https://en.wikipedia.org/wiki/Lamport_timestamps#Algorithm}
     */
    syncLamport(otherLamport) {
        if (otherLamport.greaterThan(this.lamport)) {
            return new ChangeID(this.clientSeq, otherLamport, this.actor);
        }
        return new ChangeID(this.clientSeq, this.lamport.add(1), this.actor);
    }
    /**
     * `createTimeTicket` creates a ticket of the given delimiter.
     */
    createTimeTicket(delimiter) {
        return TimeTicket.of(this.lamport, delimiter, this.actor);
    }
    /**
     * `setActor` sets the given actor.
     */
    setActor(actorID) {
        return new ChangeID(this.clientSeq, this.lamport, actorID);
    }
    /**
     * `getClientSeq` returns the client sequence of this ID.
     */
    getClientSeq() {
        return this.clientSeq;
    }
    /**
     * `getLamport` returns the lamport clock of this ID.
     */
    getLamport() {
        return this.lamport;
    }
    /**
     * `getLamportAsString` returns the lamport clock of this ID as a string.
     */
    getLamportAsString() {
        return this.lamport.toString();
    }
    /**
     * `getActorID` returns the actor of this ID.
     */
    getActorID() {
        return this.actor;
    }
    /**
     * `toTestString` returns a string containing the meta data of this ID.
     */
    toTestString() {
        return `${this.lamport.toString()}:${this.actor.slice(-2)}:${this.clientSeq}`;
    }
}
/**
 * `InitialChangeID` represents the initial state ID. Usually this is used to
 * represent a state where nothing has been edited.
 */
const InitialChangeID = new ChangeID(0, node_modules_long.fromInt(0, true), InitialActorID);

;// CONCATENATED MODULE: ./src/document/change/change.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * `Change` represents a unit of modification in the document.
 */
class Change {
    constructor({ id, operations, presenceChange, message, }) {
        this.id = id;
        this.operations = operations || [];
        this.presenceChange = presenceChange;
        this.message = message;
    }
    /**
     * `create` creates a new instance of Change.
     */
    static create({ id, operations, presenceChange, message, }) {
        return new Change({ id, operations, presenceChange, message });
    }
    /**
     * `getID` returns the ID of this change.
     */
    getID() {
        return this.id;
    }
    /**
     * `getMessage` returns the message of this change.
     */
    getMessage() {
        return this.message;
    }
    /**
     * `hasOperations` returns whether this change has operations or not.
     */
    hasOperations() {
        return this.operations.length > 0;
    }
    /**
     * `getOperations` returns the operations of this change.
     */
    getOperations() {
        return this.operations;
    }
    /**
     * `setActor` sets the given actor.
     */
    setActor(actorID) {
        for (const operation of this.operations) {
            operation.setActor(actorID);
        }
        this.id = this.id.setActor(actorID);
    }
    /**
     * `hasPresenceChange` returns whether this change has presence change or not.
     */
    hasPresenceChange() {
        return this.presenceChange !== undefined;
    }
    /**
     * `getPresenceChange` returns the presence change of this change.
     */
    getPresenceChange() {
        return this.presenceChange;
    }
    /**
     * `execute` executes the operations of this change to the given root.
     */
    execute(root, presences, source) {
        const changeOpInfos = [];
        const reverseOps = [];
        if (process.env.NODE_ENV !== 'production' && this.operations.length) {
            root.opsForTest.push(this.operations);
        }
        for (const operation of this.operations) {
            const executionResult = operation.execute(root, source);
            // NOTE(hackerwins): If the element was removed while executing undo/redo,
            // the operation is not executed and executionResult is undefined.
            if (!executionResult)
                continue;
            const { opInfos, reverseOp } = executionResult;
            changeOpInfos.push(...opInfos);
            // TODO(hackerwins): This condition should be removed after implementing
            // all reverse operations.
            if (reverseOp) {
                reverseOps.unshift(reverseOp);
            }
        }
        if (this.presenceChange) {
            if (this.presenceChange.type === PresenceChangeType.Put) {
                presences.set(this.id.getActorID(), deepcopy(this.presenceChange.presence));
            }
            else {
                presences.delete(this.id.getActorID());
            }
        }
        return { opInfos: changeOpInfos, reverseOps };
    }
    /**
     * `toTestString` returns a string containing the meta data of this change.
     */
    toTestString() {
        return `${this.operations
            .map((operation) => operation.toTestString())
            .join(',')}`;
    }
}

;// CONCATENATED MODULE: ./src/document/change/change_pack.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `ChangePack` is a unit for delivering changes in a document to the remote.
 *
 */
class ChangePack {
    constructor(key, checkpoint, isRemoved, changes, snapshot, minSyncedTicket) {
        this.documentKey = key;
        this.checkpoint = checkpoint;
        this.isRemoved = isRemoved;
        this.changes = changes;
        this.snapshot = snapshot;
        this.minSyncedTicket = minSyncedTicket;
    }
    /**
     * `create` creates a new instance of ChangePack.
     */
    static create(key, checkpoint, isRemoved, changes, snapshot, minSyncedTicket) {
        return new ChangePack(key, checkpoint, isRemoved, changes, snapshot, minSyncedTicket);
    }
    /**
     * `getKey` returns the document key of this pack.
     */
    getDocumentKey() {
        return this.documentKey;
    }
    /**
     * `getCheckpoint` returns the checkpoint of this pack.
     */
    getCheckpoint() {
        return this.checkpoint;
    }
    /**
     * `getIsRemoved` returns the whether this document is removed.
     */
    getIsRemoved() {
        return this.isRemoved;
    }
    /**
     * `getChanges` returns the changes of this pack.
     */
    getChanges() {
        return this.changes;
    }
    /**
     * `hasChanges` returns the whether this pack has changes or not.
     */
    hasChanges() {
        return this.changes.length > 0;
    }
    /**
     * `getChangeSize` returns the size of changes this pack has.
     */
    getChangeSize() {
        return this.changes.length;
    }
    /**
     * `hasSnapshot` returns the whether this pack has a snapshot or not.
     */
    hasSnapshot() {
        return !!this.snapshot && !!this.snapshot.length;
    }
    /**
     * `getSnapshot` returns the snapshot of this pack.
     */
    getSnapshot() {
        return this.snapshot;
    }
    /**
     * `getMinSyncedTicket` returns the minimum synced ticket of this pack.
     */
    getMinSyncedTicket() {
        return this.minSyncedTicket;
    }
}

;// CONCATENATED MODULE: ./src/document/change/checkpoint.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `Checkpoint` is used to determine the changes sent and received by the
 * client. This is immutable.
 *
 **/
class Checkpoint {
    constructor(serverSeq, clientSeq) {
        this.serverSeq = serverSeq;
        this.clientSeq = clientSeq;
    }
    /**
     * `of` creates a new instance of Checkpoint.
     */
    static of(serverSeq, clientSeq) {
        return new Checkpoint(serverSeq, clientSeq);
    }
    /**
     * `increaseClientSeq` creates a new instance with increased client sequence.
     */
    increaseClientSeq(inc) {
        if (inc === 0) {
            return this;
        }
        return new Checkpoint(this.serverSeq, this.clientSeq + inc);
    }
    /**
     * `forward` creates a new instance with the given checkpoint if it is
     * greater than the values of internal properties.
     */
    forward(other) {
        if (this.equals(other)) {
            return this;
        }
        const serverSeq = this.serverSeq.greaterThan(other.serverSeq)
            ? this.serverSeq
            : other.serverSeq;
        const clientSeq = Math.max(this.clientSeq, other.clientSeq);
        return Checkpoint.of(serverSeq, clientSeq);
    }
    /**
     * `getServerSeqAsString` returns the server seq of this checkpoint as a
     * string.
     */
    getServerSeqAsString() {
        return this.serverSeq.toString();
    }
    /**
     * `getClientSeq` returns the client seq of this checkpoint.
     */
    getClientSeq() {
        return this.clientSeq;
    }
    /**
     * `getServerSeq` returns the server seq of this checkpoint.
     */
    getServerSeq() {
        return this.serverSeq;
    }
    /**
     * `equals` returns whether the given checkpoint is equal to this checkpoint
     * or not.
     */
    equals(other) {
        return (this.clientSeq === other.clientSeq &&
            this.serverSeq.equals(other.serverSeq));
    }
    /**
     * `toTestString` returns a string containing the meta data of this
     * checkpoint.
     */
    toTestString() {
        return `serverSeq=${this.serverSeq}, clientSeq=${this.clientSeq}`;
    }
}
/**
 * `InitialCheckpoint` is the initial value of the checkpoint.
 */
const InitialCheckpoint = new Checkpoint(node_modules_long.fromInt(0, true), 0);

;// CONCATENATED MODULE: ./src/document/crdt/rga_tree_split.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




/**
 * `RGATreeSplitNodeID` is an ID of RGATreeSplitNode.
 */
class RGATreeSplitNodeID {
    constructor(createdAt, offset) {
        this.createdAt = createdAt;
        this.offset = offset;
    }
    /**
     * `of` creates a instance of RGATreeSplitNodeID.
     */
    static of(createdAt, offset) {
        return new RGATreeSplitNodeID(createdAt, offset);
    }
    /**
     * `fromStruct` creates a instance of RGATreeSplitNodeID from the struct.
     */
    static fromStruct(struct) {
        return RGATreeSplitNodeID.of(TimeTicket.fromStruct(struct.createdAt), struct.offset);
    }
    /**
     * `getCreatedAt` returns the creation time of this ID.
     */
    getCreatedAt() {
        return this.createdAt;
    }
    /**
     * `getOffset` returns returns the offset of this ID.
     */
    getOffset() {
        return this.offset;
    }
    /**
     * `equals` returns whether given ID equals to this ID or not.
     */
    equals(other) {
        return (this.createdAt.compare(other.createdAt) === 0 &&
            this.offset === other.offset);
    }
    /**
     * `hasSameCreatedAt` returns whether given ID has same creation time with this ID.
     */
    hasSameCreatedAt(other) {
        return this.createdAt.compare(other.createdAt) === 0;
    }
    /**
     * `split` creates a new ID with an offset from this ID.
     */
    split(offset) {
        return new RGATreeSplitNodeID(this.createdAt, this.offset + offset);
    }
    /**
     * `toStruct` returns the structure of this node id.
     */
    toStruct() {
        return {
            createdAt: this.createdAt.toStruct(),
            offset: this.offset,
        };
    }
    /**
     * `toTestString` returns a String containing
     * the meta data of the node id for debugging purpose.
     */
    toTestString() {
        return `${this.createdAt.toTestString()}:${this.offset}`;
    }
    /**
     * `toIDString` returns a string that can be used as an ID for this node id.
     */
    toIDString() {
        return `${this.createdAt.toIDString()}:${this.offset}`;
    }
}
const InitialRGATreeSplitNodeID = RGATreeSplitNodeID.of(InitialTimeTicket, 0);
/**
 * `RGATreeSplitPos` is the position of the text inside the node.
 */
class RGATreeSplitPos {
    constructor(id, relativeOffset) {
        this.id = id;
        this.relativeOffset = relativeOffset;
    }
    /**
     * `of` creates a instance of RGATreeSplitPos.
     */
    static of(id, relativeOffset) {
        return new RGATreeSplitPos(id, relativeOffset);
    }
    /**
     * `fromStruct` creates a instance of RGATreeSplitPos from the struct.
     */
    static fromStruct(struct) {
        const id = RGATreeSplitNodeID.fromStruct(struct.id);
        return RGATreeSplitPos.of(id, struct.relativeOffset);
    }
    /**
     * `getID` returns the ID of this RGATreeSplitPos.
     */
    getID() {
        return this.id;
    }
    /**
     * `getRelativeOffset` returns the relative offset of this RGATreeSplitPos.
     */
    getRelativeOffset() {
        return this.relativeOffset;
    }
    /**
     * `getAbsoluteID` returns the absolute id of this RGATreeSplitPos.
     */
    getAbsoluteID() {
        return RGATreeSplitNodeID.of(this.id.getCreatedAt(), this.id.getOffset() + this.relativeOffset);
    }
    /**
     *`toTestString` returns a String containing
     * the meta data of the position for debugging purpose.
     */
    toTestString() {
        return `${this.id.toTestString()}:${this.relativeOffset}`;
    }
    /**
     * `toStruct` returns the structure of this node pos.
     */
    toStruct() {
        return {
            id: this.id.toStruct(),
            relativeOffset: this.relativeOffset,
        };
    }
    /**
     * `equals` returns whether given pos equal to this pos or not.
     */
    equals(other) {
        if (!this.id.equals(other.id)) {
            return false;
        }
        return this.relativeOffset === other.relativeOffset;
    }
}
/**
 * `RGATreeSplitNode` is a node of RGATreeSplit.
 */
class RGATreeSplitNode extends SplayNode {
    constructor(id, value, removedAt) {
        super(value);
        this.id = id;
        this.removedAt = removedAt;
    }
    /**
     * `create` creates a instance of RGATreeSplitNode.
     */
    static create(id, value) {
        return new RGATreeSplitNode(id, value);
    }
    /**
     * `createComparator` creates a function to compare two RGATreeSplitNodeID.
     */
    static createComparator() {
        return (p1, p2) => {
            const compare = p1.getCreatedAt().compare(p2.getCreatedAt());
            if (compare !== 0) {
                return compare;
            }
            if (p1.getOffset() > p2.getOffset()) {
                return 1;
            }
            else if (p1.getOffset() < p2.getOffset()) {
                return -1;
            }
            return 0;
        };
    }
    /**
     * `getID` returns the ID of this RGATreeSplitNode.
     */
    getID() {
        return this.id;
    }
    /**
     * `getCreatedAt` returns creation time of the Id of RGATreeSplitNode.
     */
    getCreatedAt() {
        return this.id.getCreatedAt();
    }
    /**
     * `getLength` returns the length of this node.
     */
    getLength() {
        if (this.removedAt) {
            return 0;
        }
        return this.getContentLength();
    }
    /**
     * `getContentLength` returns the length of this value.
     */
    getContentLength() {
        return (this.value && this.value.length) || 0;
    }
    /**
     * `getPrev` returns a previous node of this node.
     */
    getPrev() {
        return this.prev;
    }
    /**
     * `getNext` returns a next node of this node.
     */
    getNext() {
        return this.next;
    }
    /**
     * `getInsPrev` returns a previous node of this node insertion.
     */
    getInsPrev() {
        return this.insPrev;
    }
    /**
     * `getInsNext` returns a next node of this node insertion.
     */
    getInsNext() {
        return this.insNext;
    }
    /**
     * `getInsPrevID` returns a ID of previous node insertion.
     */
    getInsPrevID() {
        return this.insPrev.getID();
    }
    /**
     * `setPrev` sets previous node of this node.
     */
    setPrev(node) {
        this.prev = node;
        if (node) {
            node.next = this;
        }
    }
    /**
     * `setNext` sets next node of this node.
     */
    setNext(node) {
        this.next = node;
        if (node) {
            node.prev = this;
        }
    }
    /**
     * `setInsPrev` sets previous node of this node insertion.
     */
    setInsPrev(node) {
        this.insPrev = node;
        if (node) {
            node.insNext = this;
        }
    }
    /**
     * `setInsNext` sets next node of this node insertion.
     */
    setInsNext(node) {
        this.insNext = node;
        if (node) {
            node.insPrev = this;
        }
    }
    /**
     * `hasNext` checks if next node exists.
     */
    hasNext() {
        return !!this.next;
    }
    /**
     * `hasInsPrev` checks if previous insertion node exists.
     */
    hasInsPrev() {
        return !!this.insPrev;
    }
    /**
     * `isRemoved` checks if removed time exists.
     */
    isRemoved() {
        return !!this.removedAt;
    }
    /**
     * `getRemovedAt` returns the remove time of this node.
     */
    getRemovedAt() {
        return this.removedAt;
    }
    /**
     * `split` creates a new split node of the given offset.
     */
    split(offset) {
        return new RGATreeSplitNode(this.id.split(offset), this.splitValue(offset), this.removedAt);
    }
    /**
     * `canDelete` checks if node is able to delete.
     */
    canDelete(editedAt, latestCreatedAt) {
        return (!this.getCreatedAt().after(latestCreatedAt) &&
            (!this.removedAt || editedAt.after(this.removedAt)));
    }
    /**
     * `canStyle` checks if node is able to set style.
     */
    canStyle(editedAt, latestCreatedAt) {
        return (!this.getCreatedAt().after(latestCreatedAt) &&
            (!this.removedAt || editedAt.after(this.removedAt)));
    }
    /**
     * `remove` removes node of given edited time.
     */
    remove(editedAt) {
        this.removedAt = editedAt;
    }
    /**
     * `createRange` creates ranges of RGATreeSplitPos.
     */
    createPosRange() {
        return [
            RGATreeSplitPos.of(this.id, 0),
            RGATreeSplitPos.of(this.id, this.getLength()),
        ];
    }
    /**
     * `deepcopy` returns a new instance of this RGATreeSplitNode without structural info.
     */
    deepcopy() {
        return new RGATreeSplitNode(this.id, this.value, this.removedAt);
    }
    /**
     * `toTestString` returns a String containing
     * the meta data of the node for debugging purpose.
     */
    toTestString() {
        return `${this.id.toTestString()} ${this.value ? this.value : ''}`;
    }
    splitValue(offset) {
        const value = this.value;
        this.value = value.substring(0, offset);
        return value.substring(offset, value.length);
    }
}
/**
 * `RGATreeSplit` is a block-based list with improved index-based lookup in RGA.
 * The difference from RGATreeList is that it has data on a block basis to
 * reduce the size of CRDT metadata. When an edit occurs on a block,
 * the block is split.
 *
 */
class RGATreeSplit {
    constructor() {
        this.head = RGATreeSplitNode.create(InitialRGATreeSplitNodeID);
        this.treeByIndex = new SplayTree();
        this.treeByID = new LLRBTree(RGATreeSplitNode.createComparator());
        this.removedNodeMap = new Map();
        this.treeByIndex.insert(this.head);
        this.treeByID.put(this.head.getID(), this.head);
    }
    /**
     * `create` creates a instance RGATreeSplit.
     */
    static create() {
        return new RGATreeSplit();
    }
    /**
     * `edit` does following steps
     * 1. split nodes with from and to
     * 2. delete between from and to
     * 3. insert a new node
     * 4. add removed node
     * @param range - range of RGATreeSplitNode
     * @param editedAt - edited time
     * @param value - value
     * @param latestCreatedAtMapByActor - latestCreatedAtMapByActor
     * @returns `[RGATreeSplitPos, Map<string, TimeTicket>, Array<Change>]`
     */
    edit(range, editedAt, value, latestCreatedAtMapByActor) {
        // 01. split nodes with from and to
        const [toLeft, toRight] = this.findNodeWithSplit(range[1], editedAt);
        const [fromLeft, fromRight] = this.findNodeWithSplit(range[0], editedAt);
        // 02. delete between from and to
        const nodesToDelete = this.findBetween(fromRight, toRight);
        const [changes, latestCreatedAtMap, removedNodeMapByNodeKey] = this.deleteNodes(nodesToDelete, editedAt, latestCreatedAtMapByActor);
        const caretID = toRight ? toRight.getID() : toLeft.getID();
        let caretPos = RGATreeSplitPos.of(caretID, 0);
        // 03. insert a new node
        if (value) {
            const idx = this.posToIndex(fromLeft.createPosRange()[1], true);
            const inserted = this.insertAfter(fromLeft, RGATreeSplitNode.create(RGATreeSplitNodeID.of(editedAt, 0), value));
            if (changes.length && changes[changes.length - 1].from === idx) {
                changes[changes.length - 1].value = value;
            }
            else {
                changes.push({
                    actor: editedAt.getActorID(),
                    from: idx,
                    to: idx,
                    value,
                });
            }
            caretPos = RGATreeSplitPos.of(inserted.getID(), inserted.getContentLength());
        }
        // 04. add removed node
        for (const [key, removedNode] of removedNodeMapByNodeKey) {
            this.removedNodeMap.set(key, removedNode);
        }
        return [caretPos, latestCreatedAtMap, changes];
    }
    /**
     * `indexToPos` finds RGATreeSplitPos of given offset.
     */
    indexToPos(idx) {
        const [node, offset] = this.treeByIndex.find(idx);
        const splitNode = node;
        return RGATreeSplitPos.of(splitNode.getID(), offset);
    }
    /**
     * `findIndexesFromRange` finds indexes based on range.
     */
    findIndexesFromRange(range) {
        const [fromPos, toPos] = range;
        return [this.posToIndex(fromPos, false), this.posToIndex(toPos, true)];
    }
    /**
     * `posToIndex` converts the given position to index.
     */
    posToIndex(pos, preferToLeft) {
        const absoluteID = pos.getAbsoluteID();
        const node = preferToLeft
            ? this.findFloorNodePreferToLeft(absoluteID)
            : this.findFloorNode(absoluteID);
        if (!node) {
            logger.fatal(`the node of the given id should be found: ${absoluteID.toTestString()}`);
        }
        const index = this.treeByIndex.indexOf(node);
        const offset = node.isRemoved()
            ? 0
            : absoluteID.getOffset() - node.getID().getOffset();
        return index + offset;
    }
    /**
     * `findNode` finds node of given id.
     */
    findNode(id) {
        return this.findFloorNode(id);
    }
    /**
     * `length` returns size of RGATreeSplit.
     */
    get length() {
        return this.treeByIndex.length;
    }
    /**
     * `checkWeight` returns false when there is an incorrect weight node.
     * for debugging purpose.
     */
    checkWeight() {
        return this.treeByIndex.checkWeight();
    }
    /**
     * `toString` returns the string encoding of this RGATreeSplit.
     */
    toString() {
        const str = [];
        for (const node of this) {
            if (!node.isRemoved()) {
                str.push(node.getValue());
            }
        }
        return str.join('');
    }
    // eslint-disable-next-line jsdoc/require-jsdoc
    *[Symbol.iterator]() {
        let node = this.head.getNext();
        while (node) {
            yield node;
            node = node.getNext();
        }
    }
    /**
     * `getHead` returns head of RGATreeSplitNode.
     */
    getHead() {
        return this.head;
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const clone = new RGATreeSplit();
        let node = this.head.getNext();
        let prev = clone.head;
        let current;
        while (node) {
            current = clone.insertAfter(prev, node.deepcopy());
            if (node.hasInsPrev()) {
                const insPrevNode = clone.findNode(node.getInsPrevID());
                current.setInsPrev(insPrevNode);
            }
            prev = current;
            node = node.getNext();
        }
        return clone;
    }
    /**
     * `toTestString` returns a String containing the meta data of the node
     * for debugging purpose.
     */
    toTestString() {
        const result = [];
        let node = this.head;
        while (node) {
            if (node.isRemoved()) {
                result.push(`{${node.toTestString()}}`);
            }
            else {
                result.push(`[${node.toTestString()}]`);
            }
            node = node.getNext();
        }
        return result.join('');
    }
    /**
     * `insertAfter` inserts the given node after the given previous node.
     */
    insertAfter(prevNode, newNode) {
        const next = prevNode.getNext();
        newNode.setPrev(prevNode);
        if (next) {
            next.setPrev(newNode);
        }
        this.treeByID.put(newNode.getID(), newNode);
        this.treeByIndex.insertAfter(prevNode, newNode);
        return newNode;
    }
    /**
     * `findNodeWithSplit` splits and return nodes of the given position.
     */
    findNodeWithSplit(pos, editedAt) {
        const absoluteID = pos.getAbsoluteID();
        let node = this.findFloorNodePreferToLeft(absoluteID);
        const relativeOffset = absoluteID.getOffset() - node.getID().getOffset();
        this.splitNode(node, relativeOffset);
        while (node.hasNext() && node.getNext().getCreatedAt().after(editedAt)) {
            node = node.getNext();
        }
        return [node, node.getNext()];
    }
    findFloorNodePreferToLeft(id) {
        let node = this.findFloorNode(id);
        if (!node) {
            logger.fatal(`the node of the given id should be found: ${id.toTestString()}`);
        }
        if (id.getOffset() > 0 && node.getID().getOffset() == id.getOffset()) {
            // NOTE: InsPrev may not be present due to GC.
            if (!node.hasInsPrev()) {
                return node;
            }
            node = node.getInsPrev();
        }
        return node;
    }
    findFloorNode(id) {
        const entry = this.treeByID.floorEntry(id);
        if (!entry) {
            return;
        }
        if (!entry.key.equals(id) && !entry.key.hasSameCreatedAt(id)) {
            return;
        }
        return entry.value;
    }
    /**
     * `findBetween` returns nodes between fromNode and toNode.
     */
    findBetween(fromNode, toNode) {
        const nodes = [];
        let current = fromNode;
        while (current && current !== toNode) {
            nodes.push(current);
            current = current.getNext();
        }
        return nodes;
    }
    splitNode(node, offset) {
        if (offset > node.getContentLength()) {
            logger.fatal('offset should be less than or equal to length');
        }
        if (offset === 0) {
            return node;
        }
        else if (offset === node.getContentLength()) {
            return node.getNext();
        }
        const splitNode = node.split(offset);
        this.treeByIndex.updateWeight(splitNode);
        this.insertAfter(node, splitNode);
        const insNext = node.getInsNext();
        if (insNext) {
            insNext.setInsPrev(splitNode);
        }
        splitNode.setInsPrev(node);
        return splitNode;
    }
    deleteNodes(candidates, editedAt, latestCreatedAtMapByActor) {
        if (!candidates.length) {
            return [[], new Map(), new Map()];
        }
        // There are 2 types of nodes in `candidates`: should delete, should not delete.
        // `nodesToKeep` contains nodes should not delete,
        // then is used to find the boundary of the range to be deleted.
        const [nodesToDelete, nodesToKeep] = this.filterNodes(candidates, editedAt, latestCreatedAtMapByActor);
        const createdAtMapByActor = new Map();
        const removedNodeMap = new Map();
        // First we need to collect indexes for change.
        const changes = this.makeChanges(nodesToKeep, editedAt);
        for (const node of nodesToDelete) {
            // Then make nodes be tombstones and map that.
            const actorID = node.getCreatedAt().getActorID();
            if (!createdAtMapByActor.has(actorID) ||
                node.getID().getCreatedAt().after(createdAtMapByActor.get(actorID))) {
                createdAtMapByActor.set(actorID, node.getID().getCreatedAt());
            }
            removedNodeMap.set(node.getID().toIDString(), node);
            node.remove(editedAt);
        }
        // Finally remove index nodes of tombstones.
        this.deleteIndexNodes(nodesToKeep);
        return [changes, createdAtMapByActor, removedNodeMap];
    }
    filterNodes(candidates, editedAt, latestCreatedAtMapByActor) {
        const isRemote = !!latestCreatedAtMapByActor;
        const nodesToDelete = [];
        const nodesToKeep = [];
        const [leftEdge, rightEdge] = this.findEdgesOfCandidates(candidates);
        nodesToKeep.push(leftEdge);
        for (const node of candidates) {
            const actorID = node.getCreatedAt().getActorID();
            const latestCreatedAt = isRemote
                ? latestCreatedAtMapByActor.has(actorID)
                    ? latestCreatedAtMapByActor.get(actorID)
                    : InitialTimeTicket
                : MaxTimeTicket;
            if (node.canDelete(editedAt, latestCreatedAt)) {
                nodesToDelete.push(node);
            }
            else {
                nodesToKeep.push(node);
            }
        }
        nodesToKeep.push(rightEdge);
        return [nodesToDelete, nodesToKeep];
    }
    /**
     * `findEdgesOfCandidates` finds the edges outside `candidates`,
     * (which has not already been deleted, or be undefined but not yet implemented)
     * right edge is undefined means `candidates` contains the end of text.
     */
    findEdgesOfCandidates(candidates) {
        return [
            candidates[0].getPrev(),
            candidates[candidates.length - 1].getNext(),
        ];
    }
    makeChanges(boundaries, editedAt) {
        const changes = [];
        let fromIdx, toIdx;
        for (let i = 0; i < boundaries.length - 1; i++) {
            const leftBoundary = boundaries[i];
            const rightBoundary = boundaries[i + 1];
            if (leftBoundary.getNext() == rightBoundary) {
                continue;
            }
            [fromIdx] = this.findIndexesFromRange(leftBoundary.getNext().createPosRange());
            if (rightBoundary) {
                [, toIdx] = this.findIndexesFromRange(rightBoundary.getPrev().createPosRange());
            }
            else {
                toIdx = this.treeByIndex.length;
            }
            if (fromIdx < toIdx) {
                changes.push({
                    actor: editedAt.getActorID(),
                    from: fromIdx,
                    to: toIdx,
                });
            }
        }
        return changes.reverse();
    }
    /**
     * `deleteIndexNodes` clears the index nodes of the given deletion boundaries.
     * The boundaries mean the nodes that will not be deleted in the range.
     */
    deleteIndexNodes(boundaries) {
        for (let i = 0; i < boundaries.length - 1; i++) {
            const leftBoundary = boundaries[i];
            const rightBoundary = boundaries[i + 1];
            // If there is no node to delete between boundaries, do notting.
            if (leftBoundary.getNext() != rightBoundary) {
                this.treeByIndex.deleteRange(leftBoundary, rightBoundary);
            }
        }
    }
    /**
     * `getRemovedNodesLen` returns size of removed nodes.
     */
    getRemovedNodesLen() {
        return this.removedNodeMap.size;
    }
    /**
     * `purgeRemovedNodesBefore` physically purges nodes that have been removed.
     */
    purgeRemovedNodesBefore(ticket) {
        let count = 0;
        for (const [, node] of this.removedNodeMap) {
            if (node.getRemovedAt() && ticket.compare(node.getRemovedAt()) >= 0) {
                this.treeByIndex.delete(node);
                this.purge(node);
                this.treeByID.remove(node.getID());
                this.removedNodeMap.delete(node.getID().toIDString());
                count++;
            }
        }
        return count;
    }
    /**
     * `purge` physically purges the given node from RGATreeSplit.
     */
    purge(node) {
        const prev = node.getPrev();
        const next = node.getNext();
        const insPrev = node.getInsPrev();
        const insNext = node.getInsNext();
        if (prev) {
            prev.setNext(next);
        }
        if (next) {
            next.setPrev(prev);
        }
        node.setPrev(undefined);
        node.setNext(undefined);
        if (insPrev) {
            insPrev.setInsNext(insNext);
        }
        if (insNext) {
            insNext.setInsPrev(insPrev);
        }
        node.setInsPrev(undefined);
        node.setInsNext(undefined);
    }
}

;// CONCATENATED MODULE: ./src/util/number.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 `removeDecimal` returns a number with the decimal part removed.
 */
const removeDecimal = (number) => number < 0 ? Math.ceil(number) : Math.floor(number);

;// CONCATENATED MODULE: ./src/document/crdt/counter.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */





var CounterType;
(function (CounterType) {
    CounterType[CounterType["IntegerCnt"] = 0] = "IntegerCnt";
    CounterType[CounterType["LongCnt"] = 1] = "LongCnt";
})(CounterType || (CounterType = {}));
/**
 * `CRDTCounter` is a CRDT implementation of a counter. It is used to represent
 * a number that can be incremented or decremented.
 *
 * @internal
 */
class CRDTCounter extends CRDTElement {
    constructor(valueType, value, createdAt) {
        super(createdAt);
        this.valueType = valueType;
        switch (valueType) {
            case CounterType.IntegerCnt:
                if (typeof value === 'number') {
                    if (value > Math.pow(2, 31) - 1 || value < -Math.pow(2, 31)) {
                        this.value = node_modules_long.fromNumber(value).toInt();
                    }
                    else {
                        this.value = removeDecimal(value);
                    }
                }
                else {
                    this.value = value.toInt();
                }
                break;
            case CounterType.LongCnt:
                if (typeof value === 'number') {
                    this.value = node_modules_long.fromNumber(value);
                }
                else {
                    this.value = value;
                }
                break;
            default:
                throw new YorkieError(error_Code.Unimplemented, `unimplemented type: ${valueType}`);
        }
    }
    /**
     * `of` creates a new instance of Counter.
     */
    static create(valueType, value, createdAt) {
        return new CRDTCounter(valueType, value, createdAt);
    }
    /**
     * `valueFromBytes` parses the given bytes into value.
     */
    static valueFromBytes(counterType, bytes) {
        switch (counterType) {
            case CounterType.IntegerCnt:
                return bytes[0] | (bytes[1] << 8) | (bytes[2] << 16) | (bytes[3] << 24);
            case CounterType.LongCnt:
                return node_modules_long.fromBytesLE(Array.from(bytes));
            default:
                throw new YorkieError(error_Code.Unimplemented, `unimplemented type: ${counterType}`);
        }
    }
    /**
     * `toJSON` returns the JSON encoding of the value.
     */
    toJSON() {
        return `${this.value}`;
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of the value.
     */
    toSortedJSON() {
        return this.toJSON();
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     */
    toJSForTest() {
        return {
            createdAt: this.getCreatedAt().toTestString(),
            value: this.value,
            type: 'YORKIE_COUNTER',
        };
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        const counter = CRDTCounter.create(this.valueType, this.value, this.getCreatedAt());
        counter.setMovedAt(this.getMovedAt());
        return counter;
    }
    /**
     * `getType` returns the type of the value.
     */
    getType() {
        return this.valueType;
    }
    /**
     * `getCounterType` returns counter type of given value.
     */
    static getCounterType(value) {
        switch (typeof value) {
            case 'object':
                if (value instanceof node_modules_long) {
                    return CounterType.LongCnt;
                }
                else {
                    return;
                }
            case 'number':
                if (value > Math.pow(2, 31) - 1 || value < -Math.pow(2, 31)) {
                    return CounterType.LongCnt;
                }
                else {
                    return CounterType.IntegerCnt;
                }
            default:
                return;
        }
    }
    /**
     * `isSupport` check if there is a counter type of given value.
     */
    static isSupport(value) {
        return !!CRDTCounter.getCounterType(value);
    }
    /**
     * `isInteger` checks if the num is integer.
     */
    static isInteger(num) {
        return num % 1 === 0;
    }
    /**
     * `isNumericType` check numeric type by JSONCounter.
     */
    isNumericType() {
        const t = this.valueType;
        return t === CounterType.IntegerCnt || t === CounterType.LongCnt;
    }
    /**
     * `getValueType` get counter value type.
     */
    getValueType() {
        return this.valueType;
    }
    /**
     * `getValue` get counter value.
     */
    getValue() {
        return this.value;
    }
    /**
     * `toBytes` creates an array representing the value.
     */
    toBytes() {
        switch (this.valueType) {
            case CounterType.IntegerCnt: {
                const intVal = this.value;
                return new Uint8Array([
                    intVal & 0xff,
                    (intVal >> 8) & 0xff,
                    (intVal >> 16) & 0xff,
                    (intVal >> 24) & 0xff,
                ]);
            }
            case CounterType.LongCnt: {
                const longVal = this.value;
                const longToBytes = longVal.toBytesLE();
                return Uint8Array.from(longToBytes);
            }
            default:
                throw new YorkieError(error_Code.Unimplemented, `unimplemented type: ${this.valueType}`);
        }
    }
    /**
     * `increase` increases numeric data.
     */
    increase(v) {
        /**
         * `checkNumericType` checks if the given target is a numeric type.
         */
        function checkNumericType(target) {
            if (!target.isNumericType()) {
                throw new TypeError(`Unsupported type of value: ${typeof target.getValue()}`);
            }
        }
        checkNumericType(this);
        checkNumericType(v);
        if (this.valueType === CounterType.LongCnt) {
            this.value = this.value.add(v.getValue());
        }
        else {
            if (v.getType() === PrimitiveType.Long) {
                this.value = this.value + v.getValue().toInt();
            }
            else {
                this.value = node_modules_long.fromNumber(this.value + removeDecimal(v.getValue())).toInt();
            }
        }
        return this;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/increase_operation.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




/**
 * `IncreaseOperation` represents an operation that increments a numeric value to Counter.
 * Among Primitives, numeric types Integer, Long are used as values.
 */
class IncreaseOperation extends Operation {
    constructor(parentCreatedAt, value, executedAt) {
        super(parentCreatedAt, executedAt);
        this.value = value;
    }
    /**
     * `create` creates a new instance of IncreaseOperation.
     */
    static create(parentCreatedAt, value, executedAt) {
        return new IncreaseOperation(parentCreatedAt, value, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTCounter)) {
            logger.fatal(`fail to execute, only Counter can execute increase`);
        }
        const counter = parentObject;
        const value = this.value.deepcopy();
        counter.increase(value);
        return {
            opInfos: [
                {
                    type: 'increase',
                    path: root.createPath(this.getParentCreatedAt()),
                    value: value.getValue(),
                },
            ],
            reverseOp: this.toReverseOperation(),
        };
    }
    /**
     * `toReverseOperation` returns the reverse operation of this operation.
     */
    toReverseOperation() {
        const primitiveValue = this.value.deepcopy();
        const valueType = primitiveValue.getType();
        const value = valueType === PrimitiveType.Long
            ? primitiveValue.getValue().multiply(-1)
            : primitiveValue.getValue() * -1;
        const reverseOp = IncreaseOperation.create(this.getParentCreatedAt(), Primitive.of(value, primitiveValue.getCreatedAt()));
        return reverseOp;
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.getParentCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        return `${this.getParentCreatedAt().toTestString()}.INCREASE.${this.value.toJSON()}`;
    }
    /**
     * `getValue` returns the value of this operation.
     */
    getValue() {
        return this.value;
    }
}

;// CONCATENATED MODULE: ./src/document/operation/tree_style_operation.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `TreeStyleOperation` represents an operation that modifies the style of the
 * node in the Tree.
 */
class TreeStyleOperation extends Operation {
    constructor(parentCreatedAt, fromPos, toPos, attributes, attributesToRemove, executedAt) {
        super(parentCreatedAt, executedAt);
        this.fromPos = fromPos;
        this.toPos = toPos;
        this.attributes = attributes;
        this.attributesToRemove = attributesToRemove;
    }
    /**
     * `create` creates a new instance of TreeStyleOperation.
     */
    static create(parentCreatedAt, fromPos, toPos, attributes, executedAt) {
        return new TreeStyleOperation(parentCreatedAt, fromPos, toPos, attributes, new Array(), executedAt);
    }
    /**
     * `createTreeRemoveStyleOperation` creates a new instance of TreeStyleOperation for style deletion.
     */
    static createTreeRemoveStyleOperation(parentCreatedAt, fromPos, toPos, attributesToRemove, executedAt) {
        return new TreeStyleOperation(parentCreatedAt, fromPos, toPos, new Map(), attributesToRemove, executedAt);
    }
    /**
     * `execute` executes this operation on the given `CRDTRoot`.
     */
    execute(root) {
        const parentObject = root.findByCreatedAt(this.getParentCreatedAt());
        if (!parentObject) {
            logger.fatal(`fail to find ${this.getParentCreatedAt()}`);
        }
        if (!(parentObject instanceof CRDTTree)) {
            logger.fatal(`fail to execute, only Tree can execute edit`);
        }
        const tree = parentObject;
        let changes;
        if (this.attributes.size) {
            const attributes = {};
            [...this.attributes].forEach(([key, value]) => (attributes[key] = value));
            changes = tree.style([this.fromPos, this.toPos], attributes, this.getExecutedAt());
        }
        else {
            const attributesToRemove = this.attributesToRemove;
            changes = tree.removeStyle([this.fromPos, this.toPos], attributesToRemove, this.getExecutedAt());
        }
        return {
            opInfos: changes.map(({ from, to, value, fromPath }) => {
                return {
                    type: 'tree-style',
                    from,
                    to,
                    value,
                    fromPath,
                    path: root.createPath(this.getParentCreatedAt()),
                };
            }),
        };
    }
    /**
     * `getEffectedCreatedAt` returns the creation time of the effected element.
     */
    getEffectedCreatedAt() {
        return this.getParentCreatedAt();
    }
    /**
     * `toTestString` returns a string containing the meta data.
     */
    toTestString() {
        const parent = this.getParentCreatedAt().toTestString();
        const fromPos = `${this.fromPos
            .getLeftSiblingID()
            .getCreatedAt()
            .toTestString()}:${this.fromPos.getLeftSiblingID().getOffset()}`;
        const toPos = `${this.toPos
            .getLeftSiblingID()
            .getCreatedAt()
            .toTestString()}:${this.toPos.getLeftSiblingID().getOffset()}`;
        return `${parent}.STYLE(${fromPos},${toPos},${Object.entries(this.attributes || {})
            .map(([k, v]) => `${k}:"${v}"`)
            .join(' ')})`;
    }
    /**
     * `getFromPos` returns the start point of the editing range.
     */
    getFromPos() {
        return this.fromPos;
    }
    /**
     * `getToPos` returns the end point of the editing range.
     */
    getToPos() {
        return this.toPos;
    }
    /**
     * `getAttributes` returns the attributes of Style.
     */
    getAttributes() {
        return this.attributes;
    }
    /**
     * `getAttributesToRemove` returns the attributes of Style to remove.
     */
    getAttributesToRemove() {
        return this.attributesToRemove;
    }
}

;// CONCATENATED MODULE: ./src/api/converter.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */






























/**
 * `toPresence` converts the given model to Protobuf format.
 */
function toPresence(presence) {
    const pbPresence = new resources_pb.Presence();
    const pbDataMap = pbPresence.data;
    for (const [key, value] of Object.entries(presence)) {
        pbDataMap[key] = JSON.stringify(value);
    }
    return pbPresence;
}
/**
 * `toPresenceChange` converts the given model to Protobuf format.
 */
function toPresenceChange(presenceChange) {
    if (presenceChange.type === PresenceChangeType.Put) {
        return new resources_pb.PresenceChange({
            type: resources_pb.PresenceChange_ChangeType.PUT,
            presence: toPresence(presenceChange.presence),
        });
    }
    if (presenceChange.type === PresenceChangeType.Clear) {
        return new resources_pb.PresenceChange({
            type: resources_pb.PresenceChange_ChangeType.CLEAR,
        });
    }
    throw new YorkieError(error_Code.Unimplemented, `unimplemented type`);
}
/**
 * `toCheckpoint` converts the given model to Protobuf format.
 */
function toCheckpoint(checkpoint) {
    return new resources_pb.Checkpoint({
        serverSeq: checkpoint.getServerSeqAsString(),
        clientSeq: checkpoint.getClientSeq(),
    });
}
/**
 * `toChangeID` converts the given model to Protobuf format.
 */
function toChangeID(changeID) {
    return new resources_pb.ChangeID({
        clientSeq: changeID.getClientSeq(),
        lamport: changeID.getLamportAsString(),
        actorId: toUint8Array(changeID.getActorID()),
    });
}
/**
 * `toTimeTicket` converts the given model to Protobuf format.
 */
function toTimeTicket(ticket) {
    if (!ticket) {
        return;
    }
    return new resources_pb.TimeTicket({
        lamport: ticket.getLamportAsString(),
        delimiter: ticket.getDelimiter(),
        actorId: toUint8Array(ticket.getActorID()),
    });
}
/**
 * `toValueType` converts the given model to Protobuf format.
 */
function toValueType(valueType) {
    switch (valueType) {
        case PrimitiveType.Null:
            return resources_pb.ValueType.NULL;
        case PrimitiveType.Boolean:
            return resources_pb.ValueType.BOOLEAN;
        case PrimitiveType.Integer:
            return resources_pb.ValueType.INTEGER;
        case PrimitiveType.Long:
            return resources_pb.ValueType.LONG;
        case PrimitiveType.Double:
            return resources_pb.ValueType.DOUBLE;
        case PrimitiveType.String:
            return resources_pb.ValueType.STRING;
        case PrimitiveType.Bytes:
            return resources_pb.ValueType.BYTES;
        case PrimitiveType.Date:
            return resources_pb.ValueType.DATE;
        default:
            throw new YorkieError(error_Code.Unsupported, `unsupported type: ${valueType}`);
    }
}
/**
 * `toCounterType` converts the given model to Protobuf format.
 */
function toCounterType(valueType) {
    switch (valueType) {
        case CounterType.IntegerCnt:
            return resources_pb.ValueType.INTEGER_CNT;
        case CounterType.LongCnt:
            return resources_pb.ValueType.LONG_CNT;
        default:
            throw new YorkieError(error_Code.Unsupported, `unsupported type: ${valueType}`);
    }
}
/**
 * `toElementSimple` converts the given model to Protobuf format.
 */
function toElementSimple(element) {
    if (element instanceof CRDTObject) {
        return new resources_pb.JSONElementSimple({
            type: resources_pb.ValueType.JSON_OBJECT,
            createdAt: toTimeTicket(element.getCreatedAt()),
            value: objectToBytes(element),
        });
    }
    if (element instanceof CRDTArray) {
        return new resources_pb.JSONElementSimple({
            type: resources_pb.ValueType.JSON_ARRAY,
            createdAt: toTimeTicket(element.getCreatedAt()),
            value: arrayToBytes(element),
        });
    }
    if (element instanceof CRDTText) {
        return new resources_pb.JSONElementSimple({
            type: resources_pb.ValueType.TEXT,
            createdAt: toTimeTicket(element.getCreatedAt()),
        });
    }
    if (element instanceof Primitive) {
        return new resources_pb.JSONElementSimple({
            type: toValueType(element.getType()),
            createdAt: toTimeTicket(element.getCreatedAt()),
            value: element.toBytes(),
        });
    }
    if (element instanceof CRDTCounter) {
        return new resources_pb.JSONElementSimple({
            type: toCounterType(element.getType()),
            createdAt: toTimeTicket(element.getCreatedAt()),
            value: element.toBytes(),
        });
    }
    if (element instanceof CRDTTree) {
        return new resources_pb.JSONElementSimple({
            type: resources_pb.ValueType.TREE,
            createdAt: toTimeTicket(element.getCreatedAt()),
            value: treeToBytes(element),
        });
    }
    throw new YorkieError(error_Code.Unimplemented, `unimplemented element`);
}
/**
 * `toTextNodeID` converts the given model to Protobuf format.
 */
function toTextNodeID(id) {
    return new resources_pb.TextNodeID({
        createdAt: toTimeTicket(id.getCreatedAt()),
        offset: id.getOffset(),
    });
}
/**
 * `toTextNodePos` converts the given model to Protobuf format.
 */
function toTextNodePos(pos) {
    return new resources_pb.TextNodePos({
        createdAt: toTimeTicket(pos.getID().getCreatedAt()),
        offset: pos.getID().getOffset(),
        relativeOffset: pos.getRelativeOffset(),
    });
}
/**
 * `toTreePos` converts the given model to Protobuf format.
 */
function toTreePos(pos) {
    return new resources_pb.TreePos({
        parentId: toTreeNodeID(pos.getParentID()),
        leftSiblingId: toTreeNodeID(pos.getLeftSiblingID()),
    });
}
/**
 * `toTreeNodeID` converts the given model to Protobuf format.
 */
function toTreeNodeID(treeNodeID) {
    return new resources_pb.TreeNodeID({
        createdAt: toTimeTicket(treeNodeID.getCreatedAt()),
        offset: treeNodeID.getOffset(),
    });
}
/**
 * `toOperation` converts the given model to Protobuf format.
 */
function toOperation(operation) {
    const pbOperation = new resources_pb.Operation();
    if (operation instanceof SetOperation) {
        const setOperation = operation;
        const pbSetOperation = new resources_pb.Operation_Set();
        pbSetOperation.parentCreatedAt = toTimeTicket(setOperation.getParentCreatedAt());
        pbSetOperation.key = setOperation.getKey();
        pbSetOperation.value = toElementSimple(setOperation.getValue());
        pbSetOperation.executedAt = toTimeTicket(setOperation.getExecutedAt());
        pbOperation.body.case = 'set';
        pbOperation.body.value = pbSetOperation;
    }
    else if (operation instanceof AddOperation) {
        const addOperation = operation;
        const pbAddOperation = new resources_pb.Operation_Add();
        pbAddOperation.parentCreatedAt = toTimeTicket(addOperation.getParentCreatedAt());
        pbAddOperation.prevCreatedAt = toTimeTicket(addOperation.getPrevCreatedAt());
        pbAddOperation.value = toElementSimple(addOperation.getValue());
        pbAddOperation.executedAt = toTimeTicket(addOperation.getExecutedAt());
        pbOperation.body.case = 'add';
        pbOperation.body.value = pbAddOperation;
    }
    else if (operation instanceof MoveOperation) {
        const moveOperation = operation;
        const pbMoveOperation = new resources_pb.Operation_Move();
        pbMoveOperation.parentCreatedAt = toTimeTicket(moveOperation.getParentCreatedAt());
        pbMoveOperation.prevCreatedAt = toTimeTicket(moveOperation.getPrevCreatedAt());
        pbMoveOperation.createdAt = toTimeTicket(moveOperation.getCreatedAt());
        pbMoveOperation.executedAt = toTimeTicket(moveOperation.getExecutedAt());
        pbOperation.body.case = 'move';
        pbOperation.body.value = pbMoveOperation;
    }
    else if (operation instanceof RemoveOperation) {
        const removeOperation = operation;
        const pbRemoveOperation = new resources_pb.Operation_Remove();
        pbRemoveOperation.parentCreatedAt = toTimeTicket(removeOperation.getParentCreatedAt());
        pbRemoveOperation.createdAt = toTimeTicket(removeOperation.getCreatedAt());
        pbRemoveOperation.executedAt = toTimeTicket(removeOperation.getExecutedAt());
        pbOperation.body.case = 'remove';
        pbOperation.body.value = pbRemoveOperation;
    }
    else if (operation instanceof EditOperation) {
        const editOperation = operation;
        const pbEditOperation = new resources_pb.Operation_Edit();
        pbEditOperation.parentCreatedAt = toTimeTicket(editOperation.getParentCreatedAt());
        pbEditOperation.from = toTextNodePos(editOperation.getFromPos());
        pbEditOperation.to = toTextNodePos(editOperation.getToPos());
        const pbCreatedAtMapByActor = pbEditOperation.createdAtMapByActor;
        for (const [key, value] of editOperation.getMaxCreatedAtMapByActor()) {
            pbCreatedAtMapByActor[key] = toTimeTicket(value);
        }
        pbEditOperation.content = editOperation.getContent();
        const pbAttributes = pbEditOperation.attributes;
        for (const [key, value] of editOperation.getAttributes()) {
            pbAttributes[key] = value;
        }
        pbEditOperation.executedAt = toTimeTicket(editOperation.getExecutedAt());
        pbOperation.body.case = 'edit';
        pbOperation.body.value = pbEditOperation;
    }
    else if (operation instanceof StyleOperation) {
        const styleOperation = operation;
        const pbStyleOperation = new resources_pb.Operation_Style();
        pbStyleOperation.parentCreatedAt = toTimeTicket(styleOperation.getParentCreatedAt());
        pbStyleOperation.from = toTextNodePos(styleOperation.getFromPos());
        pbStyleOperation.to = toTextNodePos(styleOperation.getToPos());
        const pbCreatedAtMapByActor = pbStyleOperation.createdAtMapByActor;
        for (const [key, value] of styleOperation.getMaxCreatedAtMapByActor()) {
            pbCreatedAtMapByActor[key] = toTimeTicket(value);
        }
        const pbAttributes = pbStyleOperation.attributes;
        for (const [key, value] of styleOperation.getAttributes()) {
            pbAttributes[key] = value;
        }
        pbStyleOperation.executedAt = toTimeTicket(styleOperation.getExecutedAt());
        pbOperation.body.case = 'style';
        pbOperation.body.value = pbStyleOperation;
    }
    else if (operation instanceof IncreaseOperation) {
        const increaseOperation = operation;
        const pbIncreaseOperation = new resources_pb.Operation_Increase();
        pbIncreaseOperation.parentCreatedAt = toTimeTicket(increaseOperation.getParentCreatedAt());
        pbIncreaseOperation.value = toElementSimple(increaseOperation.getValue());
        pbIncreaseOperation.executedAt = toTimeTicket(increaseOperation.getExecutedAt());
        pbOperation.body.case = 'increase';
        pbOperation.body.value = pbIncreaseOperation;
    }
    else if (operation instanceof TreeEditOperation) {
        const treeEditOperation = operation;
        const pbTreeEditOperation = new resources_pb.Operation_TreeEdit();
        const pbCreatedAtMapByActor = pbTreeEditOperation.createdAtMapByActor;
        for (const [key, value] of treeEditOperation.getMaxCreatedAtMapByActor()) {
            pbCreatedAtMapByActor[key] = toTimeTicket(value);
        }
        pbTreeEditOperation.parentCreatedAt = toTimeTicket(treeEditOperation.getParentCreatedAt());
        pbTreeEditOperation.from = toTreePos(treeEditOperation.getFromPos());
        pbTreeEditOperation.to = toTreePos(treeEditOperation.getToPos());
        pbTreeEditOperation.contents = toTreeNodesWhenEdit(treeEditOperation.getContents());
        pbTreeEditOperation.splitLevel = treeEditOperation.getSplitLevel();
        pbTreeEditOperation.executedAt = toTimeTicket(treeEditOperation.getExecutedAt());
        pbOperation.body.case = 'treeEdit';
        pbOperation.body.value = pbTreeEditOperation;
    }
    else if (operation instanceof TreeStyleOperation) {
        const treeStyleOperation = operation;
        const pbTreeStyleOperation = new resources_pb.Operation_TreeStyle();
        pbTreeStyleOperation.parentCreatedAt = toTimeTicket(treeStyleOperation.getParentCreatedAt());
        pbTreeStyleOperation.from = toTreePos(treeStyleOperation.getFromPos());
        pbTreeStyleOperation.to = toTreePos(treeStyleOperation.getToPos());
        const attributesToRemove = treeStyleOperation.getAttributesToRemove();
        if (attributesToRemove.length > 0) {
            pbTreeStyleOperation.attributesToRemove = attributesToRemove;
        }
        else {
            const attributesMap = pbTreeStyleOperation.attributes;
            for (const [key, value] of treeStyleOperation.getAttributes()) {
                attributesMap[key] = value;
            }
        }
        pbTreeStyleOperation.executedAt = toTimeTicket(treeStyleOperation.getExecutedAt());
        pbOperation.body.case = 'treeStyle';
        pbOperation.body.value = pbTreeStyleOperation;
    }
    else {
        throw new YorkieError(error_Code.Unimplemented, 'unimplemented operation');
    }
    return pbOperation;
}
/**
 * `toOperations` converts the given model to Protobuf format.
 */
function toOperations(operations) {
    const pbOperations = [];
    for (const operation of operations) {
        pbOperations.push(toOperation(operation));
    }
    return pbOperations;
}
/**
 * `toChange` converts the given model to Protobuf format.
 */
function toChange(change) {
    const pbChange = new resources_pb.Change({
        id: toChangeID(change.getID()),
        message: change.getMessage(),
    });
    if (change.hasOperations()) {
        pbChange.operations = toOperations(change.getOperations());
    }
    if (change.hasPresenceChange()) {
        pbChange.presenceChange = toPresenceChange(change.getPresenceChange());
    }
    return pbChange;
}
/**
 * `toChanges` converts the given model to Protobuf format.
 */
function toChanges(changes) {
    const pbChanges = [];
    for (const change of changes) {
        pbChanges.push(toChange(change));
    }
    return pbChanges;
}
/**
 * `toRHTNodes` converts the given model to Protobuf format.
 */
function toRHTNodes(rht) {
    const pbRHTNodes = [];
    for (const rhtNode of rht) {
        pbRHTNodes.push(new resources_pb.RHTNode({
            key: rhtNode.getStrKey(),
            element: toElement(rhtNode.getValue()),
        }));
    }
    return pbRHTNodes;
}
/**
 * `toRGANodes` converts the given model to Protobuf format.
 */
function toRGANodes(rgaTreeList) {
    const pbRGANodes = [];
    for (const rgaTreeListNode of rgaTreeList) {
        pbRGANodes.push(new resources_pb.RGANode({
            element: toElement(rgaTreeListNode.getValue()),
        }));
    }
    return pbRGANodes;
}
/**
 * `toTextNodes` converts the given model to Protobuf format.
 */
function toTextNodes(rgaTreeSplit) {
    const pbTextNodes = [];
    for (const textNode of rgaTreeSplit) {
        const pbTextNode = new resources_pb.TextNode();
        pbTextNode.id = toTextNodeID(textNode.getID());
        pbTextNode.value = textNode.getValue().getContent();
        pbTextNode.removedAt = toTimeTicket(textNode.getRemovedAt());
        const pbNodeAttrsMap = pbTextNode.attributes;
        const attrs = textNode.getValue().getAttrs();
        for (const attr of attrs) {
            const pbNodeAttr = new resources_pb.NodeAttr();
            pbNodeAttr.value = attr.getValue();
            pbNodeAttr.updatedAt = toTimeTicket(attr.getUpdatedAt());
            pbNodeAttrsMap[attr.getKey()] = pbNodeAttr;
        }
        pbTextNodes.push(pbTextNode);
    }
    return pbTextNodes;
}
/**
 * `toTreeNodesWhenEdit` converts the given model to Protobuf format.
 */
function toTreeNodesWhenEdit(nodes) {
    const pbTreeNodesList = [];
    if (!nodes || !nodes.length) {
        return pbTreeNodesList;
    }
    for (const node of nodes) {
        pbTreeNodesList.push(new resources_pb.TreeNodes({
            content: toTreeNodes(node),
        }));
    }
    return pbTreeNodesList;
}
/**
 * `toTreeNodes` converts the given model to Protobuf format.
 */
function toTreeNodes(node) {
    if (!node) {
        return [];
    }
    const pbTreeNodes = [];
    traverse(node, (n, depth) => {
        const pbTreeNode = new resources_pb.TreeNode({
            id: toTreeNodeID(n.id),
            type: n.type,
            removedAt: toTimeTicket(n.removedAt),
            depth,
        });
        if (n.isText) {
            pbTreeNode.value = n.value;
        }
        if (n.insPrevID) {
            pbTreeNode.insPrevId = toTreeNodeID(n.insPrevID);
        }
        if (n.insNextID) {
            pbTreeNode.insNextId = toTreeNodeID(n.insNextID);
        }
        if (n.attrs) {
            for (const attr of n.attrs) {
                pbTreeNode.attributes[attr.getKey()] = new resources_pb.NodeAttr({
                    value: attr.getValue(),
                    updatedAt: toTimeTicket(attr.getUpdatedAt()),
                });
            }
        }
        pbTreeNodes.push(pbTreeNode);
    });
    return pbTreeNodes;
}
/**
 * `toObject` converts the given model to Protobuf format.
 */
function toObject(obj) {
    const pbElement = new resources_pb.JSONElement();
    pbElement.body.case = 'jsonObject';
    pbElement.body.value = new resources_pb.JSONElement_JSONObject({
        nodes: toRHTNodes(obj.getRHT()),
        createdAt: toTimeTicket(obj.getCreatedAt()),
        movedAt: toTimeTicket(obj.getMovedAt()),
        removedAt: toTimeTicket(obj.getRemovedAt()),
    });
    return pbElement;
}
/**
 * `toArray` converts the given model to Protobuf format.
 */
function toArray(arr) {
    const pbElement = new resources_pb.JSONElement();
    pbElement.body.case = 'jsonArray';
    pbElement.body.value = new resources_pb.JSONElement_JSONArray({
        nodes: toRGANodes(arr.getElements()),
        createdAt: toTimeTicket(arr.getCreatedAt()),
        movedAt: toTimeTicket(arr.getMovedAt()),
        removedAt: toTimeTicket(arr.getRemovedAt()),
    });
    return pbElement;
}
/**
 * `toPrimitive` converts the given model to Protobuf format.
 */
function toPrimitive(primitive) {
    const pbElement = new resources_pb.JSONElement();
    pbElement.body.case = 'primitive';
    pbElement.body.value = new resources_pb.JSONElement_Primitive({
        type: toValueType(primitive.getType()),
        value: primitive.toBytes(),
        createdAt: toTimeTicket(primitive.getCreatedAt()),
        movedAt: toTimeTicket(primitive.getMovedAt()),
        removedAt: toTimeTicket(primitive.getRemovedAt()),
    });
    return pbElement;
}
/**
 * `toText` converts the given model to Protobuf format.
 */
function toText(text) {
    const pbElement = new resources_pb.JSONElement();
    pbElement.body.case = 'text';
    pbElement.body.value = new resources_pb.JSONElement_Text({
        nodes: toTextNodes(text.getRGATreeSplit()),
        createdAt: toTimeTicket(text.getCreatedAt()),
        movedAt: toTimeTicket(text.getMovedAt()),
        removedAt: toTimeTicket(text.getRemovedAt()),
    });
    return pbElement;
}
/**
 * `toCounter` converts the given model to Protobuf format.
 */
function toCounter(counter) {
    const pbElement = new resources_pb.JSONElement();
    pbElement.body.case = 'counter';
    pbElement.body.value = new resources_pb.JSONElement_Counter({
        type: toCounterType(counter.getType()),
        value: counter.toBytes(),
        createdAt: toTimeTicket(counter.getCreatedAt()),
        movedAt: toTimeTicket(counter.getMovedAt()),
        removedAt: toTimeTicket(counter.getRemovedAt()),
    });
    return pbElement;
}
/**
 * `toTree` converts the given model to Protobuf format.
 */
function toTree(tree) {
    const pbElement = new resources_pb.JSONElement();
    pbElement.body.case = 'tree';
    pbElement.body.value = new resources_pb.JSONElement_Tree({
        nodes: toTreeNodes(tree.getRoot()),
        createdAt: toTimeTicket(tree.getCreatedAt()),
        movedAt: toTimeTicket(tree.getMovedAt()),
        removedAt: toTimeTicket(tree.getRemovedAt()),
    });
    return pbElement;
}
/**
 * `toElement` converts the given model to Protobuf format.
 */
function toElement(element) {
    if (element instanceof CRDTObject) {
        return toObject(element);
    }
    if (element instanceof CRDTArray) {
        return toArray(element);
    }
    if (element instanceof Primitive) {
        return toPrimitive(element);
    }
    if (element instanceof CRDTText) {
        return toText(element);
    }
    if (element instanceof CRDTCounter) {
        return toCounter(element);
    }
    if (element instanceof CRDTTree) {
        return toTree(element);
    }
    throw new YorkieError(error_Code.Unimplemented, `unimplemented element`);
}
/**
 * `toChangePack` converts the given model to Protobuf format.
 */
function toChangePack(pack) {
    return new resources_pb.ChangePack({
        documentKey: pack.getDocumentKey(),
        checkpoint: toCheckpoint(pack.getCheckpoint()),
        isRemoved: pack.getIsRemoved(),
        changes: toChanges(pack.getChanges()),
        snapshot: pack.getSnapshot(),
        minSyncedTicket: toTimeTicket(pack.getMinSyncedTicket()),
    });
}
/**
 * `fromChangeID` converts the given Protobuf format to model format.
 */
function fromChangeID(pbChangeID) {
    return ChangeID.of(pbChangeID.clientSeq, node_modules_long.fromString(pbChangeID.lamport, true), toHexString(pbChangeID.actorId));
}
/**
 * `fromTimeTicket` converts the given Protobuf format to model format.
 */
function fromTimeTicket(pbTimeTicket) {
    if (!pbTimeTicket) {
        return;
    }
    return TimeTicket.of(node_modules_long.fromString(pbTimeTicket.lamport, true), pbTimeTicket.delimiter, toHexString(pbTimeTicket.actorId));
}
/**
 * `fromPresence` converts the given Protobuf format to model format.
 */
function fromPresence(pbPresence) {
    const data = {};
    Object.entries(pbPresence.data).forEach(([key, value]) => {
        data[key] = JSON.parse(value);
    });
    return data;
}
/**
 * `fromPresenceChange` converts the given Protobuf format to model format.
 */
function fromPresenceChange(pbPresenceChange) {
    const type = pbPresenceChange.type;
    if (type === resources_pb.PresenceChange_ChangeType.PUT) {
        const presence = fromPresence(pbPresenceChange.presence);
        return {
            type: PresenceChangeType.Put,
            presence,
        };
    }
    if (type === resources_pb.PresenceChange_ChangeType.CLEAR) {
        return {
            type: PresenceChangeType.Clear,
        };
    }
    throw new YorkieError(error_Code.Unsupported, `unsupported type: ${type}`);
}
/**
 * `fromPresences` converts the given Protobuf format to model format.
 */
function fromPresences(pbPresences) {
    const presences = new Map();
    Object.entries(pbPresences).forEach(([actorID, pbPresence]) => {
        presences.set(actorID, fromPresence(pbPresence));
    });
    return presences;
}
/**
 * `fromValueType` converts the given Protobuf format to model format.
 */
function fromValueType(pbValueType) {
    switch (pbValueType) {
        case resources_pb.ValueType.NULL:
            return PrimitiveType.Null;
        case resources_pb.ValueType.BOOLEAN:
            return PrimitiveType.Boolean;
        case resources_pb.ValueType.INTEGER:
            return PrimitiveType.Integer;
        case resources_pb.ValueType.LONG:
            return PrimitiveType.Long;
        case resources_pb.ValueType.DOUBLE:
            return PrimitiveType.Double;
        case resources_pb.ValueType.STRING:
            return PrimitiveType.String;
        case resources_pb.ValueType.BYTES:
            return PrimitiveType.Bytes;
        case resources_pb.ValueType.DATE:
            return PrimitiveType.Date;
    }
    throw new YorkieError(error_Code.Unimplemented, `unimplemented value type: ${pbValueType}`);
}
/**
 * `fromCounterType` converts the given Protobuf format to model format.
 */
function fromCounterType(pbValueType) {
    switch (pbValueType) {
        case resources_pb.ValueType.INTEGER_CNT:
            return CounterType.IntegerCnt;
        case resources_pb.ValueType.LONG_CNT:
            return CounterType.LongCnt;
    }
    throw new YorkieError(error_Code.Unimplemented, `unimplemented value type: ${pbValueType}`);
}
/**
 * `fromElementSimple` converts the given Protobuf format to model format.
 */
function fromElementSimple(pbElementSimple) {
    switch (pbElementSimple.type) {
        case resources_pb.ValueType.JSON_OBJECT:
            if (!pbElementSimple.value) {
                return CRDTObject.create(fromTimeTicket(pbElementSimple.createdAt));
            }
            return bytesToObject(pbElementSimple.value);
        case resources_pb.ValueType.JSON_ARRAY:
            if (!pbElementSimple.value) {
                return CRDTArray.create(fromTimeTicket(pbElementSimple.createdAt));
            }
            return bytesToArray(pbElementSimple.value);
        case resources_pb.ValueType.TEXT:
            return CRDTText.create(RGATreeSplit.create(), fromTimeTicket(pbElementSimple.createdAt));
        case resources_pb.ValueType.TREE:
            return bytesToTree(pbElementSimple.value);
        case resources_pb.ValueType.NULL:
        case resources_pb.ValueType.BOOLEAN:
        case resources_pb.ValueType.INTEGER:
        case resources_pb.ValueType.LONG:
        case resources_pb.ValueType.DOUBLE:
        case resources_pb.ValueType.STRING:
        case resources_pb.ValueType.BYTES:
        case resources_pb.ValueType.DATE:
            return Primitive.of(Primitive.valueFromBytes(fromValueType(pbElementSimple.type), pbElementSimple.value), fromTimeTicket(pbElementSimple.createdAt));
        case resources_pb.ValueType.INTEGER_CNT:
        case resources_pb.ValueType.LONG_CNT:
            return CRDTCounter.create(fromCounterType(pbElementSimple.type), CRDTCounter.valueFromBytes(fromCounterType(pbElementSimple.type), pbElementSimple.value), fromTimeTicket(pbElementSimple.createdAt));
    }
}
/**
 * `fromTextNodePos` converts the given Protobuf format to model format.
 */
function fromTextNodePos(pbTextNodePos) {
    return RGATreeSplitPos.of(RGATreeSplitNodeID.of(fromTimeTicket(pbTextNodePos.createdAt), pbTextNodePos.offset), pbTextNodePos.relativeOffset);
}
/**
 * `fromTextNodeID` converts the given Protobuf format to model format.
 */
function fromTextNodeID(pbTextNodeID) {
    return RGATreeSplitNodeID.of(fromTimeTicket(pbTextNodeID.createdAt), pbTextNodeID.offset);
}
/**
 * `fromTextNode` converts the given Protobuf format to model format.
 */
function fromTextNode(pbTextNode) {
    const textValue = CRDTTextValue.create(pbTextNode.value);
    Object.entries(pbTextNode.attributes).forEach(([key, value]) => {
        textValue.setAttr(key, value.value, fromTimeTicket(value.updatedAt));
    });
    const textNode = RGATreeSplitNode.create(fromTextNodeID(pbTextNode.id), textValue);
    textNode.remove(fromTimeTicket(pbTextNode.removedAt));
    return textNode;
}
/**
 * `fromTreePos` converts the given Protobuf format to model format.
 */
function fromTreePos(pbTreePos) {
    return CRDTTreePos.of(fromTreeNodeID(pbTreePos.parentId), fromTreeNodeID(pbTreePos.leftSiblingId));
}
/**
 * `fromTreeNodeID` converts the given Protobuf format to model format.
 */
function fromTreeNodeID(pbTreeNodeID) {
    return CRDTTreeNodeID.of(fromTimeTicket(pbTreeNodeID.createdAt), pbTreeNodeID.offset);
}
/**
 * `fromTreeNodesWhenEdit` converts the given Protobuf format to model format.
 */
function fromTreeNodesWhenEdit(pbTreeNodes) {
    if (!pbTreeNodes.length) {
        return;
    }
    const treeNodes = [];
    pbTreeNodes.forEach((node) => {
        const treeNode = fromTreeNodes(node.content);
        treeNodes.push(treeNode);
    });
    return treeNodes;
}
/**
 * `fromTreeNodes` converts the given Protobuf format to model format.
 */
function fromTreeNodes(pbTreeNodes) {
    if (pbTreeNodes.length === 0) {
        return;
    }
    const nodes = [];
    for (const pbTreeNode of pbTreeNodes) {
        nodes.push(fromTreeNode(pbTreeNode));
    }
    const root = nodes[nodes.length - 1];
    for (let i = nodes.length - 2; i >= 0; i--) {
        let parent;
        for (let j = i + 1; j < nodes.length; j++) {
            if (pbTreeNodes[i].depth - 1 === pbTreeNodes[j].depth) {
                parent = nodes[j];
                break;
            }
        }
        parent.prepend(nodes[i]);
    }
    // build CRDTTree from the root to construct the links between nodes.
    return CRDTTree.create(root, InitialTimeTicket).getRoot();
}
/**
 * `fromTreeNode` converts the given Protobuf format to model format.
 */
function fromTreeNode(pbTreeNode) {
    const id = fromTreeNodeID(pbTreeNode.id);
    const node = CRDTTreeNode.create(id, pbTreeNode.type);
    if (node.isText) {
        node.value = pbTreeNode.value;
    }
    else {
        const attrs = RHT.create();
        Object.entries(pbTreeNode.attributes).forEach(([key, value]) => {
            attrs.set(key, value.value, fromTimeTicket(value.updatedAt));
        });
        node.attrs = attrs;
    }
    if (pbTreeNode.insPrevId) {
        node.insPrevID = fromTreeNodeID(pbTreeNode.insPrevId);
    }
    if (pbTreeNode.insNextId) {
        node.insNextID = fromTreeNodeID(pbTreeNode.insNextId);
    }
    node.removedAt = fromTimeTicket(pbTreeNode.removedAt);
    return node;
}
/**
 * `fromOperations` converts the given Protobuf format to model format.
 */
function fromOperations(pbOperations) {
    const operations = [];
    for (const pbOperation of pbOperations) {
        let operation;
        if (pbOperation.body.case === 'set') {
            const pbSetOperation = pbOperation.body.value;
            operation = SetOperation.create(pbSetOperation.key, fromElementSimple(pbSetOperation.value), fromTimeTicket(pbSetOperation.parentCreatedAt), fromTimeTicket(pbSetOperation.executedAt));
        }
        else if (pbOperation.body.case === 'add') {
            const pbAddOperation = pbOperation.body.value;
            operation = AddOperation.create(fromTimeTicket(pbAddOperation.parentCreatedAt), fromTimeTicket(pbAddOperation.prevCreatedAt), fromElementSimple(pbAddOperation.value), fromTimeTicket(pbAddOperation.executedAt));
        }
        else if (pbOperation.body.case === 'move') {
            const pbMoveOperation = pbOperation.body.value;
            operation = MoveOperation.create(fromTimeTicket(pbMoveOperation.parentCreatedAt), fromTimeTicket(pbMoveOperation.prevCreatedAt), fromTimeTicket(pbMoveOperation.createdAt), fromTimeTicket(pbMoveOperation.executedAt));
        }
        else if (pbOperation.body.case === 'remove') {
            const pbRemoveOperation = pbOperation.body.value;
            operation = RemoveOperation.create(fromTimeTicket(pbRemoveOperation.parentCreatedAt), fromTimeTicket(pbRemoveOperation.createdAt), fromTimeTicket(pbRemoveOperation.executedAt));
        }
        else if (pbOperation.body.case === 'edit') {
            const pbEditOperation = pbOperation.body.value;
            const createdAtMapByActor = new Map();
            Object.entries(pbEditOperation.createdAtMapByActor).forEach(([key, value]) => {
                createdAtMapByActor.set(key, fromTimeTicket(value));
            });
            const attributes = new Map();
            Object.entries(pbEditOperation.attributes).forEach(([key, value]) => {
                attributes.set(key, value);
            });
            operation = EditOperation.create(fromTimeTicket(pbEditOperation.parentCreatedAt), fromTextNodePos(pbEditOperation.from), fromTextNodePos(pbEditOperation.to), createdAtMapByActor, pbEditOperation.content, attributes, fromTimeTicket(pbEditOperation.executedAt));
        }
        else if (pbOperation.body.case === 'style') {
            const pbStyleOperation = pbOperation.body.value;
            const createdAtMapByActor = new Map();
            Object.entries(pbStyleOperation.createdAtMapByActor).forEach(([key, value]) => {
                createdAtMapByActor.set(key, fromTimeTicket(value));
            });
            const attributes = new Map();
            Object.entries(pbStyleOperation.attributes).forEach(([key, value]) => {
                attributes.set(key, value);
            });
            operation = StyleOperation.create(fromTimeTicket(pbStyleOperation.parentCreatedAt), fromTextNodePos(pbStyleOperation.from), fromTextNodePos(pbStyleOperation.to), createdAtMapByActor, attributes, fromTimeTicket(pbStyleOperation.executedAt));
        }
        else if (pbOperation.body.case === 'select') {
            // TODO(hackerwins): Select is deprecated.
            continue;
        }
        else if (pbOperation.body.case === 'increase') {
            const pbIncreaseOperation = pbOperation.body.value;
            operation = IncreaseOperation.create(fromTimeTicket(pbIncreaseOperation.parentCreatedAt), fromElementSimple(pbIncreaseOperation.value), fromTimeTicket(pbIncreaseOperation.executedAt));
        }
        else if (pbOperation.body.case === 'treeEdit') {
            const pbTreeEditOperation = pbOperation.body.value;
            const createdAtMapByActor = new Map();
            Object.entries(pbTreeEditOperation.createdAtMapByActor).forEach(([key, value]) => {
                createdAtMapByActor.set(key, fromTimeTicket(value));
            });
            operation = TreeEditOperation.create(fromTimeTicket(pbTreeEditOperation.parentCreatedAt), fromTreePos(pbTreeEditOperation.from), fromTreePos(pbTreeEditOperation.to), fromTreeNodesWhenEdit(pbTreeEditOperation.contents), pbTreeEditOperation.splitLevel, createdAtMapByActor, fromTimeTicket(pbTreeEditOperation.executedAt));
        }
        else if (pbOperation.body.case === 'treeStyle') {
            const pbTreeStyleOperation = pbOperation.body.value;
            const attributes = new Map();
            const attributesToRemove = pbTreeStyleOperation.attributesToRemove;
            if (attributesToRemove.length > 0) {
                operation = TreeStyleOperation.createTreeRemoveStyleOperation(fromTimeTicket(pbTreeStyleOperation.parentCreatedAt), fromTreePos(pbTreeStyleOperation.from), fromTreePos(pbTreeStyleOperation.to), attributesToRemove, fromTimeTicket(pbTreeStyleOperation.executedAt));
            }
            else {
                Object.entries(pbTreeStyleOperation.attributes).forEach(([key, value]) => {
                    attributes.set(key, value);
                });
                operation = TreeStyleOperation.create(fromTimeTicket(pbTreeStyleOperation.parentCreatedAt), fromTreePos(pbTreeStyleOperation.from), fromTreePos(pbTreeStyleOperation.to), attributes, fromTimeTicket(pbTreeStyleOperation.executedAt));
            }
        }
        else {
            throw new YorkieError(error_Code.Unimplemented, `unimplemented operation`);
        }
        operations.push(operation);
    }
    return operations;
}
/**
 * `fromChanges` converts the given Protobuf format to model format.
 */
function fromChanges(pbChanges) {
    const changes = [];
    for (const pbChange of pbChanges) {
        changes.push(Change.create({
            id: fromChangeID(pbChange.id),
            operations: fromOperations(pbChange.operations),
            presenceChange: pbChange.presenceChange
                ? fromPresenceChange(pbChange.presenceChange)
                : undefined,
            message: pbChange.message,
        }));
    }
    return changes;
}
/**
 * `fromCheckpoint` converts the given Protobuf format to model format.
 */
function fromCheckpoint(pbCheckpoint) {
    return Checkpoint.of(node_modules_long.fromString(pbCheckpoint.serverSeq, true), pbCheckpoint.clientSeq);
}
/**
 * `fromChangePack` converts the given Protobuf format to model format.
 */
function fromChangePack(pbPack) {
    return ChangePack.create(pbPack.documentKey, fromCheckpoint(pbPack.checkpoint), pbPack.isRemoved, fromChanges(pbPack.changes), pbPack.snapshot, fromTimeTicket(pbPack.minSyncedTicket));
}
/**
 * `fromObject` converts the given Protobuf format to model format.
 */
function fromObject(pbObject) {
    const rht = new ElementRHT();
    for (const pbRHTNode of pbObject.nodes) {
        const value = fromElement(pbRHTNode.element);
        rht.set(pbRHTNode.key, value, value.getPositionedAt());
    }
    const obj = new CRDTObject(fromTimeTicket(pbObject.createdAt), rht);
    obj.setMovedAt(fromTimeTicket(pbObject.movedAt));
    obj.setRemovedAt(fromTimeTicket(pbObject.removedAt));
    return obj;
}
/**
 * `fromArray` converts the given Protobuf format to model format.
 */
function fromArray(pbArray) {
    const rgaTreeList = new RGATreeList();
    for (const pbRGANode of pbArray.nodes) {
        // eslint-disable-next-line
        rgaTreeList.insert(fromElement(pbRGANode.element));
    }
    const arr = new CRDTArray(fromTimeTicket(pbArray.createdAt), rgaTreeList);
    arr.setMovedAt(fromTimeTicket(pbArray.movedAt));
    arr.setRemovedAt(fromTimeTicket(pbArray.removedAt));
    return arr;
}
/**
 * `fromPrimitive` converts the given Protobuf format to model format.
 */
function fromPrimitive(pbPrimitive) {
    const primitive = Primitive.of(Primitive.valueFromBytes(fromValueType(pbPrimitive.type), pbPrimitive.value), fromTimeTicket(pbPrimitive.createdAt));
    primitive.setMovedAt(fromTimeTicket(pbPrimitive.movedAt));
    primitive.setRemovedAt(fromTimeTicket(pbPrimitive.removedAt));
    return primitive;
}
/**
 * `fromText` converts the given Protobuf format to model format.
 */
function fromText(pbText) {
    const rgaTreeSplit = new RGATreeSplit();
    let prev = rgaTreeSplit.getHead();
    for (const pbNode of pbText.nodes) {
        const current = rgaTreeSplit.insertAfter(prev, fromTextNode(pbNode));
        if (pbNode.insPrevId) {
            current.setInsPrev(rgaTreeSplit.findNode(fromTextNodeID(pbNode.insPrevId)));
        }
        prev = current;
    }
    const text = new CRDTText(rgaTreeSplit, fromTimeTicket(pbText.createdAt));
    text.setMovedAt(fromTimeTicket(pbText.movedAt));
    text.setRemovedAt(fromTimeTicket(pbText.removedAt));
    return text;
}
/**
 * `fromCounter` converts the given Protobuf format to model format.
 */
function fromCounter(pbCounter) {
    const counter = CRDTCounter.create(fromCounterType(pbCounter.type), CRDTCounter.valueFromBytes(fromCounterType(pbCounter.type), pbCounter.value), fromTimeTicket(pbCounter.createdAt));
    counter.setMovedAt(fromTimeTicket(pbCounter.movedAt));
    counter.setRemovedAt(fromTimeTicket(pbCounter.removedAt));
    return counter;
}
/**
 * `fromTree` converts the given Protobuf format to model format.
 */
function fromTree(pbTree) {
    const root = fromTreeNodes(pbTree.nodes);
    return CRDTTree.create(root, fromTimeTicket(pbTree.createdAt));
}
/**
 * `fromElement` converts the given Protobuf format to model format.
 */
function fromElement(pbElement) {
    if (pbElement.body.case === 'jsonObject') {
        return fromObject(pbElement.body.value);
    }
    else if (pbElement.body.case === 'jsonArray') {
        return fromArray(pbElement.body.value);
    }
    else if (pbElement.body.case === 'primitive') {
        return fromPrimitive(pbElement.body.value);
    }
    else if (pbElement.body.case === 'text') {
        return fromText(pbElement.body.value);
    }
    else if (pbElement.body.case === 'counter') {
        return fromCounter(pbElement.body.value);
    }
    else if (pbElement.body.case === 'tree') {
        return fromTree(pbElement.body.value);
    }
    else {
        throw new YorkieError(error_Code.Unimplemented, `unimplemented element`);
    }
}
/**
 * `bytesToSnapshot` creates a Snapshot from the given byte array.
 */
function bytesToSnapshot(bytes) {
    if (!bytes) {
        return {
            root: CRDTObject.create(InitialTimeTicket),
            presences: new Map(),
        };
    }
    const snapshot = resources_pb.Snapshot.fromBinary(bytes);
    return {
        root: fromElement(snapshot.root),
        presences: fromPresences(snapshot.presences),
    };
}
/**
 * `bytesToObject` creates an JSONObject from the given byte array.
 */
function bytesToObject(bytes) {
    if (!bytes) {
        throw new Error('bytes is empty');
    }
    const pbElement = resources_pb.JSONElement.fromBinary(bytes);
    return fromObject(pbElement.body.value);
}
/**
 * `objectToBytes` converts the given JSONObject to byte array.
 */
function objectToBytes(obj) {
    return toElement(obj).toBinary();
}
/**
 * `bytesToArray` creates an CRDTArray from the given bytes.
 */
function bytesToArray(bytes) {
    if (!bytes) {
        throw new Error('bytes is empty');
    }
    const pbElement = resources_pb.JSONElement.fromBinary(bytes);
    return fromArray(pbElement.body.value);
}
/**
 * `arrayToBytes` converts the given CRDTArray to bytes.
 */
function arrayToBytes(array) {
    return toArray(array).toBinary();
}
/**
 * `bytesToTree` creates an CRDTTree from the given bytes.
 */
function bytesToTree(bytes) {
    if (!bytes) {
        throw new Error('bytes is empty');
    }
    const pbElement = resources_pb.JSONElement.fromBinary(bytes);
    return fromTree(pbElement.body.value);
}
/**
 * `treeToBytes` converts the given tree to bytes.
 */
function treeToBytes(tree) {
    return toTree(tree).toBinary();
}
/**
 * `bytesToHex` creates an hex string from the given byte array.
 */
function bytesToHex(bytes) {
    if (!bytes) {
        return '';
    }
    return Array.from(bytes)
        .map((b) => b.toString(16).padStart(2, '0'))
        .join('');
}
/**
 * `toHexString` converts the given byte array to hex string.
 */
function toHexString(bytes) {
    return bytesToHex(bytes);
}
/**
 * `hexToBytes` converts the given hex string to byte array.
 */
function hexToBytes(hex) {
    return new Uint8Array(hex.match(/.{1,2}/g).map((byte) => parseInt(byte, 16)));
}
/**
 * `toUnit8Array` converts the given hex string to byte array.
 */
function toUint8Array(hex) {
    return hexToBytes(hex);
}
/**
 * `converter` is a converter that converts the given model to protobuf format.
 * is also used to convert models to bytes and vice versa.
 */
const converter = {
    fromPresence,
    toChangePack,
    fromChangePack,
    fromChanges,
    objectToBytes,
    bytesToObject,
    bytesToSnapshot,
    toHexString,
    toUint8Array,
};

;// CONCATENATED MODULE: ./src/client/attachment.ts

/**
 * `Attachment` is a class that manages the state of the document.
 */
class Attachment {
    constructor(reconnectStreamDelay, doc, docID, syncMode) {
        this.reconnectStreamDelay = reconnectStreamDelay;
        this.doc = doc;
        this.docID = docID;
        this.syncMode = syncMode;
        this.remoteChangeEventReceived = false;
    }
    /**
     * `changeSyncMode` changes the sync mode of the document.
     */
    changeSyncMode(syncMode) {
        this.syncMode = syncMode;
    }
    /**
     * `needRealtimeSync` returns whether the document needs to be synced in real time.
     */
    needRealtimeSync() {
        if (this.syncMode === SyncMode.RealtimeSyncOff) {
            return false;
        }
        return (this.syncMode !== SyncMode.Manual &&
            (this.doc.hasLocalChanges() || this.remoteChangeEventReceived));
    }
    /**
     * `runWatchLoop` runs the watch loop.
     */
    async runWatchLoop(watchStreamCreator) {
        const doLoop = async () => {
            if (this.watchStream) {
                return Promise.resolve();
            }
            if (this.watchLoopTimerID) {
                clearTimeout(this.watchLoopTimerID);
                this.watchLoopTimerID = undefined;
            }
            try {
                [this.watchStream, this.watchAbortController] =
                    await watchStreamCreator(() => {
                        this.watchStream = undefined;
                        this.watchAbortController = undefined;
                        this.watchLoopTimerID = setTimeout(doLoop, this.reconnectStreamDelay);
                    });
            }
            catch (err) {
                // TODO(hackerwins): For now, if the creation of the watch stream fails,
                // it is considered normal and the watch loop is executed again after a
                // certain period of time.
                // In the future, we need to find a better way to handle this.
            }
        };
        await doLoop();
    }
    /**
     * `cancelWatchStream` cancels the watch stream.
     */
    cancelWatchStream() {
        if (this.watchStream && this.watchAbortController) {
            this.watchAbortController.abort();
            this.watchStream = undefined;
            this.watchAbortController = undefined;
        }
        clearTimeout(this.watchLoopTimerID);
        this.watchLoopTimerID = undefined;
    }
}

;// CONCATENATED MODULE: ./src/document/change/context.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `ChangeContext` is used to record the context of modification when editing
 * a document. Each time we add an operation, a new time ticket is issued.
 * Finally returns a Change after the modification has been completed.
 */
class ChangeContext {
    constructor(id, root, presence, message) {
        this.id = id;
        this.delimiter = InitialDelimiter;
        this.root = root;
        this.operations = [];
        this.previousPresence = deepcopy(presence);
        this.presenceChange = undefined;
        this.reversePresenceKeys = new Set();
        this.message = message;
    }
    /**
     * `create` creates a new instance of ChangeContext.
     */
    static create(id, root, presence, message) {
        return new ChangeContext(id, root, presence, message);
    }
    /**
     * `push` pushes the given operation to this context.
     */
    push(operation) {
        this.operations.push(operation);
    }
    /**
     * `registerElement` registers the given element to the root.
     */
    registerElement(element, parent) {
        this.root.registerElement(element, parent);
    }
    /**
     * `registerRemovedElement` register removed element for garbage collection.
     */
    registerRemovedElement(deleted) {
        this.root.registerRemovedElement(deleted);
    }
    /**
     * `registerElementHasRemovedNodes` register GC element has removed node for
     * garbage collection.
     */
    registerElementHasRemovedNodes(elem) {
        this.root.registerElementHasRemovedNodes(elem);
    }
    /**
     * `getChange` creates a new instance of Change in this context.
     */
    getChange() {
        return Change.create({
            id: this.id,
            operations: this.operations,
            presenceChange: this.presenceChange,
            message: this.message,
        });
    }
    /**
     * `hasChange` returns whether this context has change or not.
     */
    hasChange() {
        return this.operations.length > 0 || this.presenceChange !== undefined;
    }
    /**
     * `setPresenceChange` registers the presence change to this context.
     */
    setPresenceChange(presenceChange) {
        this.presenceChange = presenceChange;
    }
    /**
     * `setReversePresence` registers the previous presence to undo presence updates.
     */
    setReversePresence(presence, option) {
        for (const key of Object.keys(presence)) {
            if (option === null || option === void 0 ? void 0 : option.addToHistory) {
                this.reversePresenceKeys.add(key);
            }
            else {
                this.reversePresenceKeys.delete(key);
            }
        }
    }
    /**
     * `toReversePresence` returns the reverse presence of this context.
     */
    getReversePresence() {
        if (this.reversePresenceKeys.size === 0)
            return undefined;
        const reversePresence = {};
        for (const key of this.reversePresenceKeys) {
            reversePresence[key] = this.previousPresence[key];
        }
        return reversePresence;
    }
    /**
     * `issueTimeTicket` creates a time ticket to be used to create a new operation.
     */
    issueTimeTicket() {
        this.delimiter += 1;
        return this.id.createTimeTicket(this.delimiter);
    }
    /**
     * `getLastTimeTicket` returns the last time ticket issued in this context.
     */
    getLastTimeTicket() {
        return this.id.createTimeTicket(this.delimiter);
    }
}

;// CONCATENATED MODULE: ./src/document/crdt/root.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */




/**
 * `CRDTRoot` is a structure that represents the root. It has a hash table of
 * all elements to find a specific element when applying remote changes
 * received from server.
 *
 * Every element has a unique `TimeTicket` at creation, which allows us to find
 * a particular element.
 */
class CRDTRoot {
    constructor(rootObject) {
        this.rootObject = rootObject;
        this.elementPairMapByCreatedAt = new Map();
        this.removedElementSetByCreatedAt = new Set();
        this.elementHasRemovedNodesSetByCreatedAt = new Set();
        this.opsForTest = [];
        this.registerElement(rootObject, undefined);
    }
    /**
     * `create` creates a new instance of Root.
     */
    static create() {
        return new CRDTRoot(CRDTObject.create(InitialTimeTicket));
    }
    /**
     * `findByCreatedAt` returns the element of given creation time.
     */
    findByCreatedAt(createdAt) {
        const pair = this.elementPairMapByCreatedAt.get(createdAt.toIDString());
        if (!pair) {
            return;
        }
        return pair.element;
    }
    /**
     * `findElementPairByCreatedAt` returns the element and parent pair
     * of given creation time.
     */
    findElementPairByCreatedAt(createdAt) {
        return this.elementPairMapByCreatedAt.get(createdAt.toIDString());
    }
    /**
     * `createSubPaths` creates an array of the sub paths for the given element.
     */
    createSubPaths(createdAt) {
        let pair = this.elementPairMapByCreatedAt.get(createdAt.toIDString());
        if (!pair) {
            return [];
        }
        const subPaths = [];
        while (pair.parent) {
            const createdAt = pair.element.getCreatedAt();
            const subPath = pair.parent.subPathOf(createdAt);
            if (subPath === undefined) {
                logger.fatal(`cant find the given element: ${createdAt.toIDString()}`);
            }
            subPaths.unshift(subPath);
            pair = this.elementPairMapByCreatedAt.get(pair.parent.getCreatedAt().toIDString());
        }
        subPaths.unshift('$');
        return subPaths;
    }
    /**
     * `createPath` creates path of the given element.
     */
    createPath(createdAt) {
        return this.createSubPaths(createdAt).join('.');
    }
    /**
     * `registerElement` registers the given element and its descendants to hash table.
     */
    registerElement(element, parent) {
        this.elementPairMapByCreatedAt.set(element.getCreatedAt().toIDString(), {
            parent,
            element,
        });
        if (element instanceof CRDTContainer) {
            element.getDescendants((elem, parent) => {
                this.registerElement(elem, parent);
                return false;
            });
        }
    }
    /**
     * `deregisterElement` deregister the given element and its descendants from hash table.
     */
    deregisterElement(element) {
        let count = 0;
        const deregisterElementInternal = (elem) => {
            const createdAt = elem.getCreatedAt().toIDString();
            this.elementPairMapByCreatedAt.delete(createdAt);
            this.removedElementSetByCreatedAt.delete(createdAt);
            count++;
        };
        deregisterElementInternal(element);
        if (element instanceof CRDTContainer) {
            element.getDescendants((e) => {
                deregisterElementInternal(e);
                return false;
            });
        }
        return count;
    }
    /**
     * `registerRemovedElement` registers the given element to the hash set.
     */
    registerRemovedElement(element) {
        this.removedElementSetByCreatedAt.add(element.getCreatedAt().toIDString());
    }
    /**
     * `registerElementHasRemovedNodes` registers the given GC element to the
     * hash set.
     */
    registerElementHasRemovedNodes(elem) {
        this.elementHasRemovedNodesSetByCreatedAt.add(elem.getCreatedAt().toIDString());
    }
    /**
     * `getElementMapSize` returns the size of element map.
     */
    getElementMapSize() {
        return this.elementPairMapByCreatedAt.size;
    }
    /**
     * `getRemovedElementSetSize()` returns the size of removed element set.
     */
    getRemovedElementSetSize() {
        return this.removedElementSetByCreatedAt.size;
    }
    /**
     * `getObject` returns root object.
     */
    getObject() {
        return this.rootObject;
    }
    /**
     * `getGarbageLen` returns length of nodes which can be garbage collected.
     */
    getGarbageLen() {
        let count = 0;
        const seen = new Set();
        for (const createdAt of this.removedElementSetByCreatedAt) {
            seen.add(createdAt);
            const pair = this.elementPairMapByCreatedAt.get(createdAt);
            if (pair.element instanceof CRDTContainer) {
                pair.element.getDescendants((el) => {
                    seen.add(el.getCreatedAt().toIDString());
                    return false;
                });
            }
        }
        count += seen.size;
        for (const createdAt of this.elementHasRemovedNodesSetByCreatedAt) {
            const pair = this.elementPairMapByCreatedAt.get(createdAt);
            const elem = pair.element;
            count += elem.getRemovedNodesLen();
        }
        return count;
    }
    /**
     * `deepcopy` copies itself deeply.
     */
    deepcopy() {
        return new CRDTRoot(this.rootObject.deepcopy());
    }
    /**
     * `garbageCollect` purges elements that were removed before the given time.
     */
    garbageCollect(ticket) {
        let count = 0;
        for (const createdAt of this.removedElementSetByCreatedAt) {
            const pair = this.elementPairMapByCreatedAt.get(createdAt);
            if (pair.element.getRemovedAt() &&
                ticket.compare(pair.element.getRemovedAt()) >= 0) {
                pair.parent.purge(pair.element);
                count += this.deregisterElement(pair.element);
            }
        }
        for (const createdAt of this.elementHasRemovedNodesSetByCreatedAt) {
            const pair = this.elementPairMapByCreatedAt.get(createdAt);
            const elem = pair.element;
            const removedNodeCnt = elem.purgeRemovedNodesBefore(ticket);
            if (removedNodeCnt > 0) {
                this.elementHasRemovedNodesSetByCreatedAt.delete(elem.getCreatedAt().toIDString());
            }
            count += removedNodeCnt;
        }
        return count;
    }
    /**
     * `toJSON` returns the JSON encoding of this root object.
     */
    toJSON() {
        return this.rootObject.toJSON();
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of this root object.
     */
    toSortedJSON() {
        return this.rootObject.toSortedJSON();
    }
}

;// CONCATENATED MODULE: ./src/document/json/object.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */





/**
 * `createJSONObject` creates a new instance of JSONObject.
 */
function createJSONObject(context, target) {
    const objectProxy = new ObjectProxy(context);
    return new Proxy(target, objectProxy.getHandlers());
}
/**
 * `ObjectProxy` is a proxy representing `Object`.
 */
class ObjectProxy {
    constructor(context) {
        this.context = context;
        this.handlers = {
            set: (target, key, value) => {
                if (logger.isEnabled(LogLevel.Trivial)) {
                    logger.trivial(`obj[${key}]=${JSON.stringify(value)}`);
                }
                ObjectProxy.setInternal(context, target, key, value);
                return true;
            },
            get: (target, keyOrMethod) => {
                if (logger.isEnabled(LogLevel.Trivial)) {
                    logger.trivial(`obj[${keyOrMethod}]`);
                }
                if (keyOrMethod === 'getID') {
                    return () => {
                        return target.getCreatedAt();
                    };
                }
                else if (keyOrMethod === 'toJSON' || keyOrMethod === 'toString') {
                    return () => {
                        return target.toJSON();
                    };
                }
                else if (keyOrMethod === 'toJS') {
                    return () => {
                        return target.toJS();
                    };
                }
                else if (keyOrMethod === 'toJSForTest') {
                    return () => {
                        return target.toJSForTest();
                    };
                }
                return toJSONElement(context, target.get(keyOrMethod));
            },
            ownKeys: (target) => {
                return target.getKeys();
            },
            getOwnPropertyDescriptor: () => {
                return {
                    enumerable: true,
                    configurable: true,
                };
            },
            deleteProperty: (target, key) => {
                if (logger.isEnabled(LogLevel.Trivial)) {
                    logger.trivial(`obj[${key}]`);
                }
                ObjectProxy.deleteInternal(context, target, key);
                return true;
            },
        };
    }
    /**
     * `setInternal` sets a new Object for the given key
     */
    static setInternal(context, target, key, value) {
        if (key.includes('.')) {
            throw new YorkieError(error_Code.InvalidObjectKey, `key must not contain the '.'.`);
        }
        const createdAt = context.issueTimeTicket();
        const element = buildCRDTElement(context, value, createdAt);
        const removed = target.set(key, element, createdAt);
        context.registerElement(element, target);
        if (removed) {
            context.registerRemovedElement(removed);
        }
        context.push(SetOperation.create(key, element.deepcopy(), target.getCreatedAt(), createdAt));
    }
    /**
     * `buildObjectMembers` constructs an object where all values from the
     * user-provided object are transformed into CRDTElements.
     * This function takes an object and iterates through its values,
     * converting each value into a corresponding CRDTElement.
     */
    static buildObjectMembers(context, value) {
        const members = {};
        for (const [k, v] of Object.entries(value)) {
            if (k.includes('.')) {
                throw new YorkieError(error_Code.InvalidObjectKey, `key must not contain the '.'.`);
            }
            const createdAt = context.issueTimeTicket();
            const elem = buildCRDTElement(context, v, createdAt);
            members[k] = elem;
        }
        return members;
    }
    /**
     * `deleteInternal` deletes the value of the given key.
     */
    static deleteInternal(context, target, key) {
        const ticket = context.issueTimeTicket();
        const deleted = target.deleteByKey(key, ticket);
        if (!deleted) {
            return;
        }
        context.push(RemoveOperation.create(target.getCreatedAt(), deleted.getCreatedAt(), ticket));
        context.registerRemovedElement(deleted);
    }
    /**
     * `getHandlers` gets handlers.
     */
    getHandlers() {
        return this.handlers;
    }
}

;// CONCATENATED MODULE: ./src/document/json/array.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */






/**
 * `createJSONArray` creates a new instance of JSONArray.
 */
function createJSONArray(context, target) {
    const arrayProxy = new ArrayProxy(context, target);
    return new Proxy(target, arrayProxy.getHandlers());
}
/**
 * `isNumericString` checks if value is numeric string.
 */
function isNumericString(val) {
    if (typeof val === 'string' || val instanceof String) {
        return !isNaN(val);
    }
    return false;
}
/**
 * `isReadOnlyArrayMethod` checks if the method is a standard array read-only operation.
 */
function isReadOnlyArrayMethod(method) {
    return [
        'concat',
        'entries',
        'every',
        'filter',
        'find',
        'findIndex',
        'forEach',
        'join',
        'keys',
        'map',
        'reduce',
        'reduceRight',
        'slice',
        'some',
        'toLocaleString',
        'toString',
        'values',
    ].includes(method);
}
/**
 * `ArrayProxy` is a proxy for Array.
 */
class ArrayProxy {
    constructor(context, array) {
        this.context = context;
        this.array = array;
        this.handlers = {
            get: (target, method, receiver) => {
                if (method === 'getID') {
                    return () => {
                        return target.getCreatedAt();
                    };
                }
                else if (method === 'getElementByID') {
                    return (createdAt) => {
                        const elem = target.getByID(createdAt);
                        if (!elem || elem.isRemoved()) {
                            return;
                        }
                        return toWrappedElement(context, elem);
                    };
                }
                else if (method === 'getElementByIndex') {
                    return (index) => {
                        const elem = target.get(index);
                        return toWrappedElement(context, elem);
                    };
                }
                else if (method === 'getLast') {
                    return () => {
                        return toWrappedElement(context, target.getLast());
                    };
                }
                else if (method === 'deleteByID') {
                    return (createdAt) => {
                        const deleted = ArrayProxy.deleteInternalByID(context, target, createdAt);
                        return toWrappedElement(context, deleted);
                    };
                }
                else if (method === 'insertAfter') {
                    return (prevID, value) => {
                        const inserted = ArrayProxy.insertAfterInternal(context, target, prevID, value);
                        return toWrappedElement(context, inserted);
                    };
                }
                else if (method === 'insertBefore') {
                    return (nextID, value) => {
                        const inserted = ArrayProxy.insertBeforeInternal(context, target, nextID, value);
                        return toWrappedElement(context, inserted);
                    };
                }
                else if (method === 'moveBefore') {
                    return (nextID, id) => {
                        ArrayProxy.moveBeforeInternal(context, target, nextID, id);
                    };
                    // JavaScript Native API
                }
                else if (method === 'moveAfter') {
                    return (prevID, id) => {
                        ArrayProxy.moveAfterInternal(context, target, prevID, id);
                    };
                }
                else if (method === 'moveFront') {
                    return (id) => {
                        ArrayProxy.moveFrontInternal(context, target, id);
                    };
                }
                else if (method === 'moveLast') {
                    return (id) => {
                        ArrayProxy.moveLastInternal(context, target, id);
                    };
                }
                else if (isNumericString(method)) {
                    return toJSONElement(context, target.get(Number(method)));
                }
                else if (method === 'push') {
                    return (value) => {
                        return ArrayProxy.pushInternal(context, target, value);
                    };
                }
                else if (method === 'splice') {
                    return (start, deleteCount, ...items) => {
                        return ArrayProxy.splice(context, target, start, deleteCount, ...items);
                    };
                }
                else if (method === 'length') {
                    return target.length;
                }
                else if (typeof method === 'symbol' && method === Symbol.iterator) {
                    return ArrayProxy.iteratorInternal.bind(this, context, target);
                }
                else if (method === 'includes') {
                    return (searchElement, fromIndex) => {
                        return ArrayProxy.includes(context, target, searchElement, fromIndex);
                    };
                }
                else if (method === 'indexOf') {
                    return (searchElement, fromIndex) => {
                        return ArrayProxy.indexOf(context, target, searchElement, fromIndex);
                    };
                }
                else if (method === 'lastIndexOf') {
                    return (searchElement, fromIndex) => {
                        return ArrayProxy.lastIndexOf(context, target, searchElement, fromIndex);
                    };
                }
                else if (method === 'toTestString') {
                    return () => ArrayProxy.toTestString(target);
                }
                else if (typeof method === 'string' &&
                    isReadOnlyArrayMethod(method)) {
                    return (...args) => {
                        const arr = Array.from(target).map((elem) => toJSONElement(context, elem));
                        return Array.prototype[method].apply(arr, args);
                    };
                }
                // TODO we need to distinguish between the case we need to call default
                // behavior and the case where we need to call an internal method
                // throw new TypeError(`Unsupported method: ${String(method)}`);
                return Reflect.get(target, method, receiver);
            },
            deleteProperty: (target, key) => {
                if (logger.isEnabled(LogLevel.Trivial)) {
                    logger.trivial(`array[${key}]`);
                }
                ArrayProxy.deleteInternalByIndex(context, target, Number.parseInt(key));
                return true;
            },
        };
    }
    // eslint-disable-next-line jsdoc/require-jsdoc
    static *iteratorInternal(change, target) {
        for (const elem of target) {
            yield toWrappedElement(change, elem);
        }
    }
    /**
     * `buildArrayElements` constructs array elements based on the user-provided array.
     */
    static buildArrayElements(context, value) {
        const elements = [];
        for (const v of value) {
            const createdAt = context.issueTimeTicket();
            const elem = buildCRDTElement(context, v, createdAt);
            elements.push(elem);
        }
        return elements;
    }
    /**
     * `pushInternal` pushes the value to the target array.
     */
    static pushInternal(context, target, value) {
        ArrayProxy.insertAfterInternal(context, target, target.getLastCreatedAt(), value);
        return target.length;
    }
    /**
     * `moveBeforeInternal` moves the given `createdAt` element
     * after the previously created element.
     */
    static moveBeforeInternal(context, target, nextCreatedAt, createdAt) {
        const ticket = context.issueTimeTicket();
        const prevCreatedAt = target.getPrevCreatedAt(nextCreatedAt);
        target.moveAfter(prevCreatedAt, createdAt, ticket);
        context.push(MoveOperation.create(target.getCreatedAt(), prevCreatedAt, createdAt, ticket));
    }
    /**
     * `moveAfterInternal` moves the given `createdAt` element
     * after the specific element.
     */
    static moveAfterInternal(context, target, prevCreatedAt, createdAt) {
        const ticket = context.issueTimeTicket();
        target.moveAfter(prevCreatedAt, createdAt, ticket);
        context.push(MoveOperation.create(target.getCreatedAt(), prevCreatedAt, createdAt, ticket));
    }
    /**
     * `moveFrontInternal` moves the given `createdAt` element
     * at the first of array.
     */
    static moveFrontInternal(context, target, createdAt) {
        const ticket = context.issueTimeTicket();
        const head = target.getHead();
        target.moveAfter(head.getCreatedAt(), createdAt, ticket);
        context.push(MoveOperation.create(target.getCreatedAt(), head.getCreatedAt(), createdAt, ticket));
    }
    /**
     * `moveLastInternal` moves the given `createdAt` element
     * at the last of array.
     */
    static moveLastInternal(context, target, createdAt) {
        const ticket = context.issueTimeTicket();
        const last = target.getLastCreatedAt();
        target.moveAfter(last, createdAt, ticket);
        context.push(MoveOperation.create(target.getCreatedAt(), last, createdAt, ticket));
    }
    /**
     * `insertAfterInternal` inserts the value after the previously created element.
     */
    static insertAfterInternal(context, target, prevCreatedAt, value) {
        const createdAt = context.issueTimeTicket();
        const element = buildCRDTElement(context, value, createdAt);
        target.insertAfter(prevCreatedAt, element);
        context.registerElement(element, target);
        context.push(AddOperation.create(target.getCreatedAt(), prevCreatedAt, element.deepcopy(), createdAt));
        return element;
    }
    /**
     * `insertBeforeInternal` inserts the value before the previously created element.
     */
    static insertBeforeInternal(context, target, nextCreatedAt, value) {
        return ArrayProxy.insertAfterInternal(context, target, target.getPrevCreatedAt(nextCreatedAt), value);
    }
    /**
     * `deleteInternalByIndex` deletes target element of given index.
     */
    static deleteInternalByIndex(context, target, index) {
        const ticket = context.issueTimeTicket();
        const deleted = target.deleteByIndex(index, ticket);
        if (!deleted) {
            return;
        }
        context.push(RemoveOperation.create(target.getCreatedAt(), deleted.getCreatedAt(), ticket));
        context.registerRemovedElement(deleted);
        return deleted;
    }
    /**
     * `deleteInternalByID` deletes the element of the given ID.
     */
    static deleteInternalByID(context, target, createdAt) {
        const ticket = context.issueTimeTicket();
        const deleted = target.delete(createdAt, ticket);
        context.push(RemoveOperation.create(target.getCreatedAt(), deleted.getCreatedAt(), ticket));
        context.registerRemovedElement(deleted);
        return deleted;
    }
    /**
     * `splice` is a method to remove elements from the array.
     */
    static splice(context, target, start, deleteCount, ...items) {
        const length = target.length;
        const from = start >= 0 ? Math.min(start, length) : Math.max(length + start, 0);
        const to = deleteCount === undefined
            ? length
            : deleteCount < 0
                ? from
                : Math.min(from + deleteCount, length);
        const removeds = [];
        for (let i = from; i < to; i++) {
            const removed = ArrayProxy.deleteInternalByIndex(context, target, from);
            if (removed) {
                const removedElem = removed.deepcopy();
                removedElem.setRemovedAt();
                removeds.push(toJSONElement(context, removedElem));
            }
        }
        if (items) {
            let previousID = from === 0 ? target.getHead().getID() : target.get(from - 1).getID();
            for (const item of items) {
                const newElem = ArrayProxy.insertAfterInternal(context, target, previousID, item);
                previousID = newElem.getID();
            }
        }
        return removeds;
    }
    /**
     * `includes` returns true if the given element is in the array.
     */
    static includes(context, target, searchElement, fromIndex) {
        var _a;
        const length = target.length;
        const from = fromIndex === undefined
            ? 0
            : fromIndex < 0
                ? Math.max(fromIndex + length, 0)
                : fromIndex;
        if (from >= length)
            return false;
        if (Primitive.isSupport(searchElement)) {
            const arr = Array.from(target).map((elem) => toJSONElement(context, elem));
            return arr.includes(searchElement, from);
        }
        for (let i = from; i < length; i++) {
            if (((_a = target.get(i)) === null || _a === void 0 ? void 0 : _a.getID()) === searchElement.getID()) {
                return true;
            }
        }
        return false;
    }
    /**
     * `indexOf` returns the index of the given element.
     */
    static indexOf(context, target, searchElement, fromIndex) {
        var _a;
        const length = target.length;
        const from = fromIndex === undefined
            ? 0
            : fromIndex < 0
                ? Math.max(fromIndex + length, 0)
                : fromIndex;
        if (from >= length)
            return -1;
        if (Primitive.isSupport(searchElement)) {
            const arr = Array.from(target).map((elem) => toJSONElement(context, elem));
            return arr.indexOf(searchElement, from);
        }
        for (let i = from; i < length; i++) {
            if (((_a = target.get(i)) === null || _a === void 0 ? void 0 : _a.getID()) === searchElement.getID()) {
                return i;
            }
        }
        return -1;
    }
    /**
     * `lastIndexOf` returns the last index of the given element.
     */
    static lastIndexOf(context, target, searchElement, fromIndex) {
        var _a;
        const length = target.length;
        const from = fromIndex === undefined || fromIndex >= length
            ? length - 1
            : fromIndex < 0
                ? fromIndex + length
                : fromIndex;
        if (from < 0)
            return -1;
        if (Primitive.isSupport(searchElement)) {
            const arr = Array.from(target).map((elem) => toJSONElement(context, elem));
            return arr.lastIndexOf(searchElement, from);
        }
        for (let i = from; i > 0; i--) {
            if (((_a = target.get(i)) === null || _a === void 0 ? void 0 : _a.getID()) === searchElement.getID()) {
                return i;
            }
        }
        return -1;
    }
    /**
     * `toTestString` returns a String containing the meta data of the node
     * for debugging purpose.
     */
    static toTestString(target) {
        return target.toTestString();
    }
    /**
     * `getHandlers` gets handlers.
     */
    getHandlers() {
        return this.handlers;
    }
}

;// CONCATENATED MODULE: ./src/document/json/text.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */





/**
 * `Text` is an extended data type for the contents of a text editor.
 */
class Text {
    constructor(context, text) {
        this.context = context;
        this.text = text;
    }
    /**
     * `initialize` initialize this text with context and internal text.
     * @internal
     */
    initialize(context, text) {
        this.context = context;
        this.text = text;
    }
    /**
     * `getID` returns the ID of this text.
     */
    getID() {
        return this.text.getID();
    }
    /**
     * `edit` edits this text with the given content.
     */
    edit(fromIdx, toIdx, content, attributes) {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            return;
        }
        if (fromIdx > toIdx) {
            logger.fatal('from should be less than or equal to to');
            return;
        }
        const range = this.text.indexRangeToPosRange(fromIdx, toIdx);
        if (logger.isEnabled(LogLevel.Debug)) {
            logger.debug(`EDIT: f:${fromIdx}->${range[0].toTestString()}, t:${toIdx}->${range[1].toTestString()} c:${content}`);
        }
        const attrs = attributes ? stringifyObjectValues(attributes) : undefined;
        const ticket = this.context.issueTimeTicket();
        const [maxCreatedAtMapByActor, , rangeAfterEdit] = this.text.edit(range, content, ticket, attrs);
        this.context.push(new EditOperation(this.text.getCreatedAt(), range[0], range[1], maxCreatedAtMapByActor, content, attrs ? new Map(Object.entries(attrs)) : new Map(), ticket));
        if (!range[0].equals(range[1])) {
            this.context.registerElementHasRemovedNodes(this.text);
        }
        return this.text.findIndexesFromRange(rangeAfterEdit);
    }
    /**
     * `delete` deletes the text in the given range.
     */
    delete(fromIdx, toIdx) {
        return this.edit(fromIdx, toIdx, '');
    }
    /**
     * `empty` makes the text empty.
     */
    empty() {
        return this.edit(0, this.length, '');
    }
    /**
     * `setStyle` styles this text with the given attributes.
     */
    setStyle(fromIdx, toIdx, attributes) {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            return false;
        }
        if (fromIdx > toIdx) {
            logger.fatal('from should be less than or equal to to');
            return false;
        }
        const range = this.text.indexRangeToPosRange(fromIdx, toIdx);
        if (logger.isEnabled(LogLevel.Debug)) {
            logger.debug(`STYL: f:${fromIdx}->${range[0].toTestString()}, t:${toIdx}->${range[1].toTestString()} a:${JSON.stringify(attributes)}`);
        }
        const attrs = stringifyObjectValues(attributes);
        const ticket = this.context.issueTimeTicket();
        const [maxCreatedAtMapByActor] = this.text.setStyle(range, attrs, ticket);
        this.context.push(new StyleOperation(this.text.getCreatedAt(), range[0], range[1], maxCreatedAtMapByActor, new Map(Object.entries(attrs)), ticket));
        return true;
    }
    /**
     * `indexRangeToPosRange` returns TextRangeStruct of the given index range.
     */
    indexRangeToPosRange(range) {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        const textRange = this.text.indexRangeToPosRange(range[0], range[1]);
        return [textRange[0].toStruct(), textRange[1].toStruct()];
    }
    /**
     * `posRangeToIndexRange` returns indexes of the given TextRangeStruct.
     */
    posRangeToIndexRange(range) {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        const textRange = this.text.findIndexesFromRange([
            RGATreeSplitPos.fromStruct(range[0]),
            RGATreeSplitPos.fromStruct(range[1]),
        ]);
        return [textRange[0], textRange[1]];
    }
    /**
     * `toTestString` returns a String containing the meta data of the node
     * for debugging purpose.
     */
    toTestString() {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        return this.text.toTestString();
    }
    /**
     * `values` returns values of this text.
     */
    values() {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        return this.text.values();
    }
    /**
     * `length` returns size of RGATreeList.
     */
    get length() {
        return this.text.length;
    }
    /**
     * `checkWeight` returns false when there is an incorrect weight node.
     * for debugging purpose.
     */
    checkWeight() {
        return this.text.checkWeight();
    }
    /**
     * `toString` returns the string representation of this text.
     */
    toString() {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            return '';
        }
        return this.text.toString();
    }
    /**
     * `createRangeForTest` returns pair of RGATreeSplitNodePos of the given indexes
     * for testing purpose.
     */
    createRangeForTest(fromIdx, toIdx) {
        if (!this.context || !this.text) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        return this.text.indexRangeToPosRange(fromIdx, toIdx);
    }
}

;// CONCATENATED MODULE: ./src/document/json/counter.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */



/**
 * `Counter` is a custom data type that is used to counter.
 */
class Counter {
    constructor(valueType, value) {
        this.valueType = valueType;
        this.value = value;
    }
    /**
     * `initialize` initialize this text with context and internal text.
     * @internal
     */
    initialize(context, counter) {
        this.valueType = counter.getValueType();
        this.context = context;
        this.counter = counter;
        this.value = counter.getValue();
    }
    /**
     * `getID` returns the ID of this text.
     */
    getID() {
        return this.counter.getID();
    }
    /**
     * `getValue` returns the value of this counter;
     * @internal
     */
    getValue() {
        return this.value;
    }
    /**
     * `getValueType` returns the value type of this counter.
     */
    getValueType() {
        return this.valueType;
    }
    /**
     * `increase` increases numeric data.
     */
    increase(v) {
        if (!this.context || !this.counter) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        const ticket = this.context.issueTimeTicket();
        const value = Primitive.of(v, ticket);
        if (!value.isNumericType()) {
            throw new TypeError(`Unsupported type of value: ${typeof value.getValue()}`);
        }
        this.counter.increase(value);
        this.context.push(IncreaseOperation.create(this.counter.getCreatedAt(), value, ticket));
        return this;
    }
}

;// CONCATENATED MODULE: ./src/document/json/tree.ts
/*
 * Copyright 2023 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */







/**
 * `buildDescendants` builds descendants of the given tree node.
 */
function buildDescendants(treeNode, parent, context) {
    const { type } = treeNode;
    const ticket = context.issueTimeTicket();
    if (type === DefaultTextType) {
        validateTextNode(treeNode);
        const { value } = treeNode;
        const textNode = CRDTTreeNode.create(CRDTTreeNodeID.of(ticket, 0), type, value);
        parent.append(textNode);
    }
    else {
        const { children = [] } = treeNode;
        let { attributes } = treeNode;
        let attrs;
        if (typeof attributes === 'object' && !isEmpty(attributes)) {
            attributes = stringifyObjectValues(attributes);
            attrs = new RHT();
            for (const [key, value] of Object.entries(attributes)) {
                attrs.set(key, value, ticket);
            }
        }
        const elementNode = CRDTTreeNode.create(CRDTTreeNodeID.of(ticket, 0), type, undefined, attrs);
        parent.append(elementNode);
        for (const child of children) {
            buildDescendants(child, elementNode, context);
        }
    }
}
/**
 * createCRDTTreeNode returns CRDTTreeNode by given TreeNode.
 */
function createCRDTTreeNode(context, content) {
    const { type } = content;
    const ticket = context.issueTimeTicket();
    let root;
    if (content.type === DefaultTextType) {
        const { value } = content;
        root = CRDTTreeNode.create(CRDTTreeNodeID.of(ticket, 0), type, value);
    }
    else if (content) {
        const { children = [] } = content;
        let { attributes } = content;
        let attrs;
        if (typeof attributes === 'object' && !isEmpty(attributes)) {
            attributes = stringifyObjectValues(attributes);
            attrs = new RHT();
            for (const [key, value] of Object.entries(attributes)) {
                attrs.set(key, value, ticket);
            }
        }
        root = CRDTTreeNode.create(CRDTTreeNodeID.of(context.issueTimeTicket(), 0), type, undefined, attrs);
        for (const child of children) {
            buildDescendants(child, root, context);
        }
    }
    return root;
}
/**
 * `validateTextNode` ensures that a text node has a non-empty string value.
 */
function validateTextNode(textNode) {
    if (!textNode.value.length) {
        throw new Error('text node cannot have empty value');
    }
    return true;
}
/**
 * `validateTreeNodes` ensures that treeNodes consists of only one type.
 */
function validateTreeNodes(treeNodes) {
    if (!treeNodes.length) {
        return true;
    }
    const firstTreeNodeType = treeNodes[0].type;
    if (firstTreeNodeType === DefaultTextType) {
        for (const treeNode of treeNodes) {
            const { type } = treeNode;
            if (type !== DefaultTextType) {
                throw new Error('element node and text node cannot be passed together');
            }
            validateTextNode(treeNode);
        }
    }
    else {
        for (const treeNode of treeNodes) {
            const { type } = treeNode;
            if (type === DefaultTextType) {
                throw new Error('element node and text node cannot be passed together');
            }
        }
    }
    return true;
}
/**
 * `Tree` is a CRDT-based tree structure that is used to represent the document
 * tree of text-based editor such as ProseMirror.
 */
class Tree {
    constructor(initialRoot) {
        this.initialRoot = initialRoot;
    }
    /**
     * `initialize` initialize this tree with context and internal tree.
     * @internal
     */
    initialize(context, tree) {
        this.context = context;
        this.tree = tree;
    }
    /**
     * `getID` returns the ID of this tree.
     */
    getID() {
        return this.tree.getID();
    }
    /**
     * `buildRoot` builds the root of this tree with the given initial root
     * which set by the user.
     */
    buildRoot(context) {
        if (!this.initialRoot) {
            return CRDTTreeNode.create(CRDTTreeNodeID.of(context.issueTimeTicket(), 0), DefaultRootType);
        }
        // TODO(hackerwins): Need to use the ticket of operation of creating tree.
        const root = CRDTTreeNode.create(CRDTTreeNodeID.of(context.issueTimeTicket(), 0), this.initialRoot.type);
        for (const child of this.initialRoot.children) {
            buildDescendants(child, root, context);
        }
        return root;
    }
    /**
     * `getSize` returns the size of this tree.
     */
    getSize() {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.getSize();
    }
    /**
     * `getIndexTree` returns the index tree of this tree.
     */
    getIndexTree() {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.getIndexTree();
    }
    /**
     * `styleByPath` sets the attributes to the elements of the given path.
     */
    styleByPath(path, attributes) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (!path.length) {
            throw new Error('path should not be empty');
        }
        const [fromPos, toPos] = this.tree.pathToPosRange(path);
        const ticket = this.context.issueTimeTicket();
        const attrs = attributes ? stringifyObjectValues(attributes) : undefined;
        this.tree.style([fromPos, toPos], attrs, ticket);
        this.context.push(TreeStyleOperation.create(this.tree.getCreatedAt(), fromPos, toPos, attrs ? new Map(Object.entries(attrs)) : new Map(), ticket));
    }
    /**
     * `style` sets the attributes to the elements of the given range.
     */
    style(fromIdx, toIdx, attributes) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (fromIdx > toIdx) {
            throw new Error('from should be less than or equal to to');
        }
        const fromPos = this.tree.findPos(fromIdx);
        const toPos = this.tree.findPos(toIdx);
        const ticket = this.context.issueTimeTicket();
        const attrs = attributes ? stringifyObjectValues(attributes) : undefined;
        this.tree.style([fromPos, toPos], attrs, ticket);
        this.context.push(TreeStyleOperation.create(this.tree.getCreatedAt(), fromPos, toPos, attrs ? new Map(Object.entries(attrs)) : new Map(), ticket));
    }
    /**
     * `removeStyle` removes the attributes to the elements of the given range.
     */
    removeStyle(fromIdx, toIdx, attributesToRemove) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (fromIdx > toIdx) {
            throw new Error('from should be less than or equal to to');
        }
        const fromPos = this.tree.findPos(fromIdx);
        const toPos = this.tree.findPos(toIdx);
        const ticket = this.context.issueTimeTicket();
        this.tree.removeStyle([fromPos, toPos], attributesToRemove, ticket);
        this.context.push(TreeStyleOperation.createTreeRemoveStyleOperation(this.tree.getCreatedAt(), fromPos, toPos, attributesToRemove, ticket));
    }
    editInternal(fromPos, toPos, contents, splitLevel = 0) {
        var _a;
        if (contents.length !== 0 && contents[0]) {
            validateTreeNodes(contents);
            if (contents[0].type !== DefaultTextType) {
                for (const content of contents) {
                    const { children = [] } = content;
                    validateTreeNodes(children);
                }
            }
        }
        const ticket = this.context.getLastTimeTicket();
        let crdtNodes = new Array();
        if (((_a = contents[0]) === null || _a === void 0 ? void 0 : _a.type) === DefaultTextType) {
            let compVal = '';
            for (const content of contents) {
                const { value } = content;
                compVal += value;
            }
            crdtNodes.push(CRDTTreeNode.create(CRDTTreeNodeID.of(this.context.issueTimeTicket(), 0), DefaultTextType, compVal));
        }
        else {
            crdtNodes = contents
                .map((content) => content && createCRDTTreeNode(this.context, content))
                .filter((a) => a);
        }
        const [, maxCreatedAtMapByActor] = this.tree.edit([fromPos, toPos], crdtNodes.length
            ? crdtNodes.map((crdtNode) => crdtNode === null || crdtNode === void 0 ? void 0 : crdtNode.deepcopy())
            : undefined, splitLevel, ticket, () => this.context.issueTimeTicket());
        this.context.push(TreeEditOperation.create(this.tree.getCreatedAt(), fromPos, toPos, crdtNodes.length ? crdtNodes : undefined, splitLevel, maxCreatedAtMapByActor, ticket));
        if (!fromPos.equals(toPos)) {
            this.context.registerElementHasRemovedNodes(this.tree);
        }
        return true;
    }
    /**
     * `editByPath` edits this tree with the given node and path.
     */
    editByPath(fromPath, toPath, content, splitLevel = 0) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (fromPath.length !== toPath.length) {
            throw new Error('path length should be equal');
        }
        if (!fromPath.length || !toPath.length) {
            throw new Error('path should not be empty');
        }
        const fromPos = this.tree.pathToPos(fromPath);
        const toPos = this.tree.pathToPos(toPath);
        return this.editInternal(fromPos, toPos, content ? [content] : [], splitLevel);
    }
    /**
     * `editBulkByPath` edits this tree with the given node and path.
     */
    editBulkByPath(fromPath, toPath, contents, splitLevel = 0) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (fromPath.length !== toPath.length) {
            throw new Error('path length should be equal');
        }
        if (!fromPath.length || !toPath.length) {
            throw new Error('path should not be empty');
        }
        const fromPos = this.tree.pathToPos(fromPath);
        const toPos = this.tree.pathToPos(toPath);
        return this.editInternal(fromPos, toPos, contents, splitLevel);
    }
    /**
     * `edit` edits this tree with the given nodes.
     */
    edit(fromIdx, toIdx, content, splitLevel = 0) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (fromIdx > toIdx) {
            throw new Error('from should be less than or equal to to');
        }
        const fromPos = this.tree.findPos(fromIdx);
        const toPos = this.tree.findPos(toIdx);
        return this.editInternal(fromPos, toPos, content ? [content] : [], splitLevel);
    }
    /**
     * `editBulk` edits this tree with the given nodes.
     */
    editBulk(fromIdx, toIdx, contents, splitLevel = 0) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        if (fromIdx > toIdx) {
            throw new Error('from should be less than or equal to to');
        }
        const fromPos = this.tree.findPos(fromIdx);
        const toPos = this.tree.findPos(toIdx);
        return this.editInternal(fromPos, toPos, contents, splitLevel);
    }
    /**
     * `toXML` returns the XML string of this tree.
     */
    toXML() {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.toXML();
    }
    /**
     * `toJSON` returns the JSON string of this tree.
     */
    toJSON() {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.toJSON();
    }
    /**
     * `toJSInfoForTest` returns detailed TreeNode information for use in Devtools.
     *
     * @internal
     */
    toJSInfoForTest() {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.toJSInfoForTest();
    }
    /**
     * `getRootTreeNode` returns TreeNode of this tree.
     */
    getRootTreeNode() {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.getRootTreeNode();
    }
    /**
     * `indexToPath` returns the path of the given index.
     */
    indexToPath(index) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.indexToPath(index);
    }
    /**
     * `pathToIndex` returns the index of given path.
     */
    pathToIndex(path) {
        if (!this.context || !this.tree) {
            throw new Error('it is not initialized yet');
        }
        return this.tree.pathToIndex(path);
    }
    /**
     * `pathRangeToPosRange` converts the path range into the position range.
     */
    pathRangeToPosRange(range) {
        if (!this.context || !this.tree) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        const indexRange = [
            this.tree.pathToIndex(range[0]),
            this.tree.pathToIndex(range[1]),
        ];
        const posRange = this.tree.indexRangeToPosRange(indexRange);
        return [posRange[0].toStruct(), posRange[1].toStruct()];
    }
    /**
     * `indexRangeToPosRange` converts the index range into the position range.
     */
    indexRangeToPosRange(range) {
        if (!this.context || !this.tree) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        return this.tree.indexRangeToPosStructRange(range);
    }
    /**
     * `posRangeToIndexRange` converts the position range into the index range.
     */
    posRangeToIndexRange(range) {
        if (!this.context || !this.tree) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        const posRange = [
            CRDTTreePos.fromStruct(range[0]),
            CRDTTreePos.fromStruct(range[1]),
        ];
        return this.tree.posRangeToIndexRange(posRange);
    }
    /**
     * `posRangeToPathRange` converts the position range into the path range.
     */
    posRangeToPathRange(range) {
        if (!this.context || !this.tree) {
            logger.fatal('it is not initialized yet');
            // @ts-ignore
            return;
        }
        const posRange = [
            CRDTTreePos.fromStruct(range[0]),
            CRDTTreePos.fromStruct(range[1]),
        ];
        return this.tree.posRangeToPathRange(posRange);
    }
}

;// CONCATENATED MODULE: ./src/document/json/element.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */












/**
 * `createJSON` create a new instance of JSONObject.
 */
function createJSON(context, target) {
    return createJSONObject(context, target);
}
/**
 * `toWrappedElement` converts the CRDT type to `WrappedElement`.
 */
function toWrappedElement(context, elem) {
    if (!elem) {
        return;
    }
    else if (elem instanceof Primitive) {
        return elem;
    }
    else if (elem instanceof CRDTObject) {
        return createJSONObject(context, elem);
    }
    else if (elem instanceof CRDTArray) {
        return createJSONArray(context, elem);
    }
    else if (elem instanceof CRDTText) {
        return new Text(context, elem);
    }
    else if (elem instanceof CRDTCounter) {
        const counter = new Counter(CounterType.IntegerCnt, 0);
        counter.initialize(context, elem);
        return counter;
    }
    else if (elem instanceof CRDTTree) {
        const tree = new Tree();
        tree.initialize(context, elem);
        return tree;
    }
    throw new TypeError(`Unsupported type of element: ${typeof elem}`);
}
/**
 * `toJSONElement` converts the CRDT type to `JSONElement`.
 */
function toJSONElement(context, elem) {
    const wrappedElement = toWrappedElement(context, elem);
    if (wrappedElement instanceof Primitive) {
        return wrappedElement.getValue();
    }
    return wrappedElement;
}
/**
 * `buildCRDTElement` constructs a CRDTElement from the given value.
 */
function buildCRDTElement(context, value, createdAt) {
    let element;
    if (Primitive.isSupport(value)) {
        element = Primitive.of(value, createdAt);
    }
    else if (Array.isArray(value)) {
        element = CRDTArray.create(createdAt, ArrayProxy.buildArrayElements(context, value));
    }
    else if (typeof value === 'object') {
        if (value instanceof Text) {
            element = CRDTText.create(RGATreeSplit.create(), createdAt);
            value.initialize(context, element);
        }
        else if (value instanceof Counter) {
            element = CRDTCounter.create(value.getValueType(), value.getValue(), createdAt);
            value.initialize(context, element);
        }
        else if (value instanceof Tree) {
            element = CRDTTree.create(value.buildRoot(context), createdAt);
            value.initialize(context, element);
        }
        else {
            element = CRDTObject.create(createdAt, ObjectProxy.buildObjectMembers(context, value));
        }
    }
    else {
        throw new TypeError(`Unsupported type of value: ${typeof value}`);
    }
    return element;
}

;// CONCATENATED MODULE: ./src/document/history.ts
/**
 * `MaxUndoRedoStackDepth` is the maximum depth of undo/redo stack.
 */
const MaxUndoRedoStackDepth = 50;
/**
 * `History` is a class that stores the history of the document.
 */
class History {
    constructor() {
        this.undoStack = [];
        this.redoStack = [];
    }
    /**
     * `hasUndo` returns true if there are undo operations.
     */
    hasUndo() {
        return this.undoStack.length > 0;
    }
    /**
     * `hasRedo` returns true if there are redo operations.
     */
    hasRedo() {
        return this.redoStack.length > 0;
    }
    /**
     * `pushUndo` pushes new undo operations of a change to undo stack.
     */
    pushUndo(undoOps) {
        if (this.undoStack.length >= MaxUndoRedoStackDepth) {
            this.undoStack.shift();
        }
        this.undoStack.push(undoOps);
    }
    /**
     * `popUndo` pops the last undo operations of a change from undo stack.
     */
    popUndo() {
        return this.undoStack.pop();
    }
    /**
     * `pushRedo` pushes new redo operations of a change to redo stack.
     */
    pushRedo(redoOps) {
        if (this.redoStack.length >= MaxUndoRedoStackDepth) {
            this.redoStack.shift();
        }
        this.redoStack.push(redoOps);
    }
    /**
     * `popRedo` pops the last redo operations of a change from redo stack.
     */
    popRedo() {
        return this.redoStack.pop();
    }
    /**
     * `clearRedo` flushes remaining redo operations.
     */
    clearRedo() {
        this.redoStack = [];
    }
    /**
     * `getUndoStackForTest` returns the undo stack for test.
     */
    getUndoStackForTest() {
        return this.undoStack;
    }
    /**
     * `getRedoStackForTest` returns the redo stack for test.
     */
    getRedoStackForTest() {
        return this.redoStack;
    }
}

;// CONCATENATED MODULE: ./src/devtools/protocol.ts
/*
 * Copyright 2024 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `EventSourceDevPanel` is the name of the source representing messages
 *  from the Devtools panel.
 */
const EventSourceDevPanel = 'yorkie-devtools-panel';
/**
 * `EventSourceSDK` is the name of the source representing messages
 * from the SDK.
 */
const EventSourceSDK = 'yorkie-devtools-sdk';

;// CONCATENATED MODULE: ./src/devtools/index.ts
/*
 * Copyright 2024 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

let isDevtoolsConnected = false;
const unsubsByDocKey = new Map();
/**
 * `sendToPanel` sends a message to the devtools panel.
 */
function sendToPanel(message, options) {
    if (!((options === null || options === void 0 ? void 0 : options.force) || isDevtoolsConnected)) {
        return;
    }
    window.postMessage({
        source: EventSourceSDK,
        ...message,
    }, '*');
}
/**
 * `startSync` subscribes to a document and sends messages to a panel accordingly.
 * Initially sends a "full sync" message and later sends "partial sync" messages
 * on document changes.
 */
function startSync(doc) {
    sendToPanel({
        msg: 'doc::sync::full',
        docKey: doc.getKey(),
        root: doc.toJSForTest(),
        clients: [doc.getSelfForTest(), ...doc.getOthersForTest()],
    });
    const unsubPresenceEvent = doc.subscribe('presence', (event) => {
        sendToPanel({
            msg: 'doc::sync::partial',
            docKey: doc.getKey(),
            clients: [doc.getSelfForTest(), ...doc.getOthersForTest()],
            event,
        });
    });
    const unsubDocEvent = doc.subscribe((event) => {
        // TODO(hackerwins): For now, we send the full document on any change.
        // In the future, we should send only the changed part.
        sendToPanel({
            msg: 'doc::sync::partial',
            docKey: doc.getKey(),
            root: doc.toJSForTest(),
            event,
        });
    });
    unsubsByDocKey.set(doc.getKey(), [unsubPresenceEvent, unsubDocEvent]);
}
/**
 * `stopSync` cancels all subscriptions to a document.
 */
function stopSync(docKey) {
    const unsubs = unsubsByDocKey.get(docKey);
    if (!unsubs)
        return;
    unsubsByDocKey.delete(docKey);
    for (const unsub of unsubs) {
        unsub();
    }
}
/**
 * `setupDevtools` sets up the devtools integration. It sends messages to the
 * devtools panel when a document is available, when a document is subscribed,
 * and when a document is changed.
 */
function setupDevtools(doc) {
    // NOTE(hackerwins): For production builds, or when running in Node.js, do nothing.
    if ((typeof process !== 'undefined' && process.env.NODE_ENV === 'production') ||
        typeof window === 'undefined') {
        return;
    }
    // NOTE(chacha912): Send initial message, in case the devtool panel is already open.
    sendToPanel({
        msg: 'refresh-devtools',
    }, { force: true });
    // TODO(hackerwins): We need to ensure that this event listener should be
    // removed later.
    window.addEventListener('message', (event) => {
        var _a, _b;
        if (((_a = event.data) === null || _a === void 0 ? void 0 : _a.source) !== EventSourceDevPanel) {
            return;
        }
        const message = event.data;
        switch (message.msg) {
            case 'devtools::connect':
                isDevtoolsConnected = true;
                sendToPanel({
                    msg: 'doc::available',
                    docKey: doc.getKey(),
                });
                break;
            case 'devtools::disconnect':
                isDevtoolsConnected = false;
                stopSync(doc.getKey());
                break;
            case 'devtools::subscribe':
                startSync(doc);
                break;
            case 'devtools::node::detail':
                if (message.data.type === 'YORKIE_TREE') {
                    sendToPanel({
                        msg: 'doc::node::detail',
                        node: (_b = doc.getValueByPath(message.data.path)) === null || _b === void 0 ? void 0 : _b.toJSInfoForTest(),
                    });
                }
                break;
        }
    });
}

;// CONCATENATED MODULE: ./src/document/document.ts















/**
 * `DocumentStatus` represents the status of the document.
 * @public
 */
var DocumentStatus;
(function (DocumentStatus) {
    /**
     * Detached means that the document is not attached to the client.
     * The actor of the ticket is created without being assigned.
     */
    DocumentStatus["Detached"] = "detached";
    /**
     * Attached means that this document is attached to the client.
     * The actor of the ticket is created with being assigned by the client.
     */
    DocumentStatus["Attached"] = "attached";
    /**
     * Removed means that this document is removed. If the document is removed,
     * it cannot be edited.
     */
    DocumentStatus["Removed"] = "removed";
})(DocumentStatus || (DocumentStatus = {}));
/**
 * `DocEventType` represents the type of the event that occurs in `Document`.
 * @public
 */
var DocEventType;
(function (DocEventType) {
    /**
     * snapshot event type
     */
    DocEventType["Snapshot"] = "snapshot";
    /**
     * local document change event type
     */
    DocEventType["LocalChange"] = "local-change";
    /**
     * remote document change event type
     */
    DocEventType["RemoteChange"] = "remote-change";
    /**
     * `Initialized` means that online clients have been loaded from the server.
     */
    DocEventType["Initialized"] = "initialized";
    /**
     * `Watched` means that the client has established a connection with the server,
     * enabling real-time synchronization.
     */
    DocEventType["Watched"] = "watched";
    /**
     * `Unwatched` means that the connection has been disconnected.
     */
    DocEventType["Unwatched"] = "unwatched";
    /**
     * `PresenceChanged` means that the presences of the client has updated.
     */
    DocEventType["PresenceChanged"] = "presence-changed";
})(DocEventType || (DocEventType = {}));
/**
 * `Document` is a CRDT-based data type. We can represent the model
 * of the application and edit it even while offline.
 *
 * @public
 */
class Document {
    constructor(key, opts) {
        this.opts = opts || {};
        this.key = key;
        this.status = DocumentStatus.Detached;
        this.root = CRDTRoot.create();
        this.changeID = InitialChangeID;
        this.checkpoint = InitialCheckpoint;
        this.localChanges = [];
        this.eventStream = createObservable((observer) => {
            this.eventStreamObserver = observer;
        });
        this.onlineClients = new Set();
        this.presences = new Map();
        this.isUpdating = false;
        this.internalHistory = new History();
        this.history = {
            canUndo: this.canUndo.bind(this),
            canRedo: this.canRedo.bind(this),
            undo: this.undo.bind(this),
            redo: this.redo.bind(this),
        };
        setupDevtools(this);
    }
    /**
     * `update` executes the given updater to update this document.
     */
    update(updater, message) {
        if (this.getStatus() === DocumentStatus.Removed) {
            throw new YorkieError(error_Code.DocumentRemoved, `${this.key} is removed`);
        }
        // 01. Update the clone object and create a change.
        this.ensureClone();
        const actorID = this.changeID.getActorID();
        const context = ChangeContext.create(this.changeID.next(), this.clone.root, this.clone.presences.get(actorID) || {}, message);
        try {
            const proxy = createJSON(context, this.clone.root.getObject());
            if (!this.presences.has(actorID)) {
                this.clone.presences.set(actorID, {});
            }
            // NOTE(hackerwins): The updater should not be able to call undo/redo.
            // If the updater calls undo/redo, an error will be thrown.
            this.isUpdating = true;
            updater(proxy, new Presence(context, this.clone.presences.get(actorID)));
        }
        catch (err) {
            // drop clone because it is contaminated.
            this.clone = undefined;
            logger.error(err);
            throw err;
        }
        finally {
            this.isUpdating = false;
        }
        // 02. Update the root object and presences from changes.
        if (context.hasChange()) {
            if (logger.isEnabled(LogLevel.Trivial)) {
                logger.trivial(`trying to update a local change: ${this.toJSON()}`);
            }
            const change = context.getChange();
            const { opInfos, reverseOps } = change.execute(this.root, this.presences, OpSource.Local);
            const reversePresence = context.getReversePresence();
            if (reversePresence) {
                reverseOps.push({
                    type: 'presence',
                    value: reversePresence,
                });
            }
            this.localChanges.push(change);
            if (reverseOps.length > 0) {
                this.internalHistory.pushUndo(reverseOps);
            }
            // NOTE(chacha912): Clear redo when a new local operation is applied.
            if (opInfos.length > 0) {
                this.internalHistory.clearRedo();
            }
            this.changeID = change.getID();
            // 03. Publish the document change event.
            // NOTE(chacha912): Check opInfos, which represent the actually executed operations.
            if (opInfos.length > 0) {
                this.publish({
                    type: DocEventType.LocalChange,
                    value: {
                        message: change.getMessage() || '',
                        operations: opInfos,
                        actor: actorID,
                    },
                });
            }
            if (change.hasPresenceChange()) {
                this.publish({
                    type: DocEventType.PresenceChanged,
                    value: {
                        clientID: actorID,
                        presence: this.getPresence(actorID),
                    },
                });
            }
            if (logger.isEnabled(LogLevel.Trivial)) {
                logger.trivial(`after update a local change: ${this.toJSON()}`);
            }
        }
    }
    /**
     * `subscribe` registers a callback to subscribe to events on the document.
     */
    subscribe(arg1, arg2, arg3, arg4) {
        if (typeof arg1 === 'string') {
            if (typeof arg2 !== 'function') {
                throw new Error('Second argument must be a callback function');
            }
            if (arg1 === 'presence') {
                const callback = arg2;
                return this.eventStream.subscribe((event) => {
                    if (event.type !== DocEventType.Initialized &&
                        event.type !== DocEventType.Watched &&
                        event.type !== DocEventType.Unwatched &&
                        event.type !== DocEventType.PresenceChanged) {
                        return;
                    }
                    callback(event);
                }, arg3, arg4);
            }
            if (arg1 === 'my-presence') {
                const callback = arg2;
                return this.eventStream.subscribe((event) => {
                    if (event.type !== DocEventType.Initialized &&
                        event.type !== DocEventType.Watched &&
                        event.type !== DocEventType.Unwatched &&
                        event.type !== DocEventType.PresenceChanged) {
                        return;
                    }
                    if (event.type !== DocEventType.Initialized &&
                        event.value.clientID !== this.changeID.getActorID()) {
                        return;
                    }
                    callback(event);
                }, arg3, arg4);
            }
            if (arg1 === 'others') {
                const callback = arg2;
                return this.eventStream.subscribe((event) => {
                    if (event.type !== DocEventType.Watched &&
                        event.type !== DocEventType.Unwatched &&
                        event.type !== DocEventType.PresenceChanged) {
                        return;
                    }
                    if (event.value.clientID !== this.changeID.getActorID()) {
                        callback(event);
                    }
                }, arg3, arg4);
            }
            const target = arg1;
            const callback = arg2;
            return this.eventStream.subscribe((event) => {
                if (event.type === DocEventType.Initialized ||
                    event.type === DocEventType.Watched ||
                    event.type === DocEventType.Unwatched ||
                    event.type === DocEventType.PresenceChanged) {
                    return;
                }
                if (event.type === DocEventType.Snapshot) {
                    target === '$' && callback(event);
                    return;
                }
                const { message, operations, actor } = event.value;
                const targetOps = [];
                for (const op of operations) {
                    if (this.isSameElementOrChildOf(op.path, target)) {
                        targetOps.push(op);
                    }
                }
                targetOps.length &&
                    callback({
                        type: event.type,
                        value: {
                            message,
                            operations: targetOps,
                            actor,
                        },
                    });
            }, arg3, arg4);
        }
        if (typeof arg1 === 'function') {
            const callback = arg1;
            const error = arg2;
            const complete = arg3;
            return this.eventStream.subscribe((event) => {
                if (event.type === DocEventType.Initialized ||
                    event.type === DocEventType.Watched ||
                    event.type === DocEventType.Unwatched ||
                    event.type === DocEventType.PresenceChanged) {
                    return;
                }
                callback(event);
            }, error, complete);
        }
        throw new Error(`"${arg1}" is not a valid`);
    }
    /**
     * `publish` triggers an event in this document, which can be received by
     * callback functions from document.subscribe().
     */
    publish(event) {
        if (this.eventStreamObserver) {
            this.eventStreamObserver.next(event);
        }
    }
    isSameElementOrChildOf(elem, parent) {
        if (parent === elem) {
            return true;
        }
        const nodePath = elem.split('.');
        const targetPath = parent.split('.');
        return targetPath.every((path, index) => path === nodePath[index]);
    }
    /**
     * `applyChangePack` applies the given change pack into this document.
     * 1. Remove local changes applied to server.
     * 2. Update the checkpoint.
     * 3. Do Garbage collection.
     *
     * @param pack - change pack
     * @internal
     */
    applyChangePack(pack) {
        if (pack.hasSnapshot()) {
            this.applySnapshot(pack.getCheckpoint().getServerSeq(), pack.getSnapshot());
        }
        else if (pack.hasChanges()) {
            this.applyChanges(pack.getChanges());
        }
        // 02. Remove local changes applied to server.
        while (this.localChanges.length) {
            const change = this.localChanges[0];
            if (change.getID().getClientSeq() > pack.getCheckpoint().getClientSeq()) {
                break;
            }
            this.localChanges.shift();
        }
        // 03. Update the checkpoint.
        this.checkpoint = this.checkpoint.forward(pack.getCheckpoint());
        // 04. Do Garbage collection.
        this.garbageCollect(pack.getMinSyncedTicket());
        // 05. Update the status.
        if (pack.getIsRemoved()) {
            this.setStatus(DocumentStatus.Removed);
        }
        if (logger.isEnabled(LogLevel.Trivial)) {
            logger.trivial(`${this.root.toJSON()}`);
        }
    }
    /**
     * `getCheckpoint` returns the checkpoint of this document.
     *
     * @internal
     */
    getCheckpoint() {
        return this.checkpoint;
    }
    /**
     * `getChangeID` returns the change id of this document.
     *
     * @internal
     */
    getChangeID() {
        return this.changeID;
    }
    /**
     * `hasLocalChanges` returns whether this document has local changes or not.
     */
    hasLocalChanges() {
        return this.localChanges.length > 0;
    }
    /**
     * `ensureClone` make a clone of root.
     *
     * @internal
     */
    ensureClone() {
        if (this.clone) {
            return;
        }
        this.clone = {
            root: this.root.deepcopy(),
            presences: deepcopy(this.presences),
        };
    }
    /**
     * `createChangePack` create change pack of the local changes to send to the
     * remote server.
     *
     * @internal
     */
    createChangePack() {
        const changes = Array.from(this.localChanges);
        const checkpoint = this.checkpoint.increaseClientSeq(changes.length);
        return ChangePack.create(this.key, checkpoint, false, changes);
    }
    /**
     * `setActor` sets actor into this document. This is also applied in the local
     * changes the document has.
     *
     * @internal
     */
    setActor(actorID) {
        for (const change of this.localChanges) {
            change.setActor(actorID);
        }
        this.changeID = this.changeID.setActor(actorID);
        // TODO also apply into root.
    }
    /**
     * `getKey` returns the key of this document.
     */
    getKey() {
        return this.key;
    }
    /**
     * `setStatus` updates the status of this document.
     *
     * @internal
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * `getStatus` returns the status of this document.
     */
    getStatus() {
        return this.status;
    }
    /**
     * `getClone` return clone object.
     *
     * @internal
     */
    getCloneRoot() {
        if (!this.clone) {
            return;
        }
        return this.clone.root.getObject();
    }
    /**
     * `getRoot` returns a new proxy of cloned root.
     */
    getRoot() {
        this.ensureClone();
        const context = ChangeContext.create(this.changeID.next(), this.clone.root, this.clone.presences.get(this.changeID.getActorID()) || {});
        return createJSON(context, this.clone.root.getObject());
    }
    /**
     * `getOpsForTest` returns the operations of this document for testing.
     */
    getOpsForTest() {
        return this.root.opsForTest;
    }
    /**
     * `garbageCollect` purges elements that were removed before the given time.
     *
     * @internal
     */
    garbageCollect(ticket) {
        if (this.opts.disableGC) {
            return 0;
        }
        if (this.clone) {
            this.clone.root.garbageCollect(ticket);
        }
        return this.root.garbageCollect(ticket);
    }
    /**
     * `getRootObject` returns root object.
     *
     * @internal
     */
    getRootObject() {
        return this.root.getObject();
    }
    /**
     * `getGarbageLen` returns the length of elements should be purged.
     *
     * @internal
     */
    getGarbageLen() {
        return this.root.getGarbageLen();
    }
    /**
     * `getGarbageLenFromClone` returns the length of elements should be purged from clone.
     */
    getGarbageLenFromClone() {
        return this.clone.root.getGarbageLen();
    }
    /**
     * `toJSON` returns the JSON encoding of this document.
     */
    toJSON() {
        return this.root.toJSON();
    }
    /**
     * `toSortedJSON` returns the sorted JSON encoding of this document.
     */
    toSortedJSON() {
        return this.root.toSortedJSON();
    }
    /**
     * `toJSForTest` returns value with meta data for testing.
     */
    toJSForTest() {
        return {
            ...this.getRoot().toJSForTest(),
            key: 'root',
        };
    }
    /**
     * `applySnapshot` applies the given snapshot into this document.
     */
    applySnapshot(serverSeq, snapshot) {
        const { root, presences } = converter.bytesToSnapshot(snapshot);
        this.root = new CRDTRoot(root);
        this.presences = presences;
        this.changeID = this.changeID.syncLamport(serverSeq);
        // drop clone because it is contaminated.
        this.clone = undefined;
        this.publish({
            type: DocEventType.Snapshot,
            value: snapshot,
        });
    }
    /**
     * `applyChanges` applies the given changes into this document.
     */
    applyChanges(changes) {
        if (logger.isEnabled(LogLevel.Debug)) {
            logger.debug(`trying to apply ${changes.length} remote changes.` +
                `elements:${this.root.getElementMapSize()}, ` +
                `removeds:${this.root.getRemovedElementSetSize()}`);
        }
        if (logger.isEnabled(LogLevel.Trivial)) {
            logger.trivial(changes
                .map((change) => `${change.getID().toTestString()}\t${change.toTestString()}`)
                .join('\n'));
        }
        this.ensureClone();
        for (const change of changes) {
            change.execute(this.clone.root, this.clone.presences, OpSource.Remote);
            let presenceEvent;
            const actorID = change.getID().getActorID();
            if (change.hasPresenceChange() && this.onlineClients.has(actorID)) {
                const presenceChange = change.getPresenceChange();
                switch (presenceChange.type) {
                    case PresenceChangeType.Put:
                        // NOTE(chacha912): When the user exists in onlineClients, but
                        // their presence was initially absent, we can consider that we have
                        // received their initial presence, so trigger the 'watched' event.
                        presenceEvent = {
                            type: this.presences.has(actorID)
                                ? DocEventType.PresenceChanged
                                : DocEventType.Watched,
                            value: {
                                clientID: actorID,
                                presence: presenceChange.presence,
                            },
                        };
                        break;
                    case PresenceChangeType.Clear:
                        // NOTE(chacha912): When the user exists in onlineClients, but
                        // PresenceChange(clear) is received, we can consider it as detachment
                        // occurring before unwatching.
                        // Detached user is no longer participating in the document, we remove
                        // them from the online clients and trigger the 'unwatched' event.
                        presenceEvent = {
                            type: DocEventType.Unwatched,
                            value: {
                                clientID: actorID,
                                presence: this.getPresence(actorID),
                            },
                        };
                        this.removeOnlineClient(actorID);
                        break;
                    default:
                        break;
                }
            }
            const { opInfos } = change.execute(this.root, this.presences, OpSource.Remote);
            // DocEvent should be emitted synchronously with applying changes.
            // This is because 3rd party model should be synced with the Document
            // after RemoteChange event is emitted. If the event is emitted
            // asynchronously, the model can be changed and breaking consistency.
            if (opInfos.length > 0) {
                this.publish({
                    type: DocEventType.RemoteChange,
                    value: {
                        actor: actorID,
                        message: change.getMessage() || '',
                        operations: opInfos,
                    },
                });
            }
            if (presenceEvent) {
                this.publish(presenceEvent);
            }
            this.changeID = this.changeID.syncLamport(change.getID().getLamport());
        }
        if (logger.isEnabled(LogLevel.Debug)) {
            logger.debug(`after appling ${changes.length} remote changes.` +
                `elements:${this.root.getElementMapSize()}, ` +
                ` removeds:${this.root.getRemovedElementSetSize()}`);
        }
    }
    /**
     * `getValueByPath` returns the JSONElement corresponding to the given path.
     */
    getValueByPath(path) {
        if (!path.startsWith('$')) {
            throw new YorkieError(error_Code.InvalidArgument, `path must start with "$"`);
        }
        const pathArr = path.split('.');
        pathArr.shift();
        let value = this.getRoot();
        for (const key of pathArr) {
            value = value[key];
            if (value === undefined)
                return undefined;
        }
        return value;
    }
    /**
     * `setOnlineClients` sets the given online client set.
     *
     * @internal
     */
    setOnlineClients(onlineClients) {
        this.onlineClients = onlineClients;
    }
    /**
     * `addOnlineClient` adds the given clientID into the online client set.
     *
     * @internal
     */
    addOnlineClient(clientID) {
        this.onlineClients.add(clientID);
    }
    /**
     * `removeOnlineClient` removes the clientID from the online client set.
     *
     * @internal
     */
    removeOnlineClient(clientID) {
        this.onlineClients.delete(clientID);
    }
    /**
     * `hasPresence` returns whether the given clientID has a presence or not.
     *
     * @internal
     */
    hasPresence(clientID) {
        return this.presences.has(clientID);
    }
    /**
     * `getMyPresence` returns the presence of the current client.
     */
    getMyPresence() {
        if (this.status !== DocumentStatus.Attached) {
            return {};
        }
        const p = this.presences.get(this.changeID.getActorID());
        return deepcopy(p);
    }
    /**
     * `getPresence` returns the presence of the given clientID.
     */
    getPresence(clientID) {
        if (!this.onlineClients.has(clientID))
            return;
        const p = this.presences.get(clientID);
        return p ? deepcopy(p) : undefined;
    }
    /**
     * `getPresenceForTest` returns the presence of the given clientID
     * regardless of whether the client is online or not.
     *
     * @internal
     */
    getPresenceForTest(clientID) {
        const p = this.presences.get(clientID);
        return p ? deepcopy(p) : undefined;
    }
    /**
     * `getPresences` returns the presences of online clients.
     */
    getPresences() {
        const presences = [];
        for (const clientID of this.onlineClients) {
            if (this.presences.has(clientID)) {
                presences.push({
                    clientID,
                    presence: deepcopy(this.presences.get(clientID)),
                });
            }
        }
        return presences;
    }
    /**
     * `getSelfForTest` returns the client that has attached this document.
     *
     * @internal
     */
    getSelfForTest() {
        return {
            clientID: this.getChangeID().getActorID(),
            presence: this.getMyPresence(),
        };
    }
    /**
     * `getOthersForTest` returns all the other clients in online, sorted by clientID.
     *
     * @internal
     */
    getOthersForTest() {
        const myClientID = this.getChangeID().getActorID();
        return this.getPresences()
            .filter((a) => a.clientID !== myClientID)
            .sort((a, b) => (a.clientID > b.clientID ? 1 : -1));
    }
    /**
     * `canUndo` returns whether there are any operations to undo.
     */
    canUndo() {
        return this.internalHistory.hasUndo() && !this.isUpdating;
    }
    /**
     * `canRedo` returns whether there are any operations to redo.
     */
    canRedo() {
        return this.internalHistory.hasRedo() && !this.isUpdating;
    }
    /**
     * `undo` undoes the last operation executed by the current client.
     * It does not impact operations made by other clients.
     */
    undo() {
        if (this.isUpdating) {
            throw new Error('Undo is not allowed during an update');
        }
        const undoOps = this.internalHistory.popUndo();
        if (undoOps === undefined) {
            throw new Error('There is no operation to be undone');
        }
        this.ensureClone();
        // TODO(chacha912): After resolving the presence initialization issue,
        // remove default presence.(#608)
        const context = ChangeContext.create(this.changeID.next(), this.clone.root, this.clone.presences.get(this.changeID.getActorID()) || {});
        // apply undo operation in the context to generate a change
        for (const undoOp of undoOps) {
            if (!(undoOp instanceof Operation)) {
                // apply presence change to the context
                const presence = new Presence(context, deepcopy(this.clone.presences.get(this.changeID.getActorID())));
                presence.set(undoOp.value, { addToHistory: true });
                continue;
            }
            const ticket = context.issueTimeTicket();
            undoOp.setExecutedAt(ticket);
            context.push(undoOp);
        }
        const change = context.getChange();
        change.execute(this.clone.root, this.clone.presences, OpSource.UndoRedo);
        const { opInfos, reverseOps } = change.execute(this.root, this.presences, OpSource.UndoRedo);
        const reversePresence = context.getReversePresence();
        if (reversePresence) {
            reverseOps.push({
                type: 'presence',
                value: reversePresence,
            });
        }
        if (reverseOps.length > 0) {
            this.internalHistory.pushRedo(reverseOps);
        }
        // NOTE(chacha912): When there is no applied operation or presence
        // during undo/redo, skip propagating change remotely.
        if (!change.hasPresenceChange() && opInfos.length === 0) {
            return;
        }
        this.localChanges.push(change);
        this.changeID = change.getID();
        const actorID = this.changeID.getActorID();
        if (opInfos.length > 0) {
            this.publish({
                type: DocEventType.LocalChange,
                value: {
                    message: change.getMessage() || '',
                    operations: opInfos,
                    actor: actorID,
                },
            });
        }
        if (change.hasPresenceChange()) {
            this.publish({
                type: DocEventType.PresenceChanged,
                value: {
                    clientID: actorID,
                    presence: this.getPresence(actorID),
                },
            });
        }
    }
    /**
     * `redo` redoes the last operation executed by the current client.
     * It does not impact operations made by other clients.
     */
    redo() {
        if (this.isUpdating) {
            throw new Error('Redo is not allowed during an update');
        }
        const redoOps = this.internalHistory.popRedo();
        if (redoOps === undefined) {
            throw new Error('There is no operation to be redone');
        }
        this.ensureClone();
        const context = ChangeContext.create(this.changeID.next(), this.clone.root, this.clone.presences.get(this.changeID.getActorID()) || {});
        // apply redo operation in the context to generate a change
        for (const redoOp of redoOps) {
            if (!(redoOp instanceof Operation)) {
                // apply presence change to the context
                const presence = new Presence(context, deepcopy(this.clone.presences.get(this.changeID.getActorID())));
                presence.set(redoOp.value, { addToHistory: true });
                continue;
            }
            const ticket = context.issueTimeTicket();
            redoOp.setExecutedAt(ticket);
            context.push(redoOp);
        }
        const change = context.getChange();
        change.execute(this.clone.root, this.clone.presences, OpSource.UndoRedo);
        const { opInfos, reverseOps } = change.execute(this.root, this.presences, OpSource.UndoRedo);
        const reversePresence = context.getReversePresence();
        if (reversePresence) {
            reverseOps.push({
                type: 'presence',
                value: reversePresence,
            });
        }
        if (reverseOps.length > 0) {
            this.internalHistory.pushUndo(reverseOps);
        }
        // NOTE(chacha912): When there is no applied operation or presence
        // during undo/redo, skip propagating change remotely.
        if (!change.hasPresenceChange() && opInfos.length === 0) {
            return;
        }
        this.localChanges.push(change);
        this.changeID = change.getID();
        const actorID = this.changeID.getActorID();
        if (opInfos.length > 0) {
            this.publish({
                type: DocEventType.LocalChange,
                value: {
                    message: change.getMessage() || '',
                    operations: opInfos,
                    actor: actorID,
                },
            });
        }
        if (change.hasPresenceChange()) {
            this.publish({
                type: DocEventType.PresenceChanged,
                value: {
                    clientID: actorID,
                    presence: this.getPresence(actorID),
                },
            });
        }
    }
    /**
     * `getUndoStackForTest` returns the undo stack for test.
     */
    getUndoStackForTest() {
        return this.internalHistory.getUndoStackForTest();
    }
    /**
     * `getRedoStackForTest` returns the redo stack for test.
     */
    getRedoStackForTest() {
        return this.internalHistory.getRedoStackForTest();
    }
}

;// CONCATENATED MODULE: ./src/client/auth_interceptor.ts
/*
 * Copyright 2021 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `createAuthInterceptor` creates an interceptor to add the Authorization header for each
 * request.
 */
function createAuthInterceptor(apiKey, token) {
    return (next) => async (req) => {
        if (apiKey) {
            req.header.set('x-api-key', apiKey);
        }
        if (token) {
            req.header.set('authorization', token);
        }
        return await next(req);
    };
}

;// CONCATENATED MODULE: ./package.json
const package_namespaceObject = JSON.parse('{"u2":"yorkie-js-sdk","i8":"0.4.17"}');
;// CONCATENATED MODULE: ./src/client/metric_interceptor.ts
/*
 * Copyright 2021 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * `createMetricInterceptor` creates an interceptor to add the x-yorkie-user-agent header for each
 * request.
 */
function createMetricInterceptor() {
    return (next) => async (req) => {
        req.header.set('x-yorkie-user-agent', package_namespaceObject.u2 + '/' + package_namespaceObject.i8);
        return await next(req);
    };
}

;// CONCATENATED MODULE: ./src/client/client.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */














/**
 * `SyncMode` defines synchronization modes for the PushPullChanges API.
 * @public
 */
var SyncMode;
(function (SyncMode) {
    /**
     * `Manual` mode indicates that changes are not automatically pushed or pulled.
     */
    SyncMode["Manual"] = "manual";
    /**
     * `Realtime` mode indicates that changes are automatically pushed and pulled.
     */
    SyncMode["Realtime"] = "realtime";
    /**
     * `RealtimePushOnly` mode indicates that only local changes are automatically pushed.
     */
    SyncMode["RealtimePushOnly"] = "realtime-pushonly";
    /**
     * `RealtimeSyncOff` mode indicates that changes are not automatically pushed or pulled,
     * but the watch stream is kept active.
     */
    SyncMode["RealtimeSyncOff"] = "realtime-syncoff";
})(SyncMode || (SyncMode = {}));
/**
 * `ClientStatus` represents the status of the client.
 * @public
 */
var ClientStatus;
(function (ClientStatus) {
    /**
     * `Deactivated` means that the client is not activated. It is the initial
     * status of the client. If the client is deactivated, all `Document`s of the
     * client are also not used.
     */
    ClientStatus["Deactivated"] = "deactivated";
    /**
     * `Activated` means that the client is activated. If the client is activated,
     * all `Document`s of the client are also ready to be used.
     */
    ClientStatus["Activated"] = "activated";
})(ClientStatus || (ClientStatus = {}));
/**
 * `StreamConnectionStatus` represents whether the stream connection between the
 * client and the server is connected or not.
 * @public
 */
var StreamConnectionStatus;
(function (StreamConnectionStatus) {
    /**
     * `Connected` means that the stream connection is connected.
     */
    StreamConnectionStatus["Connected"] = "connected";
    /**
     * `Disconnected` means that the stream connection is disconnected.
     */
    StreamConnectionStatus["Disconnected"] = "disconnected";
})(StreamConnectionStatus || (StreamConnectionStatus = {}));
/**
 * `DocumentSyncResultType` represents the result of synchronizing the document
 *  with the server.
 * @public
 */
var DocumentSyncResultType;
(function (DocumentSyncResultType) {
    /**
     * type when Document synced successfully.
     */
    DocumentSyncResultType["Synced"] = "synced";
    /**
     * type when Document sync failed.
     */
    DocumentSyncResultType["SyncFailed"] = "sync-failed";
})(DocumentSyncResultType || (DocumentSyncResultType = {}));
/**
 * `ClientEventType` represents the type of the event that the client can emit.
 * @public
 */
var ClientEventType;
(function (ClientEventType) {
    /**
     * `StatusChanged` means that the status of the client has changed.
     */
    ClientEventType["StatusChanged"] = "status-changed";
    /**
     * `DocumentChanged` means that the document has changed.
     */
    ClientEventType["DocumentChanged"] = "document-changed";
    /**
     * `StreamConnectionStatusChanged` means that the stream connection status of
     * the client has changed.
     */
    ClientEventType["StreamConnectionStatusChanged"] = "stream-connection-status-changed";
    /**
     * `DocumentSynced` means that the document has been synced with the server.
     */
    ClientEventType["DocumentSynced"] = "document-synced";
})(ClientEventType || (ClientEventType = {}));
/**
 * `DefaultClientOptions` is the default options for Client.
 */
const DefaultClientOptions = {
    syncLoopDuration: 50,
    retrySyncLoopDelay: 1000,
    reconnectStreamDelay: 1000,
};
/**
 * `Client` is a normal client that can communicate with the server.
 * It has documents and sends changes of the documents in local
 * to the server to synchronize with other replicas in remote.
 *
 * @public
 */
class Client {
    /**
     * @param rpcAddr - the address of the RPC server.
     * @param opts - the options of the client.
     */
    constructor(rpcAddr, opts) {
        opts = opts || DefaultClientOptions;
        this.key = opts.key ? opts.key : uuid();
        this.status = ClientStatus.Deactivated;
        this.attachmentMap = new Map();
        // TODO(hackerwins): Consider to group the options as a single object.
        this.apiKey = opts.apiKey || '';
        this.syncLoopDuration =
            opts.syncLoopDuration || DefaultClientOptions.syncLoopDuration;
        this.reconnectStreamDelay =
            opts.reconnectStreamDelay || DefaultClientOptions.reconnectStreamDelay;
        this.retrySyncLoopDelay =
            opts.retrySyncLoopDelay || DefaultClientOptions.retrySyncLoopDelay;
        // Here we make the client itself, combining the service
        // definition with the transport.
        this.rpcClient = createPromiseClient(yorkie_connect/* YorkieService */.V, createGrpcWebTransport({
            baseUrl: rpcAddr,
            interceptors: [
                createAuthInterceptor(opts.apiKey, opts.token),
                createMetricInterceptor(),
            ],
        }));
        this.eventStream = createObservable((observer) => {
            this.eventStreamObserver = observer;
        });
    }
    /**
     * `activate` activates this client. That is, it registers itself to the server
     * and receives a unique ID from the server. The given ID is used to
     * distinguish different clients.
     */
    activate() {
        if (this.isActive()) {
            return Promise.resolve();
        }
        return this.rpcClient
            .activateClient({
            clientKey: this.key,
        }, { headers: { 'x-shard-key': this.apiKey } })
            .then((res) => {
            this.id = res.clientId;
            this.status = ClientStatus.Activated;
            this.runSyncLoop();
            this.eventStreamObserver.next({
                type: ClientEventType.StatusChanged,
                value: this.status,
            });
            logger.info(`[AC] c:"${this.getKey()}" activated, id:"${this.id}"`);
        })
            .catch((err) => {
            logger.error(`[AC] c:"${this.getKey()}" err :`, err);
            throw err;
        });
    }
    /**
     * `deactivate` deactivates this client.
     */
    deactivate() {
        if (this.status === ClientStatus.Deactivated) {
            return Promise.resolve();
        }
        for (const [key] of this.attachmentMap) {
            this.detachInternal(key);
        }
        return this.rpcClient
            .deactivateClient({
            clientId: this.id,
        }, { headers: { 'x-shard-key': this.apiKey } })
            .then(() => {
            this.status = ClientStatus.Deactivated;
            this.eventStreamObserver.next({
                type: ClientEventType.StatusChanged,
                value: this.status,
            });
            logger.info(`[DC] c"${this.getKey()}" deactivated`);
        })
            .catch((err) => {
            logger.error(`[DC] c:"${this.getKey()}" err :`, err);
            throw err;
        });
    }
    /**
     * `attach` attaches the given document to this client. It tells the server that
     * this client will synchronize the given document.
     */
    attach(doc, options = {}) {
        var _a;
        if (!this.isActive()) {
            throw new YorkieError(error_Code.ClientNotActive, `${this.key} is not active`);
        }
        if (doc.getStatus() !== DocumentStatus.Detached) {
            throw new YorkieError(error_Code.DocumentNotDetached, `${doc.getKey()} is not detached`);
        }
        doc.setActor(this.id);
        doc.update((_, p) => p.set(options.initialPresence || {}));
        const syncMode = (_a = options.syncMode) !== null && _a !== void 0 ? _a : SyncMode.Realtime;
        return this.rpcClient
            .attachDocument({
            clientId: this.id,
            changePack: converter.toChangePack(doc.createChangePack()),
        }, {
            headers: { 'x-shard-key': `${this.apiKey}/${doc.getKey()}` },
        })
            .then(async (res) => {
            const pack = converter.fromChangePack(res.changePack);
            doc.applyChangePack(pack);
            if (doc.getStatus() === DocumentStatus.Removed) {
                return doc;
            }
            doc.setStatus(DocumentStatus.Attached);
            this.attachmentMap.set(doc.getKey(), new Attachment(this.reconnectStreamDelay, doc, res.documentId, syncMode));
            if (syncMode !== SyncMode.Manual) {
                await this.runWatchLoop(doc.getKey());
            }
            logger.info(`[AD] c:"${this.getKey()}" attaches d:"${doc.getKey()}"`);
            return doc;
        })
            .catch((err) => {
            logger.error(`[AD] c:"${this.getKey()}" err :`, err);
            throw err;
        });
    }
    /**
     * `detach` detaches the given document from this client. It tells the
     * server that this client will no longer synchronize the given document.
     *
     * To collect garbage things like CRDT tombstones left on the document, all
     * the changes should be applied to other replicas before GC time. For this,
     * if the document is no longer used by this client, it should be detached.
     */
    detach(doc, options = {}) {
        var _a;
        if (!this.isActive()) {
            throw new YorkieError(error_Code.ClientNotActive, `${this.key} is not active`);
        }
        const attachment = this.attachmentMap.get(doc.getKey());
        if (!attachment) {
            throw new YorkieError(error_Code.DocumentNotAttached, `${doc.getKey()} is not attached`);
        }
        doc.update((_, p) => p.clear());
        return this.rpcClient
            .detachDocument({
            clientId: this.id,
            documentId: attachment.docID,
            changePack: converter.toChangePack(doc.createChangePack()),
            removeIfNotAttached: (_a = options.removeIfNotAttached) !== null && _a !== void 0 ? _a : false,
        }, {
            headers: { 'x-shard-key': `${this.apiKey}/${doc.getKey()}` },
        })
            .then((res) => {
            const pack = converter.fromChangePack(res.changePack);
            doc.applyChangePack(pack);
            if (doc.getStatus() !== DocumentStatus.Removed) {
                doc.setStatus(DocumentStatus.Detached);
            }
            this.detachInternal(doc.getKey());
            logger.info(`[DD] c:"${this.getKey()}" detaches d:"${doc.getKey()}"`);
            return doc;
        })
            .catch((err) => {
            logger.error(`[DD] c:"${this.getKey()}" err :`, err);
            throw err;
        });
    }
    /**
     * `changeRealtimeSync` changes the synchronization mode of the given document.
     */
    async changeSyncMode(doc, syncMode) {
        if (!this.isActive()) {
            throw new YorkieError(error_Code.ClientNotActive, `${this.key} is not active`);
        }
        const attachment = this.attachmentMap.get(doc.getKey());
        if (!attachment) {
            throw new YorkieError(error_Code.DocumentNotAttached, `${doc.getKey()} is not attached`);
        }
        const prevSyncMode = attachment.syncMode;
        if (prevSyncMode === syncMode) {
            return doc;
        }
        attachment.changeSyncMode(syncMode);
        // realtime to manual
        if (syncMode === SyncMode.Manual) {
            attachment.cancelWatchStream();
            return doc;
        }
        if (syncMode === SyncMode.Realtime) {
            // NOTE(hackerwins): In non-pushpull mode, the client does not receive change events
            // from the server. Therefore, we need to set `remoteChangeEventReceived` to true
            // to sync the local and remote changes. This has limitations in that unnecessary
            // syncs occur if the client and server do not have any changes.
            attachment.remoteChangeEventReceived = true;
        }
        // manual to realtime
        if (prevSyncMode === SyncMode.Manual) {
            await this.runWatchLoop(doc.getKey());
        }
        return doc;
    }
    /**
     * `sync` pushes local changes of the attached documents to the server and
     * receives changes of the remote replica from the server then apply them to
     * local documents.
     */
    sync(doc) {
        if (!this.isActive()) {
            throw new YorkieError(error_Code.ClientNotActive, `${this.key} is not active`);
        }
        const promises = [];
        if (doc) {
            // prettier-ignore
            const attachment = this.attachmentMap.get(doc.getKey());
            if (!attachment) {
                throw new YorkieError(error_Code.DocumentNotAttached, `${doc.getKey()} is not attached`);
            }
            promises.push(this.syncInternal(attachment, SyncMode.Realtime));
        }
        else {
            this.attachmentMap.forEach((attachment) => {
                promises.push(this.syncInternal(attachment, attachment.syncMode));
            });
        }
        return Promise.all(promises).catch((err) => {
            this.eventStreamObserver.next({
                type: ClientEventType.DocumentSynced,
                value: DocumentSyncResultType.SyncFailed,
            });
            throw err;
        });
    }
    /**
     * `remove` removes the given document.
     */
    remove(doc) {
        if (!this.isActive()) {
            throw new YorkieError(error_Code.ClientNotActive, `${this.key} is not active`);
        }
        const attachment = this.attachmentMap.get(doc.getKey());
        if (!attachment) {
            throw new YorkieError(error_Code.DocumentNotAttached, `${doc.getKey()} is not attached`);
        }
        doc.setActor(this.id);
        const pbChangePack = converter.toChangePack(doc.createChangePack());
        pbChangePack.isRemoved = true;
        return this.rpcClient
            .removeDocument({
            clientId: this.id,
            documentId: attachment.docID,
            changePack: pbChangePack,
        }, {
            headers: { 'x-shard-key': `${this.apiKey}/${doc.getKey()}` },
        })
            .then((res) => {
            const pack = converter.fromChangePack(res.changePack);
            doc.applyChangePack(pack);
            this.detachInternal(doc.getKey());
            logger.info(`[RD] c:"${this.getKey()}" removes d:"${doc.getKey()}"`);
        })
            .catch((err) => {
            logger.error(`[RD] c:"${this.getKey()}" err :`, err);
            throw err;
        });
    }
    /**
     * `subscribe` subscribes to the given topics.
     */
    subscribe(nextOrObserver, error, complete) {
        return this.eventStream.subscribe(nextOrObserver, error, complete);
    }
    /**
     * `getID` returns a ActorID of client.
     */
    getID() {
        return this.id;
    }
    /**
     * `getKey` returns a key of client.
     */
    getKey() {
        return this.key;
    }
    /**
     * `isActive` checks if the client is active.
     */
    isActive() {
        return this.status === ClientStatus.Activated;
    }
    /**
     * `getStatus` returns the status of this client.
     */
    getStatus() {
        return this.status;
    }
    runSyncLoop() {
        const doLoop = () => {
            if (!this.isActive()) {
                logger.debug(`[SL] c:"${this.getKey()}" exit sync loop`);
                return;
            }
            const syncJobs = [];
            for (const [, attachment] of this.attachmentMap) {
                if (attachment.needRealtimeSync()) {
                    attachment.remoteChangeEventReceived = false;
                    syncJobs.push(this.syncInternal(attachment, attachment.syncMode));
                }
            }
            Promise.all(syncJobs)
                .then(() => setTimeout(doLoop, this.syncLoopDuration))
                .catch((err) => {
                logger.error(`[SL] c:"${this.getKey()}" sync failed:`, err);
                this.eventStreamObserver.next({
                    type: ClientEventType.DocumentSynced,
                    value: DocumentSyncResultType.SyncFailed,
                });
                setTimeout(doLoop, this.retrySyncLoopDelay);
            });
        };
        logger.debug(`[SL] c:"${this.getKey()}" run sync loop`);
        doLoop();
    }
    async runWatchLoop(docKey) {
        const attachment = this.attachmentMap.get(docKey);
        if (!attachment) {
            throw new YorkieError(error_Code.DocumentNotAttached, `${docKey} is not attached`);
        }
        return attachment.runWatchLoop((onDisconnect) => {
            if (!this.isActive()) {
                return Promise.reject(new YorkieError(error_Code.ClientNotActive, `${this.key} is not active`));
            }
            const ac = new AbortController();
            const stream = this.rpcClient.watchDocument({
                clientId: this.id,
                documentId: attachment.docID,
            }, {
                headers: { 'x-shard-key': `${this.apiKey}/${docKey}` },
                signal: ac.signal,
            });
            this.eventStreamObserver.next({
                type: ClientEventType.StreamConnectionStatusChanged,
                value: StreamConnectionStatus.Connected,
            });
            logger.info(`[WD] c:"${this.getKey()}" watches d:"${docKey}"`);
            return new Promise((resolve, reject) => {
                const handleStream = async () => {
                    try {
                        for await (const resp of stream) {
                            this.handleWatchDocumentsResponse(attachment, resp);
                            // NOTE(hackerwins): When the first response is received, we need to
                            // resolve the promise to notify that the watch stream is ready.
                            if (resp.body.case === 'initialization') {
                                resolve([stream, ac]);
                            }
                        }
                    }
                    catch (err) {
                        this.eventStreamObserver.next({
                            type: ClientEventType.StreamConnectionStatusChanged,
                            value: StreamConnectionStatus.Disconnected,
                        });
                        logger.debug(`[WD] c:"${this.getKey()}" unwatches`);
                        onDisconnect();
                        reject(err);
                    }
                };
                handleStream();
            });
        });
    }
    handleWatchDocumentsResponse(attachment, resp) {
        const docKey = attachment.doc.getKey();
        if (resp.body.case === 'initialization') {
            const clientIDs = resp.body.value.clientIds;
            const onlineClients = new Set();
            for (const clientID of clientIDs) {
                onlineClients.add(clientID);
            }
            attachment.doc.setOnlineClients(onlineClients);
            attachment.doc.publish({
                type: DocEventType.Initialized,
                value: attachment.doc.getPresences(),
            });
            return;
        }
        else if (resp.body.case === 'event') {
            const pbWatchEvent = resp.body.value;
            const eventType = pbWatchEvent.type;
            const publisher = pbWatchEvent.publisher;
            switch (eventType) {
                case resources_pb.DocEventType.DOCUMENT_CHANGED:
                    attachment.remoteChangeEventReceived = true;
                    this.eventStreamObserver.next({
                        type: ClientEventType.DocumentChanged,
                        value: [docKey],
                    });
                    break;
                case resources_pb.DocEventType.DOCUMENT_WATCHED:
                    attachment.doc.addOnlineClient(publisher);
                    // NOTE(chacha912): We added to onlineClients, but we won't trigger watched event
                    // unless we also know their initial presence data at this point.
                    if (attachment.doc.hasPresence(publisher)) {
                        attachment.doc.publish({
                            type: DocEventType.Watched,
                            value: {
                                clientID: publisher,
                                presence: attachment.doc.getPresence(publisher),
                            },
                        });
                    }
                    break;
                case resources_pb.DocEventType.DOCUMENT_UNWATCHED: {
                    const presence = attachment.doc.getPresence(publisher);
                    attachment.doc.removeOnlineClient(publisher);
                    // NOTE(chacha912): There is no presence, when PresenceChange(clear) is applied before unwatching.
                    // In that case, the 'unwatched' event is triggered while handling the PresenceChange.
                    if (presence) {
                        attachment.doc.publish({
                            type: DocEventType.Unwatched,
                            value: { clientID: publisher, presence },
                        });
                    }
                    break;
                }
            }
        }
    }
    detachInternal(docKey) {
        // NOTE(hackerwins): If attachment is not found, it means that the document
        // has been already detached by another routine.
        // This can happen when detach or remove is called while the watch loop is
        // running.
        const attachment = this.attachmentMap.get(docKey);
        if (!attachment) {
            return;
        }
        attachment.cancelWatchStream();
        logger.debug(`[WD] c:"${this.getKey()}" unwatches`);
        this.eventStreamObserver.next({
            type: ClientEventType.StreamConnectionStatusChanged,
            value: StreamConnectionStatus.Disconnected,
        });
        this.attachmentMap.delete(docKey);
    }
    syncInternal(attachment, syncMode) {
        const { doc, docID } = attachment;
        const reqPack = doc.createChangePack();
        return this.rpcClient
            .pushPullChanges({
            clientId: this.id,
            documentId: docID,
            changePack: converter.toChangePack(reqPack),
            pushOnly: syncMode === SyncMode.RealtimePushOnly,
        }, {
            headers: { 'x-shard-key': `${this.apiKey}/${doc.getKey()}` },
        })
            .then((res) => {
            const respPack = converter.fromChangePack(res.changePack);
            // NOTE(chacha912, hackerwins): If syncLoop already executed with
            // PushPull, ignore the response when the syncMode is PushOnly.
            if (respPack.hasChanges() &&
                attachment.syncMode === SyncMode.RealtimePushOnly) {
                return doc;
            }
            doc.applyChangePack(respPack);
            this.eventStreamObserver.next({
                type: ClientEventType.DocumentSynced,
                value: DocumentSyncResultType.Synced,
            });
            // NOTE(chacha912): If a document has been removed, watchStream should
            // be disconnected to not receive an event for that document.
            if (doc.getStatus() === DocumentStatus.Removed) {
                this.detachInternal(doc.getKey());
            }
            const docKey = doc.getKey();
            const remoteSize = respPack.getChangeSize();
            logger.info(`[PP] c:"${this.getKey()}" sync d:"${docKey}", push:${reqPack.getChangeSize()} pull:${remoteSize} cp:${respPack
                .getCheckpoint()
                .toTestString()}`);
            return doc;
        })
            .catch((err) => {
            logger.error(`[PP] c:"${this.getKey()}" err :`, err);
            throw err;
        });
    }
}

;// CONCATENATED MODULE: ./src/yorkie.ts
/*
 * Copyright 2020 The Yorkie Authors. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


















/**
 * The top-level yorkie namespace with additional properties.
 *
 * In production, this will be called exactly once and the result
 * assigned to the `yorkie` global.
 *
 * e.g) `new yorkie.Client(...);`
 *
 * @public
 */
const yorkie = {
    Client: Client,
    Document: Document,
    Primitive: Primitive,
    Text: Text,
    Counter: Counter,
    Tree: Tree,
    IntType: CounterType.IntegerCnt,
    LongType: CounterType.LongCnt,
};
/* harmony default export */ const src_yorkie = (yorkie);

})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=yorkie-js-sdk.js.map